
(******************************************************************************)
(*                                                                            *)
(*                                                                            *)
(*                       Terminal Reliability of                              *)
(*                       Shuffle-exchange Network                             *)
(*                          Yassmeen Elderhalli                               *)
(*                      y_elderh@encs.concordia.ca                            *)
(******************************************************************************)

(*loadPath := "/home/yassmeen/Downloads/Reqiured-Theories" :: !loadPath;
loadPath := "/home/yassmeen/Downloads/DFT-Theories" :: !loadPath;
loadPath := "/home/yassmeen/Downloads/DRBD-Theories" :: !loadPath;

*)
(*set_trace "Unicode" 0;*)




(* app load ["HolKernel", "Parse", "boolLib", "bossLib", "numLib", "unwindLib", 
"tautLib", "Arith", "prim_recTheory", "combinTheory", "quotientTheory", 
"arithmeticTheory", "realTheory", "hrealTheory", "realaxTheory", "realLib",  
"jrhUtils", "pairTheory", "seqTheory", "limTheory", "transcTheory", "listTheory", 
"mesonLib", "boolTheory", "topologyTheory", "pred_setTheory", "util_probTheory", 
"optionTheory", "numTheory", "sumTheory", "InductiveDefinition", "ind_typeTheory",
"pred_setLib", "iterate_hvgTheory", "card_hvgTheory", "product_hvgTheory", 
"topology_hvgTheory", "derivative_hvgTheory", "integration_hvgTheory",
"real_sigmaTheory", "extreal_hvgTheory", "measure_hvgTheory", "lebesgue_hvgTheory",
"probability_hvgTheory", "lebesgue_measure_hvgTheory", "normal_rv_hvgTheory", "netsTheory",
"PIE_EXTREALTheory", "integration_before_afterTheory", "dep_rewrite", "DFT_Gates_def_PROBTheory",  "WCSPTheory",  "DRBDTheory", "rewrite_Rules_LemmasTheory","Rewrite_RulesTheory", "rich_listTheory", "DFT_DRBDTheory"];
*)

open HolKernel Parse boolLib bossLib numLib unwindLib tautLib Arith prim_recTheory 
combinTheory quotientTheory arithmeticTheory hrealTheory realaxTheory realTheory 
realLib jrhUtils pairTheory seqTheory limTheory transcTheory listTheory mesonLib 
boolTheory topologyTheory pred_setTheory util_probTheory optionTheory numTheory 
sumTheory InductiveDefinition ind_typeTheory pred_setLib iterate_hvgTheory 
card_hvgTheory product_hvgTheory topology_hvgTheory derivative_hvgTheory
integration_hvgTheory real_sigmaTheory extreal_hvgTheory measure_hvgTheory
lebesgue_hvgTheory probability_hvgTheory lebesgue_measure_hvgTheory
normal_rv_hvgTheory netsTheory PIE_EXTREALTheory integration_before_afterTheory dep_rewrite DFT_Gates_def_PROBTheory  WCSPTheory   DRBDTheory rewrite_Rules_LemmasTheory Rewrite_RulesTheory
rich_listTheory DFT_DRBDTheory;
  

val _ = new_theory "SEN";



infixr 0 ++ << || ORELSEC ## --> THENC;
infix 1 >> |->;
fun parse_with_goal t (asms, g) =
  let
    val ctxt = free_varsl (g::asms)
  in
    Parse.parse_in_context ctxt t
  end;
 
val PARSE_TAC = fn tac => fn q => W (tac o parse_with_goal q);
val Suff = PARSE_TAC SUFF_TAC;
val POP_ORW = POP_ASSUM (fn thm => ONCE_REWRITE_TAC [thm]);
val !! = REPEAT;
val op++ = op THEN;
val op<< = op THENL;
val op|| = op ORELSE;
val op>> = op THEN1;
val std_ss' = simpLib.++ (std_ss, boolSimps.ETA_ss);

(*---------------------------*)
fun SET_TAC L =
    POP_ASSUM_LIST(K ALL_TAC) THEN REPEAT COND_CASES_TAC THEN
    REWRITE_TAC (append [EXTENSION, SUBSET_DEF, PSUBSET_DEF, DISJOINT_DEF,
    SING_DEF] L) THEN SIMP_TAC std_ss [NOT_IN_EMPTY, IN_UNIV, IN_UNION,
    IN_INTER, IN_DIFF, IN_INSERT, IN_DELETE, IN_BIGINTER, IN_BIGUNION,
    IN_IMAGE, GSPECIFICATION, IN_DEF] THEN METIS_TAC [];

fun SET_RULE tm = prove(tm,SET_TAC []);


val set_rewrs
= [INTER_EMPTY, INTER_UNIV, UNION_EMPTY, UNION_UNIV, DISJOINT_UNION,
DISJOINT_INSERT, DISJOINT_EMPTY, GSYM DISJOINT_EMPTY_REFL,
DISJOINT_BIGUNION, INTER_SUBSET, INTER_IDEMPOT, UNION_IDEMPOT,
SUBSET_UNION];

val UNIONL_def = Define `(UNIONL [] = {})
/\ (UNIONL (s::ss) = (s:'a ->bool) UNION UNIONL ss)`;


val IN_UNIONL = store_thm
("IN_UNIONL",
``!l (v:'a ). v IN UNIONL l = (?s. MEM s l /\ v IN s)``,
Induct >> RW_TAC std_ss [UNIONL_def, MEM, NOT_IN_EMPTY]
++ RW_TAC std_ss [UNIONL_def, MEM, NOT_IN_EMPTY, IN_UNION]
++ PROVE_TAC []);


val elt_rewrs
= [SUBSET_DEF, IN_COMPL, IN_DIFF, IN_UNIV, NOT_IN_EMPTY, IN_UNION,
IN_INTER, IN_IMAGE, IN_FUNSET, IN_DFUNSET, GSPECIFICATION,
DISJOINT_DEF, IN_BIGUNION, IN_BIGINTER, IN_COUNT, IN_o,
IN_UNIONL, IN_DELETE, IN_PREIMAGE, IN_SING, IN_INSERT];


fun rewr_ss ths =
simpLib.++
(std_ss,
simpLib.SSFRAG
{ac = [],
name = NONE,
convs = [],
dprocs = [],
filter = NONE,
rewrs = set_rewrs @ elt_rewrs,
congs = []});
val pset_set_ss = rewr_ss set_rewrs;
val pset_elt_ss = rewr_ss elt_rewrs;
val pset_ss = rewr_ss (set_rewrs @ elt_rewrs);


fun PSET_TAC ths =
REPEAT (POP_ASSUM MP_TAC)
++ RW_TAC pset_set_ss ths
++ REPEAT (POP_ASSUM MP_TAC)
++ RW_TAC pset_elt_ss ths;

fun parse_with_goal t (asms, g) =
  let
    val ctxt = free_varsl (g::asms)
  in
    Parse.parse_in_context ctxt t
  end;
val PARSE_TAC = fn tac => fn q => W (tac o parse_with_goal q);
val Simplify = RW_TAC arith_ss;
val Suff = PARSE_TAC SUFF_TAC;
val Know = PARSE_TAC KNOW_TAC;
fun wrap a = [a];
val Rewr = DISCH_THEN (REWRITE_TAC o wrap);
val Rewr' = DISCH_THEN (ONCE_REWRITE_TAC o wrap);
val Cond =
  DISCH_THEN
  (fn mp_th =>
   let
     val cond = fst (dest_imp (concl mp_th))
   in
     KNOW_TAC cond << [ALL_TAC, DISCH_THEN (MP_TAC o MP mp_th)]
   end);
val FUN_EQ_TAC = CONV_TAC (CHANGED_CONV (ONCE_DEPTH_CONV FUN_EQ_CONV));
fun K_TAC _ = ALL_TAC;
fun MESON ths tm = prove(tm,MESON_TAC ths);
fun METIS ths tm = prove(tm,METIS_TAC ths);
val DISC_RW_KILL = DISCH_TAC THEN ONCE_ASM_REWRITE_TAC [] THEN 
                   POP_ASSUM K_TAC;
			   
val IN_REST = store_thm ("IN_REST",
 ``!x:'a. !s. x IN (REST s) <=> x IN s /\ ~(x = CHOICE s)``,
  REWRITE_TAC[REST_DEF, IN_DELETE]);
fun SET_TAC L = 
    POP_ASSUM_LIST(K ALL_TAC) THEN REPEAT COND_CASES_TAC THEN
    REWRITE_TAC (append [EXTENSION, SUBSET_DEF, PSUBSET_DEF, DISJOINT_DEF,
    SING_DEF] L) THEN
    SIMP_TAC std_ss [NOT_IN_EMPTY, IN_UNIV, IN_UNION, IN_INTER, IN_DIFF, 
      IN_INSERT, IN_DELETE, IN_REST, IN_BIGINTER, IN_BIGUNION, IN_IMAGE, 
      GSPECIFICATION, IN_DEF, EXISTS_PROD] THEN METIS_TAC [];
fun ASSERT_TAC tm = SUBGOAL_THEN tm STRIP_ASSUME_TAC;
fun SET_RULE tm = prove(tm,SET_TAC []);
fun ASM_SET_TAC L = REPEAT (POP_ASSUM MP_TAC) THEN SET_TAC L;
val ASM_ARITH_TAC = REPEAT (POP_ASSUM MP_TAC) THEN ARITH_TAC;
val ASM_REAL_ARITH_TAC = REPEAT (POP_ASSUM MP_TAC) THEN REAL_ARITH_TAC;



(******************************************************************************)
(*                                                                            *)
(*                          some extreal numbers properties                   *)
(*                                                                            *)
(******************************************************************************)


val normal_real_mul1 = store_thm("normal_real_mul1",
  ``  !a b c.
            a <> PosInf /\ a <> NegInf /\ b <> PosInf /\ b <> NegInf ==>
            (Normal (real a * real b * c) = a * b * Normal c)``,
REPEAT Cases
THEN RW_TAC std_ss[]
THEN RW_TAC std_ss[real_normal]
THEN RW_TAC std_ss[extreal_mul_def]);


val normal_real_mul2 = store_thm("normal_real_mul2",
  ``    !a b c d.
            a <> PosInf /\ a <> NegInf /\ b <> PosInf /\ b <> NegInf ==>
            (Normal (real a * c * d * real b) = a * b * Normal (c * d)) ``,
REPEAT Cases
THEN RW_TAC std_ss[]
THEN RW_TAC std_ss[real_normal]
THEN RW_TAC std_ss[extreal_mul_def]
THEN METIS_TAC[REAL_MUL_ASSOC, REAL_MUL_COMM]);


val normal_real_mul3 = store_thm("normal_real_mul3",
  `` !a b c.
            a <> PosInf /\ a <> NegInf /\ b <> PosInf /\ b <> NegInf ==>
            (Normal (real a * c * real b) = a * b * Normal c)``,
REPEAT Cases
THEN RW_TAC std_ss[]
THEN RW_TAC std_ss[real_normal]
THEN RW_TAC std_ss[extreal_mul_def]
THEN METIS_TAC[REAL_MUL_ASSOC, REAL_MUL_COMM]);

val real_mul_real = store_thm("real_mul_real",
  ``!a b.
        a <> PosInf /\ a <> NegInf /\ b <> PosInf /\ b<> NegInf ==>
        (real a * real b = real (a * b))  ``,
RW_TAC std_ss[real_def]
THEN RW_TAC std_ss[REAL_MUL_LZERO] 
THEN SELECT_ELIM_TAC
THEN RW_TAC std_ss[]
     THEN1(Q.EXISTS_TAC`real a`
           THEN METIS_TAC[normal_real])
     THEN1(SELECT_ELIM_TAC
           THEN RW_TAC std_ss[]
                THEN1 (Q.EXISTS_TAC`real b`
                       THEN METIS_TAC[normal_real])
           THEN FULL_SIMP_TAC std_ss[extreal_mul_def]      
           THEN METIS_TAC[extreal_not_infty])
     THEN1(Q.EXISTS_TAC`real a`
           THEN METIS_TAC[normal_real])          
     THEN1(SELECT_ELIM_TAC
           THEN RW_TAC std_ss[]
                THEN1 (Q.EXISTS_TAC`real b`
                       THEN METIS_TAC[normal_real])
           THEN FULL_SIMP_TAC std_ss[extreal_mul_def]      
           THEN METIS_TAC[extreal_not_infty])
    THEN1(Q.EXISTS_TAC`real a`
           THEN METIS_TAC[normal_real])          
THEN SELECT_ELIM_TAC
THEN RW_TAC std_ss[]
     THEN1 (Q.EXISTS_TAC`real b`
            THEN METIS_TAC[normal_real])
THEN SELECT_ELIM_TAC
THEN RW_TAC std_ss[]
      THEN1(RW_TAC std_ss[extreal_mul_def])
THEN FULL_SIMP_TAC std_ss[extreal_mul_def]
THEN RW_TAC std_ss[] );
    	   

val extreal_sub_sub2 = store_thm("extreal_sub_sub2",
  ``   !a b.
            a <> PosInf /\ a <> NegInf /\ b <> PosInf /\ b <> NegInf ==>
            (a - (a - b) = b)  ``,
REPEAT Cases
THEN RW_TAC std_ss[]
THEN RW_TAC std_ss[extreal_sub_def]
THEN METIS_TAC[REAL_SUB_SUB2]);



(******************************************************************************)
(*                          event set                                         *)
(*                                                                            *)
(*                                                                            *)
(******************************************************************************)

val event_set1_def = Define `event_set1 (X,i) Y = (\j. if j = i then X else Y j)  `;

val event_set2_def = Define `event_set2 (X1, i1) (X2, i2) Y =
                             event_set1 X1 i1 (event_set1 X2 i2 Y)  `;


val event_set_def = Define `(event_set [(X1,i1)] Y  = event_set1 (X1,i1) Y) /\
                            (event_set ((X1,i1)::t) Y = event_set1 (X1,i1) (event_set t Y))`;

val ind_set_def = Define `ind_set A = (\i. EL i A)  `;



(******************************************************************************)
(*                                                                            *)
(*                  probability of n_OR & n_AND                               *)
(*                                                                            *)
(******************************************************************************)

val bigunion_def = Define `bigunion Y (s:num->bool) = BIGUNION { Y i| i IN s}`;

val biginter_def = Define `biginter Y (s:num->bool) = BIGINTER { Y i| i IN s}`;

val rv_to_devent_def = Define `rv_to_devent p X t = (\i. DFT_event p (X i) t )  `;


val n_OR_BIGUNION = store_thm("n_OR_BIGUNION",
  ``  !p X t s. FINITE s ==> (DFT_event p (n_OR (MAP X (SET_TO_LIST s))) t = BIGUNION {rv_to_devent p X t i| i IN s})   ``,


NTAC 3 GEN_TAC 
THEN SET_INDUCT_TAC
     THEN1(`FINITE (({}):('b->bool))` by ASM_SET_TAC[FINITE_DEF, FINITE_EMPTY]
           THEN RW_TAC std_ss[n_OR_nR_AND]
	   THEN RW_TAC std_ss[nR_AND_def, R_NEVER_def]
	   THEN ONCE_REWRITE_TAC[pred_setTheory.ITSET_def]
           THEN RW_TAC std_ss[]
       	   THEN RW_TAC std_ss[DFT_event_def]
	   THEN `PosInf <> Normal t` by RW_TAC std_ss[extreal_not_infty]
	   THEN KNOW_TAC(``{s:'a|s:'a|PosInf <= Normal t}  = {}``)
	        THEN1(SRW_TAC[][GSPECIFICATION, EXTENSION]
		      THEN METIS_TAC[extreal_not_infty, extreal_lt_def, extreal_le_def, lt_le, le_lt])
	   THEN RW_TAC std_ss[INTER_EMPTY]
	   THEN `{rv_to_devent p X t i | i IN {}} = {}` by ASM_SET_TAC[]
       	   THEN RW_TAC std_ss[BIGUNION_EMPTY])

THEN `FINITE ((e:'b) INSERT s)` by ASM_SET_TAC[FINITE_INSERT]
THEN RW_TAC std_ss[n_OR_nR_AND]
THEN RW_TAC std_ss[nR_AND_THM]
THEN `s DELETE (e:'b) = s`  by ASM_SET_TAC[]
THEN ONCE_ASM_REWRITE_TAC[]
THEN RW_TAC std_ss[GSYM D_OR_R_AND]
THEN RW_TAC std_ss[OR_UNION]
THEN RW_TAC std_ss[rv_to_devent_def]
THEN `(e:'b) INSERT s = {e} UNION s` by ASM_SET_TAC[]
THEN ONCE_ASM_REWRITE_TAC[]
THEN  `{DFT_event p (X i) t | i IN {e} UNION s} =
       {DFT_event p (X e) t} UNION {DFT_event p (X i) t | i IN  s}` by ASM_SET_TAC[]
THEN RW_TAC std_ss[BIGUNION_UNION, BIGUNION_SING]
THEN KNOW_TAC(`` DFT_event p (nR_AND X (s:'b->bool)) t =  DFT_event p (n_OR (MAP (X:'b->'a->extreal) (SET_TO_LIST s))) t ``)
     THEN1(`nR_AND X (s:'b->bool) = (n_OR (MAP (X:'b->'a->extreal) (SET_TO_LIST s)))` by 
     RW_TAC std_ss[n_OR_nR_AND]
           THEN RW_TAC std_ss[])
THEN RW_TAC std_ss[rv_to_devent_def]);	   



val PROB_n_OR = store_thm("PROB_n_OR",
  ``!p X t s.  indep_sets p (\i. {rv_to_devent p X t i}) s /\ s <> {} /\ FINITE s ==>
	  (prob p (DFT_event p (n_OR (MAP X (SET_TO_LIST s))) t) =
	   1 - Normal (product s (\i. real (1 - prob p (rv_to_devent p X t i)))))``,

RW_TAC std_ss[n_OR_BIGUNION]
THEN RW_TAC std_ss[GSYM DRBD_parallel_def]
THEN DEP_REWRITE_TAC[PROB_DRBD_parallel] 
THEN RW_TAC std_ss[]
THEN FULL_SIMP_TAC std_ss[indep_sets]
THEN ASM_SET_TAC[]);




val PROB_n_OR_CDF = store_thm("PROB_n_OR_CDF",
  ``!p X t s.   s <> {} /\ FINITE s  /\
  indep_sets p (\i. {rv_to_devent p X t i}) s /\
   (!i. i IN s ==> rv_gt0_ninfinity [X i]) ==>
	  (prob p (DFT_event p (n_OR (MAP X (SET_TO_LIST s))) t) =
	   1 - Normal (product s (\i. real (1 - CDF p (real o (X i)) t))))``,

RW_TAC std_ss[PROB_n_OR]
THEN RW_TAC std_ss[rv_to_devent_def, o_DEF]
THEN KNOW_TAC(``!i:num. i IN s ==> (real (1 - prob p (DFT_event p (X i) t)) =
                                real (1 - CDF p (\x. real (X i x)) t)) ``)
    THEN1(RW_TAC std_ss[]
          THEN FULL_SIMP_TAC std_ss[rv_gt0_ninfinity_def]
	  THEN RW_TAC std_ss[CDF_prob_DFT_event]
	  THEN METIS_TAC[ETA_THM])
THEN RW_TAC std_ss[th]	  
THEN KNOW_TAC(``product s (\i:num. real (1 - prob p (DFT_event p (X i) t))) =
                product s (\i. real (1 - CDF p (\x. real (X i x)) t)) ``)
     THEN1 RW_TAC std_ss[th]
THEN RW_TAC std_ss[] );


val n_AND_BIGINTER_lem = store_thm("n_AND_BIGINTER_lem",
  `` !p X t s.
          FINITE s ==>
          0 <= t ==>
          (DFT_event p (n_AND (MAP X (SET_TO_LIST s))) t =
           BIGINTER {rv_to_devent p X t i | i IN s} INTER p_space p) ``,


NTAC 3 GEN_TAC 
THEN SET_INDUCT_TAC
     THEN1(`FINITE (({}):('b->bool))` by ASM_SET_TAC[FINITE_DEF, FINITE_EMPTY]
           THEN RW_TAC std_ss[n_AND_nR_OR]
	   THEN RW_TAC std_ss[nR_OR_def, R_ALWAYS_def]
	   THEN ONCE_REWRITE_TAC[pred_setTheory.ITSET_def]
           THEN RW_TAC std_ss[]
       	   THEN RW_TAC std_ss[DFT_event_def]
	   THEN ` 0 = Normal 0` by METIS_TAC[extreal_of_num_def]
	   THEN ONCE_ASM_REWRITE_TAC[]
	   THEN RW_TAC std_ss[extreal_le_def]
	   THEN `{rv_to_devent p X t i | i IN {}} = {}` by ASM_SET_TAC[]
	   THEN ASM_SET_TAC[BIGUNION_EMPTY])
THEN `FINITE ((e:'b) INSERT s)` by ASM_SET_TAC[FINITE_INSERT]
THEN RW_TAC std_ss[n_AND_nR_OR]
THEN RW_TAC std_ss[nR_OR_THM]
THEN `s DELETE (e:'b) = s`  by ASM_SET_TAC[]
THEN ONCE_ASM_REWRITE_TAC[]
THEN RW_TAC std_ss[GSYM D_AND_R_OR]
THEN RW_TAC std_ss[AND_INTER]
THEN RW_TAC std_ss[rv_to_devent_def]
THEN `(e:'b) INSERT s = {e} UNION s` by ASM_SET_TAC[]
THEN ONCE_ASM_REWRITE_TAC[]
THEN  `{DFT_event p (X i) t | i IN {e} UNION s} =
       {DFT_event p (X e) t} UNION {DFT_event p (X i) t | i IN  s}` by ASM_SET_TAC[]
THEN RW_TAC std_ss[BIGINTER_UNION, BIGINTER_SING]
THEN KNOW_TAC(`` DFT_event p (nR_OR X (s:'b->bool)) t =  DFT_event p (n_AND (MAP (X:'b->'a->extreal) (SET_TO_LIST s))) t ``)
     THEN1(`nR_OR X (s:'b->bool) = (n_AND (MAP (X:'b->'a->extreal) (SET_TO_LIST s)))` by 
     RW_TAC std_ss[n_AND_nR_OR]
           THEN RW_TAC std_ss[])
THEN RW_TAC std_ss[rv_to_devent_def, INTER_ASSOC]);	   

val n_AND_BIGINTER = store_thm("n_AND_BIGINTER",
  `` !p X t s.
          FINITE s /\ s <>{} /\  0 <= t  ==>
          (DFT_event p (n_AND (MAP X (SET_TO_LIST s))) t =
           BIGINTER {rv_to_devent p X t i | i IN s} ) ``,

RW_TAC std_ss[n_AND_BIGINTER_lem]
THEN KNOW_TAC(``?e:'b. s = e INSERT (s DELETE e) ``)
     THEN1 ASM_SET_TAC[]
THEN RW_TAC std_ss[]
THEN ONCE_ASM_REWRITE_TAC[]
THEN RW_TAC std_ss[rv_to_devent_def]
THEN `(e:'b) INSERT (s DELETE e)  = {e} UNION (s DELETE e)` by ASM_SET_TAC[]
THEN ONCE_ASM_REWRITE_TAC[]
THEN `{DFT_event p (X i) t | i IN {e} UNION (s DELETE e)} =
      {DFT_event p (X e) t} UNION {DFT_event p (X i) t | i IN  (s DELETE e)}` by ASM_SET_TAC[]

THEN RW_TAC std_ss[BIGINTER_UNION]
THEN RW_TAC std_ss[BIGINTER_SING]
THEN RW_TAC std_ss[DFT_event_def]
THEN ASM_SET_TAC[]);

val PROB_n_AND = store_thm("PROB_n_AND",
  `` ! p X t s. FINITE s /\ s <> {} /\  0<= t /\
                 indep_sets p (\i. {rv_to_devent p X t i}) s  ==>

( prob p (DFT_event p (n_AND (MAP X (SET_TO_LIST s))) t) =
 Normal (product s (\i. real (prob p (rv_to_devent p X t i)))))``,

RW_TAC std_ss[n_AND_BIGINTER]
THEN RW_TAC std_ss[GSYM DRBD_series_def]
THEN DEP_REWRITE_TAC[PROB_DRBD_series] 
THEN RW_TAC std_ss[]);




val PROB_n_AND_CDF = store_thm("PROB_n_AND_CDF",
  `` ! p X t s. FINITE s /\ s <> {} /\  0<= t /\
                 indep_sets p (\i. {rv_to_devent p X t i}) s /\
		 (!i. i IN s ==> rv_gt0_ninfinity [X i]) ==>

( prob p (DFT_event p (n_AND (MAP X (SET_TO_LIST s))) t) =
 Normal (product s (\i. real (CDF p (real o (X i)) t))))``,


RW_TAC std_ss[PROB_n_AND]
THEN KNOW_TAC(``!i:num. i IN s ==> (real (prob p (rv_to_devent p X t i)) =
                                  real (CDF p (real o X i) t))``)

    THEN1 (RW_TAC std_ss[] THEN FULL_SIMP_TAC std_ss[rv_gt0_ninfinity_def] THEN RW_TAC std_ss[o_DEF, CDF_prob_DFT_event, rv_to_devent_def] THEN METIS_TAC[ETA_THM])
THEN RW_TAC std_ss[th]);



val n_AND_n_OR_BIGINTER_lem1 = store_thm("n_AND_n_OR_BIGINTER_lem1",
  `` !p X t ii s.
          FINITE s /\ 0 <= t /\ s <> {} ==>
          (DFT_event p
             (n_AND
                (MAP (\i. n_OR (MAP X (SET_TO_LIST (ii i)))) (SET_TO_LIST s)))
             t =
           BIGINTER
             {rv_to_devent p (\i. n_OR (MAP X (SET_TO_LIST (ii i)))) t i |
             i IN s})``,
  RW_TAC std_ss[n_AND_BIGINTER]);



val IMAGE_EQ = store_thm("IMAGE_EQ",
  `` !X Y J . (!i. i IN J==> (Y i = X i)) ==> (IMAGE Y J = IMAGE X J)``,
RW_TAC std_ss[]
THEN RW_TAC std_ss[IMAGE_DEF]
THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
THEN EQ_TAC
THEN RW_TAC std_ss[]
THEN METIS_TAC[]);

val n_AND_n_OR_BIGINTER_BIGUNION = store_thm("n_AND_n_OR_BIGINTER_BIGUNION",
  `` !p X t J s.
         (!j. j IN J ==> FINITE (s j))/\ FINITE J /\ 0 <= t /\ J <> {} ==>
          (DFT_event p
             (n_AND
                (MAP (\j. n_OR (MAP X (SET_TO_LIST (s j)))) (SET_TO_LIST J)))
             t =
           BIGINTER
             {BIGUNION {rv_to_devent p X t i | i IN s j} |j IN J})``,


RW_TAC std_ss[n_AND_n_OR_BIGINTER_lem1]
THEN RW_TAC std_ss[rv_to_devent_def]
THEN KNOW_TAC(``!j:'c. j IN J==>  (DFT_event p (n_OR (MAP X (SET_TO_LIST ((s:'c->'b->bool) j)))) t = BIGUNION {DFT_event p (X i) t | i IN s j})``)
    THEN1 RW_TAC std_ss[n_OR_BIGUNION, rv_to_devent_def]
THEN RW_TAC std_ss[]
THEN AP_TERM_TAC
THEN RW_TAC std_ss[GSYM IMAGE_DEF]
THEN FULL_SIMP_TAC std_ss[GSYM IMAGE_DEF]
THEN RW_TAC std_ss[IMAGE_EQ]);


val n_OR_n_AND_BIGUNION_BIGINTER = store_thm("n_OR_n_AND_BIGUNION_BIGINTER",
  `` !p X t J s.
         (!j. j IN J ==> FINITE (s j) /\ ((s j) <> {}) ) /\ FINITE J/\ 0<=t   ==>
          (DFT_event p
             (n_OR
                (MAP (\j. n_AND (MAP X (SET_TO_LIST (s j)))) (SET_TO_LIST J)))
             t =
           BIGUNION
             {BIGINTER {rv_to_devent p X t i | i IN s j} |j IN J})``,


RW_TAC std_ss[n_OR_BIGUNION]
THEN RW_TAC std_ss[rv_to_devent_def]
THEN KNOW_TAC(``!j:'c. j IN J==>  (DFT_event p (n_AND (MAP X (SET_TO_LIST ((s:'c->'b->bool) j)))) t = BIGINTER {DFT_event p (X i) t | i IN s j})``)
    THEN1 RW_TAC std_ss[n_AND_BIGINTER, rv_to_devent_def]
THEN RW_TAC std_ss[]
THEN AP_TERM_TAC
THEN RW_TAC std_ss[GSYM IMAGE_DEF]
THEN FULL_SIMP_TAC std_ss[GSYM IMAGE_DEF]
THEN RW_TAC std_ss[IMAGE_EQ]);


val IMAGE_EQ2 = store_thm("IMAGE_EQ2",
  ``!Y X A J. (!a. a IN BIGUNION {A j| j IN J} ==> (Y a = X a)) ==>
(IMAGE (\j. BIGINTER (IMAGE (\i. X i) (A j))) J = IMAGE (\j. BIGINTER (IMAGE (\i. Y i) (A j)))J)``,   

RW_TAC std_ss[]
THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
THEN EQ_TAC
THEN1 ( RW_TAC std_ss[]
       THEN Q.EXISTS_TAC`j`
       THEN ASM_SET_TAC[])
THEN ASM_SET_TAC[] );      


val n_OR_AND_OR_BIGUNION_INTER_UNION = store_thm(
  "n_OR_AND_OR_BIGUNION_INTER_UNION",
  ``!p X t L A J.   FINITE J /\ (!i.  i IN J ==> FINITE (A i) /\ ((A i) <> {})) /\ (! i. i IN BIGUNION {A j | j IN J} ==> FINITE (L i)) /\  0<=t  ==>

( DFT_event p
             (n_OR
                (MAP (\j. n_AND (MAP (\i. n_OR (MAP X (SET_TO_LIST (L i)))) (SET_TO_LIST (A j)))) (SET_TO_LIST J)))
             t =
           BIGUNION
             {BIGINTER {BIGUNION {rv_to_devent p X t i | i IN L a} |a IN A j}| j IN J})``,

RW_TAC std_ss[]
THEN DEP_REWRITE_TAC[n_OR_n_AND_BIGUNION_BIGINTER]
THEN RW_TAC std_ss[]
THEN RW_TAC std_ss[rv_to_devent_def]
THEN AP_TERM_TAC
THEN KNOW_TAC(``!(a:'c). a IN BIGUNION { (A:'d->'c->bool) j | j:'d IN J} ==>
      (DFT_event p (n_OR (MAP X (SET_TO_LIST ((L:'c->'b->bool) a)))) t=
                       BIGUNION {DFT_event p (X i) t | i IN L a})``)
     THEN1 (RW_TAC std_ss[]                                                                                    THEN DEP_REWRITE_TAC[n_OR_BIGUNION]
	   THEN RW_TAC std_ss[rv_to_devent_def])
THEN RW_TAC std_ss[]
THEN RW_TAC std_ss[GSYM IMAGE_DEF]
THEN MP_TAC(Q.ISPECL[`(\a:'c.BIGUNION (IMAGE (\i:'b. DFT_event p ((X:'b->'a->extreal) i) t) ((L:'c->'b->bool) (a:'c))))`,`(\i:'c. DFT_event p (n_OR (MAP (X:'b->'a->extreal) (SET_TO_LIST ((L:'c->'b->bool) i)))) t)`, `A:'d->'c->bool`, `J:'d->bool`] IMAGE_EQ2)
THEN RW_TAC std_ss[]
THEN FULL_SIMP_TAC std_ss[IMAGE_DEF]);







(******************************************************************************)
(*                            Reliability of single path SEN                  *)
(*                                                                            *)
(*                                                                            *)
(******************************************************************************)


val sSEN_nR_AND = store_thm("sSEN_nR_AND",
  ``!p X Y Ysa Ysd t L. DISJOINT {0} L /\ FINITE L /\ L <>{} ==> (DRBD_event p
          (nR_AND (λi. if i = 0 then R_WSP Y Ysa Ysd else ((X:num->'a->extreal) i)) ({0} ∪ L)) t=
        DRBD_series
          (λi.
               event_set [(DRBD_event p (R_WSP Y Ysa Ysd) t,0)]
                 (rv_to_event p X t) i) ({0} UNION L))``,
RW_TAC std_ss[]
THEN `FINITE {0:num}` by ASM_SET_TAC[FINITE_SING]
THEN `FINITE ({0} UNION L)` by ASM_SET_TAC[FINITE_UNION]
THEN `{0:num} UNION L <> {}` by ASM_SET_TAC[]
THEN RW_TAC std_ss[nR_AND_DRBD_series]
THEN RW_TAC std_ss[rv_to_event_def, event_set_def, event_set1_def]
THEN RW_TAC std_ss[DRBD_series_def]
THEN ASM_SET_TAC[]);


val Rel_sSEN = store_thm("Rel_sSEN",
  `` !p X Y Ysa Ysd t L. DISJOINT {0} L /\ FINITE L /\ L <> {} /\
        indep_sets p
              (\i.
                   {event_set [(DRBD_event p (R_WSP Y Ysa Ysd) t,0)]
                 (rv_to_event p X t) i}) ({0} UNION L) ==>

(prob p (DRBD_event p
             (nR_AND (\i. if i = 0 then R_WSP Y Ysa Ysd else (X:num->'a->extreal) i)
                ({0} UNION L)) t) =
  Rel p (R_WSP Y Ysa Ysd) t  *
       Normal (product L (\l. real (Rel p (X l) t) )))``,

RW_TAC std_ss[sSEN_nR_AND, Rel_def]
THEN DEP_REWRITE_TAC[PROB_DRBD_series]
THEN RW_TAC std_ss[]
THEN1 ASM_SET_TAC[]
THEN1 ASM_SET_TAC[FINITE_SING, FINITE_UNION]
THEN `FINITE{0:num}` by ASM_SET_TAC[FINITE_SING]
THEN RW_TAC std_ss[PRODUCT_UNION]
THEN RW_TAC std_ss[PRODUCT_SING]
THEN RW_TAC std_ss[event_set_def, event_set1_def]
THEN KNOW_TAC(``!i:num. i IN L ==> 
             (real
               (prob p
                  (if i = 0 then DRBD_event p (R_WSP Y Ysa Ysd) t
                   else rv_to_event p X t i)) =
		   
             real
               (prob p
                  ( rv_to_event p X t i)))``)
     THEN1( RW_TAC std_ss[]
            THEN ASM_SET_TAC[DISJOINT_DEF])
THEN DISCH_TAC
THEN KNOW_TAC(``product L
        (\i:num.
             real
               (prob p
                  (if i = 0 then DRBD_event p (R_WSP Y Ysa Ysd) t
                   else rv_to_event p X t i))) =
		   product L
        (\i.
             real
               (prob p
                  (rv_to_event p X t i)))``)
     THEN1 RW_TAC std_ss[th]	    
THEN RW_TAC std_ss[]
THEN RW_TAC std_ss[GSYM extreal_mul_def]
THEN KNOW_TAC(``(DRBD_event p (R_WSP (Y:'a->extreal) Ysa Ysd) t) IN events p ``)
     THEN1(FULL_SIMP_TAC std_ss[indep_sets]
           THEN FULL_SIMP_TAC std_ss[event_set_def, event_set1_def]
	   THEN UNDISCH_TAC(`` !i:num.
             i IN {0} UNION L ==>
             {if i = 0 then DRBD_event p (R_WSP Y Ysa Ysd) t
              else rv_to_event p X t i} SUBSET events p ``)
	   THEN DISCH_TAC
	   THEN POP_ASSUM (MP_TAC o Q.SPEC `0:num`)
	   THEN ASM_SET_TAC[])
THEN DISCH_TAC	   
THEN `prob p (DRBD_event p (R_WSP Y Ysa Ysd) t) <> PosInf /\ prob p (DRBD_event p (R_WSP Y Ysa Ysd) t)<> NegInf` by METIS_TAC[PROB_FINITE, indep_sets]
THEN RW_TAC std_ss[normal_real, rv_to_event_def]);


val PROB_sSEN_DFT = store_thm("PROB_sSEN_DFT",
  ``!p X Y Ysa Ysd t L. DISJOINT {0} L /\ FINITE L /\ L <> {} /\
    indep_sets p
     (\i. {rv_to_devent p (\i. if i = 0 then WSP Y Ysa Ysd else X i) t i})
     ({0} UNION L)  ==> (prob p (DFT_event p (n_OR (MAP (\i. if i = 0 then WSP Y Ysa Ysd else (X:num->'a->extreal) i) (SET_TO_LIST ({0} UNION L)))) t) =
     1 -
   (1 - prob p (DFT_event p (WSP Y Ysa Ysd) t)) *
   Normal (product L (\i. real (1 - prob p (DFT_event p (X i) t)))))``,

RW_TAC std_ss[]
THEN DEP_REWRITE_TAC [PROB_n_OR]
THEN RW_TAC std_ss[]
THEN1 ASM_SET_TAC[]
THEN1 ASM_SET_TAC[FINITE_SING, FINITE_UNION]
THEN `FINITE {0:num}` by ASM_SET_TAC[FINITE_SING]
THEN RW_TAC std_ss[PRODUCT_UNION]
THEN RW_TAC std_ss[PRODUCT_SING]
THEN RW_TAC std_ss[rv_to_devent_def]
THEN KNOW_TAC(``!i:num. i IN L ==>
               (
             real
               (1 -
                prob p
                  (DFT_event p (if i = 0 then WSP Y Ysa Ysd else X i) t)) =
		 
             real
               (1 -
                prob p
                  (DFT_event p (X i) t))) ``)

     THEN1 ASM_SET_TAC[]

THEN RW_TAC std_ss[]
THEN KNOW_TAC(``product L
        (\i:num.
             real
               (1 -
                prob p
                  (DFT_event p (if i = 0 then WSP Y Ysa Ysd else X i) t))) =
		  product L
        (\i.
             real
               (1 -
                prob p
                  (DFT_event p ( X i) t)))``)
    THEN1 RW_TAC std_ss[th]
     
THEN RW_TAC std_ss[]
THEN KNOW_TAC(``DFT_event p (WSP Y Ysa Ysd) t IN events p ``)
     THEN1(FULL_SIMP_TAC std_ss[indep_sets]
           THEN UNDISCH_TAC(`` !i:num.
             i IN {0} UNION L ==>
             {rv_to_devent p (\i. if i = 0 then WSP Y Ysa Ysd else X i) t i} SUBSET
             events p``)
	   THEN  DISCH_TAC
 	   THEN POP_ASSUM (MP_TAC o Q.SPEC `0:num`)
	   THEN ASM_SET_TAC[rv_to_devent_def])
THEN RW_TAC std_ss[]
THEN `prob p (DFT_event p (WSP Y Ysa Ysd) t) <> PosInf /\
      prob p (DFT_event p (WSP Y Ysa Ysd) t) <> NegInf` by FULL_SIMP_TAC std_ss[PROB_FINITE, indep_sets]	   
THEN RW_TAC std_ss[normal_real]
THEN `1 <> PosInf /\ 1 <> NegInf` by METIS_TAC[extreal_not_infty, extreal_of_num_def]
THEN RW_TAC std_ss[GSYM extreal_mul_def]
THEN RW_TAC std_ss[normal_real, sub_not_infty, extreal_not_infty]);




val PROB_sSEN_DFT_CDF_lem = store_thm("PROB_sSEN_DFT_CDF_lem",
  ``!p X Y Ysa Ysd t L. DISJOINT {0} L /\ FINITE L /\ L <> {} /\
    indep_sets p
     (\i. {rv_to_devent p (\i. if i = 0 then WSP Y Ysa Ysd else X i) t i})
     ({0} UNION L) /\
     (!i:num. i IN L ==> rv_gt0_ninfinity [X i])

 ==> (prob p (DFT_event p (n_OR (MAP (\i. if i = 0 then WSP Y Ysa Ysd else (X:num->'a->extreal) i) (SET_TO_LIST ({0} UNION L)))) t) =
     1 -
   (1 - prob p (DFT_event p (WSP Y Ysa Ysd) t)) *
   Normal (product L (\i. real (1 - CDF p (real o (X i)) t))))``,

RW_TAC std_ss[PROB_sSEN_DFT]
THEN KNOW_TAC(`` !i:num. i IN L ==> (real (1 - prob p (DFT_event p (X i) t)) =
                                  real (1 - CDF p (real o X i) t))``)
     THEN1(RW_TAC std_ss[]
           THEN FULL_SIMP_TAC std_ss[rv_gt0_ninfinity_def]
           THEN RW_TAC std_ss[CDF_prob_DFT_event, o_DEF]
	   THEN METIS_TAC[ETA_THM])
THEN RW_TAC std_ss[]	   
THEN `product L (\i. real (1 - prob p (DFT_event p (X i) t))) =
      product L (\i. real (1 - CDF p (real o X i) t))` by RW_TAC std_ss[th] 

THEN RW_TAC std_ss[]);


val PROB_sSEN_DFT_CDF = store_thm("PROB_sSEN_DFT_CDF",
  ``!p X Y Ysa Ysd t L. DISJOINT {0} L /\ FINITE L /\ L <> {} /\
    indep_sets p
     (\i. {event_set [(DFT_event p (WSP Y Ysa Ysd ) t ,0)] (rv_to_devent p X t ) i})
     ({0} UNION L) /\
     (!i:num. i IN L ==> rv_gt0_ninfinity [X i])

 ==> (prob p (DFT_event p (n_OR (MAP (\i. if i = 0 then WSP Y Ysa Ysd else (X:num->'a->extreal) i) (SET_TO_LIST ({0} UNION L)))) t) =
     1 -
   (1 - prob p (DFT_event p (WSP Y Ysa Ysd) t)) *
   Normal (product L (\i. real (1 - CDF p (real o (X i)) t))))``,


RW_TAC std_ss[event_set_def, event_set1_def]
THEN DEP_REWRITE_TAC[PROB_sSEN_DFT_CDF_lem]
THEN RW_TAC std_ss[]
THEN KNOW_TAC(`` !i:num.  {if i = 0 then DFT_event p (WSP Y Ysa Ysd) t
                 else rv_to_devent p X t i} =
		  {rv_to_devent p (\i. if i = 0 then WSP Y Ysa Ysd else X i) t i}``)
     THEN1(RW_TAC std_ss[rv_to_devent_def])
THEN RW_TAC std_ss[]
THEN FULL_SIMP_TAC std_ss[]);




(******************************************************************************)
(*                                                                            *)
(*                      Reliability of SEN+                                   *)
(*                                                                            *)
(******************************************************************************)


val DISJOINT3_def = Define `DISJOINT3 L1 L2 L3 =
                            DISJOINT L1 L2 /\ DISJOINT L1 L3 /\ DISJOINT L2 L3`;

val PROB_DRBD_SEN_plus_lem1 = store_thm("PROB_DRBD_SEN_plus_lem1",
  `` !p X L1 L2 L A J.
            L1 <> {} /\ L2 <> {} /\ FINITE L1 /\ FINITE L2 /\
            (!l. l IN BIGUNION_o_BIGUNION L A J ==> X l IN events p) /\
            indep_sets p (\i. {X i}) (BIGUNION_o_BIGUNION L A J) /\
            disjoint_family_on (ind_set [{0}; L1; L2; {3}]) {0; 1; 2; 3} /\
            (J = {0; 1; 2}) /\ (A = ind_set [{0}; {1; 2}; {3}]) /\
            (L = ind_set [{0}; L1; L2; {3}]) ==>
            (prob p
               (DRBD_series
                  (\j. DRBD_parallel (\a. DRBD_series X (L a)) (A j)) J) =
             prob p (X 0) * prob p (X 3) *
             (1 -
              (1 - Normal (product L1 (\l. real (prob p (X l))))) *
              (1 - Normal (product L2 (\l. real (prob p (X l)))))))``,
    
RW_TAC std_ss[disjoint_family_on]
THEN KNOW_TAC(``DISJOINT3 {0;3:num} L1 L2 ``)
     THEN1(RW_TAC std_ss[DISJOINT3_def]
           THEN1( FULL_SIMP_TAC std_ss[ind_set_def]
	         THEN KNOW_TAC(`` {0:num} INTER L1 = {}``)
    	              THEN1(POP_ASSUM (MP_TAC o Q.SPEC `0:num `)
	                   THEN DISCH_TAC
	              	   THEN POP_ASSUM (MP_TAC o Q.SPEC `1:num `)
		      	   THEN RW_TAC list_ss[])
	         THEN DISCH_TAC	       
                 THEN KNOW_TAC(`` {3:num} INTER L1 = {}``)
    	              THEN1(POP_ASSUM MP_TAC
		            THEN POP_ASSUM (MP_TAC o Q.SPEC `3:num `)
	              	    THEN DISCH_TAC
	              	    THEN POP_ASSUM (MP_TAC o Q.SPEC `1:num `)
		      	    THEN RW_TAC list_ss[])
	         THEN DISCH_TAC THEN ASM_SET_TAC[DISJOINT_DEF])
	    THEN1(FULL_SIMP_TAC std_ss[ind_set_def]
	         THEN KNOW_TAC(`` {0:num} INTER L2 = {}``)
    	              THEN1(POP_ASSUM (MP_TAC o Q.SPEC `0:num `)
	                   THEN DISCH_TAC
	              	   THEN POP_ASSUM (MP_TAC o Q.SPEC `2:num `)
		      	   THEN RW_TAC list_ss[])
	         THEN DISCH_TAC	       
                 THEN KNOW_TAC(`` {3:num} INTER L2 = {}``)
    	              THEN1(POP_ASSUM MP_TAC
		            THEN POP_ASSUM (MP_TAC o Q.SPEC `3:num `)
	              	    THEN DISCH_TAC
	              	    THEN POP_ASSUM (MP_TAC o Q.SPEC `2:num `)
		      	    THEN RW_TAC list_ss[])
	         THEN DISCH_TAC THEN ASM_SET_TAC[DISJOINT_DEF])
	    THEN POP_ASSUM (MP_TAC o Q.SPEC `2:num `)
	    THEN DISCH_TAC
	    THEN POP_ASSUM (MP_TAC o Q.SPEC `1:num `)
     	    THEN RW_TAC list_ss[]
	    THEN FULL_SIMP_TAC list_ss[ind_set_def]
	    THEN ASM_SET_TAC[DISJOINT_DEF])
THEN RW_TAC std_ss[DISJOINT3_def]
THEN KNOW_TAC(``BIGUNION {EL j [{0:num}; {1; 2}; {3}] | j IN {0; 1; 2:num}} = {0;1;2;3} ``)
     THEN1( SRW_TAC[][GSPECIFICATION, EXTENSION]
            THEN EQ_TAC
                THEN1(RW_TAC std_ss[]
      		      THEN FULL_SIMP_TAC list_ss[])
         	 THEN RW_TAC std_ss[]
		      THEN1( Q.EXISTS_TAC`{0}` THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[] 
	                    THEN Q.EXISTS_TAC`0` THEN RW_TAC std_ss[]
			    THEN RW_TAC list_ss[])
	 	      THEN1( Q.EXISTS_TAC`{1;2}` THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
	                    THEN Q.EXISTS_TAC`1` THEN RW_TAC std_ss[]
	   	            THEN RW_TAC list_ss[])
		      THEN1( Q.EXISTS_TAC`{1;2}` THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
		             THEN Q.EXISTS_TAC`1` THEN RW_TAC std_ss[]
		             THEN RW_TAC list_ss[])
           THEN Q.EXISTS_TAC`{3}` THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
     	   THEN Q.EXISTS_TAC`2` THEN RW_TAC list_ss[])
THEN DISCH_TAC
THEN DEP_REWRITE_TAC[PROB_DRBD_series_parallel_series_lem]
THEN RW_TAC std_ss[]
     THEN1 ASM_SET_TAC[]
     THEN1 (RW_TAC std_ss[sets_finite_not_empty2_def]
            THEN1(RW_TAC std_ss[ind_set_def]
	          THEN `(j=0:num) \/(j=1) \/(j=2)` by ASM_SET_TAC[]
		  THEN RW_TAC list_ss[] THEN ASM_SET_TAC[])
            THEN1(RW_TAC std_ss[ind_set_def]
	          THEN `(j=0:num) \/(j=1) \/(j=2)` by ASM_SET_TAC[]
	               THEN1( RW_TAC list_ss[] THEN ASM_SET_TAC[FINITE_SING])
		       THEN1(RW_TAC list_ss[] THEN `{1:num;2} = {1} UNION {2}` by ASM_SET_TAC[]
		            THEN ONCE_ASM_REWRITE_TAC[] THEN ASM_SET_TAC[FINITE_SING, FINITE_UNION])
		  THEN RW_TAC list_ss[] THEN ASM_SET_TAC[FINITE_SING])
 	    THEN1( RW_TAC std_ss [ind_set_def]
	           THEN FULL_SIMP_TAC std_ss[ind_set_def]
		   THEN`(a:num = 0) \/ (a = 1) \/ (a = 2) \/ (a = 3)` by ASM_SET_TAC[]
		   THEN RW_TAC list_ss[] THEN ASM_SET_TAC[])
	    THEN1(RW_TAC std_ss[ind_set_def] THEN FULL_SIMP_TAC std_ss[ind_set_def]
	         THEN `(a:num = 0) \/ (a = 1) \/ (a = 2) \/ (a = 3)` by ASM_SET_TAC[]
		      THEN1(RW_TAC list_ss[] THEN ASM_SET_TAC[FINITE_SING])
		      THEN1(RW_TAC list_ss[])
		      THEN1(RW_TAC list_ss[])
		 THEN RW_TAC list_ss[]  THEN ASM_SET_TAC[FINITE_SING])
	    THEN1( `{0:num;1;2} = {0} UNION {1} UNION {2}` by ASM_SET_TAC[]
	          THEN ONCE_ASM_REWRITE_TAC[] THEN ASM_SET_TAC[FINITE_SING, FINITE_UNION])
            THEN1( RW_TAC std_ss[ind_set_def] THEN RW_TAC std_ss[disjoint_family_on]
	         THEN `((j = 0:num) \/ (j = 1) \/ (j=2)) /\ ((j'=0:num) \/ (j'=1)\/(j'=2))` by ASM_SET_TAC[]
		      THEN1(FULL_SIMP_TAC std_ss[])
		      THEN1(RW_TAC list_ss[] THEN ASM_SET_TAC[])
		      THEN1(RW_TAC list_ss[] THEN ASM_SET_TAC[])
	              THEN1(RW_TAC list_ss[] THEN ASM_SET_TAC[])
	              THEN1(FULL_SIMP_TAC std_ss[])
		      THEN1(RW_TAC list_ss[] THEN ASM_SET_TAC[])
		      THEN1(RW_TAC list_ss[] THEN ASM_SET_TAC[])
		      THEN1(RW_TAC list_ss[] THEN ASM_SET_TAC[])
	          THEN FULL_SIMP_TAC std_ss[])
            THEN1(ASM_SET_TAC[])
            THEN RW_TAC std_ss[disjoint_family_on, ind_set_def]	            
            THEN PSET_TAC[] THEN RW_TAC list_ss[] THEN ASM_SET_TAC[])
THEN `{0;1;2:num} = {0} UNION {1;2}` by ASM_SET_TAC[]		 
THEN ONCE_ASM_REWRITE_TAC[]
THEN KNOW_TAC(``FINITE {0:num} /\ FINITE {1;2:num} /\ DISJOINT {0:num} {1;2}``)
     THEN1(RW_TAC std_ss[FINITE_SING]
         THEN1(`{1;2:num} = {1} UNION {2}` by ASM_SET_TAC[]
            THEN ONCE_ASM_REWRITE_TAC[] THEN ASM_SET_TAC[FINITE_SING, FINITE_UNION])
     THEN ASM_SET_TAC[DISJOINT_DEF])	    
THEN RW_TAC std_ss[PRODUCT_UNION]
THEN RW_TAC std_ss[PRODUCT_SING]
THEN KNOW_TAC(``ind_set [{0}; {1; 2}; {3}] 0 = {0} ``)
    THEN1(RW_TAC std_ss[ind_set_def]
          THEN RW_TAC list_ss[])
THEN RW_TAC std_ss[]	  
THEN ONCE_ASM_REWRITE_TAC[]
THEN KNOW_TAC(``
      real
        (1 -
         Normal(product (ind_set [{0}; {1; 2}; {3}] 0)
              (\a.
                   real
                     (1 -
                      Normal
                        (product (ind_set [{0}; (L1:num->bool); L2; {3}] a)
                           (\l. real (1 - Normal (real (1 - prob p (X l)))))))))) =
     real (1-Normal (real (1 - Normal (real (1 - Normal (real (1 - prob p (X 0))))))) ) ``)

    THEN1(NTAC 3(AP_TERM_TAC)
          THEN ONCE_ASM_REWRITE_TAC[]
	  THEN KNOW_TAC(`` product (ind_set [{0}; {1; 2}; {3}] 0)
     (\a.
          real
            (1 -
             Normal
               (product (ind_set [{0}; L1; L2; {3:num}] a)
                  (\l. real (1 - Normal (real (1 - prob p (X l))))))))  =
		   product ({0})
     (\a.
          real
            (1 -
             Normal
               (product (ind_set [{0}; L1; L2; {3}] a)
                  (\l. real (1 - Normal (real (1 - prob p (X l))))))))``)
	      THEN1(RW_TAC std_ss[ind_set_def] THEN RW_TAC list_ss[])
	  THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]    
	  THEN RW_TAC std_ss[PRODUCT_SING]
	  THEN RW_TAC std_ss[ind_set_def]
          THEN RW_TAC list_ss[]
	  THEN RW_TAC std_ss[PRODUCT_SING])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]	  
THEN `({1:num;2} = {1} UNION {2}) /\ FINITE {1:num} /\ FINITE {2:num} /\ DISJOINT {1:num}{2}` by ASM_SET_TAC[FINITE_SING, DISJOINT_DEF]
THEN RW_TAC std_ss[PRODUCT_UNION, PRODUCT_SING]
THEN RW_TAC list_ss[ind_set_def, PRODUCT_SING]
THEN KNOW_TAC(``
      real
         (1 -
          Normal
            (product ({1} UNION {2})
               (\a.
                    real
                      (1 -
                       Normal
                         (product (EL a [{0}; L1; L2; {3:num}])
                            (\l. real (1 - Normal (real (1 - prob p ((X:num->'a->bool) l)))))))))) =
       real
          (1 -
           Normal
             (real
                (1 -
                 Normal
                   (product L1
                      (\l. real (1 - Normal (real (1 - prob p (X l))))))) *
              real
                (1 -
                 Normal
                   (product L2
                      (\l. real (1 - Normal (real (1 - prob p (X l)))))))))``)
     THEN1(NTAC 3(AP_TERM_TAC)
           THEN RW_TAC std_ss[PRODUCT_UNION, PRODUCT_SING]
	   THEN RW_TAC list_ss[])
THEN RW_TAC std_ss[]	   
THEN KNOW_TAC(``prob p ((X:num->'a->bool) 0) <> PosInf /\ prob p (X 0) <> NegInf ``)
     THEN1(KNOW_TAC(`` 0:num IN BIGUNION_o_BIGUNION (ind_set [{0}; L1; L2; {3}])
               (ind_set [{0}; {1; 2}; {3}]) {0; 1; 2:num}``)
           THEN1(RW_TAC std_ss[ind_set_def, BIGUNION_o_BIGUNION_def]
                 THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
   	         THEN Q.EXISTS_TAC`{0}`
	         THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
	 	 THEN Q.EXISTS_TAC`0` THEN RW_TAC list_ss[]
		 THEN Q.EXISTS_TAC`{0}` THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
 		 THEN Q.EXISTS_TAC`0` THEN RW_TAC list_ss[])
		 THEN DISCH_TAC THEN `(X:num->'a->bool) 0 IN events p` by ASM_SET_TAC[]
		 THEN `prob_space p` by FULL_SIMP_TAC std_ss[indep_sets]
		 THEN METIS_TAC[PROB_FINITE])
THEN DISCH_TAC
THEN `1 <> PosInf /\ 1 <> NegInf` by METIS_TAC[extreal_of_num_def, extreal_not_infty]
THEN KNOW_TAC(``prob p ((X:num->'a->bool) 3) <> PosInf /\ prob p (X 3) <> NegInf ``)
     THEN1(KNOW_TAC(`` 3:num IN BIGUNION_o_BIGUNION (ind_set [{0}; L1; L2; {3}])
               (ind_set [{0}; {1; 2}; {3}]) {0; 1; 2:num}``)
           THEN1(RW_TAC std_ss[ind_set_def, BIGUNION_o_BIGUNION_def]
                 THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
	         THEN Q.EXISTS_TAC`{3}`
		 THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
		 THEN Q.EXISTS_TAC`3` THEN RW_TAC list_ss[]
		 THEN Q.EXISTS_TAC`{3}` THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
 		 THEN Q.EXISTS_TAC`2` THEN RW_TAC list_ss[])
	   THEN DISCH_TAC	 
	   THEN  `(X:num->'a->bool) 3 IN events p` by ASM_SET_TAC[]
	   THEN `prob_space p` by FULL_SIMP_TAC std_ss[indep_sets]
	   THEN METIS_TAC[PROB_FINITE])
THEN DISCH_TAC
	   	 
THEN KNOW_TAC(`` 
     (real
        (1 -
         Normal
           (real (1 - Normal (real (1 - Normal (real (1 - prob p ((X:num->'a->bool) 0))))))))) =
	   real (prob p (X 0)) ``)
      THEN1(AP_TERM_TAC
	    THEN KNOW_TAC(`` Normal (real (1 - prob p ((X:num->'a->bool) 0))) = 1-prob p (X 0) ``)
                 THEN1(METIS_TAC[sub_not_infty, normal_real])
	    THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
	    THEN KNOW_TAC(``(1 - (1 - prob p (X 0))) = prob p ((X:num->'a->bool) 0) ``)
		THEN1(METIS_TAC[extreal_sub_sub2])
	    THEN RW_TAC std_ss[]
	    THEN RW_TAC std_ss[normal_real])
THEN RW_TAC std_ss[]	    
THEN KNOW_TAC(``
       real
          (1 -
          Normal
            (real (1 - Normal (real (1 - Normal (real (1 - prob p (X 3)))))))) =
      real (prob p ((X:num->'a->bool) 3))``)
      THEN1( KNOW_TAC(`` Normal (real (1 - prob p (X 3))) = (1-prob p ((X:num->'a->bool) 3)) ``) 
	        THEN1 METIS_TAC[sub_not_infty, normal_real]
	   THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
	   THEN KNOW_TAC(``(1 - (1 - prob p (X 3))) = prob p ((X:num->'a->bool) 3) ``)
		THEN1(METIS_TAC[extreal_sub_sub2])
	    THEN RW_TAC std_ss[]
	    THEN RW_TAC std_ss[normal_real])
THEN RW_TAC std_ss[]
THEN RW_TAC std_ss[REAL_MUL_ASSOC]
THEN RW_TAC std_ss[normal_real_mul3]
THEN KNOW_TAC(``(product L1
                    (\l. real (1 - Normal (real (1 - prob p ((X:num->'a->bool) l)))))) =
		(product L1
                    (\l. real (prob p (X l))))``)
      THEN1(KNOW_TAC(``
          !l:num.
	     l IN L1 ==> (real (1 - Normal (real (1 - prob p ((X:num->'a->bool) l)))) =
             real (prob p ((X:num->'a->bool)l)))``)
	     THEN1(RW_TAC std_ss[]
	           THEN KNOW_TAC(``prob p ((X:num->'a->bool)l ) <> PosInf /\
		                   prob p (X l) <> NegInf ``)
		        THEN1(KNOW_TAC(`` l:num IN BIGUNION_o_BIGUNION (ind_set [{0}; L1; L2; {3}])
               (ind_set [{0}; {1; 2}; {3}]) {0; 1; 2:num}``)
                              THEN1(RW_TAC std_ss[ind_set_def, BIGUNION_o_BIGUNION_def]
                 	            THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
   	         		    THEN Q.EXISTS_TAC`L1`
	         		    THEN RW_TAC std_ss[] 
	 	 		    THEN Q.EXISTS_TAC`1` THEN RW_TAC list_ss[]
		 		    THEN Q.EXISTS_TAC`{1;2}` THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
 		 		    THEN Q.EXISTS_TAC`1` THEN RW_TAC list_ss[])
		 	     THEN DISCH_TAC THEN `(X:num->'a->bool) l IN events p` by ASM_SET_TAC[]
		 	     THEN `prob_space p` by FULL_SIMP_TAC std_ss[indep_sets]
		 	     THEN METIS_TAC[PROB_FINITE])
		   THEN DISCH_TAC
		   THEN KNOW_TAC(``(1 - (1 - prob p (X l))) = prob p ((X:num->'a->bool) l) ``)
		        THEN1(METIS_TAC[extreal_sub_sub2])
	           THEN RW_TAC std_ss[]
	           THEN RW_TAC std_ss[normal_real]
		   THEN METIS_TAC[sub_not_infty, normal_real])
	    THEN DISCH_TAC THEN RW_TAC std_ss[th])
THEN RW_TAC std_ss[]	    
THEN KNOW_TAC(``(product L2
                    (\l. real (1 - Normal (real (1 - prob p ((X:num->'a->bool) l)))))) =
		(product L2
                    (\l. real (prob p (X l))))``)
      THEN1(KNOW_TAC(``
            !l:num.
	      l IN L2 ==>
	      (real (1 - Normal (real (1 - prob p ((X:num->'a->bool) l)))) =
               real (prob p ((X:num->'a->bool)l)))``)
	     THEN1(RW_TAC std_ss[]
	           THEN KNOW_TAC(``prob p ((X:num->'a->bool)l ) <> PosInf /\
		                   prob p (X l) <> NegInf ``)
		        THEN1(KNOW_TAC(`` l:num IN BIGUNION_o_BIGUNION (ind_set [{0}; L1; L2; {3}])
               (ind_set [{0}; {1; 2}; {3}]) {0; 1; 2:num}``)
                              THEN1(RW_TAC std_ss[ind_set_def, BIGUNION_o_BIGUNION_def]
                 	            THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
   	         		    THEN Q.EXISTS_TAC`L2`
	         		    THEN RW_TAC std_ss[] 
	 	 		    THEN Q.EXISTS_TAC`2` THEN RW_TAC list_ss[]
		 		    THEN Q.EXISTS_TAC`{1;2}` THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
 		 		    THEN Q.EXISTS_TAC`1` THEN RW_TAC list_ss[])
		 	     THEN DISCH_TAC THEN `(X:num->'a->bool) l IN events p` by ASM_SET_TAC[]
		 	     THEN `prob_space p` by FULL_SIMP_TAC std_ss[indep_sets]
		 	     THEN METIS_TAC[PROB_FINITE])
		   THEN DISCH_TAC
		   THEN KNOW_TAC(``(1 - (1 - prob p (X l))) = prob p ((X:num->'a->bool) l) ``)
		        THEN1(METIS_TAC[extreal_sub_sub2])
	           THEN RW_TAC std_ss[]
	           THEN RW_TAC std_ss[normal_real]
		   THEN METIS_TAC[sub_not_infty, normal_real])
	    THEN DISCH_TAC THEN RW_TAC std_ss[th])
THEN RW_TAC std_ss[]
THEN `(1 − Normal (product L1 (λl. real (prob p ((X:num->'a->bool) l))))) <> PosInf /\
      (1 − Normal (product L1 (λl. real (prob p (X l))))) <> NegInf` by METIS_TAC[sub_not_infty, extreal_not_infty]
THEN  `(1 − Normal (product L2 (λl. real (prob p ((X:num->'a->bool) l))))) <> PosInf /\
       (1 − Normal (product L2 (λl. real (prob p (X l))))) <> NegInf` by METIS_TAC[sub_not_infty, extreal_not_infty]
THEN RW_TAC std_ss[real_mul_real]
THEN `((1 − Normal (product L1 (λl. real (prob p ((X:num->'a->bool) l))))) *
               (1 − Normal (product L2 (λl. real (prob p (X l)))))) <> PosInf /\
	       ((1 − Normal (product L1 (λl. real (prob p (X l))))) *
               (1 − Normal (product L2 (λl. real (prob p (X l)))))) <> NegInf` by METIS_TAC[mul_extreal_not_infty]
THEN RW_TAC std_ss[normal_real]
THEN `(1 −
         (1 − Normal (product L1 (λl. real (prob p ((X:num->'a->bool) l))))) *
         (1 − Normal (product L2 (λl. real (prob p (X l)))))) <> PosInf /\
      (1 −
         (1 − Normal (product L1 (λl. real (prob p (X l))))) *
         (1 − Normal (product L2 (λl. real (prob p (X l)))))) <> NegInf` by METIS_TAC[sub_not_infty]THEN RW_TAC std_ss[normal_real]);	 


val PROB_DRBD_SEN_plus = store_thm("PROB_DRBD_SEN_plus",
  `` !p X Y Z t L1 L2 L A J.
            L1 <> {} /\ L2 <> {} /\ FINITE L1 /\ FINITE L2 /\
            (!l.
                 l IN BIGUNION_o_BIGUNION L A J ==>
                 event_set [(DRBD_event p Y t,0); (DRBD_event p Z t,3)] X l IN
                 events p) /\
            indep_sets p
              (\i.
                   {event_set [(DRBD_event p Y t,0); (DRBD_event p Z t,3)] X
                      i}) (BIGUNION_o_BIGUNION L A J) /\
            disjoint_family_on (ind_set [{0}; L1; L2; {3}]) {0; 1; 2; 3} /\
            (J = {0; 1; 2}) /\ (A = ind_set [{0}; {1; 2}; {3}]) /\
            (L = ind_set [{0}; L1; L2; {3}]) ==>
            (prob p
               (DRBD_series
                  (\j.
                       DRBD_parallel
                         (\a.
                              DRBD_series
                                (\i.
                                     event_set
                                       [(DRBD_event p Y t,0);
                                        (DRBD_event p Z t,3)] X i) (L a))
                         (A j)) J) =
             prob p (DRBD_event p Y t) * prob p (DRBD_event p Z t) *
             (1 -
              (1 - Normal (product L1 (\l. real (prob p (X l))))) *
              (1 - Normal (product L2 (\l. real (prob p (X l)))))))``,

RW_TAC std_ss[event_set_def, event_set1_def]
THEN DEP_REWRITE_TAC[PROB_DRBD_SEN_plus_lem1]
THEN RW_TAC std_ss[]
     THEN1 ASM_SET_TAC[ETA_THM]
     THEN1 (UNDISCH_TAC(`` !l:num.
             l IN
             BIGUNION_o_BIGUNION (ind_set [{0}; L1; L2; {3}])
               (ind_set [{0}; {1; 2}; {3}]) {0; 1; 2} ==>
             (if l = 0 then DRBD_event p Y t
              else if l = 3 then DRBD_event p Z t
              else X l) IN events p``)
	    THEN DISCH_TAC   
	    THEN POP_ASSUM (MP_TAC o Q.ISPEC`3:num`)
	    THEN RW_TAC std_ss[]
	    THEN METIS_TAC[ETA_THM])
    THEN1 ASM_SET_TAC[ETA_THM]
    THEN1 ASM_SET_TAC[ETA_THM]
    THEN1 ASM_SET_TAC[ETA_THM]
    THEN1 ASM_SET_TAC[ETA_THM]
THEN RW_TAC std_ss[]    
THEN KNOW_TAC(``{0:num} INTER L1 = {} ``)
     THEN1 (FULL_SIMP_TAC std_ss[disjoint_family_on, ind_set_def]
            THEN POP_ASSUM (MP_TAC o Q.SPEC `0:num `)
            THEN DISCH_TAC
       	    THEN POP_ASSUM (MP_TAC o Q.SPEC `1:num `)
	    THEN RW_TAC list_ss[])
THEN KNOW_TAC(``{3:num} INTER L1 = {} ``)
     THEN1 (FULL_SIMP_TAC std_ss[disjoint_family_on, ind_set_def]
            THEN POP_ASSUM (MP_TAC o Q.SPEC `3:num `)
            THEN DISCH_TAC
       	    THEN POP_ASSUM (MP_TAC o Q.SPEC `1:num `)
	    THEN RW_TAC list_ss[])
THEN RW_TAC std_ss[]
THEN KNOW_TAC(`` !i:num. i IN L1 ==>
                (real
                 (prob p
                    (if i = 0 then DRBD_event p Y t
                     else if i = 3 then DRBD_event p Z t
                     else (X:num->'a->bool) i)) =
		 real (prob p (X i))) ``)
      THEN1(RW_TAC std_ss[] THEN ASM_SET_TAC[])
THEN RW_TAC std_ss[]
THEN KNOW_TAC(``
     (1 -
     Normal
       (product L1
          (\i.
               real
                 (prob p
                    (if i = 0 then DRBD_event p Y t
                     else if i = 3 then DRBD_event p Z t
                     else (X:num->'a->bool) i))))) =

     (1 -
     Normal
       (product L1
          (\i.
               real
                 (prob p
                     (X i)))))``)
      THEN1 (NTAC 2(AP_TERM_TAC) THEN  RW_TAC std_ss[th])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]      
THEN KNOW_TAC(``{0:num} INTER L2 = {} ``)
     THEN1 (FULL_SIMP_TAC std_ss[disjoint_family_on, ind_set_def]
            THEN UNDISCH_TAC (``!m n:num.
             m IN {0; 1; 2; 3} /\ n IN {0; 1; 2; 3} /\ m <> n ==>
             (EL m [{0:num}; L1; L2; {3}] INTER EL n [{0}; L1; L2; {3}] = {})``)
	    THEN DISCH_TAC
 	    THEN POP_ASSUM (MP_TAC o Q.SPEC `0:num `)
            THEN DISCH_TAC
       	    THEN POP_ASSUM (MP_TAC o Q.SPEC `2:num `)
	    THEN RW_TAC list_ss[])
THEN DISCH_TAC	    
THEN KNOW_TAC(``{3:num} INTER L2 = {} ``)
     THEN1 (FULL_SIMP_TAC std_ss[disjoint_family_on, ind_set_def]
     	    THEN UNDISCH_TAC (``!m n:num.
             m IN {0; 1; 2; 3} /\ n IN {0; 1; 2; 3} /\ m <> n ==>
             (EL m [{0:num}; L1; L2; {3}] INTER EL n [{0}; L1; L2; {3}] = {})``)
	    THEN DISCH_TAC
 	    THEN POP_ASSUM (MP_TAC o Q.SPEC `3:num `)
            THEN DISCH_TAC
       	    THEN POP_ASSUM (MP_TAC o Q.SPEC `2:num `)
	    THEN RW_TAC list_ss[])
THEN RW_TAC std_ss[]
THEN KNOW_TAC(``!i. i IN L2 ==> (

                 real
                 (prob p
                    (if i = 0 then DRBD_event p Y t
                     else if i = 3 then DRBD_event p Z t
                     else X i)) =
		 real (prob p ((X:num->'a->bool) i)))``)

       THEN1(RW_TAC std_ss[] THEN ASM_SET_TAC[])
THEN DISCH_TAC
THEN KNOW_TAC(``
        product L2
             (\i.
               real
                 (prob p
                    (if i = 0 then DRBD_event p Y t
                     else if i = 3 then DRBD_event p Z t
                     else X i))) =
       (product L2 (\l. real (prob p ((X:num->'a->bool) l))))  ``)
       THEN1(RW_TAC std_ss[th])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]       
THEN RW_TAC std_ss[]);

val PROB_DRBD_SEN_plus_rel_lem = store_thm("PROB_DRBD_SEN_plus_rel_lem",
  ``  !p X Y Ys_a Ys_d Z Zs_a Zs_d t L1 L2 L A J.
            L1 <> {} /\ L2 <> {} /\ FINITE L1 /\ FINITE L2 /\
            (!l.
                 l IN BIGUNION_o_BIGUNION L A J ==>
                 event_set
                   [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0);
                    (DRBD_event p (R_WSP Z Zs_a Zs_d) t,3)] X l IN events p) /\
            indep_sets p
              (\i.
                   {event_set
                      [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0);
                       (DRBD_event p (R_WSP Z Zs_a Zs_d) t,3)] X i})
              (BIGUNION_o_BIGUNION L A J) /\
            disjoint_family_on (ind_set [{0}; L1; L2; {3}]) {0; 1; 2; 3} /\
            (J = {0; 1; 2}) /\ (A = ind_set [{0}; {1; 2}; {3}]) /\
            (L = ind_set [{0}; L1; L2; {3}]) ==>
            (prob p
               (DRBD_series
                  (\j.
                       DRBD_parallel
                         (\a.
                              DRBD_series
                                (\i.
                                     event_set
                                       [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0);
                                        (DRBD_event p (R_WSP Z Zs_a Zs_d) t,3)]
                                       X i) (L a)) (A j)) J) =
             Rel p (R_WSP Y Ys_a Ys_d) t * Rel p (R_WSP Z Zs_a Zs_d) t *
             (1 -
              (1 - Normal (product L1 (\l. real (prob p (X l))))) *
              (1 - Normal (product L2 (\l. real (prob p (X l)))))))``,

RW_TAC std_ss[Rel_def]
THEN DEP_REWRITE_TAC[PROB_DRBD_SEN_plus]
THEN METIS_TAC[ETA_THM]);


val SEN_set_req_def = Define `SEN_set_req p L1 L2 L A J X =
L1 <> {} /\ (L2:num->bool) <> {} /\ FINITE L1 /\ FINITE L2 /\
            (!l.
                 l IN BIGUNION_o_BIGUNION L A J ==>
                 X l IN events p) /\
            indep_sets p
              (\i. {X i}) (BIGUNION_o_BIGUNION L A J) /\
            disjoint_family_on (ind_set [{0}; L1; L2; {3}]) {0:num; 1; 2; 3}`;


val PROB_DRBD_SEN_plus_rel = store_thm("PROB_DRBD_SEN_plus_rel",
  `` !p X Y Ys_a Ys_d Z Zs_a Zs_d t L1 L2 L A J.
            SEN_set_req p L1 L2 (ind_set [{0:num}; L1; L2; {3}])
	         (ind_set [{0}; {1:num; 2}; {3}]){0;1;2} (event_set
                   [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0);
                    (DRBD_event p (R_WSP Z Zs_a Zs_d) t,3)]
                   (rv_to_event p X t))  ==>
            (prob p
               (DRBD_series
                  (\j.
                       DRBD_parallel
                         (\a.
                              DRBD_series
                                (\i.
                                     event_set
                                       [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0);
                                        (DRBD_event p (R_WSP Z Zs_a Zs_d) t,3)]
                                       (rv_to_event p X t) i)
                                (ind_set [{0}; L1; L2; {3}] a))
                         (ind_set [{0}; {1; 2}; {3}] j)) {0; 1; 2}) =
             Rel p (R_WSP Y Ys_a Ys_d) t * Rel p (R_WSP Z Zs_a Zs_d) t *
             (1 -
              (1 - Normal (product L1 (\l. real (Rel p (X l) t)))) *
              (1 - Normal (product L2 (\l. real (Rel p (X l) t))))))``,

RW_TAC std_ss[Rel_def, PROB_DRBD_SEN_plus, rv_to_event_def, SEN_set_req_def]
THEN DEP_REWRITE_TAC[PROB_DRBD_SEN_plus]
THEN METIS_TAC[ETA_THM]);


val SEN_nR_AND = store_thm("SEN_nR_AND",
  ``!p X Y Ys_a Ys_d Z Zs_a Zs_d t L1 L2.
        DISJOINT3 {0; 3} L1 L2  /\
        FINITE L1 /\ FINITE L2 /\ L1 <> {} /\ L2 <> {} ==>
        ( DRBD_event p
           (nR_AND
              (\i.
                   if i = 0 then R_WSP Y Ys_a Ys_d
                   else if i = 1 then R_OR (nR_AND X L1) (nR_AND X L2)
                   else R_WSP Z Zs_a Zs_d) {0; 1; 2:num}) t =
	  DRBD_series
           (\j.
                DRBD_parallel
                  (\a.
                       DRBD_series
                         (\i.
                              event_set
                                [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0);
                                 (DRBD_event p (R_WSP Z Zs_a Zs_d) t,3)]
                                (rv_to_event p X t) i)
                         (ind_set [{0}; L1; L2; {3}] a))
                  (ind_set [{0}; {1; 2}; {3}] j)) {0; 1; 2})``,


RW_TAC std_ss[DISJOINT3_def]
THEN `{0;1;2:num} <>{}` by ASM_SET_TAC[]
THEN KNOW_TAC(``FINITE {0;1;2:num} ``)
     THEN1( `{0:num;1;2} = {0} UNION {1} UNION {2}` by ASM_SET_TAC[]
              THEN ONCE_ASM_REWRITE_TAC[]
	      THEN RW_TAC std_ss[FINITE_UNION, FINITE_SING])
THEN DISCH_TAC
THEN KNOW_TAC(``
   DRBD_event p
     (nR_AND
        (\i.
             if i = 0:num then R_WSP Y Ys_a Ys_d
             else if i = 1 then R_OR (nR_AND X L1) (nR_AND X L2)
             else R_WSP Z Zs_a Zs_d) {0; 1; 2}) t =
   DRBD_series
     (rv_to_event p 
        (\i:num.
             if i = 0 then R_WSP Y Ys_a Ys_d
             else if i = 1 then R_OR (nR_AND X (L1:num->bool)) (nR_AND X (L2:num->bool))
             else R_WSP Z Zs_a Zs_d) t) {0; 1; 2:num} ``)

      THEN1 RW_TAC std_ss[nR_AND_DRBD_series]
THEN RW_TAC std_ss[]
THEN KNOW_TAC(``
    DRBD_series
     (rv_to_event p
        (\i.
             if i = 0 then R_WSP Y Ys_a Ys_d
             else if i = 1 then R_OR (nR_AND X (L1:num->bool)) (nR_AND X (L2:num->bool))
             else R_WSP Z Zs_a Zs_d) t) {0; 1; 2}=
    DRBD_event p (R_WSP Y Ys_a Ys_d) t INTER
    DRBD_event p (R_OR (nR_AND X L1) (nR_AND X L2)) t INTER
    DRBD_event p (R_WSP Z Zs_a Zs_d) t ``)
     THEN1(RW_TAC std_ss[DRBD_series_def, rv_to_event_def]
           THEN KNOW_TAC(``
     {DRBD_event p
       (if i:num = 0 then R_WSP Y Ys_a Ys_d
        else if i = 1 then R_OR (nR_AND X L1) (nR_AND X L2)
        else R_WSP Z Zs_a Zs_d) t |
     i IN {0; 1; 2}} =
     {DRBD_event p
       (R_WSP Y Ys_a Ys_d) t;
      DRBD_event p (R_OR (nR_AND X (L1:num->bool)) (nR_AND X (L2:num->bool))) t;
      DRBD_event p ( R_WSP Z Zs_a Zs_d) t}``)
              THEN1(PSET_TAC[]
                    THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
 		    THEN EQ_TAC
		         THEN1(RW_TAC std_ss[] THEN RW_TAC std_ss[])
	            THEN RW_TAC std_ss[]
		         THEN1(Q.EXISTS_TAC`0`
			        THEN RW_TAC std_ss[])
			 THEN1(Q.EXISTS_TAC`1`
			       THEN RW_TAC std_ss[])
 	 	    THEN Q.EXISTS_TAC`2`
		    THEN RW_TAC std_ss[])
       THEN RW_TAC std_ss[BIGINTER_3_sets])
THEN RW_TAC std_ss[]
THEN ASM_REWRITE_TAC[]
THEN ONCE_REWRITE_TAC[DRBD_series_def]
THEN PSET_TAC[]
THEN KNOW_TAC(``
    {DRBD_parallel
       (\a.
            DRBD_series
              (\i.
                   event_set
                     [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0);
                      (DRBD_event p (R_WSP Z Zs_a Zs_d) t,3)]
                     (rv_to_event p X t) i) (ind_set [{0}; L1; L2; {3}] a))
       (ind_set [{0}; {1:num; 2}; {3}] i) |
     (i = 0) \/ (i = 1) \/ (i = 2)} =
     {DRBD_parallel
       (\a.
            DRBD_series
              (\i.
                   event_set
                     [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0);
                      (DRBD_event p (R_WSP Z Zs_a Zs_d) t,3)]
                     (rv_to_event p X t) i) (ind_set [{0}; L1; L2; {3}] a))
       (ind_set [{0}; {1; 2}; {3}] 0);
      DRBD_parallel
       (\a.
            DRBD_series
              (\i.
                   event_set
                     [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0);
                      (DRBD_event p (R_WSP Z Zs_a Zs_d) t,3)]
                     (rv_to_event p X t) i) (ind_set [{0}; L1; L2; {3}] a))
       (ind_set [{0}; {1; 2}; {3}] 1);
      DRBD_parallel
       (\a.
            DRBD_series
              (\i.
                   event_set
                     [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0);
                      (DRBD_event p (R_WSP Z Zs_a Zs_d) t,3)]
                     (rv_to_event p X t) i) (ind_set [{0}; L1; L2; {3}] a))
       (ind_set [{0}; {1; 2}; {3:num}] 2)}``)
     THEN1 ASM_SET_TAC[]
THEN RW_TAC std_ss[]
THEN RW_TAC std_ss[BIGINTER_3_sets]
THEN RW_TAC list_ss[ind_set_def, EL, HD]
THEN RW_TAC std_ss[DRBD_parallel_def]
THEN KNOW_TAC(``
    !k:num.
      {DRBD_series
       (\i.
            event_set
              [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0);
               (DRBD_event p (R_WSP Z Zs_a Zs_d) t,3)] (rv_to_event p X t) i)
       (EL a [{0}; L1; L2; {3}]) |
     a = k}=
       {DRBD_series
       (\i.
            event_set
              [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0);
               (DRBD_event p (R_WSP Z Zs_a Zs_d) t,3)] (rv_to_event p X t) i)
       (EL k [{0}; L1; L2; {3}])}``)

      THEN1(ASM_SET_TAC[])
THEN RW_TAC std_ss[]
THEN RW_TAC list_ss[EL]
THEN RW_TAC std_ss[BIGUNION_SING]
THEN KNOW_TAC(``{DRBD_series
       (\i.
            event_set
              [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0);
               (DRBD_event p (R_WSP Z Zs_a Zs_d) t,3)] (rv_to_event p X t) i)
       (EL a [{0}; L1; L2; {3}]) |
     (a = 1) \/ (a = 2:num)} =
     {DRBD_series
       (\i.
            event_set
              [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0);
               (DRBD_event p (R_WSP Z Zs_a Zs_d) t,3)] (rv_to_event p X t) i)
       (EL 1 [{0}; L1; L2; {3}]) ;
       DRBD_series
       (\i.
            event_set
              [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0);
               (DRBD_event p (R_WSP Z Zs_a Zs_d) t,3)] (rv_to_event p X t) i)
       (EL 2 [{0}; L1; L2; {3}])}``)
        THEN1(ASM_SET_TAC[])
THEN RW_TAC list_ss[]
THEN RW_TAC std_ss[BIGUNION_PAIR]
THEN RW_TAC std_ss[DRBD_parallel_def, DRBD_series_def, event_set_def, event_set1_def, ind_set_def, EL, rv_to_event_def]
THEN KNOW_TAC(``{if i:num = 0 then DRBD_event p (R_WSP Y Ys_a Ys_d) t
     else if i = 3 then DRBD_event p (R_WSP Z Zs_a Zs_d) t
     else DRBD_event p (X i) t |
     i IN {0}} = { DRBD_event p (R_WSP Y Ys_a Ys_d) t} ``)

    THEN1(ASM_SET_TAC[])
THEN RW_TAC std_ss[]
THEN KNOW_TAC(``
     {if i:num = 0 then DRBD_event p (R_WSP Y Ys_a Ys_d) t
      else if i = 3 then DRBD_event p (R_WSP Z Zs_a Zs_d) t
      else DRBD_event p (X i) t |
      i IN L1} =
      {DRBD_event p (X i) t |
      i IN L1}``)
      THEN1 ASM_SET_TAC[]
THEN RW_TAC std_ss[]      
THEN KNOW_TAC(``
     {if i:num = 0 then DRBD_event p (R_WSP Y Ys_a Ys_d) t
      else if i = 3 then DRBD_event p (R_WSP Z Zs_a Zs_d) t
      else DRBD_event p (X i) t |
      i IN L2} =
      {DRBD_event p (X i) t |
      i IN L2}``)
      THEN1 ASM_SET_TAC[]
THEN RW_TAC std_ss[]      
THEN KNOW_TAC(``
    {if i:num = 0 then DRBD_event p (R_WSP Y Ys_a Ys_d) t
     else if i = 3 then DRBD_event p (R_WSP Z Zs_a Zs_d) t
     else DRBD_event p (X i) t |
     i IN {3}} =
     {DRBD_event p (R_WSP Z Zs_a Zs_d) t}``)
    THEN1 ASM_SET_TAC[]
THEN RW_TAC std_ss[]
THEN RW_TAC std_ss[BIGINTER_SING]
THEN RW_TAC std_ss[R_OR_UNION] 
THEN RW_TAC std_ss[nR_AND_DRBD_series, DRBD_series_def]
THEN RW_TAC std_ss[rv_to_event_def]);



val Rel_DRBD_SEN_plus = store_thm("Rel_DRBD_SEN_plus",
  ``!p X Y Ys_a Ys_d Z Zs_a Zs_d t L1 L2.
            SEN_set_req p L1 L2 (ind_set [{0}; L1; L2; {3}])
            (ind_set [{0}; {1; 2}; {3}]) {0; 1; 2}
            (event_set
               [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0);
                (DRBD_event p (R_WSP Z Zs_a Zs_d) t,3)] (rv_to_event p X t)) ==>
          (prob p
             (DRBD_event p
             (nR_AND
                (\i.
                     if i:num = 0 then R_WSP Y Ys_a Ys_d
                     else if i = 1 then R_OR (nR_AND X L1) (nR_AND X L2)
                     else R_WSP Z Zs_a Zs_d) {0:num; 1; 2}) t) =
           Rel p (R_WSP Y Ys_a Ys_d) t * Rel p (R_WSP Z Zs_a Zs_d) t *
           (1 -
            (1 - Normal (product L1 (\l. real (Rel p (X l) t)))) *
            (1 - Normal (product L2 (\l. real (Rel p (X l) t)))))) ``,


RW_TAC std_ss[SEN_set_req_def]
THEN DEP_REWRITE_TAC[GSYM PROB_DRBD_SEN_plus_rel]
THEN REWRITE_TAC[SEN_set_req_def]
THEN RW_TAC std_ss[]
THEN DEP_REWRITE_TAC[GSYM SEN_nR_AND]
THEN RW_TAC std_ss[DISJOINT3_def]
     THEN1 (FULL_SIMP_TAC std_ss[ind_set_def]
            THEN FULL_SIMP_TAC std_ss[disjoint_family_on]
 	    THEN KNOW_TAC(``{0:num} INTER L1 = {}``)
                THEN1(POP_ASSUM (MP_TAC o Q.SPEC `0:num `)
   		      THEN DISCH_TAC
    		      THEN POP_ASSUM (MP_TAC o Q.SPEC `1:num `)
		      THEN FULL_SIMP_TAC list_ss[])
            THEN KNOW_TAC(``{3:num} INTER L1 = {}``)
                THEN1(POP_ASSUM (MP_TAC o Q.SPEC `1:num `)
   		      THEN DISCH_TAC
    		      THEN POP_ASSUM (MP_TAC o Q.SPEC `3:num `)
		      THEN FULL_SIMP_TAC list_ss[INTER_COMM])
            THEN ASM_SET_TAC[disjoint_family_on, ind_set_def, EL])
      THEN1(FULL_SIMP_TAC std_ss[ind_set_def]
            THEN FULL_SIMP_TAC std_ss[disjoint_family_on]
 	    THEN KNOW_TAC(``{0:num} INTER L2 = {}``)
                THEN1(POP_ASSUM (MP_TAC o Q.SPEC `0:num `)
   		      THEN DISCH_TAC
    		      THEN POP_ASSUM (MP_TAC o Q.SPEC `2:num `)
		      THEN FULL_SIMP_TAC list_ss[])
            THEN KNOW_TAC(``{3:num} INTER L2 = {}``)
                THEN1(POP_ASSUM (MP_TAC o Q.SPEC `2:num `)
   		      THEN DISCH_TAC
    		      THEN POP_ASSUM (MP_TAC o Q.SPEC `3:num `)
		      THEN FULL_SIMP_TAC list_ss[INTER_COMM])
            THEN ASM_SET_TAC[disjoint_family_on, ind_set_def, EL])
THEN FULL_SIMP_TAC std_ss[ind_set_def]
THEN FULL_SIMP_TAC std_ss[disjoint_family_on]
THEN POP_ASSUM (MP_TAC o Q.SPEC `1:num `)
THEN DISCH_TAC
THEN POP_ASSUM (MP_TAC o Q.SPEC `2:num `)
THEN FULL_SIMP_TAC list_ss[]
THEN ASM_SET_TAC[]);



val Rel_DRBD_SEN_plus1 = store_thm("Rel_DRBD_SEN_plus1",
  ``!p X Y Ys_a Ys_d Z Zs_a Zs_d t L1 L2 f_y f_z f_condY f_condZ f_ysy f_zsz.
            SEN_set_req p L1 L2 (ind_set [{0}; L1; L2; {3}])
            (ind_set [{0}; {1; 2}; {3}]) {0; 1; 2}
            (event_set
               [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0);
                (DRBD_event p (R_WSP Z Zs_a Zs_d) t,3)] (rv_to_event p X t)) /\
            prob_space p /\ (!s. ALL_DISTINCT [Ys_a s; Ys_d s; Y s; Zs_a s; Zs_d s; Z s]) /\
         DISJOINT_WSP Y Ys_a Ys_d t /\ DISJOINT_WSP Z Zs_a Zs_d t /\
         rv_gt0_ninfinity [Ys_a; Ys_d; Y; Zs_a; Zs_d; Z] /\
         0 <= t /\
         (!y.
              cond_density lborel lborel p (real o Ys_a) (real o Y) y f_ysy
                f_y f_condY) /\ den_gt0_ninfinity f_ysy f_y f_condY /\
         indep_var p lborel (real o Ys_d) lborel (real o Y) /\
         cont_CDF p (real o Ys_d) /\ measurable_CDF p (real o Ys_d) /\
          (!z.
             cond_density lborel lborel p (real o Zs_a) (real o Z) z f_zsz f_z
               f_condZ) /\ den_gt0_ninfinity f_zsz f_z f_condZ /\
        indep_var p lborel (real o Zs_d) lborel (real o Z) /\
        cont_CDF p (real o Zs_d) /\ measurable_CDF p (real o Zs_d) ==>
          (prob p
             (DRBD_event p
             (nR_AND
                (\i.
                     if i:num = 0 then R_WSP Y Ys_a Ys_d
                     else if i = 1 then R_OR (nR_AND X L1) (nR_AND X L2)
                     else R_WSP Z Zs_a Zs_d) {0:num; 1; 2}) t) = 
          (1 -
     (pos_fn_integral lborel
        (\y.
             indicator_fn {u | 0 <= u /\ u <= t} y * f_y y *
             pos_fn_integral lborel
               (\x. indicator_fn {w | y < w /\ w <= t} x * f_condY y x)) +
      pos_fn_integral lborel
        (\y.
             f_y y *
             (indicator_fn {u | 0 <= u /\ u <= t} y * CDF p (real o Ys_d) y)))) *
    (1 -
     (pos_fn_integral lborel
        (\y.
             indicator_fn {u | 0 <= u /\ u <= t} y * f_z y *
             pos_fn_integral lborel
               (\x. indicator_fn {w | y < w /\ w <= t} x * f_condZ y x)) +
      pos_fn_integral lborel
        (\y.
             f_z y *
             (indicator_fn {u | 0 <= u /\ u <= t} y * CDF p (real o Zs_d) y)))) *
    (1 -
     (1 - Normal (product L1 (\l. real (Rel p (X l) t)))) *
     (1 - Normal (product L2 (\l. real (Rel p (X l) t)))))) ``,

RW_TAC std_ss [Rel_DRBD_SEN_plus]
THEN KNOW_TAC(``Rel p (R_WSP Y Ys_a Ys_d) t = (1 -
    (pos_fn_integral lborel
       (\y.
            indicator_fn {u | 0 <= u /\ u <= t} y * f_y y *
            pos_fn_integral lborel
              (\x. indicator_fn {w | y < w /\ w <= t} x * f_condY y x)) +
     pos_fn_integral lborel
       (\y.
            f_y y *
            (indicator_fn {u | 0 <= u /\ u <= t} y * CDF p (real o Ys_d) y)))) ``)
     THEN1(`rv_gt0_ninfinity[Ys_a; Ys_d; Y]` by FULL_SIMP_TAC std_ss[rv_gt0_ninfinity_def]
           THEN `(!s. ALL_DISTINCT [Ys_a s; Ys_d s; Y s])` by FULL_SIMP_TAC list_ss[ALL_DISTINCT]
           THEN METIS_TAC[Rel_R_WSP])
THEN KNOW_TAC(``Rel p (R_WSP Z Zs_a Zs_d) t = (1 -
     (pos_fn_integral lborel
        (\y.
             indicator_fn {u | 0 <= u /\ u <= t} y * f_z y *
             pos_fn_integral lborel
               (\x. indicator_fn {w | y < w /\ w <= t} x * f_condZ y x)) +
      pos_fn_integral lborel
        (\y.
             f_z y *
             (indicator_fn {u | 0 <= u /\ u <= t} y * CDF p (real o Zs_d) y)))) ``)

      THEN1(`rv_gt0_ninfinity[Zs_a; Zs_d; Z]` by FULL_SIMP_TAC std_ss[rv_gt0_ninfinity_def]
           THEN `(!s. ALL_DISTINCT [Zs_a s; Zs_d s; Z s])` by FULL_SIMP_TAC list_ss[ALL_DISTINCT]
           THEN METIS_TAC[Rel_R_WSP])
THEN RW_TAC std_ss[]);






val bigunion_biginter_bigunion_lem = store_thm(
  "bigunion_biginter_bigunion_lem",
  `` ! X s L A j.
            biginter
              (\j:num.
                   bigunion
                     (\a:num. biginter (\l:num. bigunion X (s l)) (L a)) (A j))
              {j} =
            bigunion (\a:num. biginter (\l:num. bigunion (X :num->'a->bool) (s l)) (L a)) (A j)``,

RW_TAC std_ss[]
THEN RW_TAC std_ss[bigunion_def, biginter_def]
THEN RW_TAC std_ss[] THEN PSET_TAC[]
THEN KNOW_TAC(``{BIGUNION {BIGINTER {BIGUNION {(X:num->'a->bool) i | (i:num) IN s (l:num)} | l IN (L:num->num->bool) a} | a IN (A:num->num->bool) j'} |
     j' = j:num} =
     {BIGUNION {BIGINTER {BIGUNION {X i | i IN s l} | l IN L a} | a IN A j} }``)
    THEN1 ASM_SET_TAC[]
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
THEN RW_TAC std_ss[BIGINTER_SING]);


val DRBD_parallel_bigunion = store_thm("DRBD_parallel_bigunion",
  `` !Y s. DRBD_parallel Y s = bigunion Y s ``,
RW_TAC std_ss[DRBD_parallel_def, bigunion_def]);

val DRBD_series_biginter = store_thm("DRBD_series_biginter",
  `` !Y s. DRBD_series Y s = biginter Y s ``,
RW_TAC std_ss[DRBD_series_def, biginter_def]);




val PROB_bigunion_biginter_bigunion_lem1 = store_thm(
  "PROB_bigunion_biginter_bigunion_lem1",
  `` !p X s L A j.
            indep_sets p (\i. {X i}) (BIGUNION_o_BIGUNION s L (A j)) /\
            sets_finite_not_empty s L A {j} ==>
            (prob p
               (biginter
                  (\j.
                       bigunion
                         (\a. biginter (\l. bigunion X (s l)) (L a))
                         (A j)) {j}) =
            
     (1 -
      Normal
        (product (A j)
           (\a.
                real
                  (1 -
                   Normal
                     (product (L a)
                        (\l.
                             real
                               (1 -
                                Normal
                                  (product (s l)
                                     (\i. real (1 - prob p (X i))))))))))))``,

RW_TAC std_ss[GSYM DRBD_parallel_bigunion, GSYM DRBD_series_biginter]
THEN DEP_REWRITE_TAC[PROB_DRBD_nested_series_parallel]
THEN RW_TAC std_ss[]
     THEN1(FULL_SIMP_TAC std_ss[nested_BIGUNION_def, BIGUNION_o_BIGUNION_def] 
           THEN KNOW_TAC(``BIGUNION
	                      {s (l:num) | l IN BIGUNION
			                          {L (a:num) | a IN BIGUNION
						                     {A (j':num) | j' IN {j}}}} =
                           BIGUNION
	                      {(s:num->num->bool) (l:num) | l IN BIGUNION
			                          {L (a:num) | a IN BIGUNION
						                     {A j}}}``)
                THEN1(ASM_SET_TAC[])
	    THEN DISCH_TAC THEN FULL_SIMP_TAC std_ss[BIGUNION_SING])
THEN RW_TAC std_ss[PRODUCT_SING]
THEN RW_TAC std_ss[ normal_real_product_1, real_normal_real, normal_real_product_2]
THEN RW_TAC std_ss[GSYM extreal_sub_def]
THEN METIS_TAC[extreal_of_num_def]);



val PROB_bigunion_biginter_bigunion_lem2 = store_thm(
  "PROB_bigunion_biginter_bigunion_lem2",
  ``  !p X s L A j:num. 
            indep_sets p (\i. {X i}) (BIGUNION_o_BIGUNION s L (A j)) /\
            sets_finite_not_empty s L A {j} ==>
            (prob p
               (   bigunion
                         (\a. biginter (\l. bigunion X (s l)) (L a))
                         (A j)) =
 1 -
           Normal
             (product (A j)
                (\a.
                     real
                       (1 -
                        Normal
                          (product (L a)
                             (\l.
                                  real
                                    (1 -
                                     Normal
                                       (product (s l)
                                          (\i. real (1 - prob p (X i)))))))))))``,

RW_TAC std_ss[]

THEN DEP_ONCE_REWRITE_TAC [GSYM bigunion_biginter_bigunion_lem]
THEN DEP_REWRITE_TAC[PROB_bigunion_biginter_bigunion_lem1]
THEN RW_TAC std_ss[]);




val PROB_DFT_SEN_plus_lem1 = store_thm("PROB_DRBD_DFT_plus_lem1",
  `` !p X L1 L2 s L A j.
            L1 <> {} /\ L2 <> {} /\ FINITE L1 /\ FINITE L2 /\
            indep_sets p (\i. {X i}) (BIGUNION_o_BIGUNION s L A) /\
            disjoint_family_on (ind_set [{0}; L1; L2; {3}]) {0; 1; 2; 3} /\
            (A = {0; 1; 2}) /\ (L = ind_set [{0}; {1; 2}; {3}]) /\
            (s = ind_set [{0}; L1; L2; {3}]) ==>
            (prob p
               (bigunion
                  (\a. biginter (\l. bigunion X (s l)) (L a)) ((\i.A) j)) = 1 -
   (1 - prob p (X 0)) *
   (Normal
      (1 -
       (1 - product L1 (\i. real (1 - prob p (X i)))) *
       (1 - product L2 (\i. real (1 - prob p (X i))))) * (1 - prob p (X 3))))``,
    
RW_TAC std_ss[disjoint_family_on]
THEN KNOW_TAC(``DISJOINT3 {0;3:num} L1 L2 ``)
     THEN1(RW_TAC std_ss[DISJOINT3_def]
           THEN1( FULL_SIMP_TAC std_ss[ind_set_def]
	         THEN KNOW_TAC(`` {0:num} INTER L1 = {}``)
    	              THEN1(POP_ASSUM (MP_TAC o Q.SPEC `0:num `)
	                   THEN DISCH_TAC
	              	   THEN POP_ASSUM (MP_TAC o Q.SPEC `1:num `)
		      	   THEN RW_TAC list_ss[])
	         THEN DISCH_TAC	       
                 THEN KNOW_TAC(`` {3:num} INTER L1 = {}``)
    	              THEN1(POP_ASSUM MP_TAC
		            THEN POP_ASSUM (MP_TAC o Q.SPEC `3:num `)
	              	    THEN DISCH_TAC
	              	    THEN POP_ASSUM (MP_TAC o Q.SPEC `1:num `)
		      	    THEN RW_TAC list_ss[])
	         THEN DISCH_TAC THEN ASM_SET_TAC[DISJOINT_DEF])
	    THEN1(FULL_SIMP_TAC std_ss[ind_set_def]
	         THEN KNOW_TAC(`` {0:num} INTER L2 = {}``)
    	              THEN1(POP_ASSUM (MP_TAC o Q.SPEC `0:num `)
	                   THEN DISCH_TAC
	              	   THEN POP_ASSUM (MP_TAC o Q.SPEC `2:num `)
		      	   THEN RW_TAC list_ss[])
	         THEN DISCH_TAC	       
                 THEN KNOW_TAC(`` {3:num} INTER L2 = {}``)
    	              THEN1(POP_ASSUM MP_TAC
		            THEN POP_ASSUM (MP_TAC o Q.SPEC `3:num `)
	              	    THEN DISCH_TAC
	              	    THEN POP_ASSUM (MP_TAC o Q.SPEC `2:num `)
		      	    THEN RW_TAC list_ss[])
	         THEN DISCH_TAC THEN ASM_SET_TAC[DISJOINT_DEF])
	    THEN POP_ASSUM (MP_TAC o Q.SPEC `2:num `)
	    THEN DISCH_TAC
	    THEN POP_ASSUM (MP_TAC o Q.SPEC `1:num `)
     	    THEN RW_TAC list_ss[]
	    THEN FULL_SIMP_TAC list_ss[ind_set_def]
	    THEN ASM_SET_TAC[DISJOINT_DEF])
THEN RW_TAC std_ss[DISJOINT3_def]
THEN KNOW_TAC(``BIGUNION {EL j [{0:num}; {1; 2}; {3}] | j IN {0; 1; 2:num}} = {0;1;2;3} ``)
     THEN1( SRW_TAC[][GSPECIFICATION, EXTENSION]
            THEN EQ_TAC
                THEN1(RW_TAC std_ss[]
      		      THEN FULL_SIMP_TAC list_ss[])
         	 THEN RW_TAC std_ss[]
		      THEN1( Q.EXISTS_TAC`{0}` THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[] 
	                    THEN Q.EXISTS_TAC`0` THEN RW_TAC std_ss[]
			    THEN RW_TAC list_ss[])
	 	      THEN1( Q.EXISTS_TAC`{1;2}` THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
	                    THEN Q.EXISTS_TAC`1` THEN RW_TAC std_ss[]
	   	            THEN RW_TAC list_ss[])
		      THEN1( Q.EXISTS_TAC`{1;2}` THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
		             THEN Q.EXISTS_TAC`1` THEN RW_TAC std_ss[]
		             THEN RW_TAC list_ss[])
           THEN Q.EXISTS_TAC`{3}` THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
     	   THEN Q.EXISTS_TAC`2` THEN RW_TAC list_ss[])
THEN DISCH_TAC
THEN  MP_TAC(Q.ISPECL [`p:('a->bool)#(('a->bool)->bool)#(('a->bool)->extreal)`, `X:num->'a->bool`, `ind_set [{0:num}; L1:num->bool; L2:num->bool; {3:num}]`, `ind_set [{0:num}; {1:num; 2}; {3:num}]`, `(\i:num. {0; 1:num; 2})`, `j:num`] PROB_bigunion_biginter_bigunion_lem2)
THEN RW_TAC std_ss[]
THEN KNOW_TAC(`` sets_finite_not_empty (ind_set [{0}; L1; L2; {3:num}])
           (ind_set [{0:num}; {1; 2}; {3}]) (\i. {0; 1; 2:num}) {j:num} ``)
     THEN1(RW_TAC std_ss[sets_finite_not_empty_def]
           THEN1 ASM_SET_TAC[]
	   THEN1 (`{0;1;2:num} = {0} UNION ({1} UNION {2})` by ASM_SET_TAC[]
	          THEN ONCE_ASM_REWRITE_TAC[]
		  THEN ASM_SET_TAC[FINITE_UNION, FINITE_SING])
	   THEN1(RW_TAC std_ss[ind_set_def]
	         THEN PSET_TAC[]
		      THEN1(FULL_SIMP_TAC std_ss[ind_set_def]
		            THEN FULL_SIMP_TAC list_ss[]
			    THEN ASM_SET_TAC[])
		      THEN1 (FULL_SIMP_TAC std_ss[ind_set_def]
		            THEN FULL_SIMP_TAC list_ss[]
			    THEN ASM_SET_TAC[])
                  THEN FULL_SIMP_TAC std_ss[ind_set_def]
		  THEN FULL_SIMP_TAC list_ss[]
		  THEN ASM_SET_TAC[])
	  THEN1 (FULL_SIMP_TAC list_ss[ind_set_def]
	         THEN PSET_TAC[]
		      THEN1(FULL_SIMP_TAC std_ss[ind_set_def]
		            THEN FULL_SIMP_TAC list_ss[]
			    THEN ASM_SET_TAC[FINITE_SING])
		      THEN1(FULL_SIMP_TAC std_ss[ind_set_def]
		            THEN FULL_SIMP_TAC list_ss[])
		 THEN FULL_SIMP_TAC std_ss[ind_set_def]
		 THEN FULL_SIMP_TAC list_ss[]
		 THEN ASM_SET_TAC[FINITE_SING])
	 THEN1( FULL_SIMP_TAC list_ss[ind_set_def]
	         THEN PSET_TAC[]
		      THEN1(FULL_SIMP_TAC std_ss[ind_set_def]
		            THEN FULL_SIMP_TAC list_ss[]
			    THEN ASM_SET_TAC[FINITE_SING])
		      THEN1(FULL_SIMP_TAC std_ss[ind_set_def]
		            THEN FULL_SIMP_TAC list_ss[]
			    THEN ASM_SET_TAC[])
		 THEN FULL_SIMP_TAC std_ss[ind_set_def]
		 THEN FULL_SIMP_TAC list_ss[]
		 THEN ASM_SET_TAC[FINITE_SING])
	 THEN1(	 FULL_SIMP_TAC list_ss[ind_set_def]
	         THEN PSET_TAC[]
		      THEN1(FULL_SIMP_TAC std_ss[ind_set_def]
		            THEN FULL_SIMP_TAC list_ss[]
			    THEN ASM_SET_TAC[FINITE_SING])
		      THEN1(FULL_SIMP_TAC std_ss[ind_set_def]
		            THEN FULL_SIMP_TAC list_ss[]
			    THEN `{1;2:num} = {1} UNION {2}` by ASM_SET_TAC[]
			    THEN ONCE_ASM_REWRITE_TAC[]
			    THEN ASM_SET_TAC[FINITE_UNION, FINITE_SING])
		 THEN FULL_SIMP_TAC std_ss[ind_set_def]
		 THEN FULL_SIMP_TAC list_ss[]
		 THEN ASM_SET_TAC[FINITE_SING])
         THEN1 ASM_SET_TAC[FINITE_SING]
	 THEN1 (RW_TAC std_ss[disjoint_family_on]
	        THEN ASM_SET_TAC[])
	 THEN1 ASM_SET_TAC[]	
	 THEN1 (RW_TAC std_ss[disjoint_family_on]
	        THEN RW_TAC std_ss[ind_set_def]
		THEN PSET_TAC[] THEN FULL_SIMP_TAC list_ss[ind_set_def])
         THEN RW_TAC list_ss[disjoint_family_on, ind_set_def]
	 THEN PSET_TAC[] THEN FULL_SIMP_TAC list_ss[] THEN ASM_SET_TAC[])
THEN RW_TAC std_ss[]	 
THEN RW_TAC list_ss[ind_set_def]
THEN `{0;1;2:num} = {0} UNION {1;2}` by ASM_SET_TAC[]
THEN KNOW_TAC(``FINITE {0:num} /\ FINITE {1;2:num} /\ DISJOINT {0:num} {1;2}``)
     THEN1(RW_TAC std_ss[FINITE_SING]
           THEN1 (`{1;2:num} = {1} UNION {2}` by ASM_SET_TAC[] THEN ONCE_ASM_REWRITE_TAC[] THEN ASM_SET_TAC [FINITE_UNION, FINITE_SING])
	   THEN ASM_SET_TAC[])
THEN RW_TAC std_ss[PRODUCT_UNION, PRODUCT_SING]
THEN RW_TAC list_ss[]
THEN RW_TAC list_ss[PRODUCT_SING]
THEN `{1;2:num} = {1} UNION {2}` by ASM_SET_TAC[]
THEN `FINITE{1:num} /\ FINITE {2:num} /\ DISJOINT {1:num} {2}` by ASM_SET_TAC[FINITE_SING]
THEN RW_TAC list_ss[PRODUCT_UNION, PRODUCT_SING]
THEN RW_TAC std_ss[ normal_real_product_1, real_normal_real, normal_real_product_2]
THEN RW_TAC std_ss[REAL_SUB_SUB2]
THEN RW_TAC std_ss[GSYM extreal_sub_def]
THEN RW_TAC std_ss[GSYM extreal_mul_def]
THEN  KNOW_TAC(``prob p ((X:num->'a->bool) 0) <> PosInf /\ prob p (X 0) <> NegInf ``)
     THEN1(KNOW_TAC(`` 0:num IN BIGUNION_o_BIGUNION (ind_set [{0}; L1; L2; {3}])
               (ind_set [{0}; {1; 2}; {3}]) {0; 1; 2:num}``)
           THEN1(RW_TAC std_ss[ind_set_def, BIGUNION_o_BIGUNION_def]
                 THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
   	         THEN Q.EXISTS_TAC`{0}`
	         THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
	 	 THEN Q.EXISTS_TAC`0` THEN RW_TAC list_ss[]
		 THEN Q.EXISTS_TAC`{0}` THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
 		 THEN Q.EXISTS_TAC`0` THEN RW_TAC list_ss[])
		 THEN FULL_SIMP_TAC std_ss[indep_sets]
		 THEN DISCH_TAC THEN `(X:num->'a->bool) 0 IN events p` by ASM_SET_TAC[]
		 THEN `prob_space p` by FULL_SIMP_TAC std_ss[indep_sets]
		 THEN METIS_TAC[PROB_FINITE])
THEN DISCH_TAC
THEN `1 <> PosInf /\ 1 <> NegInf` by METIS_TAC[extreal_of_num_def, extreal_not_infty]
THEN KNOW_TAC(``prob p ((X:num->'a->bool) 3) <> PosInf /\ prob p (X 3) <> NegInf ``)
     THEN1(KNOW_TAC(`` 3:num IN BIGUNION_o_BIGUNION (ind_set [{0}; L1; L2; {3}])
               (ind_set [{0}; {1; 2}; {3}]) {0; 1; 2:num}``)
           THEN1(RW_TAC std_ss[ind_set_def, BIGUNION_o_BIGUNION_def]
                 THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
	         THEN Q.EXISTS_TAC`{3}`
		 THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
		 THEN Q.EXISTS_TAC`3` THEN RW_TAC list_ss[]
		 THEN Q.EXISTS_TAC`{3}` THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
 		 THEN Q.EXISTS_TAC`2` THEN RW_TAC list_ss[])
	   THEN DISCH_TAC
	   THEN UNDISCH_TAC(``{1:num; 2} = {1} UNION {2} ``)
	   THEN FULL_SIMP_TAC std_ss[indep_sets]
	   THEN POP_ASSUM MP_TAC
	   THEN RW_TAC std_ss[]
           THEN  `(X:num->'a->bool) 3 IN events p` by ASM_SET_TAC[]
	   THEN `prob_space p` by FULL_SIMP_TAC std_ss[indep_sets]
	   THEN METIS_TAC[PROB_FINITE])
THEN DISCH_TAC
THEN RW_TAC std_ss[extreal_of_num_def]
THEN RW_TAC std_ss[sub_not_infty, extreal_not_infty, normal_real]
THEN RW_TAC std_ss[extreal_mul_def]
THEN `1 = Normal 1` by RW_TAC std_ss[extreal_of_num_def]
THEN ONCE_ASM_REWRITE_TAC[]
THEN RW_TAC std_ss[extreal_sub_def]
THEN RW_TAC std_ss[real_normal]);


val PROB_DFT_SEN_plus_lem2 = store_thm("PROB_DFT_SEN_plus_lem2",
  ``  !p X Y Ys_a Ys_d Z Zs_a Zs_d t L1 L2. 0 <= t /\ FINITE L1 /\ FINITE L2 /\ L1 <> {} /\ L2 <> {} /\
        
         indep_sets p (\i. {rv_to_devent p X t i})
           (BIGUNION_o_BIGUNION (ind_set [{0}; L1; L2; {3}])
              (ind_set [{0}; {1; 2}; {3}]) {0; 1; 2}) /\
         disjoint_family_on (ind_set [{0}; L1; L2; {3}]) {0; 1; 2; 3}

==> ( prob p  (DFT_event p
             (n_OR
                (MAP
                   (\j.
                        n_AND
                          (MAP (\i:num. n_OR (MAP X (SET_TO_LIST ((ind_set [{0}; L1; L2; {3}]) i))))
                             (SET_TO_LIST ((ind_set [{0}; {1; 2}; {3}]) j)))) (SET_TO_LIST {0; 1; 2}))) t) =

    1 -
           (1 - prob p (rv_to_devent p X t (0:num))) *
           (Normal
              (1 -
               (1 - product L1 (\i. real (1 - prob p (rv_to_devent p X t i)))) *
               (1 - product L2 (\i. real (1 - prob p (rv_to_devent p X t i))))) *
            (1 - prob p (rv_to_devent p X t 3))))``,

RW_TAC std_ss[]
THEN DEP_REWRITE_TAC[ n_OR_AND_OR_BIGUNION_INTER_UNION]
THEN RW_TAC std_ss[]
     THEN1(`{0;1;2:num} = {0} UNION {1;2}` by ASM_SET_TAC[] THEN ONCE_ASM_REWRITE_TAC[]
           THEN `{1;2:num} = {1} UNION {2}` by ASM_SET_TAC[]
	   THEN KNOW_TAC(``FINITE{1;2:num}``) THEN1(ONCE_ASM_REWRITE_TAC[] THEN ASM_SET_TAC[FINITE_UNION, FINITE_SING])
	   
	   THEN ASM_SET_TAC[FINITE_UNION, FINITE_SING])
      THEN1(RW_TAC list_ss[ind_set_def]
            THEN PSET_TAC[] THEN RW_TAC list_ss[]
	          THEN1(ASM_SET_TAC[FINITE_SING] )
		  THEN1( `{1;2:num} = {1} UNION {2}` by ASM_SET_TAC[]
		         THEN ONCE_ASM_REWRITE_TAC[] THEN ASM_SET_TAC[FINITE_UNION, FINITE_SING])
             THEN ASM_SET_TAC[FINITE_SING])
      THEN1(RW_TAC list_ss[ind_set_def]
            THEN PSET_TAC[] THEN RW_TAC list_ss[] THEN ASM_SET_TAC[])
      THEN1(RW_TAC list_ss[ind_set_def] THEN PSET_TAC[] THEN FULL_SIMP_TAC list_ss[ind_set_def]	    	        THEN ASM_SET_TAC[FINITE_SING])

THEN RW_TAC std_ss[GSYM biginter_def, GSYM bigunion_def]
THEN MP_TAC(Q.ISPECL [`p:('a->bool)#(('a->bool)->bool)#(('a->bool)->extreal)`, `(\i:num. rv_to_devent p (X:num->'a->extreal) t i)`, `L1:num->bool` ,`L2:num->bool`, `ind_set [{0:num}; L1:num->bool; L2:num->bool; {3:num}]`, `ind_set [{0:num}; {1:num; 2}; {3:num}]`, `{0; 1:num; 2}`, `j:num`] PROB_DFT_SEN_plus_lem1)
THEN RW_TAC std_ss[]);




val BIGUNION_3_sets = store_thm("BIGUNION_3_sets",
  ``!x y z. BIGUNION{x;y;z} = x UNION y UNION z  ``,
ASM_SET_TAC[]);



val dSEN_n_OR = store_thm("dSEN_n_OR",
  ``!p Y Ys_a Ys_d Z Zs_a Zs_d X L1 L2 t .

FINITE L1 /\ FINITE L2 /\

disjoint_family_on (ind_set[{0};L1;L2;{3:num}]){0;1;2;3} ==>
 (DFT_event p
              (n_OR
                   (MAP (\i.
                     if i = 0 then WSP Y Ys_a Ys_d
                     else if i = 1 then D_AND (n_OR (MAP X (SET_TO_LIST L1))) (n_OR(MAP  X (SET_TO_LIST L2)))
                    else WSP Z Zs_a Zs_d) (SET_TO_LIST {0:num; 1; 2}))) t =




bigunion
             (\j.
                  biginter
                    (\a.
                         bigunion
                           (\i.
                                event_set
                                  [(DFT_event p (WSP Y Ys_a Ys_d) t,0);
                                   (DFT_event p (WSP Z Zs_a Zs_d) t,3)]
                                  (rv_to_devent p X t) i)
                           (ind_set [{0}; L1; L2; {3}] a))
                    (ind_set [{0}; {1; 2}; {3}] j)) {0:num; 1; 2})``,



RW_TAC std_ss[disjoint_family_on]
THEN KNOW_TAC(`` {0:num} INTER L1 = {}``)
     THEN1(POP_ASSUM(MP_TAC o Q.SPEC `0`)
          THEN DISCH_TAC
	  THEN POP_ASSUM(MP_TAC o Q.SPEC `1`)
	  THEN RW_TAC std_ss[]
	  THEN FULL_SIMP_TAC list_ss[ind_set_def])
THEN KNOW_TAC(`` {0:num} INTER L2 = {}``)
     THEN1(POP_ASSUM(MP_TAC o Q.SPEC `0`)
          THEN DISCH_TAC
	  THEN POP_ASSUM(MP_TAC o Q.SPEC `2`)
	  THEN RW_TAC std_ss[]
	  THEN FULL_SIMP_TAC list_ss[ind_set_def])
	  
THEN KNOW_TAC(`` {3:num} INTER L1 = {}``)
     THEN1(POP_ASSUM(MP_TAC o Q.SPEC `3`)
          THEN DISCH_TAC
	  THEN POP_ASSUM(MP_TAC o Q.SPEC `1`)
	  THEN RW_TAC std_ss[]
	  THEN FULL_SIMP_TAC list_ss[ind_set_def])

THEN KNOW_TAC(`` {3:num} INTER L2 = {}``)
     THEN1(POP_ASSUM(MP_TAC o Q.SPEC `3`)
          THEN DISCH_TAC
	  THEN POP_ASSUM(MP_TAC o Q.SPEC `2`)
	  THEN RW_TAC std_ss[]
	  THEN FULL_SIMP_TAC list_ss[ind_set_def])
THEN RW_TAC std_ss[]


THEN `{0;1;2:num} <>{}` by ASM_SET_TAC[]
THEN KNOW_TAC(``FINITE {0;1;2:num} ``)
     THEN1( `{0:num;1;2} = {0} UNION {1} UNION {2}` by ASM_SET_TAC[]
              THEN ONCE_ASM_REWRITE_TAC[]
	      THEN RW_TAC std_ss[FINITE_UNION, FINITE_SING])
THEN DISCH_TAC
THEN RW_TAC std_ss[n_OR_BIGUNION]
THEN RW_TAC std_ss[GSYM bigunion_def]

THEN KNOW_TAC(``
bigunion
     (\i.
          rv_to_devent p
            (\i.
                 if i = 0 then WSP Y Ys_a Ys_d
                 else if i = 1 then
                   D_AND (n_OR (MAP X (SET_TO_LIST (L1:num->bool))))
                     (n_OR (MAP X (SET_TO_LIST (L2:num->bool))))
                 else WSP Z Zs_a Zs_d) t i) {0:num; 1; 2} =
    DFT_event p (WSP Y Ys_a Ys_d) t UNION
    DFT_event p (D_AND (n_OR (MAP X (SET_TO_LIST L1))) (n_OR (MAP X (SET_TO_LIST L2)))) t UNION
    DFT_event p (WSP Z Zs_a Zs_d) t ``)
     THEN1(RW_TAC std_ss[bigunion_def, rv_to_devent_def]
           THEN KNOW_TAC(``
     {DFT_event p
       (if i = 0:num then WSP Y Ys_a Ys_d
        else if i = 1 then
          D_AND (n_OR (MAP X (SET_TO_LIST L1)))
            (n_OR (MAP X (SET_TO_LIST L2)))
        else WSP Z Zs_a Zs_d) t |
     i IN {0:num; 1; 2}} =
     {DFT_event p
       (WSP Y Ys_a Ys_d) t;
      DFT_event p (D_AND (n_OR (MAP X (SET_TO_LIST (L1:num->bool)))) (n_OR (MAP X (SET_TO_LIST (L2:num->bool))))) t;
      DFT_event p (WSP Z Zs_a Zs_d) t}``)
              THEN1(PSET_TAC[]
                    THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
 		    THEN EQ_TAC
		         THEN1(RW_TAC std_ss[] THEN RW_TAC std_ss[])
	            THEN RW_TAC std_ss[]
		         THEN1(Q.EXISTS_TAC`0`
			        THEN RW_TAC std_ss[])
			 THEN1(Q.EXISTS_TAC`1`
			       THEN RW_TAC std_ss[])
 	 	    THEN Q.EXISTS_TAC`2`
		    THEN RW_TAC std_ss[])
       THEN RW_TAC std_ss[BIGUNION_3_sets])
THEN RW_TAC std_ss[]
THEN ASM_REWRITE_TAC[]
THEN ONCE_REWRITE_TAC[bigunion_def]
THEN PSET_TAC[]
THEN KNOW_TAC(``
   {biginter
       (\a.
            bigunion
              (\i.
                   event_set
                     [(DFT_event p (WSP Y Ys_a Ys_d) t,0);
                      (DFT_event p (WSP Z Zs_a Zs_d) t,3)]
                     (rv_to_devent p X t) i) (ind_set [{0:num}; L1; L2; {3:num}] a))
       (ind_set [{0}; {1; 2}; {3}] i) |
     (i = 0) \/ (i = 1) \/ (i = 2)} =
     {biginter
       (\a.
            bigunion
              (\i.
                   event_set
                     [(DFT_event p (WSP Y Ys_a Ys_d) t,0);
                      (DFT_event p (WSP Z Zs_a Zs_d) t,3)]
                     (rv_to_devent p X t) i) (ind_set [{0}; L1; L2; {3}] a))
       (ind_set [{0}; {1; 2}; {3}] 0);
     biginter
       (\a.
            bigunion
              (\i.
                   event_set
                     [(DFT_event p (WSP Y Ys_a Ys_d) t,0);
                      (DFT_event p (WSP Z Zs_a Zs_d) t,3)]
                     (rv_to_devent p X t) i) (ind_set [{0}; L1; L2; {3}] a))
       (ind_set [{0}; {1; 2}; {3:num}] 1);
   biginter
       (\a.
            bigunion
              (\i.
                   event_set
                     [(DFT_event p (WSP Y Ys_a Ys_d) t,0);
                      (DFT_event p (WSP Z Zs_a Zs_d) t,3)]
                     (rv_to_devent p X t) i) (ind_set [{0}; L1; L2; {3}] a))
       (ind_set [{0}; {1; 2}; {3:num}] 2)}``)
     THEN1 ASM_SET_TAC[]
THEN RW_TAC std_ss[]
THEN RW_TAC std_ss[BIGUNION_3_sets]
THEN RW_TAC list_ss[ind_set_def, EL, HD]
THEN RW_TAC std_ss[biginter_def]
THEN PSET_TAC[]
THEN KNOW_TAC(``
    !k:num.
      {bigunion
       (\i.
            event_set
              [(DFT_event p (WSP Y Ys_a Ys_d) t,0);
               (DFT_event p (WSP Z Zs_a Zs_d) t,3)] (rv_to_devent p X t) i)
       (EL a [{0}; L1; L2; {3:num}]) |
     a = k}=
       {bigunion
       (\i.
            event_set
              [(DFT_event p (WSP Y Ys_a Ys_d) t,0);
               (DFT_event p (WSP Z Zs_a Zs_d) t,3)] (rv_to_devent p X t) i)
       (EL k [{0}; L1; L2; {3}]) }``)

      THEN1(ASM_SET_TAC[])
THEN RW_TAC std_ss[]
THEN RW_TAC list_ss[EL]
THEN RW_TAC std_ss[BIGINTER_SING]
THEN KNOW_TAC(``{bigunion
       (\i.
            event_set
              [(DFT_event p (WSP Y Ys_a Ys_d) t,0);
               (DFT_event p (WSP Z Zs_a Zs_d) t,3)] (rv_to_devent p X t) i)
       (EL a [{0}; L1; L2; {3:num}]) |
     (a = 1) \/ (a = 2:num)} =
     {bigunion
       (\i.
            event_set
              [(DFT_event p (WSP Y Ys_a Ys_d) t,0);
               (DFT_event p (WSP Z Zs_a Zs_d) t,3)] (rv_to_devent p X t) i)
       (EL 1 [{0}; L1; L2; {3:num}]) ;
       bigunion
       (\i.
            event_set
              [(DFT_event p (WSP Y Ys_a Ys_d) t,0);
               (DFT_event p (WSP Z Zs_a Zs_d) t,3)] (rv_to_devent p X t) i)
       (EL 2 [{0}; L1; L2; {3:num}])}``)
        THEN1(ASM_SET_TAC[])
THEN RW_TAC list_ss[]
THEN RW_TAC std_ss[BIGINTER_INTER]
THEN RW_TAC std_ss[bigunion_def, biginter_def, event_set_def, event_set1_def, ind_set_def, EL, rv_to_devent_def]
THEN KNOW_TAC(``{if i:num = 0 then DFT_event p (WSP Y Ys_a Ys_d) t
     else if i = 3 then DFT_event p (WSP Z Zs_a Zs_d) t
     else DFT_event p (X i) t |
     i IN {0}} = { DFT_event p (WSP Y Ys_a Ys_d) t} ``)

    THEN1(ASM_SET_TAC[])
THEN RW_TAC std_ss[]
THEN KNOW_TAC(``
     {if i:num = 0 then DFT_event p (WSP Y Ys_a Ys_d) t
      else if i = 3 then DFT_event p (WSP Z Zs_a Zs_d) t
      else DFT_event p (X i) t |
      i IN L1} =
      {DFT_event p (X i) t |
      i IN L1}``)
      THEN1 ASM_SET_TAC[]
THEN RW_TAC std_ss[]      
THEN KNOW_TAC(``
     {if i:num = 0 then DFT_event p (WSP Y Ys_a Ys_d) t
      else if i = 3 then DFT_event p (WSP Z Zs_a Zs_d) t
      else DFT_event p (X i) t |
      i IN L2} =
      {DFT_event p (X i) t |
      i IN L2}``)
      THEN1 ASM_SET_TAC[]
THEN RW_TAC std_ss[]      
THEN KNOW_TAC(``
    {if i:num = 0 then DFT_event p (WSP Y Ys_a Ys_d) t
     else if i = 3 then DFT_event p (WSP Z Zs_a Zs_d) t
     else DFT_event p (X i) t |
     i IN {3}} =
     {DFT_event p (WSP Z Zs_a Zs_d) t}``)
    THEN1 ASM_SET_TAC[]
THEN RW_TAC std_ss[]
THEN RW_TAC std_ss[BIGUNION_SING]
THEN RW_TAC std_ss[AND_INTER] 
THEN RW_TAC std_ss[n_OR_BIGUNION]
THEN RW_TAC std_ss[rv_to_devent_def]);



val dSEN_n_OR_BIGUNION = store_thm("dSEN_n_OR_BIGUNION",
  ``!p Y Ys_a Ys_d Z Zs_a Zs_d X L1 L2 t .

FINITE L1 /\ FINITE L2 /\

disjoint_family_on (ind_set[{0};L1;L2;{3:num}]){0;1;2;3} ==>
 (DFT_event p
              (n_OR
                   (MAP (\i.
                     if i = 0 then WSP Y Ys_a Ys_d
                    else if i = 1 then D_AND (n_OR (MAP X (SET_TO_LIST L1))) (n_OR(MAP  X (SET_TO_LIST L2)))
                    else WSP Z Zs_a Zs_d) (SET_TO_LIST {0:num; 1; 2}))) t =

 BIGUNION
     {BIGINTER
       {BIGUNION
         {event_set
           [(DFT_event p (WSP Y Ys_a Ys_d) t,0);
            (DFT_event p (WSP Z Zs_a Zs_d) t,3)] (rv_to_devent p X t) i |
         i IN ind_set [{0}; L1; L2; {3}] a} |
       a IN ind_set [{0}; {1; 2}; {3}] j} |
     j IN {0; 1; 2}})``,


RW_TAC std_ss[GSYM bigunion_def, GSYM biginter_def, dSEN_n_OR]);



val PROB_DFT_SEN_plus_lem3 = store_thm("PROB_DFT_SEN_plus_lem3",
  `` !p X Y Ys_a Ys_d Z Zs_a Zs_d t L1 L2. 0<= t /\
      SEN_set_req p L1 L2 (ind_set [{0:num}; L1; L2; {3}])
                 (ind_set [{0:num}; {1; 2}; {3}]) {0; 1; 2} (\i.
                                event_set
                                  [(DFT_event p (WSP Y Ys_a Ys_d) t,0);
                                   (DFT_event p (WSP Z Zs_a Zs_d) t,3)]
                                  (rv_to_devent p X t) i)   ==>

 ( prob p (DFT_event p
             (n_OR
                (MAP
                   (\i:num.
                        if i = 0 then WSP Y Ys_a Ys_d
                        else if i = 1 then
                          D_AND (n_OR (MAP X (SET_TO_LIST L1)))
                            (n_OR (MAP X (SET_TO_LIST L2)))
                        else WSP Z Zs_a Zs_d) (SET_TO_LIST {0; 1; 2}))) t) =

  
1 -
           (1 - prob p (rv_to_devent p(\i:num. if i = 0 then WSP Y Ys_a Ys_d
				                  else if i = 3 then WSP Z Zs_a Zs_d
						  else X i) t 0)) *
           (Normal
              (1 -
               (1 - product L1 (\i. real (1 - prob p (rv_to_devent p (\i:num. if i = 0 then WSP Y Ys_a Ys_d
				                  else if i = 3 then WSP Z Zs_a Zs_d
						  else X i) t i)))) *
               (1 - product L2 (\i. real (1 - prob p (rv_to_devent p (\i:num. if i = 0 then WSP Y Ys_a Ys_d
				                  else if i = 3 then WSP Z Zs_a Zs_d
						  else X i) t i))))) *
            (1 - prob p (rv_to_devent p(\i:num. if i = 0 then WSP Y Ys_a Ys_d
				                  else if i = 3 then WSP Z Zs_a Zs_d
						  else X i) t 3))))``,
RW_TAC std_ss[dSEN_n_OR_BIGUNION, SEN_set_req_def]
THEN KNOW_TAC(``BIGUNION
        {BIGINTER
          {BIGUNION
            {event_set
              [(DFT_event p (WSP Y Ys_a Ys_d) t,0);
               (DFT_event p (WSP Z Zs_a Zs_d) t,3)] (rv_to_devent p X t) i |
            i IN ind_set [{0:num}; L1; L2; {3}] a} |
          a IN ind_set [{0}; {1; 2}; {3}] j} |
        j IN {0; 1; 2}} =
	DFT_event p (n_OR
                   (MAP
                      (\j.
                           n_AND
                             (MAP
                                (\a:num.
                                     n_OR
                                       (MAP (\i:num. if i = 0 then WSP Y Ys_a Ys_d
				                  else if i = 3 then WSP Z Zs_a Zs_d
						  else X i)(SET_TO_LIST
                                             (ind_set [{0:num}; L1; L2; {3}] a))))
                                (SET_TO_LIST (ind_set [{0}; {1; 2}; {3}] j))))
                      (SET_TO_LIST {0; 1; 2}))) t  ``)


        THEN1(DEP_REWRITE_TAC[ n_OR_AND_OR_BIGUNION_INTER_UNION]
 	      THEN RW_TAC std_ss[]
	      THEN1(`{0:num;1;2} = {0} UNION {1;2}` by ASM_SET_TAC[] THEN ONCE_ASM_REWRITE_TAC[]
	            THEN `FINITE {1;2:num} ` by (`{1:num;2} = {1} UNION {2}` by ASM_SET_TAC[] THEN ASM_REWRITE_TAC[] THEN ASM_SET_TAC[FINITE_UNION, FINITE_SING])
		    THEN ASM_SET_TAC[FINITE_UNION, FINITE_SING])
	      THEN1(RW_TAC list_ss[ind_set_def]	    
	            THEN PSET_TAC[FINITE_SING]
		    THEN1(RW_TAC list_ss[] THEN ASM_SET_TAC[FINITE_SING])
		    THEN1(RW_TAC list_ss[]
		          THEN `{1:num;2} = {1} UNION {2}` by ASM_SET_TAC[]
			  THEN ASM_REWRITE_TAC[] THEN ASM_SET_TAC[FINITE_UNION, FINITE_SING])
		    THEN RW_TAC list_ss[] THEN RW_TAC std_ss[FINITE_SING])	
	      THEN1(RW_TAC list_ss[ind_set_def]
	            THEN PSET_TAC[] THEN RW_TAC list_ss[] THEN ASM_SET_TAC[])
	      THEN1 (FULL_SIMP_TAC list_ss[ind_set_def] THEN PSET_TAC[ind_set_def]
	             THEN1(FULL_SIMP_TAC list_ss[] THEN RW_TAC std_ss[FINITE_SING])
		     THEN FULL_SIMP_TAC list_ss[] THEN RW_TAC std_ss[FINITE_SING])
              THEN RW_TAC std_ss[event_set_def, event_set1_def]
	      THEN KNOW_TAC(``!a:num.{if i:num = 0 then DFT_event p (WSP Y Ys_a Ys_d) t
         else if i = 3 then DFT_event p (WSP Z Zs_a Zs_d) t
         else rv_to_devent p X t i |
         i IN ind_set [{0:num}; L1; L2; {3}] a} =
	 {rv_to_devent p
           (\i:num.
                if i = 0 then WSP Y Ys_a Ys_d
                else if i = 3 then WSP Z Zs_a Zs_d
                else X i) t a' |
         a' IN ind_set [{0}; L1; L2; {3}] a}``)

                THEN1(RW_TAC std_ss[rv_to_devent_def]
		     THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
		     THEN RW_TAC std_ss[] THEN EQ_TAC THEN RW_TAC std_ss[]
		     THEN1(Q.EXISTS_TAC`i:num`
		           THEN ASM_SET_TAC[])
		     THEN Q.EXISTS_TAC`a'`
		     THEN ASM_SET_TAC[])
		THEN RW_TAC std_ss[]
		THEN ONCE_ASM_REWRITE_TAC[])

THEN RW_TAC std_ss[]
THEN DEP_REWRITE_TAC[PROB_DFT_SEN_plus_lem2]
THEN RW_TAC std_ss[]
THEN KNOW_TAC(``!a:num.{rv_to_devent p
             (\i.
                  if i = 0 then WSP Y Ys_a Ys_d
                  else if i = 3 then WSP Z Zs_a Zs_d
                  else X i) t a}=
		  {event_set
                   [(DFT_event p (WSP Y Ys_a Ys_d) t,0);
                    (DFT_event p (WSP Z Zs_a Zs_d) t,3)] (rv_to_devent p X t)
                   a}``)	      

     THEN1(RW_TAC std_ss[rv_to_devent_def, event_set_def, event_set1_def]    )
THEN RW_TAC std_ss[]);



val PROB_DFT_SEN_plus = store_thm("PROB_DFT_SEN_plus",
  ``  !p X Y Ys_a Ys_d Z Zs_a Zs_d t L1 L2. 0<= t /\ 

          SEN_set_req p L1 L2 (ind_set [{0}; L1; L2; {3}])
            (ind_set [{0}; {1; 2}; {3}]) {0; 1; 2}
            (\i.
                 event_set
                   [(DFT_event p (WSP Y Ys_a Ys_d) t,0);
                    (DFT_event p (WSP Z Zs_a Zs_d) t,3)] (rv_to_devent p X t)
                   i) /\      (!i. i IN (L1 UNION L2) ==> rv_gt0_ninfinity [X i])==>
          (prob p
             (DFT_event p
                (n_OR
                   (MAP
                      (\i:num.
                           if i = 0 then WSP Y Ys_a Ys_d
                           else if i = 1 then
                             D_AND (n_OR (MAP X (SET_TO_LIST L1)))
                               (n_OR (MAP X (SET_TO_LIST L2)))
                           else WSP Z Zs_a Zs_d) (SET_TO_LIST {0; 1; 2}))) t) =
           1 -
           (1 -
            prob p
              (DFT_event p ( WSP Y Ys_a Ys_d) t))
                     *
           (Normal
              (1 -
               (1 -
                product L1
                  (\i.
                       real
                         (1 -
                         
                            (CDF p (real o (X i)) t )))) *
               (1 -
                product L2
                  (\i.
                       real
                         (1 -
                         
                            (CDF  p (real o (X i)) t))))) *
            (1 -
             prob p
               (DFT_event p (WSP Z Zs_a Zs_d) t))))``,


RW_TAC std_ss[PROB_DFT_SEN_plus_lem3]
THEN RW_TAC std_ss[rv_to_devent_def]
THEN KNOW_TAC(`` {3:num} INTER L1 = {}``)
     THEN1(FULL_SIMP_TAC list_ss[SEN_set_req_def]
            THEN UNDISCH_TAC(``disjoint_family_on (ind_set [{0:num}; L1; L2; {3}]) {0; 1; 2; 3} ``)
	    THEN RW_TAC std_ss[disjoint_family_on]
	    THEN POP_ASSUM (MP_TAC o Q.SPEC`3`)
	    THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC`1`)
	    THEN RW_TAC list_ss[ind_set_def])
	    
THEN KNOW_TAC(`` {0:num} INTER L1 = {}``)
     THEN1(FULL_SIMP_TAC list_ss[SEN_set_req_def]
            THEN UNDISCH_TAC(``disjoint_family_on (ind_set [{0:num}; L1; L2; {3}]) {0; 1; 2; 3} ``)
	    THEN RW_TAC std_ss[disjoint_family_on]
	    THEN POP_ASSUM (MP_TAC o Q.SPEC`0`)
	    THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC`1`)
	    THEN RW_TAC list_ss[ind_set_def])
	    
THEN KNOW_TAC(`` {0:num} INTER L2 = {}``)
     THEN1(FULL_SIMP_TAC list_ss[SEN_set_req_def]
            THEN UNDISCH_TAC(``disjoint_family_on (ind_set [{0:num}; L1; L2; {3}]) {0; 1; 2; 3} ``)
	    THEN RW_TAC std_ss[disjoint_family_on]
	    THEN POP_ASSUM (MP_TAC o Q.SPEC`0`)
	    THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC`2`)
	    THEN RW_TAC list_ss[ind_set_def])
    
THEN KNOW_TAC(`` {3:num} INTER L2 = {}``)
     THEN1(FULL_SIMP_TAC list_ss[SEN_set_req_def]
            THEN UNDISCH_TAC(``disjoint_family_on (ind_set [{0:num}; L1; L2; {3}]) {0; 1; 2; 3} ``)
	    THEN RW_TAC std_ss[disjoint_family_on]
	    THEN POP_ASSUM (MP_TAC o Q.SPEC`3`)
	    THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC`2`)
	    THEN RW_TAC list_ss[ind_set_def])
THEN RW_TAC std_ss[]
THEN KNOW_TAC(``!i:num. i IN L1 ==>  (real
                 (1 -
                  prob p
                    (DFT_event p
                       (if i = 0 then WSP Y Ys_a Ys_d
                        else if i = 3 then WSP Z Zs_a Zs_d
                        else (X:num->'a->extreal) i) t)) =
	 real
                 (1 -
                  prob p
                    (DFT_event p
                       ( X i) t)))``)

     THEN1(RW_TAC std_ss[]
           THEN ASM_SET_TAC[])
THEN RW_TAC std_ss[]
THEN KNOW_TAC(``product L1
          (\i:num.
               real
                 (1 -
                  prob p
                    (DFT_event p
                       (if i = 0 then WSP Y Ys_a Ys_d
                        else if i = 3 then WSP Z Zs_a Zs_d
                        else X i) t))) =
			product L1
          (\i.
                real
                 (1 -
                  prob p
                    (DFT_event p
                       ( X i) t)))``)
		             THEN1 RW_TAC std_ss[th]
THEN RW_TAC std_ss[]
THEN KNOW_TAC(``!i:num. i IN L2 ==>  (real
                 (1 -
                  prob p
                    (DFT_event p
                       (if i = 0 then WSP Y Ys_a Ys_d
                        else if i = 3 then WSP Z Zs_a Zs_d
                        else (X:num->'a->extreal) i) t)) =
	 real
                 (1 -
                  prob p
                    (DFT_event p
                       ( X i) t)))``)

     THEN1(RW_TAC std_ss[]
           THEN ASM_SET_TAC[])
THEN RW_TAC std_ss[]
THEN KNOW_TAC(``product L2
          (\i:num.
               real
                 (1 -
                  prob p
                    (DFT_event p
                       (if i = 0 then WSP Y Ys_a Ys_d
                        else if i = 3 then WSP Z Zs_a Zs_d
                        else X i) t))) =
			product L2
          (\i.
                real
                 (1 -
                  prob p
                    (DFT_event p
                       ( X i) t)))``)
		             THEN1 RW_TAC std_ss[th]
THEN RW_TAC std_ss[]
THEN RW_TAC std_ss[o_DEF]
THEN FULL_SIMP_TAC list_ss[rv_gt0_ninfinity_def]
THEN `!i:num. i IN L1 ==> (real (1 - prob p (DFT_event p (X i) t)) =
                          real (1 - CDF p (\x. real (X i x)) t))` by (RW_TAC std_ss[] THEN RW_TAC std_ss[CDF_prob_DFT_event] THEN `!i:num. (\x. X i x) = X i`by METIS_TAC[ETA_THM] THEN ASM_REWRITE_TAC[])
THEN `!i:num. i IN L2 ==> (real (1 - prob p (DFT_event p (X i) t)) =
                          real (1 - CDF p (\x. real (X i x)) t))` by (RW_TAC std_ss[] THEN RW_TAC std_ss[CDF_prob_DFT_event] THEN `!i:num. (\x. X i x) = X i`by METIS_TAC[ETA_THM] THEN ASM_REWRITE_TAC[])
THEN  `product L1 (\i:num. real (1 - prob p (DFT_event p (X i) t)))=
      product L1 (\i. real (1 - CDF p (\x. real (X i x)) t))` by RW_TAC std_ss[th]
THEN  `product L2 (\i:num. real (1 - prob p (DFT_event p (X i) t)))=
      product L2 (\i. real (1 - CDF p (\x. real (X i x)) t))` by RW_TAC std_ss[th]
THEN RW_TAC std_ss[]);





(******************************************************************************)
(*                                                                            *)
(*                     Broadcast Reliability SEN+  DRBD                       *)
(*                                                                            *)
(******************************************************************************)




val PROB_DRBD_SEN_plus_broadcast_lem1 = store_thm("PROB_DRBD_SEN_plus_broadcast_lem1",
  `` !p X L1 L2 L3 L A J.
            L1 <> {} /\ L2 <> {} /\ FINITE L1 /\ FINITE L2 /\ FINITE L3 /\ L3 <> {} /\
            indep_sets p (\i. {X i}) (BIGUNION_o_BIGUNION L A J) /\
            disjoint_family_on (ind_set [{0}; L1; L2; L3]) {0; 1; 2; 3} /\
            (J = {0; 1; 2}) /\ (A = ind_set [{0}; {1; 2}; {3}]) /\
            (L = ind_set [{0}; L1; L2; L3]) ==>
            (prob p
               (DRBD_series
                  (\j. DRBD_parallel (\a. DRBD_series X (L a)) (A j)) J) =
             prob p (X 0) * Normal (product L3 (\l. real (prob p (X l)))) *
             (1 -
              (1 - Normal (product L1 (\l. real (prob p (X l))))) *
              (1 - Normal (product L2 (\l. real (prob p (X l)))))))``,
    
RW_TAC std_ss[disjoint_family_on]
THEN KNOW_TAC(``DISJOINT  (L1:num->bool) L2 ``)
     THEN1(RW_TAC std_ss[DISJOINT_DEF]
           THEN POP_ASSUM (MP_TAC o Q.SPEC `1:num `)
	   THEN DISCH_TAC
	   THEN POP_ASSUM (MP_TAC o Q.SPEC `2:num `)
           THEN RW_TAC list_ss[]
	   THEN FULL_SIMP_TAC list_ss[ind_set_def])
THEN KNOW_TAC(``DISJOINT  (L1:num->bool) L3 ``)
     THEN1(RW_TAC std_ss[DISJOINT_DEF]
           THEN POP_ASSUM (MP_TAC o Q.SPEC `1:num `)
	   THEN DISCH_TAC
	   THEN POP_ASSUM (MP_TAC o Q.SPEC `3:num `)
           THEN RW_TAC list_ss[]
	   THEN FULL_SIMP_TAC list_ss[ind_set_def])
THEN KNOW_TAC(``DISJOINT  (L2:num->bool) L3 ``)
     THEN1(RW_TAC std_ss[DISJOINT_DEF]
           THEN POP_ASSUM (MP_TAC o Q.SPEC `2:num `)
	   THEN DISCH_TAC
	   THEN POP_ASSUM (MP_TAC o Q.SPEC `3:num `)
           THEN RW_TAC list_ss[]
	   THEN FULL_SIMP_TAC list_ss[ind_set_def])
THEN KNOW_TAC(``DISJOINT  ({0}:num->bool) L1 ``)
     THEN1(RW_TAC std_ss[DISJOINT_DEF]
           THEN POP_ASSUM (MP_TAC o Q.SPEC `0:num `)
	   THEN DISCH_TAC
	   THEN POP_ASSUM (MP_TAC o Q.SPEC `1:num `)
           THEN RW_TAC list_ss[]
	   THEN FULL_SIMP_TAC list_ss[ind_set_def])
THEN KNOW_TAC(``DISJOINT  ({0}:num->bool) L2 ``)
     THEN1(RW_TAC std_ss[DISJOINT_DEF]
           THEN POP_ASSUM (MP_TAC o Q.SPEC `0:num `)
	   THEN DISCH_TAC
	   THEN POP_ASSUM (MP_TAC o Q.SPEC `2:num `)
           THEN RW_TAC list_ss[]
	   THEN FULL_SIMP_TAC list_ss[ind_set_def])
THEN KNOW_TAC(``DISJOINT  ({0}:num->bool) L3 ``)
     THEN1(RW_TAC std_ss[DISJOINT_DEF]
           THEN POP_ASSUM (MP_TAC o Q.SPEC `0:num `)
	   THEN DISCH_TAC
	   THEN POP_ASSUM (MP_TAC o Q.SPEC `3:num `)
           THEN RW_TAC list_ss[]
	   THEN FULL_SIMP_TAC list_ss[ind_set_def])
THEN RW_TAC std_ss[]

THEN KNOW_TAC(``BIGUNION {EL j [{0:num}; {1; 2}; {3}] | j IN {0; 1; 2:num}} = {0;1;2;3} ``)
     THEN1( SRW_TAC[][GSPECIFICATION, EXTENSION]
            THEN EQ_TAC
                THEN1(RW_TAC std_ss[]
      		      THEN FULL_SIMP_TAC list_ss[])
         	 THEN RW_TAC std_ss[]
		      THEN1( Q.EXISTS_TAC`{0}` THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[] 
	                    THEN Q.EXISTS_TAC`0` THEN RW_TAC std_ss[]
			    THEN RW_TAC list_ss[])
	 	      THEN1( Q.EXISTS_TAC`{1;2}` THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
	                    THEN Q.EXISTS_TAC`1` THEN RW_TAC std_ss[]
	   	            THEN RW_TAC list_ss[])
		      THEN1( Q.EXISTS_TAC`{1;2}` THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
		             THEN Q.EXISTS_TAC`1` THEN RW_TAC std_ss[]
		             THEN RW_TAC list_ss[])
           THEN Q.EXISTS_TAC`{3}` THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
     	   THEN Q.EXISTS_TAC`2` THEN RW_TAC list_ss[])
THEN DISCH_TAC
THEN DEP_REWRITE_TAC[PROB_DRBD_series_parallel_series_lem]
THEN RW_TAC std_ss[]
     THEN1 ASM_SET_TAC[]
     THEN1 (RW_TAC std_ss[sets_finite_not_empty2_def]
            THEN1(RW_TAC std_ss[ind_set_def]
	          THEN `(j=0:num) \/(j=1) \/(j=2)` by ASM_SET_TAC[]
		  THEN RW_TAC list_ss[] THEN ASM_SET_TAC[])
            THEN1(RW_TAC std_ss[ind_set_def]
	          THEN `(j=0:num) \/(j=1) \/(j=2)` by ASM_SET_TAC[]
	               THEN1( RW_TAC list_ss[] THEN ASM_SET_TAC[FINITE_SING])
		       THEN1(RW_TAC list_ss[] THEN `{1:num;2} = {1} UNION {2}` by ASM_SET_TAC[]
		            THEN ONCE_ASM_REWRITE_TAC[] THEN ASM_SET_TAC[FINITE_SING, FINITE_UNION])
		  THEN RW_TAC list_ss[] THEN ASM_SET_TAC[FINITE_SING])
 	    THEN1( RW_TAC std_ss [ind_set_def]
	           THEN FULL_SIMP_TAC std_ss[ind_set_def]
		   THEN`(a:num = 0) \/ (a = 1) \/ (a = 2) \/ (a = 3)` by ASM_SET_TAC[]
		   THEN RW_TAC list_ss[] THEN ASM_SET_TAC[])
	    THEN1(RW_TAC std_ss[ind_set_def] THEN FULL_SIMP_TAC std_ss[ind_set_def]
	         THEN `(a:num = 0) \/ (a = 1) \/ (a = 2) \/ (a = 3)` by ASM_SET_TAC[]
		      THEN1(RW_TAC list_ss[] THEN ASM_SET_TAC[FINITE_SING])
		      THEN1(RW_TAC list_ss[])
		      THEN1(RW_TAC list_ss[])
		 THEN RW_TAC list_ss[]  THEN ASM_SET_TAC[FINITE_SING])
	    THEN1( `{0:num;1;2} = {0} UNION {1} UNION {2}` by ASM_SET_TAC[]
	          THEN ONCE_ASM_REWRITE_TAC[] THEN ASM_SET_TAC[FINITE_SING, FINITE_UNION])
            THEN1( RW_TAC std_ss[ind_set_def] THEN RW_TAC std_ss[disjoint_family_on]
	         THEN `((j = 0:num) \/ (j = 1) \/ (j=2)) /\ ((j'=0:num) \/ (j'=1)\/(j'=2))` by ASM_SET_TAC[]
		      THEN1(FULL_SIMP_TAC std_ss[])
		      THEN1(RW_TAC list_ss[] THEN ASM_SET_TAC[])
		      THEN1(RW_TAC list_ss[] THEN ASM_SET_TAC[])
	              THEN1(RW_TAC list_ss[] THEN ASM_SET_TAC[])
	              THEN1(FULL_SIMP_TAC std_ss[])
		      THEN1(RW_TAC list_ss[] THEN ASM_SET_TAC[])
		      THEN1(RW_TAC list_ss[] THEN ASM_SET_TAC[])
		      THEN1(RW_TAC list_ss[] THEN ASM_SET_TAC[])
	          THEN FULL_SIMP_TAC std_ss[])
            THEN1 (ASM_SET_TAC[])
	    THEN RW_TAC std_ss[disjoint_family_on, ind_set_def])
THEN `{0;1;2:num} = {0} UNION {1;2}` by ASM_SET_TAC[]		 
THEN ONCE_ASM_REWRITE_TAC[]
THEN KNOW_TAC(``FINITE {0:num} /\ FINITE {1;2:num} /\ DISJOINT {0:num} {1;2}``)
     THEN1(RW_TAC std_ss[FINITE_SING]
         THEN1(`{1;2:num} = {1} UNION {2}` by ASM_SET_TAC[]
            THEN ONCE_ASM_REWRITE_TAC[] THEN ASM_SET_TAC[FINITE_SING, FINITE_UNION])
     THEN ASM_SET_TAC[DISJOINT_DEF])	    
THEN RW_TAC std_ss[PRODUCT_UNION]
THEN RW_TAC std_ss[PRODUCT_SING]
THEN KNOW_TAC(``ind_set [{0}; {1; 2}; {3}] 0 = {0} ``)
    THEN1(RW_TAC std_ss[ind_set_def]
          THEN RW_TAC list_ss[])
THEN RW_TAC std_ss[]	  
THEN ONCE_ASM_REWRITE_TAC[]
THEN KNOW_TAC(``
      real
        (1 -
         Normal(product (ind_set [{0}; {1; 2}; {3}] 0)
              (\a.
                   real
                     (1 -
                      Normal
                        (product (ind_set [{0}; (L1:num->bool); L2; L3] a)
                           (\l. real (1 - Normal (real (1 - prob p (X l)))))))))) =
     real (1-Normal (real (1 - Normal (real (1 - Normal (real (1 - prob p (X 0))))))) ) ``)

    THEN1(NTAC 3(AP_TERM_TAC)
          THEN ONCE_ASM_REWRITE_TAC[]
	  THEN KNOW_TAC(`` product (ind_set [{0:num}; {1; 2}; {3}] 0)
     (\a.
          real
            (1 -
             Normal
               (product (ind_set [{0:num}; L1; L2; L3] a)
                  (\l. real (1 - Normal (real (1 - prob p (X l))))))))  =
		   product ({0})
     (\a.
          real
            (1 -
             Normal
               (product (ind_set [{0}; L1; L2; L3] a)
                  (\l. real (1 - Normal (real (1 - prob p (X l))))))))``)
	      THEN1(RW_TAC std_ss[ind_set_def] THEN RW_TAC list_ss[])
	  THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]    
	  THEN RW_TAC std_ss[PRODUCT_SING]
	  THEN RW_TAC std_ss[ind_set_def]
          THEN RW_TAC list_ss[]
	  THEN RW_TAC std_ss[PRODUCT_SING])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]	  
THEN `({1:num;2} = {1} UNION {2}) /\ FINITE {1:num} /\ FINITE {2:num} /\ DISJOINT {1:num}{2}` by ASM_SET_TAC[FINITE_SING, DISJOINT_DEF]
THEN RW_TAC std_ss[PRODUCT_UNION, PRODUCT_SING]
THEN RW_TAC list_ss[ind_set_def, PRODUCT_SING]
THEN KNOW_TAC(``
      real
         (1 -
          Normal
            (product ({1} UNION {2})
               (\a.
                    real
                      (1 -
                       Normal
                         (product (EL a [{0:num}; L1; L2; L3])
                            (\l. real (1 - Normal (real (1 - prob p ((X:num->'a->bool) l)))))))))) =
       real
          (1 -
           Normal
             (real
                (1 -
                 Normal
                   (product L1
                      (\l. real (1 - Normal (real (1 - prob p (X l))))))) *
              real
                (1 -
                 Normal
                   (product L2
                      (\l. real (1 - Normal (real (1 - prob p (X l)))))))))``)
     THEN1(NTAC 3(AP_TERM_TAC)
           THEN RW_TAC std_ss[PRODUCT_UNION, PRODUCT_SING]
	   THEN RW_TAC list_ss[])
THEN RW_TAC std_ss[]	   
THEN KNOW_TAC(``prob p ((X:num->'a->bool) 0) <> PosInf /\ prob p (X 0) <> NegInf ``)
     THEN1(KNOW_TAC(`` 0:num IN BIGUNION_o_BIGUNION (ind_set [{0:num}; L1; L2;L3])
               (ind_set [{0}; {1; 2}; {3}]) {0; 1; 2:num}``)
           THEN1(RW_TAC std_ss[ind_set_def, BIGUNION_o_BIGUNION_def]
                 THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
   	         THEN Q.EXISTS_TAC`{0}`
	         THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
	 	 THEN Q.EXISTS_TAC`0` THEN RW_TAC list_ss[]
		 THEN Q.EXISTS_TAC`{0}` THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
 		 THEN Q.EXISTS_TAC`0` THEN RW_TAC list_ss[])
		 THEN FULL_SIMP_TAC std_ss[indep_sets]
		 THEN DISCH_TAC THEN `(X:num->'a->bool) 0 IN events p` by ASM_SET_TAC[]
		 THEN `prob_space p` by FULL_SIMP_TAC std_ss[indep_sets]
		 THEN METIS_TAC[PROB_FINITE])
THEN DISCH_TAC
THEN `1 <> PosInf /\ 1 <> NegInf` by METIS_TAC[extreal_of_num_def, extreal_not_infty]
THEN KNOW_TAC(``   (real
        (1 -
         Normal
           (real (1 - Normal (real (1 - Normal (real (1 - prob p ((X:num->'a->bool) 0))))))))) =
	   real (prob p (X 0)) ``)
	   
      THEN1(AP_TERM_TAC
	    THEN KNOW_TAC(`` Normal (real (1 - prob p ((X:num->'a->bool) 0))) = 1-prob p (X 0) ``)
                 THEN1(METIS_TAC[sub_not_infty, normal_real])
	    THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
	    THEN KNOW_TAC(``(1 - (1 - prob p (X 0))) = prob p ((X:num->'a->bool) 0) ``)
		THEN1(METIS_TAC[extreal_sub_sub2])
	    THEN RW_TAC std_ss[]
	    THEN RW_TAC std_ss[normal_real])
THEN RW_TAC std_ss[]	    

THEN KNOW_TAC(``(product L1
                    (\l. real (1 - Normal (real (1 - prob p ((X:num->'a->bool) l)))))) =
		(product L1
                    (\l. real (prob p (X l))))``)
      THEN1(KNOW_TAC(``
          !l:num.
	     l IN L1 ==> (real (1 - Normal (real (1 - prob p ((X:num->'a->bool) l)))) =
             real (prob p ((X:num->'a->bool)l)))``)
	     THEN1(RW_TAC std_ss[]
	           THEN KNOW_TAC(``prob p ((X:num->'a->bool)l ) <> PosInf /\
		                   prob p (X l) <> NegInf ``)
		        THEN1(KNOW_TAC(`` l:num IN BIGUNION_o_BIGUNION (ind_set [{0}; L1; L2; L3])
               (ind_set [{0}; {1; 2}; {3}]) {0; 1; 2:num}``)
                              THEN1(RW_TAC std_ss[ind_set_def, BIGUNION_o_BIGUNION_def]
                 	            THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
   	         		    THEN Q.EXISTS_TAC`L1`
	         		    THEN RW_TAC std_ss[] 
	 	 		    THEN Q.EXISTS_TAC`1` THEN RW_TAC list_ss[]
		 		    THEN Q.EXISTS_TAC`{1;2}` THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
 		 		    THEN Q.EXISTS_TAC`1` THEN RW_TAC list_ss[])
			     THEN UNDISCH_TAC(``indep_sets p (\i:num. {X i})
           (BIGUNION_o_BIGUNION (ind_set [{0}; L1; L2; L3])
              (ind_set [{0}; {1; 2}; {3}]) {0; 1; 2}) ``)
			     THEN UNDISCH_TAC(``{0; 1; 2} = {0} UNION {1; 2:num} ``)
			     THEN FULL_SIMP_TAC std_ss[indep_sets]
			     
	                     THEN RW_TAC std_ss[]
			     THEN `(X:num->'a->bool) l IN events p` by ASM_SET_TAC[]
		 	     THEN `prob_space p` by FULL_SIMP_TAC std_ss[indep_sets]
		 	     THEN METIS_TAC[PROB_FINITE])
		   THEN DISCH_TAC
		   THEN KNOW_TAC(``(1 - (1 - prob p (X l))) = prob p ((X:num->'a->bool) l) ``)
		        THEN1(METIS_TAC[extreal_sub_sub2])
	           THEN RW_TAC std_ss[]
	           THEN RW_TAC std_ss[normal_real]
		   THEN METIS_TAC[sub_not_infty, normal_real])
	    THEN DISCH_TAC THEN RW_TAC std_ss[th])
THEN RW_TAC std_ss[]	    
THEN KNOW_TAC(``(product L2
                    (\l. real (1 - Normal (real (1 - prob p ((X:num->'a->bool) l)))))) =
		(product L2
                    (\l. real (prob p (X l))))``)
      THEN1(KNOW_TAC(``
            !l:num.
	      l IN L2 ==>
	      (real (1 - Normal (real (1 - prob p ((X:num->'a->bool) l)))) =
               real (prob p ((X:num->'a->bool)l)))``)
	     THEN1(RW_TAC std_ss[]
	           THEN KNOW_TAC(``prob p ((X:num->'a->bool)l ) <> PosInf /\
		                   prob p (X l) <> NegInf ``)
		        THEN1(KNOW_TAC(`` l:num IN BIGUNION_o_BIGUNION (ind_set [{0}; L1; L2; L3])
               (ind_set [{0}; {1; 2}; {3}]) {0; 1; 2:num}``)
                              THEN1(RW_TAC std_ss[ind_set_def, BIGUNION_o_BIGUNION_def]
                 	            THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
   	         		    THEN Q.EXISTS_TAC`L2`
	         		    THEN RW_TAC std_ss[] 
	 	 		    THEN Q.EXISTS_TAC`2` THEN RW_TAC list_ss[]
		 		    THEN Q.EXISTS_TAC`{1;2}` THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
 		 		    THEN Q.EXISTS_TAC`1` THEN RW_TAC list_ss[])
		 	     THEN UNDISCH_TAC(``indep_sets p (\i:num. {X i})
           (BIGUNION_o_BIGUNION (ind_set [{0}; L1; L2; L3])
              (ind_set [{0}; {1; 2}; {3}]) {0; 1; 2}) ``)
	                    THEN RW_TAC std_ss[indep_sets]
			    THEN `(X:num->'a->bool) l IN events p` by ASM_SET_TAC[]
		 	     THEN `prob_space p` by FULL_SIMP_TAC std_ss[indep_sets]
		 	     THEN METIS_TAC[PROB_FINITE])
		   THEN DISCH_TAC
		   THEN KNOW_TAC(``(1 - (1 - prob p (X l))) = prob p ((X:num->'a->bool) l) ``)
		        THEN1(METIS_TAC[extreal_sub_sub2])
	           THEN RW_TAC std_ss[]
	           THEN RW_TAC std_ss[normal_real]
		   THEN METIS_TAC[sub_not_infty, normal_real])
	    THEN DISCH_TAC THEN RW_TAC std_ss[th])
THEN RW_TAC std_ss[]
THEN `(1 − Normal (product L1 (λl. real (prob p ((X:num->'a->bool) l))))) <> PosInf /\
      (1 − Normal (product L1 (λl. real (prob p (X l))))) <> NegInf` by METIS_TAC[sub_not_infty, extreal_not_infty]
THEN  `(1 − Normal (product L2 (λl. real (prob p ((X:num->'a->bool) l))))) <> PosInf /\
       (1 − Normal (product L2 (λl. real (prob p (X l))))) <> NegInf` by METIS_TAC[sub_not_infty, extreal_not_infty]
THEN RW_TAC std_ss[real_mul_real]
THEN `((1 − Normal (product L1 (λl. real (prob p ((X:num->'a->bool) l))))) *
               (1 − Normal (product L2 (λl. real (prob p (X l)))))) <> PosInf /\
	       ((1 − Normal (product L1 (λl. real (prob p (X l))))) *
               (1 − Normal (product L2 (λl. real (prob p (X l)))))) <> NegInf` by METIS_TAC[mul_extreal_not_infty]
THEN RW_TAC std_ss[normal_real]
THEN `(1 −
         (1 − Normal (product L1 (λl. real (prob p ((X:num->'a->bool) l))))) *
         (1 − Normal (product L2 (λl. real (prob p (X l)))))) <> PosInf /\
      (1 −
         (1 − Normal (product L1 (λl. real (prob p (X l))))) *
         (1 − Normal (product L2 (λl. real (prob p (X l)))))) <> NegInf` by METIS_TAC[sub_not_infty]THEN RW_TAC std_ss[normal_real]

THEN KNOW_TAC(``(product L3
                    (\l. real (1 - Normal (real (1 - prob p ((X:num->'a->bool) l)))))) =
		(product L3
                    (\l. real (prob p (X l))))``)
      THEN1(KNOW_TAC(``
            !l:num.
	      l IN L3 ==>
	      (real (1 - Normal (real (1 - prob p ((X:num->'a->bool) l)))) =
               real (prob p ((X:num->'a->bool)l)))``)
	     THEN1(RW_TAC std_ss[]
	           THEN KNOW_TAC(``prob p ((X:num->'a->bool)l ) <> PosInf /\
		                   prob p (X l) <> NegInf ``)
		        THEN1(KNOW_TAC(`` l:num IN BIGUNION_o_BIGUNION (ind_set [{0}; L1; L2; L3])
               (ind_set [{0}; {1; 2}; {3}]) {0; 1; 2:num}``)
                              THEN1(RW_TAC std_ss[ind_set_def, BIGUNION_o_BIGUNION_def]
                 	            THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
   	         		    THEN Q.EXISTS_TAC`L3`
	         		    THEN RW_TAC std_ss[] 
	 	 		    THEN Q.EXISTS_TAC`3` THEN RW_TAC list_ss[]
		 		    THEN Q.EXISTS_TAC`{3}` THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
 		 		    THEN Q.EXISTS_TAC`2` THEN RW_TAC list_ss[])
			     THEN UNDISCH_TAC(`` indep_sets p (\i:num. {X i})
           (BIGUNION_o_BIGUNION (ind_set [{0}; L1; L2; L3])
              (ind_set [{0}; {1; 2}; {3}]) {0; 1; 2})``)
	                     THEN RW_TAC std_ss[indep_sets]
			     THEN `(X:num->'a->bool) l IN events p` by ASM_SET_TAC[]
		 	     THEN `prob_space p` by FULL_SIMP_TAC std_ss[indep_sets]
		 	     THEN METIS_TAC[PROB_FINITE])
		   THEN DISCH_TAC
		   THEN KNOW_TAC(``(1 - (1 - prob p (X l))) = prob p ((X:num->'a->bool) l) ``)
		        THEN1(METIS_TAC[extreal_sub_sub2])
	           THEN RW_TAC std_ss[]
	           THEN RW_TAC std_ss[normal_real]
		   THEN METIS_TAC[sub_not_infty, normal_real])
	    THEN DISCH_TAC THEN RW_TAC std_ss[th])
	    
THEN RW_TAC std_ss[]
THEN  `(1 − Normal (product L3 (λl. real (prob p ((X:num->'a->bool) l))))) <> PosInf /\
       (1 − Normal (product L3 (λl. real (prob p (X l))))) <> NegInf` by METIS_TAC[sub_not_infty, extreal_not_infty]
THEN RW_TAC std_ss[real_mul_real]
THEN `(1 − Normal (product L3 (λl. real (prob p ((X:num->'a->bool) l))))) <> PosInf /\
      (1 − Normal (product L3 (λl. real (prob p (X l))))) <> NegInf` by METIS_TAC[sub_not_infty, extreal_not_infty]
THEN RW_TAC std_ss[normal_real]
THEN RW_TAC std_ss[extreal_sub_sub2]
THEN RW_TAC std_ss[REAL_MUL_ASSOC]
THEN RW_TAC std_ss[normal_real_mul3]
THEN RW_TAC std_ss[normal_real]);	 




val PROB_DRBD_SEN_plus_broadcast = store_thm("PROB_DRBD_SEN_plus_broadcast",
  `` !p X Y t L1 L2 L3 L A J.
            L1 <> {} /\ L2 <> {} /\ L3 <> {} /\FINITE L1 /\ FINITE L2 /\ FINITE L3 /\
           
            indep_sets p
              (\i.
                   {event_set [(DRBD_event p Y t,0)] X
                      i}) (BIGUNION_o_BIGUNION L A J) /\
            disjoint_family_on (ind_set [{0}; L1; L2; L3]) {0; 1; 2; 3} /\
            (J = {0; 1; 2}) /\ (A = ind_set [{0}; {1; 2}; {3}]) /\
            (L = ind_set [{0}; L1; L2; L3]) ==>
            (prob p
               (DRBD_series
                  (\j.
                       DRBD_parallel
                         (\a.
                              DRBD_series
                                (\i.
                                     event_set
                                       [(DRBD_event p Y t,0)] X i) (L a))
                         (A j)) J) =
             prob p (DRBD_event p Y t) *  Normal (product L3 (\l. real (prob p (X l)))) *
             (1 -
              (1 - Normal (product L1 (\l. real (prob p (X l))))) *
              (1 - Normal (product L2 (\l. real (prob p (X l)))))))``,

RW_TAC std_ss[event_set_def, event_set1_def]
THEN DEP_REWRITE_TAC[PROB_DRBD_SEN_plus_broadcast_lem1]
THEN RW_TAC std_ss[]
     THEN1 (FULL_SIMP_TAC list_ss[indep_sets, BIGUNION_o_BIGUNION_def, ind_set_def]
           THEN PSET_TAC[]
	   THEN ASM_SET_TAC[])
     THEN1 (FULL_SIMP_TAC list_ss[indep_sets, BIGUNION_o_BIGUNION_def, ind_set_def]
           THEN PSET_TAC[]
	   THEN ASM_SET_TAC[])
     THEN1 ASM_SET_TAC[ETA_THM]
THEN RW_TAC std_ss[]    
THEN KNOW_TAC(``{0:num} INTER L1 = {} ``)
     THEN1 (FULL_SIMP_TAC std_ss[disjoint_family_on, ind_set_def]
            THEN POP_ASSUM (MP_TAC o Q.SPEC `0:num `)
            THEN DISCH_TAC
       	    THEN POP_ASSUM (MP_TAC o Q.SPEC `1:num `)
	    THEN RW_TAC list_ss[])
THEN KNOW_TAC(``{0:num} INTER L3 = {} ``)
     THEN1 (FULL_SIMP_TAC std_ss[disjoint_family_on, ind_set_def]
            THEN POP_ASSUM (MP_TAC o Q.SPEC `0:num `)
            THEN DISCH_TAC
       	    THEN POP_ASSUM (MP_TAC o Q.SPEC `3:num `)
	    THEN RW_TAC list_ss[])
THEN RW_TAC std_ss[]
THEN KNOW_TAC(`` !i:num. i IN L1 ==>
                (real
                 (prob p
                    (if i = 0 then DRBD_event p Y t
                     else (X:num->'a->bool) i)) =
		 real (prob p (X i))) ``)
      THEN1(RW_TAC std_ss[] THEN ASM_SET_TAC[])
THEN RW_TAC std_ss[]
THEN KNOW_TAC(``
     (1 -
     Normal
       (product L1
          (\i.
               real
                 (prob p
                    (if i = 0 then DRBD_event p Y t
                     
                     else (X:num->'a->bool) i))))) =

     (1 -
     Normal
       (product L1
          (\i.
               real
                 (prob p
                     (X i)))))``)
      THEN1 (NTAC 2(AP_TERM_TAC) THEN  RW_TAC std_ss[th])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]      
THEN KNOW_TAC(``{0:num} INTER L2 = {} ``)
     THEN1 (FULL_SIMP_TAC std_ss[disjoint_family_on, ind_set_def]
            THEN UNDISCH_TAC (``!m n:num.
             m IN {0; 1; 2; 3} /\ n IN {0; 1; 2; 3} /\ m <> n ==>
             (EL m [{0:num}; L1; L2; L3] INTER EL n [{0}; L1; L2; L3] = {})``)
	    THEN DISCH_TAC
 	    THEN POP_ASSUM (MP_TAC o Q.SPEC `0:num `)
            THEN DISCH_TAC
       	    THEN POP_ASSUM (MP_TAC o Q.SPEC `2:num `)
	    THEN RW_TAC list_ss[])
THEN DISCH_TAC	    
THEN RW_TAC std_ss[]
THEN KNOW_TAC(``!i. i IN L2 ==> (

                 real
                 (prob p
                    (if i = 0 then DRBD_event p Y t
                     else X i)) =
		 real (prob p ((X:num->'a->bool) i)))``)

       THEN1(RW_TAC std_ss[] THEN ASM_SET_TAC[])
THEN DISCH_TAC
THEN KNOW_TAC(``
        product L2
             (\i.
               real
                 (prob p
                    (if i = 0 then DRBD_event p Y t
                    
                     else X i))) =
       (product L2 (\l. real (prob p ((X:num->'a->bool) l))))  ``)
       THEN1(RW_TAC std_ss[th])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]       
THEN RW_TAC std_ss[]
THEN KNOW_TAC(``!i. i IN L3 ==> (

                 real
                 (prob p
                    (if i = 0 then DRBD_event p Y t
                     else X i)) =
		 real (prob p ((X:num->'a->bool) i)))``)

       THEN1(RW_TAC std_ss[] THEN ASM_SET_TAC[])
THEN DISCH_TAC
THEN KNOW_TAC(``
        product L3
             (\i.
               real
                 (prob p
                    (if i = 0 then DRBD_event p Y t
                    
                     else X i))) =
       (product L3 (\l. real (prob p ((X:num->'a->bool) l))))  ``)
       THEN1(RW_TAC std_ss[th])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]       
THEN RW_TAC std_ss[]);

 
val PROB_DRBD_SEN_plus_broadcast_rel_lem = store_thm("PROB_DRBD_SEN_plus_broadcast_rel_lem",
  ``  !p X Y Ys_a Ys_d t L1 L2 L3 L A J.
            L1 <> {} /\ L2 <> {} /\ L3 <> {} /\ FINITE L1 /\ FINITE L2 /\ FINITE L3 /\
           
            indep_sets p
              (\i.
                   {event_set
                      [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0)] X i})
              (BIGUNION_o_BIGUNION L A J) /\
            disjoint_family_on (ind_set [{0}; L1; L2; L3]) {0; 1; 2; 3} /\
            (J = {0; 1; 2}) /\ (A = ind_set [{0}; {1; 2}; {3}]) /\
            (L = ind_set [{0}; L1; L2; L3]) ==>
            (prob p
               (DRBD_series
                  (\j.
                       DRBD_parallel
                         (\a.
                              DRBD_series
                                (\i.
                                     event_set
                                       [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0)]
                                       X i) (L a)) (A j)) J) =
             Rel p (R_WSP Y Ys_a Ys_d) t *  Normal (product L3 (\l. real (prob p (X l)))) *
             (1 -
              (1 - Normal (product L1 (\l. real (prob p (X l))))) *
              (1 - Normal (product L2 (\l. real (prob p (X l)))))))``,

RW_TAC std_ss[Rel_def]
THEN DEP_REWRITE_TAC[PROB_DRBD_SEN_plus_broadcast]
THEN METIS_TAC[ETA_THM]);



val SEN_broad_set_req_def = Define `SEN_broad_set_req p L1 L2 L3 L A J X =
 L1 <> {} /\ (L2:num->bool) <> {} /\ FINITE L1 /\ FINITE L2 /\ L3 <> {} /\ FINITE L3 /\
            indep_sets p
              (\i. {X i}) (BIGUNION_o_BIGUNION L A J) /\
            disjoint_family_on (ind_set [{0}; L1; L2; L3]) {0:num; 1; 2; 3}`;



val PROB_DRBD_SEN_plus_broadcast_rel = store_thm("PROB_DRBD_SEN_plus_rel",
  `` !p X Y Ys_a Ys_d t L1 L2 L3 L A J.
    SEN_broad_set_req p L1 L2 L3 (ind_set [{0:num}; L1; L2; L3])
	         (ind_set [{0}; {1:num; 2}; {3}]){0;1;2} (event_set
                   [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0)]
                   (rv_to_event p X t))  ==>
            (prob p
               (DRBD_series
                  (\j.
                       DRBD_parallel
                         (\a.
                              DRBD_series
                                (\i.
                                     event_set
                                       [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0)]
                                       (rv_to_event p X t) i)
                                (ind_set [{0}; L1; L2; L3] a))
                         (ind_set [{0}; {1; 2}; {3}] j)) {0; 1; 2}) =
             Rel p (R_WSP Y Ys_a Ys_d) t *  Normal (product L3 (\l. real (Rel p (X l) t))) *
             (1 -
              (1 - Normal (product L1 (\l. real (Rel p (X l) t)))) *
              (1 - Normal (product L2 (\l. real (Rel p (X l) t))))))``,

RW_TAC std_ss[Rel_def, PROB_DRBD_SEN_plus_broadcast, rv_to_event_def, SEN_broad_set_req_def]
THEN DEP_REWRITE_TAC[PROB_DRBD_SEN_plus_broadcast]
THEN RW_TAC std_ss[]
THEN METIS_TAC[ETA_THM]);


val SEN_plus_broadcast_nR_AND = store_thm("SEN_plus_broadcast_nR_AND",
  ``!p X Y Ys_a Ys_d t L1 L2 L3.
        disjoint_family_on (ind_set [{0:num}; L1; L2; L3]) {0;1;2;3} /\
        FINITE L1 /\ FINITE L2 /\ FINITE L3 /\ L1 <> {} /\ L2 <> {}/\ L3 <> {} ==>
        (DRBD_event p
           (nR_AND
              (\i.
                   if i = 0 then R_WSP Y Ys_a Ys_d
                   else if i = 1 then R_OR (nR_AND X L1) (nR_AND X L2)
                   else (nR_AND X L3)) {0; 1; 2:num}) t =
	  DRBD_series
           (\j.
                DRBD_parallel
                  (\a.
                       DRBD_series
                         (\i.
                              event_set
                                [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0)]
                                (rv_to_event p X t) i)
                         (ind_set [{0}; L1; L2; L3] a))
                  (ind_set [{0}; {1; 2}; {3}] j)) {0; 1; 2})``,


RW_TAC std_ss[]
THEN `{0;1;2:num} <>{}` by ASM_SET_TAC[]
THEN KNOW_TAC(``FINITE {0;1;2:num} ``)
     THEN1( `{0:num;1;2} = {0} UNION {1} UNION {2}` by ASM_SET_TAC[]
              THEN ONCE_ASM_REWRITE_TAC[]
	      THEN RW_TAC std_ss[FINITE_UNION, FINITE_SING])
THEN DISCH_TAC
THEN KNOW_TAC(``
   DRBD_event p
     (nR_AND
        (\i.
             if i = 0:num then R_WSP Y Ys_a Ys_d
             else if i = 1 then R_OR (nR_AND X L1) (nR_AND X L2)
             else nR_AND X L3) {0; 1; 2}) t =
   DRBD_series
     (rv_to_event p 
        (\i:num.
             if i = 0 then R_WSP Y Ys_a Ys_d
             else if i = 1 then R_OR (nR_AND X (L1:num->bool)) (nR_AND X (L2:num->bool))
             else nR_AND X L3) t) {0; 1; 2:num} ``)

      THEN1 RW_TAC std_ss[nR_AND_DRBD_series]
THEN RW_TAC std_ss[]
THEN KNOW_TAC(``
    DRBD_series
     (rv_to_event p
        (\i.
             if i = 0 then R_WSP Y Ys_a Ys_d
             else if i = 1 then R_OR (nR_AND X (L1:num->bool)) (nR_AND X (L2:num->bool))
             else nR_AND X L3) t) {0; 1; 2}=
    DRBD_event p (R_WSP Y Ys_a Ys_d) t INTER
    DRBD_event p (R_OR (nR_AND X L1) (nR_AND X L2)) t INTER
    DRBD_event p (nR_AND X L3) t ``)
     THEN1(RW_TAC std_ss[DRBD_series_def, rv_to_event_def]
           THEN KNOW_TAC(``
     {DRBD_event p
       (if i:num = 0 then R_WSP Y Ys_a Ys_d
        else if i = 1 then R_OR (nR_AND X L1) (nR_AND X L2)
        else nR_AND X L3) t |
     i IN {0; 1; 2}} =
     {DRBD_event p
       (R_WSP Y Ys_a Ys_d) t;
      DRBD_event p (R_OR (nR_AND X (L1:num->bool)) (nR_AND X (L2:num->bool))) t;
      DRBD_event p (nR_AND X L3) t}``)
              THEN1(PSET_TAC[]
                    THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
 		    THEN EQ_TAC
		         THEN1(RW_TAC std_ss[] THEN RW_TAC std_ss[])
	            THEN RW_TAC std_ss[]
		         THEN1(Q.EXISTS_TAC`0`
			        THEN RW_TAC std_ss[])
			 THEN1(Q.EXISTS_TAC`1`
			       THEN RW_TAC std_ss[])
 	 	    THEN Q.EXISTS_TAC`2`
		    THEN RW_TAC std_ss[])
       THEN RW_TAC std_ss[BIGINTER_3_sets])
THEN RW_TAC std_ss[]
THEN ASM_REWRITE_TAC[]
THEN ONCE_REWRITE_TAC[DRBD_series_def]
THEN PSET_TAC[]
THEN KNOW_TAC(``
    {DRBD_parallel
       (\a.
            DRBD_series
              (\i.
                   event_set
                     [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0)]
                     (rv_to_event p X t) i) (ind_set [{0}; L1; L2; L3] a))
       (ind_set [{0}; {1:num; 2}; {3}] i) |
     (i = 0) \/ (i = 1) \/ (i = 2)} =
     {DRBD_parallel
       (\a.
            DRBD_series
              (\i.
                   event_set
                     [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0)]
                     (rv_to_event p X t) i) (ind_set [{0}; L1; L2; L3] a))
       (ind_set [{0}; {1; 2}; {3}] 0);
      DRBD_parallel
       (\a.
            DRBD_series
              (\i.
                   event_set
                     [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0)]
                     (rv_to_event p X t) i) (ind_set [{0}; L1; L2; L3] a))
       (ind_set [{0}; {1; 2}; {3}] 1);
      DRBD_parallel
       (\a.
            DRBD_series
              (\i.
                   event_set
                     [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0)]
                     (rv_to_event p X t) i) (ind_set [{0}; L1; L2;L3] a))
       (ind_set [{0}; {1; 2}; {3:num}] 2)}``)
     THEN1 ASM_SET_TAC[]
THEN RW_TAC std_ss[]
THEN RW_TAC std_ss[BIGINTER_3_sets]
THEN RW_TAC list_ss[ind_set_def, EL, HD]
THEN RW_TAC std_ss[DRBD_parallel_def]
THEN KNOW_TAC(``
    !k:num.
      {DRBD_series
       (\i.
            event_set
              [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0)] (rv_to_event p X t) i)
       (EL a [{0}; L1; L2; L3]) |
     a = k}=
       {DRBD_series
       (\i.
            event_set
              [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0)] (rv_to_event p X t) i)
       (EL k [{0}; L1; L2; L3])}``)

      THEN1(ASM_SET_TAC[])
THEN RW_TAC std_ss[]
THEN RW_TAC list_ss[EL]
THEN RW_TAC std_ss[BIGUNION_SING]
THEN KNOW_TAC(``{DRBD_series
       (\i.
            event_set
              [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0)] (rv_to_event p X t) i)
       (EL a [{0}; L1; L2; L3]) |
     (a = 1) \/ (a = 2:num)} =
     {DRBD_series
       (\i.
            event_set
              [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0)] (rv_to_event p X t) i)
       (EL 1 [{0}; L1; L2; L3]) ;
       DRBD_series
       (\i.
            event_set
              [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0)] (rv_to_event p X t) i)
       (EL 2 [{0}; L1; L2; L3])}``)
        THEN1(ASM_SET_TAC[])
THEN RW_TAC list_ss[]
THEN RW_TAC std_ss[BIGUNION_PAIR]
THEN RW_TAC std_ss[DRBD_parallel_def, DRBD_series_def, event_set_def, event_set1_def, ind_set_def, EL, rv_to_event_def]
THEN KNOW_TAC(``{if i:num = 0 then DRBD_event p (R_WSP Y Ys_a Ys_d) t
    
     else DRBD_event p (X i) t |
     i IN {0}} = { DRBD_event p (R_WSP Y Ys_a Ys_d) t} ``)

    THEN1(ASM_SET_TAC[])
THEN RW_TAC std_ss[]
THEN UNDISCH_TAC(``  disjoint_family_on (ind_set [{0:num}; L1; L2; L3]) {0:num; 1; 2; 3}``)
THEN RW_TAC std_ss[disjoint_family_on]    
THEN KNOW_TAC(``{0:num} INTER L1 ={} ``)
     THEN1(POP_ASSUM (MP_TAC o Q.SPEC `0:num`)
           THEN DISCH_TAC
           THEN POP_ASSUM (MP_TAC o Q.SPEC `1:num`)
	   THEN RW_TAC std_ss[ind_set_def]
	   THEN FULL_SIMP_TAC list_ss[])
THEN KNOW_TAC(``{0:num} INTER L2 ={} ``)
     THEN1(POP_ASSUM (MP_TAC o Q.SPEC `0:num`)
           THEN DISCH_TAC
           THEN POP_ASSUM (MP_TAC o Q.SPEC `2:num`)
	   THEN RW_TAC std_ss[ind_set_def]
	   THEN FULL_SIMP_TAC list_ss[])
THEN KNOW_TAC(``{0:num} INTER L3 ={} ``)
     THEN1(POP_ASSUM (MP_TAC o Q.SPEC `0:num`)
           THEN DISCH_TAC
           THEN POP_ASSUM (MP_TAC o Q.SPEC `3:num`)
	   THEN RW_TAC std_ss[ind_set_def]
	   THEN FULL_SIMP_TAC list_ss[])
THEN RW_TAC std_ss[]
THEN KNOW_TAC(``
     {if i:num = 0 then DRBD_event p (R_WSP Y Ys_a Ys_d) t
     
      else DRBD_event p (X i) t |
      i IN L1} =
      {DRBD_event p (X i) t |
      i IN L1}``)
      THEN1 ASM_SET_TAC[]
THEN RW_TAC std_ss[]      
THEN KNOW_TAC(``
     {if i:num = 0 then DRBD_event p (R_WSP Y Ys_a Ys_d) t
        else DRBD_event p (X i) t |
      i IN L2} =
      {DRBD_event p (X i) t |
      i IN L2}``)
      THEN1 ASM_SET_TAC[]
THEN RW_TAC std_ss[]      
THEN KNOW_TAC(``
    {if i:num = 0 then DRBD_event p (R_WSP Y Ys_a Ys_d) t
     else DRBD_event p (X i) t |
     i IN L3} =
     {DRBD_event p (X i) t |
      i IN L3}``)
    THEN1 ASM_SET_TAC[]
THEN RW_TAC std_ss[]
THEN RW_TAC std_ss[BIGINTER_SING]
THEN RW_TAC std_ss[R_OR_UNION] 
THEN RW_TAC std_ss[nR_AND_DRBD_series, DRBD_series_def]
THEN RW_TAC std_ss[rv_to_event_def]);


val Rel_DRBD_SEN_plus_broadcast = store_thm("Rel_DRBD_SEN_plus_broadcast",
  ``!p X Y Ys_a Ys_d t L1 L2 L3.
            SEN_broad_set_req p L1 L2 L3 (ind_set [{0}; L1; L2; L3])
            (ind_set [{0}; {1; 2}; {3}]) {0; 1; 2}
            (event_set
               [(DRBD_event p (R_WSP Y Ys_a Ys_d) t,0)] (rv_to_event p X t)) ==>
          (prob p
             (DRBD_event p
             (nR_AND
                (\i.
                     if i:num = 0 then R_WSP Y Ys_a Ys_d
                     else if i = 1 then R_OR (nR_AND X L1) (nR_AND X L2)
                     else nR_AND X L3 ) {0:num; 1; 2}) t) =
           Rel p (R_WSP Y Ys_a Ys_d) t * Normal (product L3 (\l. real (Rel p (X l) t))) *
           (1 -
            (1 - Normal (product L1 (\l. real (Rel p (X l) t)))) *
            (1 - Normal (product L2 (\l. real (Rel p (X l) t)))))) ``,


RW_TAC std_ss[SEN_broad_set_req_def]
THEN DEP_REWRITE_TAC[GSYM PROB_DRBD_SEN_plus_broadcast_rel]
THEN REWRITE_TAC[SEN_broad_set_req_def]
THEN RW_TAC std_ss[]
THEN DEP_REWRITE_TAC[GSYM SEN_plus_broadcast_nR_AND]
THEN RW_TAC std_ss[]);

 

(* -------------------------------------------------------------------------- *)
(*                                                                            *)
(*                                                                            *)
(*                                                                            *)
(* -------------------------------------------------------------------------- *)




val PROB_DFT_SEN_plus_broadcast_lem1 = store_thm("PROB_DRBD_DFT_plus_broadcast_lem1",
  `` !p X L1 L2 L3 s L A j.
            L1 <> {} /\ L2 <> {} /\ L3 <> {} /\  FINITE L1 /\ FINITE L2 /\ FINITE L3 /\
               indep_sets p (\i. {X i}) (BIGUNION_o_BIGUNION s L A) /\
            disjoint_family_on (ind_set [{0}; L1; L2; L3]) {0; 1; 2; 3} /\
            (A = {0; 1; 2}) /\ (L = ind_set [{0}; {1; 2}; {3}]) /\
            (s = ind_set [{0}; L1; L2; L3]) ==>
            (prob p
               (bigunion
                  (\a. biginter (\l. bigunion X (s l)) (L a)) ((\i.A) j)) = 1 -
   (1 - prob p (X 0)) *
   (Normal
      (1 -
       (1 - product L1 (\i. real (1 - prob p (X i)))) *
       (1 - product L2 (\i. real (1 - prob p (X i))))) * ( Normal (product L3 (\i. real (1 - prob p (X i)))))))``,
    
RW_TAC std_ss[disjoint_family_on]
THEN KNOW_TAC(``BIGUNION {EL j [{0:num}; {1; 2}; {3}] | j IN {0; 1; 2:num}} = {0;1;2;3} ``)
     THEN1( SRW_TAC[][GSPECIFICATION, EXTENSION]
            THEN EQ_TAC
                THEN1(RW_TAC std_ss[]
      		      THEN FULL_SIMP_TAC list_ss[])
         	 THEN RW_TAC std_ss[]
		      THEN1( Q.EXISTS_TAC`{0}` THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[] 
	                    THEN Q.EXISTS_TAC`0` THEN RW_TAC std_ss[]
			    THEN RW_TAC list_ss[])
	 	      THEN1( Q.EXISTS_TAC`{1;2}` THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
	                    THEN Q.EXISTS_TAC`1` THEN RW_TAC std_ss[]
	   	            THEN RW_TAC list_ss[])
		      THEN1( Q.EXISTS_TAC`{1;2}` THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
		             THEN Q.EXISTS_TAC`1` THEN RW_TAC std_ss[]
		             THEN RW_TAC list_ss[])
           THEN Q.EXISTS_TAC`{3}` THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
     	   THEN Q.EXISTS_TAC`2` THEN RW_TAC list_ss[])
THEN DISCH_TAC
THEN  MP_TAC(Q.ISPECL [`p:('a->bool)#(('a->bool)->bool)#(('a->bool)->extreal)`, `X:num->'a->bool`, `ind_set [{0:num}; L1:num->bool; L2:num->bool; L3:num->bool]`, `ind_set [{0:num}; {1:num; 2}; {3:num}]`, `(\i:num. {0; 1:num; 2})`, `j:num`] PROB_bigunion_biginter_bigunion_lem2)
THEN RW_TAC std_ss[]
THEN KNOW_TAC(`` sets_finite_not_empty (ind_set [{0:num}; L1; L2; L3])
           (ind_set [{0:num}; {1; 2}; {3}]) (\i. {0; 1; 2:num}) {j:num} ``)
     THEN1(RW_TAC std_ss[sets_finite_not_empty_def]
           THEN1 ASM_SET_TAC[]
	   THEN1 (`{0;1;2:num} = {0} UNION ({1} UNION {2})` by ASM_SET_TAC[]
	          THEN ONCE_ASM_REWRITE_TAC[]
		  THEN ASM_SET_TAC[FINITE_UNION, FINITE_SING])
	   THEN1(RW_TAC std_ss[ind_set_def]
	         THEN PSET_TAC[]
		      THEN1(FULL_SIMP_TAC std_ss[ind_set_def]
		            THEN FULL_SIMP_TAC list_ss[]
			    THEN ASM_SET_TAC[])
		      THEN1 (FULL_SIMP_TAC std_ss[ind_set_def]
		            THEN FULL_SIMP_TAC list_ss[]
			    THEN ASM_SET_TAC[])
                  THEN FULL_SIMP_TAC std_ss[ind_set_def]
		  THEN FULL_SIMP_TAC list_ss[]
		  THEN ASM_SET_TAC[])
	  THEN1 (FULL_SIMP_TAC list_ss[ind_set_def]
	         THEN PSET_TAC[]
		      THEN1(FULL_SIMP_TAC std_ss[ind_set_def]
		            THEN FULL_SIMP_TAC list_ss[]
			    THEN ASM_SET_TAC[FINITE_SING])
		      THEN1(FULL_SIMP_TAC std_ss[ind_set_def]
		            THEN FULL_SIMP_TAC list_ss[])
		 THEN FULL_SIMP_TAC std_ss[ind_set_def]
		 THEN FULL_SIMP_TAC list_ss[]
		 THEN ASM_SET_TAC[FINITE_SING])
	 THEN1( FULL_SIMP_TAC list_ss[ind_set_def]
	         THEN PSET_TAC[]
		      THEN1(FULL_SIMP_TAC std_ss[ind_set_def]
		            THEN FULL_SIMP_TAC list_ss[]
			    THEN ASM_SET_TAC[FINITE_SING])
		      THEN1(FULL_SIMP_TAC std_ss[ind_set_def]
		            THEN FULL_SIMP_TAC list_ss[]
			    THEN ASM_SET_TAC[])
		 THEN FULL_SIMP_TAC std_ss[ind_set_def]
		 THEN FULL_SIMP_TAC list_ss[]
		 THEN ASM_SET_TAC[FINITE_SING])
	 THEN1(	 FULL_SIMP_TAC list_ss[ind_set_def]
	         THEN PSET_TAC[]
		      THEN1(FULL_SIMP_TAC std_ss[ind_set_def]
		            THEN FULL_SIMP_TAC list_ss[]
			    THEN ASM_SET_TAC[FINITE_SING])
		      THEN1(FULL_SIMP_TAC std_ss[ind_set_def]
		            THEN FULL_SIMP_TAC list_ss[]
			    THEN `{1;2:num} = {1} UNION {2}` by ASM_SET_TAC[]
			    THEN ONCE_ASM_REWRITE_TAC[]
			    THEN ASM_SET_TAC[FINITE_UNION, FINITE_SING])
		 THEN FULL_SIMP_TAC std_ss[ind_set_def]
		 THEN FULL_SIMP_TAC list_ss[]
		 THEN ASM_SET_TAC[FINITE_SING])
         THEN1 ASM_SET_TAC[FINITE_SING]
	 THEN1 (RW_TAC std_ss[disjoint_family_on]
	        THEN ASM_SET_TAC[])
	 THEN1 ASM_SET_TAC[]	
	 THEN1 (RW_TAC std_ss[disjoint_family_on]
	        THEN RW_TAC std_ss[ind_set_def]
		THEN PSET_TAC[] THEN FULL_SIMP_TAC list_ss[ind_set_def])
         THEN RW_TAC list_ss[disjoint_family_on, ind_set_def]
	 THEN PSET_TAC[] THEN FULL_SIMP_TAC list_ss[] THEN ASM_SET_TAC[])
THEN RW_TAC std_ss[]	 
THEN FULL_SIMP_TAC list_ss[]
THEN KNOW_TAC(``(!l.
              l IN
              BIGUNION_o_BIGUNION (ind_set [{0:num}; L1; L2; L3])
                (ind_set [{0}; {1; 2}; {3}]) {0; 1; 2} ==>
              X l IN events p)  ``)
   THEN1(FULL_SIMP_TAC list_ss[indep_sets]
         THEN RW_TAC std_ss[]
	 THEN ASM_SET_TAC[])
THEN DISCH_TAC THEN FULL_SIMP_TAC std_ss[]	 
THEN RW_TAC std_ss[]
THEN RW_TAC std_ss[ind_set_def]
THEN `{0;1;2:num} = {0} UNION {1;2}` by ASM_SET_TAC[]
THEN KNOW_TAC(``FINITE {0:num} /\ FINITE {1;2:num} /\ DISJOINT {0:num} {1;2}``)
     THEN1(RW_TAC std_ss[FINITE_SING]
           THEN1 (`{1;2:num} = {1} UNION {2}` by ASM_SET_TAC[] THEN ONCE_ASM_REWRITE_TAC[] THEN ASM_SET_TAC [FINITE_UNION, FINITE_SING])
	   THEN ASM_SET_TAC[])
THEN RW_TAC std_ss[PRODUCT_UNION, PRODUCT_SING]
THEN RW_TAC list_ss[]
THEN RW_TAC list_ss[PRODUCT_SING]
THEN `{1;2:num} = {1} UNION {2}` by ASM_SET_TAC[]
THEN `FINITE{1:num} /\ FINITE {2:num} /\ DISJOINT {1:num} {2}` by ASM_SET_TAC[FINITE_SING]
THEN RW_TAC list_ss[PRODUCT_UNION, PRODUCT_SING]
THEN RW_TAC std_ss[ normal_real_product_1, real_normal_real, normal_real_product_2]
THEN RW_TAC std_ss[REAL_SUB_SUB2]
THEN RW_TAC std_ss[GSYM extreal_sub_def]
THEN RW_TAC std_ss[GSYM extreal_mul_def]
THEN  KNOW_TAC(``prob p ((X:num->'a->bool) 0) <> PosInf /\ prob p (X 0) <> NegInf ``)
     THEN1(KNOW_TAC(`` 0:num IN BIGUNION_o_BIGUNION (ind_set [{0:num}; L1; L2; L3])
               (ind_set [{0}; {1; 2}; {3}]) {0; 1; 2:num}``)
           THEN1(RW_TAC std_ss[ind_set_def, BIGUNION_o_BIGUNION_def]
                 THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
   	         THEN Q.EXISTS_TAC`{0}`
	         THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
	 	 THEN Q.EXISTS_TAC`0` THEN RW_TAC list_ss[]
		 THEN Q.EXISTS_TAC`{0}` THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
 		 THEN Q.EXISTS_TAC`0` THEN RW_TAC list_ss[])
		 THEN FULL_SIMP_TAC std_ss[indep_sets]
		 THEN DISCH_TAC
		 THEN `X 0 IN events p` by ASM_SET_TAC[]
		 THEN METIS_TAC[PROB_FINITE])
THEN DISCH_TAC
THEN `1 <> PosInf /\ 1 <> NegInf` by METIS_TAC[extreal_of_num_def, extreal_not_infty]
(*THEN KNOW_TAC(``prob p ((X:num->'a->bool) 3) <> PosInf /\ prob p (X 3) <> NegInf ``)
     THEN1(KNOW_TAC(`` 3:num IN BIGUNION_o_BIGUNION (ind_set [{0}; L1; L2; {3}])
               (ind_set [{0}; {1; 2}; {3}]) {0; 1; 2:num}``)
           THEN1(RW_TAC std_ss[ind_set_def, BIGUNION_o_BIGUNION_def]
                 THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
	         THEN Q.EXISTS_TAC`{3}`
		 THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
		 THEN Q.EXISTS_TAC`3` THEN RW_TAC list_ss[]
		 THEN Q.EXISTS_TAC`{3}` THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
 		 THEN Q.EXISTS_TAC`2` THEN RW_TAC list_ss[])
	   THEN DISCH_TAC	 
	   THEN  `(X:num->'a->bool) 3 IN events p` by ASM_SET_TAC[]
	   THEN `prob_space p` by FULL_SIMP_TAC std_ss[indep_sets]
	   THEN METIS_TAC[PROB_FINITE])
	   *)
	   
THEN RW_TAC std_ss[extreal_of_num_def]
THEN RW_TAC std_ss[sub_not_infty, extreal_not_infty, normal_real]
THEN RW_TAC std_ss[extreal_mul_def]
THEN `1 = Normal 1` by RW_TAC std_ss[extreal_of_num_def]
THEN ONCE_ASM_REWRITE_TAC[]
THEN RW_TAC std_ss[extreal_sub_def]
THEN RW_TAC std_ss[real_normal]
THEN RW_TAC std_ss[extreal_mul_def]);




val PROB_DFT_SEN_plus_broadcast_lem2 = store_thm("PROB_DFT_SEN_plus_broadcast_lem2",
  ``  !p X Y Ys_a Ys_d t L1 L2 L3. 0 <= t /\ FINITE L1 /\ FINITE L2 /\ FINITE L3 /\  L1 <> {} /\ L2 <> {} /\ L3 <> {} /\
        (!i. i IN (L1 UNION L2 UNION L3) ==> rv_gt0_ninfinity [X i]) /\
         indep_sets p (\i. {rv_to_devent p X t i})
           (BIGUNION_o_BIGUNION (ind_set [{0}; L1; L2; L3])
              (ind_set [{0}; {1; 2}; {3}]) {0; 1; 2}) /\
         disjoint_family_on (ind_set [{0}; L1; L2; L3]) {0; 1; 2; 3}
==> ( prob p  (DFT_event p
             (n_OR
                (MAP
                   (\j.
                        n_AND
                          (MAP (\i:num. n_OR (MAP X (SET_TO_LIST ((ind_set [{0}; L1; L2; L3]) i))))
                             (SET_TO_LIST ((ind_set [{0}; {1; 2}; {3}]) j)))) (SET_TO_LIST {0; 1; 2}))) t) =

    1 -
           (1 - prob p (rv_to_devent p X t (0:num))) *
           (Normal
              (1 -
               (1 - product L1 (\i. real (1 - CDF p (real o (X i)) t))) *
               (1 - product L2 (\i. real (1 - CDF p (real o (X i)) t)))) *
            Normal  (product L3 (\i. real (1 - CDF p (real o (X i)) t)))))``,

RW_TAC std_ss[]
THEN DEP_REWRITE_TAC[ n_OR_AND_OR_BIGUNION_INTER_UNION]
THEN RW_TAC std_ss[]
     THEN1(`{0;1;2:num} = {0} UNION {1;2}` by ASM_SET_TAC[] THEN ONCE_ASM_REWRITE_TAC[]
           THEN `{1;2:num} = {1} UNION {2}` by ASM_SET_TAC[]
	   THEN KNOW_TAC(``FINITE{1;2:num}``) THEN1(ONCE_ASM_REWRITE_TAC[] THEN ASM_SET_TAC[FINITE_UNION, FINITE_SING])
	   
	   THEN ASM_SET_TAC[FINITE_UNION, FINITE_SING])
      THEN1(RW_TAC list_ss[ind_set_def]
            THEN PSET_TAC[] THEN RW_TAC list_ss[]
	          THEN1(ASM_SET_TAC[FINITE_SING] )
		  THEN1( `{1;2:num} = {1} UNION {2}` by ASM_SET_TAC[]
		         THEN ONCE_ASM_REWRITE_TAC[] THEN ASM_SET_TAC[FINITE_UNION, FINITE_SING])
             THEN ASM_SET_TAC[FINITE_SING])
      THEN1(RW_TAC list_ss[ind_set_def]
            THEN PSET_TAC[] THEN RW_TAC list_ss[] THEN ASM_SET_TAC[])
      THEN1(RW_TAC list_ss[ind_set_def] THEN PSET_TAC[] THEN FULL_SIMP_TAC list_ss[ind_set_def]	    	        THEN ASM_SET_TAC[FINITE_SING])

THEN RW_TAC std_ss[GSYM biginter_def, GSYM bigunion_def]
THEN MP_TAC(Q.ISPECL [`p:('a->bool)#(('a->bool)->bool)#(('a->bool)->extreal)`, `(\i:num. rv_to_devent p (X:num->'a->extreal) t i)`, `L1:num->bool` ,`L2:num->bool`, `L3:num->bool`,`ind_set [{0:num}; L1:num->bool; L2:num->bool; L3:num->bool]`, `ind_set [{0:num}; {1:num; 2}; {3:num}]`, `{0; 1:num; 2}`, `j:num`] PROB_DFT_SEN_plus_broadcast_lem1)
THEN RW_TAC std_ss[]
THEN KNOW_TAC(``!i. i:num IN L1 ==> ( real (1 - prob p (rv_to_devent p X t i)) = real (1 - CDF p (real o X i) t))``)
     THEN1(RW_TAC std_ss[]
           THEN FULL_SIMP_TAC list_ss[rv_gt0_ninfinity_def]
           THEN RW_TAC std_ss[CDF_prob_DFT_event, o_DEF, rv_to_devent_def] 	  
           THEN METIS_TAC[ETA_THM])
THEN RW_TAC std_ss[th]       
THEN KNOW_TAC(`` product (L1:num->bool) (\i'. real (1 - prob p (rv_to_devent p (X:num->'a->extreal) t i'))) =
                 product L1 (\i. real (1 - CDF p (real o X i) t))``)
     THEN1(RW_TAC std_ss[th])
THEN RW_TAC std_ss[]     
THEN KNOW_TAC(``!i. i:num IN L2 ==> ( real (1 - prob p (rv_to_devent p X t i)) = real (1 - CDF p (real o X i) t))``)
     THEN1(RW_TAC std_ss[]
           THEN FULL_SIMP_TAC list_ss[rv_gt0_ninfinity_def]
           THEN RW_TAC std_ss[CDF_prob_DFT_event, o_DEF, rv_to_devent_def] 	  
           THEN METIS_TAC[ETA_THM])
       
THEN RW_TAC std_ss[]       
THEN KNOW_TAC(`` product (L2:num->bool) (\i'. real (1 - prob p (rv_to_devent p (X:num->'a->extreal) t i'))) =
                 product L2 (\i. real (1 - CDF p (real o X i) t))``)
     THEN1(RW_TAC std_ss[th])
THEN RW_TAC std_ss[]     
THEN KNOW_TAC(``!i. i:num IN L3 ==> ( real (1 - prob p (rv_to_devent p X t i)) = real (1 - CDF p (real o X i) t))``)
     THEN1(RW_TAC std_ss[]
            THEN FULL_SIMP_TAC list_ss[rv_gt0_ninfinity_def]
           THEN RW_TAC std_ss[CDF_prob_DFT_event, o_DEF, rv_to_devent_def] 	  
           THEN METIS_TAC[ETA_THM])
THEN RW_TAC std_ss[]       
THEN KNOW_TAC(`` product (L3:num->bool) (\i'. real (1 - prob p (rv_to_devent p (X:num->'a->extreal) t i'))) =
                 product L3 (\i. real (1 - CDF p (real o X i) t))``)
     THEN1(RW_TAC std_ss[th])
THEN RW_TAC std_ss[]);   




val Q_dSEN_plus_lem1 = store_thm("Q_dSEN_plus_lem1",
  `` !L1 L2 L3 X Y.  FINITE (L1:num->bool) /\ FINITE (L2:num->bool) /\ FINITE (L3:num->bool)==> (n_OR
                (MAP
                   (\i. if i = 0 then Y
		         else if i = 1 then
			      D_AND (n_OR (MAP X (SET_TO_LIST L1))) (n_OR (MAP X (SET_TO_LIST L2)))
			 else n_OR (MAP X (SET_TO_LIST L3))) (SET_TO_LIST {0:num;1;2})) 

= nR_AND (\i. if i = 0 then Y
           else if i = 1 then R_OR (nR_AND X L1)(nR_AND X L2)
	   else nR_AND X L3) {0:num;1;2})``,

RW_TAC std_ss[]
THEN DEP_REWRITE_TAC[n_OR_nR_AND,n_AND_nR_OR]
THEN RW_TAC std_ss[]
THEN1 (`{0:num;1;2} = {0} UNION {1;2}` by ASM_SET_TAC[]
       THEN ONCE_ASM_REWRITE_TAC[]
       THEN KNOW_TAC(``FINITE {1;2:num} ``)
       	    THEN1(`{1:num; 2} = {1} UNION {2}` by ASM_SET_TAC[]
	    THEN ONCE_ASM_REWRITE_TAC[]
	    THEN ASM_SET_TAC[FINITE_UNION, FINITE_SING])
       THEN ASM_SET_TAC[FINITE_UNION, FINITE_SING])
THEN RW_TAC std_ss[D_AND_def, R_OR_def]);

   


val Q_dSEN_plus_lem2 = store_thm("Q_dSEN_plus_lem2",
  ``  !p L1 L2 L3 X Y t. disjoint_family_on (ind_set [{0}; L1 ; L2; L3]) {0;1;2;3} /\
FINITE (L1:num->bool) /\ FINITE (L2:num->bool) /\ FINITE (L3:num->bool) /\ 0<=t==>
(DFT_event p (n_OR
             (MAP
                (\i.
                     if i = 0 then Y
                     else if i = 1 then
                       D_AND (n_OR (MAP X (SET_TO_LIST L1)))
                         (n_OR (MAP X (SET_TO_LIST L2)))
                     else n_OR (MAP X (SET_TO_LIST L3)))
                (SET_TO_LIST {0:num; 1; 2}))) t=

  
BIGUNION
     {BIGINTER
       {BIGUNION
         {event_set [(DFT_event p Y t,0)] (rv_to_devent p X t) i |
         i IN ind_set [{0}; L1; L2; L3] a} |
       a IN ind_set [{0:num}; {1; 2}; {3}] j} |
     j IN {0; 1; 2}})``,

RW_TAC std_ss[GSYM biginter_def, GSYM bigunion_def]
THEN KNOW_TAC(``DISJOINT {0:num} L1 ``)
     THEN1(FULL_SIMP_TAC list_ss[disjoint_family_on, ind_set_def]
     	   THEN UNDISCH_TAC(``  !m n.
             ((m = 0:num) \/ (m = 1) \/ (m = 2) \/ (m = 3)) /\
             ((n = 0) \/ (n = 1) \/ (n = 2) \/ (n = 3)) /\ m <> n ==>
             (EL m [{0:num}; L1; L2; L3] INTER EL n [{0}; L1; L2; L3] = {})``)
	   THEN DISCH_TAC
	   THEN POP_ASSUM (MP_TAC o Q.SPEC `0`)
	   THEN DISCH_TAC
 	   THEN POP_ASSUM (MP_TAC o Q.SPEC `1`)
	   THEN RW_TAC list_ss[DISJOINT_DEF])	     
THEN RW_TAC std_ss[]
THEN KNOW_TAC(``DISJOINT {0:num} L2 ``)
     THEN1(FULL_SIMP_TAC list_ss[disjoint_family_on, ind_set_def]
     	   THEN UNDISCH_TAC(``  !m n.
             ((m = 0:num) \/ (m = 1) \/ (m = 2) \/ (m = 3)) /\
             ((n = 0) \/ (n = 1) \/ (n = 2) \/ (n = 3)) /\ m <> n ==>
             (EL m [{0:num}; L1; L2; L3] INTER EL n [{0}; L1; L2; L3] = {})``)
	   THEN DISCH_TAC
	   THEN POP_ASSUM (MP_TAC o Q.SPEC `0`)
	   THEN DISCH_TAC
 	   THEN POP_ASSUM (MP_TAC o Q.SPEC `2`)
	   THEN RW_TAC list_ss[DISJOINT_DEF])	     
THEN RW_TAC std_ss[]
THEN KNOW_TAC(``DISJOINT {0:num} L3 ``)
     THEN1(FULL_SIMP_TAC list_ss[disjoint_family_on, ind_set_def]
     	   THEN UNDISCH_TAC(``  !m n.
             ((m = 0:num) \/ (m = 1) \/ (m = 2) \/ (m = 3)) /\
             ((n = 0) \/ (n = 1) \/ (n = 2) \/ (n = 3)) /\ m <> n ==>
             (EL m [{0:num}; L1; L2; L3] INTER EL n [{0}; L1; L2; L3] = {})``)
	   THEN DISCH_TAC
	   THEN POP_ASSUM (MP_TAC o Q.SPEC `0`)
	   THEN DISCH_TAC
 	   THEN POP_ASSUM (MP_TAC o Q.SPEC `3`)
	   THEN RW_TAC list_ss[DISJOINT_DEF])	     
THEN RW_TAC std_ss[]
THEN DEP_REWRITE_TAC [n_OR_BIGUNION]
THEN RW_TAC std_ss[]
THEN1 (`{0:num;1;2} = {0} UNION {1;2}` by ASM_SET_TAC[]
       THEN ONCE_ASM_REWRITE_TAC[]
       THEN KNOW_TAC(``FINITE {1;2:num} ``)
       	    THEN1(`{1:num; 2} = {1} UNION {2}` by ASM_SET_TAC[]
	    THEN ONCE_ASM_REWRITE_TAC[]
	    THEN ASM_SET_TAC[FINITE_UNION, FINITE_SING])
       THEN ASM_SET_TAC[FINITE_UNION, FINITE_SING])
THEN RW_TAC std_ss[GSYM bigunion_def]
THEN KNOW_TAC(``
    bigunion
     (\i.
          rv_to_devent p
            (\i.
                 if i = 0 then Y
                 else if i = 1 then
                   D_AND (n_OR (MAP X (SET_TO_LIST (L1:num->bool))))
                     (n_OR (MAP X (SET_TO_LIST L2)))
                 else n_OR (MAP X (SET_TO_LIST L3))) t i) {0:num; 1; 2}=
    DFT_event p (Y) t UNION
    DFT_event p ( D_AND (n_OR (MAP X (SET_TO_LIST L1)))
                     (n_OR (MAP X (SET_TO_LIST L2)))) t UNION
    DFT_event p (n_OR (MAP X (SET_TO_LIST L3))) t ``)
     THEN1(RW_TAC std_ss[bigunion_def, rv_to_devent_def]
           THEN KNOW_TAC(``
     {DFT_event p
       (if i = 0 then Y
        else if i = 1 then
          D_AND (n_OR (MAP X (SET_TO_LIST (L1:num->bool))))
            (n_OR (MAP X (SET_TO_LIST L2)))
        else n_OR (MAP X (SET_TO_LIST L3))) t |
     i IN {0; 1; 2:num}} =
     {DFT_event p
       (Y) t;
      DFT_event p (D_AND  (n_OR (MAP X (SET_TO_LIST L1)))
                     (n_OR (MAP X (SET_TO_LIST L2)))) t;
       DFT_event p (n_OR (MAP X (SET_TO_LIST L3))) t}``)
              THEN1(PSET_TAC[]
                    THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
 		    THEN EQ_TAC
		         THEN1(RW_TAC std_ss[] THEN RW_TAC std_ss[])
	            THEN RW_TAC std_ss[]
		         THEN1(Q.EXISTS_TAC`0`
			        THEN RW_TAC std_ss[])
			 THEN1(Q.EXISTS_TAC`1`
			       THEN RW_TAC std_ss[])
 	 	    THEN Q.EXISTS_TAC`2`
		    THEN RW_TAC std_ss[])
       THEN RW_TAC std_ss[BIGUNION_3_sets])
THEN RW_TAC std_ss[]
THEN ASM_REWRITE_TAC[]
THEN ONCE_REWRITE_TAC[bigunion_def]
THEN PSET_TAC[]
THEN KNOW_TAC(``
     {biginter
       (\a.
           bigunion
              (\i. event_set [(DFT_event p Y t,0)] (rv_to_devent p X t) i)
              (ind_set [{0:num}; L1; L2; L3] a)) (ind_set [{0}; {1; 2}; {3}] i) |
     (i = 0) \/ (i = 1) \/ (i = 2:num)} =
     {biginter
       (\a.
            bigunion
              (\i. event_set [(DFT_event p Y t,0)] (rv_to_devent p X t) i)
              (ind_set [{0}; L1; L2; L3] a)) (ind_set [{0}; {1; 2}; {3}] 0);
      biginter
       (\a.
            bigunion
               (\i. event_set [(DFT_event p Y t,0)] (rv_to_devent p X t) i)
              (ind_set [{0}; L1; L2; L3] a)) (ind_set [{0}; {1; 2}; {3}] 1);
      biginter
       (\a.
            bigunion
              (\i. event_set [(DFT_event p Y t,0)] (rv_to_devent p X t) i)
              (ind_set [{0}; L1; L2; L3] a)) (ind_set [{0}; {1; 2}; {3}] 2)}``)
     THEN1 ASM_SET_TAC[]
THEN RW_TAC std_ss[]
THEN RW_TAC std_ss[BIGUNION_3_sets]
THEN RW_TAC list_ss[ind_set_def, EL, HD]
THEN RW_TAC std_ss[biginter_def]
THEN PSET_TAC[]
THEN KNOW_TAC(``
    !k:num.
      {bigunion
       (\i. event_set [(DFT_event p Y t,0)] (rv_to_devent p X t) i)
       (EL a [{0:num}; L1; L2; L3]) |
     a = k}=
       {bigunion
       (\i. event_set [(DFT_event p Y t,0)] (rv_to_devent p X t) i)
       (EL k [{0}; L1; L2; L3])}``)

      THEN1(ASM_SET_TAC[])
THEN RW_TAC std_ss[]
THEN RW_TAC list_ss[EL]
THEN RW_TAC std_ss[BIGINTER_SING]
THEN KNOW_TAC(``{bigunion
       (\i. event_set [(DFT_event p Y t,0)] (rv_to_devent p X t) i)
       (EL a [{0:num}; L1; L2; L3]) |
     (a = 1) \/ (a = 2:num)} =
     {bigunion
       (\i. event_set [(DFT_event p Y t,0)] (rv_to_devent p X t) i)
       (EL 1 [{0:num}; L1; L2; L3]) ;
       bigunion
       (\i. event_set [(DFT_event p Y t,0)] (rv_to_devent p X t) i)
       (EL 2 [{0:num}; L1; L2; L3])}``)
        THEN1(ASM_SET_TAC[])
THEN RW_TAC list_ss[]
THEN RW_TAC std_ss[BIGINTER_2]
THEN RW_TAC std_ss[bigunion_def, biginter_def, event_set_def, event_set1_def, ind_set_def, EL, rv_to_devent_def]
THEN KNOW_TAC(``{if i = 0 then DFT_event p Y t else DFT_event p (X i) t | i IN {0:num}}
             = { DFT_event p Y t} ``)

    THEN1(ASM_SET_TAC[])
THEN RW_TAC std_ss[]
THEN KNOW_TAC(``
     {if i = 0:num then DFT_event p Y t else DFT_event p (X i) t | i IN L1} =
      {DFT_event p (X i) t |   i IN L1}``)
      THEN1 ASM_SET_TAC[]
THEN RW_TAC std_ss[]      
THEN KNOW_TAC(``
     {if i = 0:num then DFT_event p Y t else DFT_event p (X i) t | i IN L2} =
      {DFT_event p (X i) t |   i IN L2}``)
      THEN1 ASM_SET_TAC[]
THEN RW_TAC std_ss[]      
THEN KNOW_TAC(``
    {if i = 0:num then DFT_event p Y t else DFT_event p (X i) t | i IN L3} =
      {DFT_event p (X i) t |   i IN L3}``)
    THEN1 ASM_SET_TAC[]
THEN RW_TAC std_ss[]
THEN RW_TAC std_ss[BIGUNION_SING]
THEN RW_TAC std_ss[AND_INTER]
THEN RW_TAC std_ss[n_OR_BIGUNION]
THEN RW_TAC std_ss[rv_to_devent_def]);



val PROB_DFT_SEN_plus_broadcast = store_thm("PROB_DFT_SEN_plus_broadcast",
  ``!p X Y Ysa Ysd t L1 L2 L3.   0<= t /\ (!i.
               i IN (L1 UNION L2 UNION L3)==>
               rv_gt0_ninfinity [X i]) /\  
              SEN_broad_set_req p L1 L2 L3 (ind_set [{0}; L1; L2; L3])
	          (ind_set [{0}; {1; 2}; {3}]) {0; 1; 2}
		   (event_set [(DFT_event p (WSP Y Ysa Ysd) t,0)]
               (rv_to_devent p X t)) ==>
	      (prob p
             (DFT_event p
                (n_OR
                   (MAP
                      (\j.
                           n_AND
                             (MAP
                                (\i.
                                     n_OR
                                       (MAP (\i. if i = 0 then WSP Y Ysa Ysd
				                  else X i)
                                          (SET_TO_LIST
                                             (ind_set [{0}; L1; L2; L3] i))))
                                (SET_TO_LIST (ind_set [{0}; {1; 2}; {3}] j))))
                      (SET_TO_LIST {0; 1; 2}))) t) =
           1 -
           (1 - prob p (DFT_event p (WSP Y Ysa Ysd) t)) *
           (Normal
              (1 -
               (1 - product L1 (\i. real (1 - CDF p (real o X i) t))) *
               (1 - product L2 (\i. real (1 - CDF p (real o X i) t)))) *
            Normal (product L3 (\i. real (1 - CDF p (real o X i) t)))))``,

RW_TAC std_ss[]
THEN KNOW_TAC(``(DFT_event p (WSP Y Ysa Ysd) t) = (rv_to_devent p (\i:num. if i = 0 then WSP Y Ysa Ysd
				                  else X i) t 0) ``)
THEN1(RW_TAC std_ss[rv_to_devent_def])
THEN DISC_RW_KILL

THEN KNOW_TAC(``DISJOINT {0:num} L1 ``)
     THEN1(FULL_SIMP_TAC list_ss[disjoint_family_on, ind_set_def, SEN_broad_set_req_def]
     	   THEN UNDISCH_TAC(``  !m n.
             ((m = 0:num) \/ (m = 1) \/ (m = 2) \/ (m = 3)) /\
             ((n = 0) \/ (n = 1) \/ (n = 2) \/ (n = 3)) /\ m <> n ==>
             (EL m [{0:num}; L1; L2; L3] INTER EL n [{0}; L1; L2; L3] = {})``)
	   THEN DISCH_TAC
	   THEN POP_ASSUM (MP_TAC o Q.SPEC `0`)
	   THEN DISCH_TAC
 	   THEN POP_ASSUM (MP_TAC o Q.SPEC `1`)
	   THEN RW_TAC list_ss[DISJOINT_DEF])	     
THEN RW_TAC std_ss[]
THEN KNOW_TAC(``DISJOINT {0:num} L2 ``)
     THEN1(FULL_SIMP_TAC list_ss[disjoint_family_on, ind_set_def, SEN_broad_set_req_def]
     	   THEN UNDISCH_TAC(``  !m n.
             ((m = 0:num) \/ (m = 1) \/ (m = 2) \/ (m = 3)) /\
             ((n = 0) \/ (n = 1) \/ (n = 2) \/ (n = 3)) /\ m <> n ==>
             (EL m [{0:num}; L1; L2; L3] INTER EL n [{0}; L1; L2; L3] = {})``)
	   THEN DISCH_TAC
	   THEN POP_ASSUM (MP_TAC o Q.SPEC `0`)
	   THEN DISCH_TAC
 	   THEN POP_ASSUM (MP_TAC o Q.SPEC `2`)
	   THEN RW_TAC list_ss[DISJOINT_DEF])	     
THEN RW_TAC std_ss[]
THEN KNOW_TAC(``DISJOINT {0:num} L3 ``)
     THEN1(FULL_SIMP_TAC list_ss[disjoint_family_on, ind_set_def, SEN_broad_set_req_def]
     	   THEN UNDISCH_TAC(``  !m n.
             ((m = 0:num) \/ (m = 1) \/ (m = 2) \/ (m = 3)) /\
             ((n = 0) \/ (n = 1) \/ (n = 2) \/ (n = 3)) /\ m <> n ==>
             (EL m [{0:num}; L1; L2; L3] INTER EL n [{0}; L1; L2; L3] = {})``)
	   THEN DISCH_TAC
	   THEN POP_ASSUM (MP_TAC o Q.SPEC `0`)
	   THEN DISCH_TAC
 	   THEN POP_ASSUM (MP_TAC o Q.SPEC `3`)
	   THEN RW_TAC list_ss[DISJOINT_DEF])	     
THEN RW_TAC std_ss[]
THEN DEP_REWRITE_TAC[PROB_DFT_SEN_plus_broadcast_lem2]
THEN RW_TAC std_ss[]
THEN FULL_SIMP_TAC list_ss[SEN_broad_set_req_def]
THEN FULL_SIMP_TAC list_ss[event_set_def, event_set1_def]
THEN1 ASM_SET_TAC[]
THEN1 ASM_SET_TAC[]
THEN1 ASM_SET_TAC[]
THEN1( KNOW_TAC(`` !i:num. {if i = 0 then DFT_event p (WSP Y Ysa Ysd) t
                 else rv_to_devent p X t i}  =
		 {rv_to_devent p (\i. if i = 0 then WSP Y Ysa Ysd else X i) t i}``)
     THEN1(RW_TAC std_ss[rv_to_devent_def])
     THEN RW_TAC std_ss[]
     THEN ONCE_ASM_REWRITE_TAC[]
     THEN FULL_SIMP_TAC list_ss[event_set_def, event_set1_def])
    
THEN RW_TAC std_ss[o_DEF]
THEN RW_TAC std_ss[rv_to_devent_def]
THEN KNOW_TAC(`` product (L1:num->bool)
          (\i.
               real
                 (1 -
                  CDF p (\x. real ((if i = 0 then WSP Y Ysa Ysd else X i) x))
                    t)) =
		    product L1 (\i. real (1 - CDF p (\x. real (X i x)) t)) ``)

     THEN1(KNOW_TAC(``!i:num. i IN L1  ==> 
          (real
            (1 -
             CDF p (\x. real ((if i = 0 then WSP Y Ysa Ysd else X i) x)) t) =
	    real (1 - CDF p (\x. real (X i x)) t))``)
	   THEN1(RW_TAC std_ss[]
	         THEN ASM_SET_TAC[])
	  THEN RW_TAC std_ss[th])
THEN RW_TAC std_ss[]	  
THEN KNOW_TAC(`` product (L2:num->bool)
          (\i.
               real
                 (1 -
                  CDF p (\x. real ((if i = 0 then WSP Y Ysa Ysd else X i) x))
                    t)) =
		    product L2 (\i. real (1 - CDF p (\x. real (X i x)) t)) ``)

     THEN1(KNOW_TAC(``!i:num. i IN L2  ==> 
          (real
            (1 -
             CDF p (\x. real ((if i = 0 then WSP Y Ysa Ysd else X i) x)) t) =
	    real (1 - CDF p (\x. real (X i x)) t))``)
	   THEN1(RW_TAC std_ss[]
	         THEN ASM_SET_TAC[])
	  THEN RW_TAC std_ss[th])
THEN RW_TAC std_ss[]	  
THEN KNOW_TAC(`` product (L3:num->bool)
          (\i.
               real
                 (1 -
                  CDF p (\x. real ((if i = 0 then WSP Y Ysa Ysd else X i) x))
                    t)) =
		    product L3 (\i. real (1 - CDF p (\x. real (X i x)) t)) ``)

     THEN1(KNOW_TAC(``!i:num. i IN L3  ==> 
          (real
            (1 -
             CDF p (\x. real ((if i = 0 then WSP Y Ysa Ysd else X i) x)) t) =
	    real (1 - CDF p (\x. real (X i x)) t))``)
	   THEN1(RW_TAC std_ss[]
	         THEN ASM_SET_TAC[])
	  THEN RW_TAC std_ss[th])
THEN RW_TAC std_ss[]);	  

val Q_dSEN_lem3 = store_thm("Q_dSEN_lem3",
  `` !p X Y Ysa Ysd t L1 L2 L3.
          disjoint_family_on (ind_set [{0}; L1; L2; L3]) {0; 1; 2; 3} /\
          FINITE L1 /\ FINITE L2 /\ FINITE L3 /\ 0 <= t ==>
          (DFT_event p
             (n_OR
                (MAP
                   (\j:num.
                        n_AND
                          (MAP
                             (\i:num.
                                  n_OR
                                    (MAP
                                       (\i:num.
                                            if i = 0 then WSP Y Ysa Ysd
                                            else X i)
                                       (SET_TO_LIST
                                          (ind_set [{0}; L1; L2; L3] i))))
                             (SET_TO_LIST (ind_set [{0}; {1; 2}; {3}] j))))
                   (SET_TO_LIST {0; 1; 2}))) t =
           DFT_event p
             (n_OR
                (MAP
                   (\i:num.
                        if i = 0 then WSP Y Ysa Ysd
                        else if i = 1 then
                          D_AND (n_OR (MAP X (SET_TO_LIST L1)))
                            (n_OR (MAP X (SET_TO_LIST L2)))
                        else n_OR (MAP X (SET_TO_LIST L3)))
                   (SET_TO_LIST {0; 1; 2}))) t)``,

RW_TAC std_ss[Q_dSEN_plus_lem2, SEN_broad_set_req_def]
THEN DEP_REWRITE_TAC[n_OR_AND_OR_BIGUNION_INTER_UNION]
THEN RW_TAC std_ss[]

THEN1( `{0:num;1;2} = {0} UNION {1;2}` by ASM_SET_TAC[]
       THEN ONCE_ASM_REWRITE_TAC[]
       THEN KNOW_TAC(``FINITE {1;2:num} ``)
       	    THEN1(`{1:num; 2} = {1} UNION {2}` by ASM_SET_TAC[]
	    THEN ONCE_ASM_REWRITE_TAC[]
	    THEN ASM_SET_TAC[FINITE_UNION, FINITE_SING])
       THEN ASM_SET_TAC[FINITE_UNION, FINITE_SING])
THEN1(RW_TAC std_ss[ind_set_def]
      THEN PSET_TAC[]
           THEN1(RW_TAC list_ss[]
	         THEN ASM_SET_TAC[FINITE_SING])
	   THEN1(RW_TAC list_ss[]
	         THEN `{0:num;1;2} = {0} UNION {1;2}` by ASM_SET_TAC[]
       		 THEN ONCE_ASM_REWRITE_TAC[]
       		 THEN KNOW_TAC(``FINITE {1;2:num} ``)
       	    	      THEN1(`{1:num; 2} = {1} UNION {2}` by ASM_SET_TAC[]
	                     THEN ONCE_ASM_REWRITE_TAC[]
	    		     THEN ASM_SET_TAC[FINITE_UNION, FINITE_SING])
                 THEN ASM_SET_TAC[FINITE_UNION, FINITE_SING])
           THEN RW_TAC list_ss[]
	   THEN ASM_SET_TAC[FINITE_SING])
THEN1(RW_TAC list_ss[ind_set_def]
      THEN PSET_TAC[] THEN RW_TAC list_ss[] THEN ASM_SET_TAC[])
THEN1(RW_TAC list_ss[ind_set_def]
      THEN FULL_SIMP_TAC list_ss[ind_set_def]
      THEN PSET_TAC[]
      THEN1(FULL_SIMP_TAC list_ss[]
            THEN ASM_SET_TAC[FINITE_SING])	
      THEN1(FULL_SIMP_TAC list_ss[])
      THEN FULL_SIMP_TAC list_ss[])


THEN RW_TAC list_ss[rv_to_devent_def, event_set_def, event_set1_def]
THEN KNOW_TAC(``!i:num. DFT_event p (if i = 0 then WSP Y Ysa Ysd else X i) t  =
                        if i = 0 then DFT_event p (WSP Y Ysa Ysd) t else DFT_event p (X i) t``)
    THEN1(RW_TAC std_ss[])
THEN RW_TAC std_ss[]  );



val PROB_DFT_SEN_plus_broadcast_final = store_thm("PROB_DFT_SEN_plus_broadcast_final",
  `` !p X Y Ysa Ysd t L1 L2 L3.
         
          
          SEN_broad_set_req p L1 L2 L3 (ind_set [{0}; L1; L2; L3])
            (ind_set [{0}; {1; 2}; {3}]) {0; 1; 2}
            (event_set [(DFT_event p (WSP Y Ysa Ysd) t,0)]
               (rv_to_devent p X t)) /\  0 <= t /\  (!i.
               i IN (L1 UNION L2 UNION L3) ==> rv_gt0_ninfinity [X i]) ==>
          (prob p
             ( DFT_event p
             (n_OR
                (MAP
                   (\i:num.
                        if i = 0 then WSP Y Ysa Ysd
                        else if i = 1 then
                          D_AND (n_OR (MAP X (SET_TO_LIST L1)))
                            (n_OR (MAP X (SET_TO_LIST L2)))
                        else n_OR (MAP X (SET_TO_LIST L3)))
                   (SET_TO_LIST {0:num; 1; 2}))) t) =
           1 -
           (1 - prob p (DFT_event p (WSP Y Ysa Ysd) t)) *
           (Normal
              (1 -
               (1 - product L1 (\i. real (1 - CDF p (real o X i) t))) *
               (1 - product L2 (\i. real (1 - CDF p (real o X i) t)))) *
            Normal (product L3 (\i. real (1 - CDF p (real o X i) t)))))``,

RW_TAC std_ss[SEN_broad_set_req_def]
THEN KNOW_TAC(`` DFT_event p
        (n_OR
           (MAP
              (\i:num.
                   if i = 0 then WSP Y Ysa Ysd
                   else if i = 1 then
                     D_AND (n_OR (MAP X (SET_TO_LIST L1)))
                       (n_OR (MAP X (SET_TO_LIST L2)))
                   else n_OR (MAP X (SET_TO_LIST L3)))
              (SET_TO_LIST {0:num; 1; 2}))) t =
	      DFT_event p
             (n_OR
                (MAP
                   (\j.
                        n_AND
                          (MAP
                             (\i:num.
                                  n_OR
                                    (MAP
                                       (\i:num.
                                            if i = 0 then WSP Y Ysa Ysd
                                            else X i)
                                       (SET_TO_LIST
                                          (ind_set [{0:num}; L1; L2; L3] i))))
                             (SET_TO_LIST (ind_set [{0:num}; {1; 2}; {3}] j))))
                   (SET_TO_LIST {0:num; 1; 2}))) t``)
		   
       THEN1( DEP_REWRITE_TAC[GSYM Q_dSEN_lem3]
               THEN RW_TAC std_ss[])
THEN RW_TAC std_ss[]	      
THEN ONCE_ASM_REWRITE_TAC[]
THEN DEP_REWRITE_TAC[PROB_DFT_SEN_plus_broadcast]
THEN RW_TAC std_ss[SEN_broad_set_req_def]);




(******************************************************************************)
(*                                                                            *)
(*                        Network Reliability                                 *)
(*                                                                            *)
(******************************************************************************)

val BIGINTER_4_sets = store_thm("BIGINTER_4_sets",
  ``!a b c d. BIGINTER {a;b;c;d} = a INTER b INTER c INTER d  ``,
ASM_SET_TAC[]);




(******************************************************************************)
(*                                                                            *)
(*             sSEN with spares                                               *)
(*                                                                            *)
(******************************************************************************)





val sSEN_nR_AND_spares = store_thm("sSEN_nR_AND_spares",
  ``!p X Y Ysa Ysd t L1 L2. DISJOINT L1 L2 /\ FINITE L1 /\ L1 <>{} /\ FINITE L2 /\ L2 <> {} ==> (DRBD_event p
          (nR_AND (λi. if i IN L1 then R_WSP (Y i) (Ysa i) (Ysd i) else ((X:num->'a->extreal) i)) (L1 UNION L2)) t=
        DRBD_series
          (λi.
               if i IN L1 then DRBD_event p (R_WSP (Y i) (Ysa i) (Ysd i)) t else 
                 (rv_to_event p X t) i) (L1 UNION L2))``,
RW_TAC std_ss[]
THEN `FINITE {0:num}` by ASM_SET_TAC[FINITE_SING]
THEN `FINITE (L1 UNION L2)` by ASM_SET_TAC[FINITE_UNION]
THEN `L1 UNION L2 <> {}` by ASM_SET_TAC[]
THEN RW_TAC std_ss[nR_AND_DRBD_series]
THEN RW_TAC std_ss[rv_to_event_def]
THEN RW_TAC std_ss[DRBD_series_def]
THEN ASM_SET_TAC[]);


val Rel_sSEN_spares = store_thm("Rel_sSEN_spares",
  `` !p X Y Ysa Ysd t L1 L2. DISJOINT L1 L2 /\ FINITE L1 /\ L1 <>{} /\ FINITE L2 /\ L2 <> {} /\
        indep_sets p
              (\i.
                   { if i IN L1 then DRBD_event p (R_WSP (Y i) (Ysa i) (Ysd i)) t else 
                 (rv_to_event p X t) i}) (L1 UNION L2) ==>

(prob p (DRBD_event p
             (nR_AND
                (\i. if i IN L1 then R_WSP (Y i) (Ysa i) (Ysd i) else X i)
                (L1 UNION L2)) t) =
 Normal (product L1 (\i.  real (Rel p (R_WSP (Y i) (Ysa i) (Ysd i)) t)))  *
       Normal (product L2 (\i. real (Rel p (X i) t) )))``,

RW_TAC std_ss[sSEN_nR_AND_spares, Rel_def]
THEN DEP_REWRITE_TAC[PROB_DRBD_series]
THEN RW_TAC std_ss[]
THEN1 ASM_SET_TAC[]
THEN1 ASM_SET_TAC[FINITE_UNION]
THEN RW_TAC std_ss[PRODUCT_UNION]
THEN KNOW_TAC(``!i:num. i IN L1 ==> 
             
             (real
               (prob p
                  (if i IN L1 then
                     DRBD_event p (R_WSP (Y i) (Ysa i) (Ysd i)) t
                   else rv_to_event p X t i)) =
		   
             real
               (prob p
                  ((DRBD_event p (R_WSP (Y i) (Ysa i) (Ysd i)) t))))``)
     THEN1( RW_TAC std_ss[])
THEN DISCH_TAC
THEN KNOW_TAC(``product L1
        (\i:num.
             real
               (prob p
                  (if i IN L1 then
                     DRBD_event p (R_WSP (Y i) (Ysa i) (Ysd i)) t
                   else rv_to_event p X t i))) =
		  product L1
        (\i. real (prob p (DRBD_event p (R_WSP (Y i) (Ysa i) (Ysd i)) t)))``)
     THEN1 RW_TAC std_ss[th]	    
THEN RW_TAC std_ss[]
THEN KNOW_TAC(``!i:num. i IN L2 ==>
     			(  real
               (prob p
                  (if i IN L1 then
                     DRBD_event p (R_WSP (Y i) (Ysa i) (Ysd i)) t
                   else rv_to_event p X t i)) =
		    real (prob p (DRBD_event p (X i) t))) ``)

    THEN1(RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
         THEN RW_TAC std_ss[rv_to_event_def])
THEN DISCH_TAC
THEN KNOW_TAC(`` product L2
        (\i:num.
             real
               (prob p
                  (if i IN L1 then
                     DRBD_event p (R_WSP (Y i) (Ysa i) (Ysd i)) t
                   else rv_to_event p X t i)))=
          product L2 (\i. real (prob p (DRBD_event p (X i) t)))``)

     THEN1 RW_TAC std_ss[th]
THEN RW_TAC std_ss[GSYM extreal_mul_def]);





val PROB_sSEN_DFT_spares = store_thm("PROB_sSEN_DFT_spares",
  `` !p X Y Ysa Ysd t L1 L2.
            DISJOINT L1 L2 /\ FINITE L1 /\ L1 <> {} /\ FINITE L2 /\
            L2 <> {} /\ (!i. i IN L2 ==> rv_gt0_ninfinity [X i]) /\
            indep_sets p
              (\i.
                   {rv_to_devent p
                      (\i. if i IN L1 then WSP (Y i) (Ysa i) (Ysd i) else (X:num->'a->extreal) i)
                      t i}) (L1 UNION L2) ==>
            (prob p
               (DFT_event p
                  (n_OR
                     (MAP
                        (\i.
                             if i IN L1 then WSP (Y i) (Ysa i) (Ysd i)
                             else X i) (SET_TO_LIST (L1 UNION L2)))) t) =
             1 -
             Normal
               (product L1
                  (\i.
                       real
                         (1 -
                          prob p (DFT_event p (WSP (Y i) (Ysa i) (Ysd i)) t)))) *
             Normal
               (product L2 (\i. real (1 - CDF p (real o (X i)) t))))``,

RW_TAC std_ss[]
THEN DEP_REWRITE_TAC [PROB_n_OR]
THEN RW_TAC std_ss[]
THEN1 ASM_SET_TAC[]
THEN1 ASM_SET_TAC[FINITE_UNION]
THEN RW_TAC std_ss[PRODUCT_UNION]
THEN RW_TAC std_ss[rv_to_devent_def]
THEN KNOW_TAC(``!i:num. i IN L1 ==>
                      ( real
               (1 -
                prob p
                  (DFT_event p
                     (if i IN L1 then WSP (Y i) (Ysa i) (Ysd i) else X i) t)) =
		     real (1 - prob p (DFT_event p (WSP (Y i) (Ysa i) (Ysd i)) t)))``)
     THEN1 RW_TAC std_ss[]
THEN DISCH_TAC
THEN KNOW_TAC(``product L1
        (\i:num.
             real
               (1 -
                prob p
                  (DFT_event p
                     (if i IN L1 then WSP (Y i) (Ysa i) (Ysd i) else X i) t)))=
		 product L1
        (\i. real (1 - prob p (DFT_event p (WSP (Y i) (Ysa i) (Ysd i)) t)))    ``)
    THEN1 RW_TAC std_ss[th]
THEN RW_TAC std_ss[]
THEN KNOW_TAC(`` !i:num. i IN L2 ==>
     		 (real
               (1 -
                prob p
                  (DFT_event p
                     (if i IN L1 then WSP (Y i) (Ysa i) (Ysd i) else X i) t)) =
		      real (1 - CDF p (real o X i) t)) ``)
    THEN1(RW_TAC std_ss[] THEN1 ASM_SET_TAC[] THEN FULL_SIMP_TAC list_ss[rv_gt0_ninfinity_def]
           THEN RW_TAC std_ss[o_DEF] THEN RW_TAC std_ss[GSYM CDF_prob_DFT_event])
THEN DISCH_TAC
THEN KNOW_TAC(``product L2
         (\i:num.
              real
                (1 -
                 prob p
                   (DFT_event p
                      (if i IN L1 then WSP (Y i) (Ysa i) (Ysd i) else X i) t))) =
		    product L2 (\i. real(1 - CDF p (real o X i) t)) ``)
     THEN1 RW_TAC std_ss[th]
THEN RW_TAC std_ss[GSYM extreal_mul_def]);




(* ========================================================================== *)
(*                                                                            *)
(*                      DRBD SEN+                                             *)
(*                                                                            *)
(* ========================================================================== *)






val Q_SEN_network_nR_AND_DRBD_series = store_thm(
  "Q_SEN_network_nR_AND_DRBD_series",
  `` !p L1 L2 L3 L4 L X t.
            FINITE L1 /\ L1 <> {} /\ FINITE L2 /\ L2 <> {} /\ FINITE L3 /\
            L3 <> {} /\ FINITE L4 /\ L4 <> {} /\ FINITE L /\
            DISJOINT {0; 1; 3; 4} L /\
            (!i. i IN L ==> DISJOINT {2 * i; 2 * i + 1} {0; 1; 2; 3; 4}) ==>
            (DRBD_event p
               (nR_AND
                  (\i.
                       if i = 0 then X 0
                       else if i = 1 then nR_AND X L1
                       else if i = 3 then R_OR (nR_AND X L2) (nR_AND X L3)
                       else if i = 4 then nR_AND X L4
                       else R_OR (X (2 * i)) (X (2 * i + 1)))
                  ({0; 1; 3; 4} UNION L)) t =
             DRBD_series
               (\j.
                    DRBD_parallel
                      (\a.
                           DRBD_series (\i. rv_to_event p X t i)
                             ((\a.
                                   if a = 0 then {0}
                                   else if a = 1 then L1
                                   else if a = 2 then L2
                                   else if a = 3 then L3
                                   else if a = 4 then L4
                                   else {a}) a))
                      ((\j.
                            if j = 0 then {0}
                            else if j = 1 then {1}
                            else if j IN L then {2 * j; 2 * j + 1}
                            else if j = 3 then {2; 3}
                            else {4}) j)) ({0; 1; 3; 4:num} UNION L))``,

RW_TAC std_ss[]
THEN KNOW_TAC(``FINITE ({0;1;3;4:num} UNION L) ``)
     THEN1(`{0;1;3;4:num} = {0} UNION ({1} UNION ({3} UNION ({4})))` by ASM_SET_TAC[]
           THEN RW_TAC std_ss[FINITE_UNION, FINITE_SING])
THEN `{0;1;3;4:num} UNION L <> {}` by ASM_SET_TAC[]
THEN RW_TAC std_ss[nR_AND_DRBD_series]	   
THEN KNOW_TAC(`` DRBD_series
     (rv_to_event p
        (\i.
             if i:num = 0 then X 0
             else if i = 1 then nR_AND X L1
             else if i = 3 then R_OR (nR_AND X L2) (nR_AND X L3)
             else if i = 4 then nR_AND X L4
             else R_OR (X (2 * i)) (X (2 * i + 1))) t) ({0; 1; 3; 4} UNION L) =
	     DRBD_series
     (
          rv_to_event p
            (\i:num.
                 if i = 0 then X 0
                 else if i = 1 then nR_AND X L1
                 else if i = 3 then R_OR (nR_AND X L2) (nR_AND X L3)
                 else if i = 4 then nR_AND X L4
                 else R_OR (X (2 * i)) (X (2 * i + 1))) t ) {0; 1; 3; 4} INTER
   DRBD_series
     (
          rv_to_event p
            (\i:num.
                 if i = 0 then X 0
                 else if i = 1 then nR_AND X L1
                 else if i = 3 then R_OR (nR_AND X L2) (nR_AND X L3)
                 else if i = 4 then nR_AND X L4
                 else R_OR (X (2 * i)) (X (2 * i + 1))) t ) L ``)
        THEN1(RW_TAC std_ss[DRBD_series_def]
              THEN RW_TAC std_ss[GSYM IMAGE_DEF]
 	      THEN RW_TAC std_ss[IMAGE_UNION]
	      THEN RW_TAC std_ss[BIGINTER_UNION])
THEN RW_TAC std_ss[]	      

THEN KNOW_TAC(``
   DRBD_series
     (rv_to_event p
        (\i:num.
             if i = 0 then X 0
             else if i = 1 then nR_AND X L1
             else if i = 3 then R_OR (nR_AND X L2) (nR_AND X L3)
             else if i = 4 then nR_AND X L4
             else R_OR (X (2 * i)) (X (2 * i + 1))) t) ({0; 1; 3; 4})=
    DRBD_event p (X 0) t INTER
    DRBD_event p (nR_AND X L1) t INTER
    DRBD_event p (R_OR (nR_AND X L2) (nR_AND X L3)) t INTER
    DRBD_event p (nR_AND X L4) t  ``)

    
     THEN1(RW_TAC std_ss[DRBD_series_def, rv_to_event_def]
           THEN KNOW_TAC(``
     {DRBD_event p
       (if i = 0 then X 0
        else if i = 1 then nR_AND X L1
        else if i = 3 then R_OR (nR_AND X L2) (nR_AND X L3)
        else if i = 4 then nR_AND X L4
        else R_OR (X (2 * i)) (X (2 * i + 1))) t |
     i IN {0; 1:num; 3; 4} } =
     {DRBD_event p
       (X (0:num)) t;
      DRBD_event p (nR_AND X (L1:num->bool)) t;
      DRBD_event p ( R_OR (nR_AND X (L2:num->bool)) (nR_AND X (L3:num->bool))) t;
      DRBD_event p (nR_AND X (L4:num->bool)) t }``)  

             THEN1(PSET_TAC[]
                    THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
 		    THEN EQ_TAC
		         THEN1(RW_TAC std_ss[] THEN RW_TAC std_ss[])
	            THEN RW_TAC std_ss[]
		         THEN1(Q.EXISTS_TAC`0`
			        THEN RW_TAC std_ss[])
			 THEN1(Q.EXISTS_TAC`1`
			       THEN RW_TAC std_ss[])
			  THEN1(Q.EXISTS_TAC`3`
			       THEN RW_TAC std_ss[])

		    THEN Q.EXISTS_TAC`4`
		    THEN RW_TAC std_ss[])
       THEN RW_TAC std_ss[]
       THEN RW_TAC std_ss[BIGINTER_4_sets])
THEN RW_TAC std_ss[]       
THEN KNOW_TAC(``DRBD_series
     (rv_to_event p
        (\i:num.
             if i = 0 then X 0
             else if i = 1 then nR_AND X L1
             else if i = 3 then R_OR (nR_AND X L2) (nR_AND X L3)
             else if i = 4 then nR_AND X L4
             else R_OR (X (2 * i)) (X (2 * i + 1))) t) L =
	     DRBD_series
     (rv_to_event p
        (\i. R_OR (X (2 * i)) (X (2 * i + 1))) t) L``)
    THEN1(RW_TAC std_ss[DRBD_series_def]
          THEN AP_TERM_TAC
	  THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
	  THEN EQ_TAC
	       THEN1( RW_TAC std_ss[]
	             THEN Q.EXISTS_TAC`i`
	             THEN RW_TAC std_ss[]
		     THEN EQ_TAC
	                  THEN1(RW_TAC std_ss[]
	                        THEN FULL_SIMP_TAC std_ss[DISJOINT_DEF]
		     		THEN `i:num <> 1` by ASM_SET_TAC[]
     		     		THEN `i:num <> 0` by ASM_SET_TAC[]
		     		THEN `i:num <> 3` by ASM_SET_TAC[]
		     		THEN `i:num <> 4` by ASM_SET_TAC[]
		     		THEN FULL_SIMP_TAC std_ss[]
		     		THEN FULL_SIMP_TAC std_ss[rv_to_event_def])
	             THEN RW_TAC std_ss[]
	 	     THEN `i:num <> 1` by ASM_SET_TAC[]
     	 	     THEN `i:num <> 0` by ASM_SET_TAC[]
	 	     THEN `i:num <> 3` by ASM_SET_TAC[]
	 	     THEN `i:num <> 4` by ASM_SET_TAC[]
	 	     THEN RW_TAC std_ss[rv_to_event_def]
	 	     THEN FULL_SIMP_TAC std_ss[rv_to_event_def])
          THEN RW_TAC std_ss[]
	  THEN Q.EXISTS_TAC`i`
	  THEN RW_TAC std_ss[]
	  THEN EQ_TAC
	        THEN1(RW_TAC std_ss[]
		      THEN `i:num <> 1` by ASM_SET_TAC[]
     		      THEN `i:num <> 0` by ASM_SET_TAC[]
		      THEN `i:num <> 3` by ASM_SET_TAC[]
		      THEN `i:num <> 4` by ASM_SET_TAC[]
		      THEN FULL_SIMP_TAC std_ss[]
		      THEN FULL_SIMP_TAC std_ss[rv_to_event_def])
          THEN `i:num <> 1` by ASM_SET_TAC[]
     	  THEN `i:num <> 0` by ASM_SET_TAC[]
	  THEN `i:num <> 3` by ASM_SET_TAC[]
	  THEN `i:num <> 4` by ASM_SET_TAC[]
	  THEN RW_TAC std_ss[rv_to_event_def])

THEN RW_TAC std_ss[]
THEN ONCE_REWRITE_TAC[DRBD_series_def]
THEN RW_TAC std_ss[GSYM IMAGE_DEF]
THEN RW_TAC std_ss[IMAGE_UNION]
THEN RW_TAC std_ss[BIGINTER_UNION]
THEN RW_TAC std_ss[IMAGE_DEF, GSYM DRBD_series_def]
THEN KNOW_TAC(``DRBD_series
     (\i:num.
          DRBD_parallel
            (\a:num.
                 DRBD_series (\i. rv_to_event p X t i)
                   (if a = 0 then {0}
                    else if a = 1 then L1
                    else if a = 2 then L2
                    else if a = 3 then L3
                    else if a = 4 then L4
                    else {a}))
            (if i = 0 then {0}
             else if i = 1 then {1}
             else if i IN L then {2 * i; 2 * i + 1}
             else if i = 3 then {2; 3}
             else {4})) {0; 1; 3; 4} =
	    DRBD_event p (X 0) t INTER DRBD_event p (nR_AND X L1) t INTER
   DRBD_event p (R_OR (nR_AND X L2) (nR_AND X L3)) t INTER
   DRBD_event p (nR_AND X L4) t ``)
   THEN1(RW_TAC std_ss[DRBD_series_def]
	 THEN RW_TAC std_ss[GSYM IMAGE_DEF]
	 THEN `{0;1;3;4:num} = {0} UNION ({1} UNION ({3} UNION {4}))` by ASM_SET_TAC[]
	 THEN ONCE_ASM_REWRITE_TAC[]
	 THEN RW_TAC std_ss[IMAGE_UNION]
	 THEN RW_TAC std_ss[BIGINTER_UNION]
	 THEN RW_TAC std_ss[IMAGE_DEF]


	 THEN KNOW_TAC(``!i k:num. i IN {k} ==> (i = k) ``)
	      THEN1(ASM_SET_TAC[])
	 THEN RW_TAC std_ss[]     
	 THEN PSET_TAC[]
	 THEN KNOW_TAC(`` 
	  BIGINTER
     {DRBD_parallel
       (\a.
            BIGINTER
              {rv_to_event p X t i |
              i IN if a = 0 then {0} else if a = 1 then L1
              else if a = 2 then L2 else if a = 3 then L3
              else if a = 4 then L4 else {a}})
       (if i = 0 then {0}
        else if i = 1 then {1}
        else if i IN L then {2 * i; 2 * i + 1}
        else if i = 3 then {2; 3}
        else {4}) |
     i = 0:num}  =
      BIGINTER
     {DRBD_parallel
       (\a.
            BIGINTER
              {rv_to_event p X t i |
              i IN if a = 0 then {0} else if a = 1 then L1
              else if a = 2 then L2 else if a = 3 then L3
              else if a = 4 then L4 else {a}}){0} }         ``)
	     THEN1(ASM_SET_TAC[])
      THEN RW_TAC std_ss[]	     
      THEN KNOW_TAC(`` 
	  BIGINTER
     {DRBD_parallel
       (\a.
            BIGINTER
              {rv_to_event p X t i |
              i IN if a = 0 then {0} else if a = 1 then L1
              else if a = 2 then L2 else if a = 3 then L3
              else if a = 4 then L4 else {a}})
       (if i = 0 then {0}
        else if i = 1 then {1}
        else if i IN L then {2 * i; 2 * i + 1}
        else if i = 3 then {2; 3}
        else {4}) |
     i = 1:num}  =
      BIGINTER
     {DRBD_parallel
       (\a.
            BIGINTER
              {rv_to_event p X t i |
              i IN if a = 0 then {0} else if a = 1 then L1
              else if a = 2 then L2 else if a = 3 then L3
              else if a = 4 then L4 else {a}}){1} }         ``)
	     THEN1(ASM_SET_TAC[])
	THEN RW_TAC std_ss[]
	THEN KNOW_TAC(`` 
	  BIGINTER
     {DRBD_parallel
       (\a.
            BIGINTER
              {rv_to_event p X t i |
              i IN if a = 0 then {0} else if a = 1 then L1
              else if a = 2 then L2 else if a = 3 then L3
              else if a = 4 then L4 else {a}})
       (if i = 0 then {0}
        else if i = 1 then {1}
        else if i IN L then {2 * i; 2 * i + 1}
        else if i = 3 then {2; 3}
        else {4}) |
     i = 3:num}  =
      BIGINTER
     {DRBD_parallel
       (\a.
            BIGINTER
              {rv_to_event p X t i |
              i IN if a = 0 then {0} else if a = 1 then L1
              else if a = 2 then L2 else if a = 3 then L3
              else if a = 4 then L4 else {a}}){2;3:num} }         ``)
	     THEN1(ASM_SET_TAC[])
        THEN RW_TAC std_ss[]
	 THEN KNOW_TAC(`` 
	  BIGINTER
     {DRBD_parallel
       (\a.
            BIGINTER
              {rv_to_event p X t i |
              i IN if a = 0 then {0} else if a = 1 then L1
              else if a = 2 then L2 else if a = 3 then L3
              else if a = 4 then L4 else {a}})
       (if i = 0 then {0}
        else if i = 1 then {1}
        else if i IN L then {2 * i; 2 * i + 1}
        else if i = 3 then {2; 3}
        else {4}) |
     i = 4:num}  =
      BIGINTER
     {DRBD_parallel
       (\a.
            BIGINTER
              {rv_to_event p X t i |
              i IN if a = 0 then {0} else if a = 1 then L1
              else if a = 2 then L2 else if a = 3 then L3
              else if a = 4 then L4 else {a}}){4} }         ``)
	     THEN1(ASM_SET_TAC[])
      THEN RW_TAC std_ss[]
      THEN RW_TAC std_ss[BIGINTER_SING]
      THEN RW_TAC std_ss[rv_to_event_def]
      THEN RW_TAC std_ss[DRBD_parallel_def]
      THEN PSET_TAC[]
      THEN KNOW_TAC(``  BIGUNION
     {BIGINTER
       {DRBD_event p ((X:num->'a->extreal) i) t |
       i IN if a = 0 then {0} else if a:num = 1 then L1 else if a = 2 then L2
       else if a = 3 then L3 else if a = 4 then L4 else {a}} |
     a = 0} =
      DRBD_event p (X 0) t  ``)
           THEN1(SRW_TAC[][GSPECIFICATION, EXTENSION]
	         THEN EQ_TAC THEN1 (RW_TAC std_ss[] THEN  ASM_SET_TAC[])
		 THEN ASM_SET_TAC[])
      THEN RW_TAC std_ss[]
      THEN KNOW_TAC(``BIGUNION
      {BIGINTER
        {DRBD_event p ((X:num->'a->extreal) i) t |
        i IN if a = 0 then {0} else if a = 1 then L1 else if a = 2 then L2
        else if a = 3 then L3 else if a = 4 then L4 else {a}} |
      a = 1} =
      DRBD_event p (nR_AND X L1) t``)
           THEN1(RW_TAC std_ss[nR_AND_DRBD_series]
	         THEN KNOW_TAC(``{BIGINTER
       {DRBD_event p (X i) t |
       i IN if a = 0 then {0} else if a = 1 then L1 else if a = 2 then L2
       else if a = 3 then L3 else if a = 4 then L4 else {a}} |
     a = 1} =
            {BIGINTER {rv_to_event p (X:num->'a->extreal) t i | i IN L1}}``)
	         THEN1 (ASM_SET_TAC[rv_to_event_def])
		 THEN RW_TAC std_ss[BIGUNION_SING, DRBD_series_def])
       THEN RW_TAC std_ss[]
       THEN KNOW_TAC(``BIGUNION
       {BIGINTER
         {DRBD_event p (X i) t |
         i IN if a = 0 then {0} else if a = 1 then L1 else if a = 2 then L2
         else if a = 3 then L3 else if a = 4 then L4 else {a}} |
       (a = 2) \/ (a = 3)} =
        DRBD_event p (R_OR (nR_AND X L2) (nR_AND (X:num->'a->extreal) L3)) t ``)
	    THEN1(RW_TAC std_ss[R_OR_UNION]
	         THEN RW_TAC std_ss[nR_AND_DRBD_series]
		 THEN KNOW_TAC(`` {BIGINTER
     {DRBD_event p (X i) t |
     i IN if a = 0 then {0} else if a = 1 then L1 else if a = 2 then L2
     else if a = 3 then L3 else if a = 4 then L4 else {a}} |
   (a = 2) \/ (a = 3)} =

   {BIGINTER
     {DRBD_event p (X i) t |
     i IN if a = 0 then {0} else if a = 1 then L1 else if a = 2 then L2
     else if a = 3 then L3 else if a = 4 then L4 else {a}} |
   (a = 2)} UNION
   {BIGINTER
     {DRBD_event p ((X:num->'a->extreal) i) t |
     i IN if a = 0 then {0} else if a = 1 then L1 else if a = 2 then L2
     else if a = 3 then L3 else if a = 4 then L4 else {a}} | (a = 3)}``)
                     THEN1(SRW_TAC[][GSPECIFICATION, EXTENSION]
		           THEN RW_TAC std_ss[] THEN EQ_TAC
			   THEN1(RW_TAC std_ss[] THEN ASM_SET_TAC[])
			   THEN RW_TAC std_ss[]
			        THEN1(Q.EXISTS_TAC`2:num`
				     THEN RW_TAC std_ss[])
			   THEN Q.EXISTS_TAC`3`
			   THEN RW_TAC std_ss[])
		THEN RW_TAC std_ss[]
		THEN KNOW_TAC(``{BIGINTER
     {DRBD_event p (X i) t |
     i IN if a = 0 then {0} else if a = 1 then L1 else if a = 2 then L2
     else if a = 3 then L3 else if a = 4 then L4 else {a}} |
   a = 2} =
   {BIGINTER {DRBD_event p ((X:num->'a->extreal) i) t | i IN L2}}``)
                      THEN1(ASM_SET_TAC[])
		THEN RW_TAC std_ss[]      
		THEN KNOW_TAC(``{BIGINTER
     {DRBD_event p ((X:num->'a->extreal) i) t |
     i IN if a = 0 then {0} else if a = 1 then L1 else if a = 2 then L2
     else if a = 3 then L3 else if a = 4 then L4 else {a}} |
   a = 3} =
   {BIGINTER {DRBD_event p (X i) t | i IN L3}}``)
                   THEN1(ASM_SET_TAC[])
		 THEN RW_TAC std_ss[]
		 THEN KNOW_TAC(``{BIGINTER {DRBD_event p (X i) t | i IN L2}} UNION
      {BIGINTER {DRBD_event p (X i) t | i IN L3}} =
       {BIGINTER {DRBD_event p (X i) t | i IN L2}; 
      BIGINTER {DRBD_event p ((X:num->'a->extreal) i) t | i IN L3}} ``)

                     THEN1(ASM_SET_TAC[])
		  THEN RW_TAC std_ss[]
		  THEN RW_TAC std_ss[BIGUNION_PAIR]
		  THEN RW_TAC std_ss[DRBD_series_def, BIGUNION_PAIR, rv_to_event_def])
   THEN RW_TAC std_ss[]      
   THEN KNOW_TAC(``BIGUNION
       {BIGINTER
         {DRBD_event p (X i) t |
         i IN if a = 0 then {0} else if a = 1 then L1 else if a = 2 then L2
         else if a = 3 then L3 else if a = 4 then L4 else {a}} |
       a = 4} = DRBD_event p (nR_AND (X:num->'a->extreal) L4) t ``)
     THEN1(RW_TAC std_ss[nR_AND_DRBD_series]
           THEN RW_TAC std_ss[DRBD_series_def, rv_to_event_def]
	   THEN KNOW_TAC(``{BIGINTER
       {DRBD_event p (X i) t |
       i IN if a = 0 then {0} else if a = 1 then L1 else if a = 2 then L2
       else if a = 3 then L3 else if a = 4 then L4 else {a}} |
     a = 4} =
     {BIGINTER {DRBD_event p ((X:num->'a->extreal) i) t | i IN L4}}``)
               THEN1(ASM_SET_TAC[])
	   THEN RW_TAC std_ss[]
	   THEN RW_TAC std_ss[BIGUNION_SING])
    THEN RW_TAC std_ss[]	   
    THEN RW_TAC std_ss[INTER_ASSOC])


THEN RW_TAC std_ss[]
THEN AP_TERM_TAC
THEN RW_TAC std_ss[DRBD_series_def, DRBD_parallel_def]
THEN KNOW_TAC(`` !i:num. i IN L ==>(
              {BIGINTER
         {rv_to_event p X t i |
         i IN if a = 0 then {0} else if a = 1 then L1 else if a = 2 then L2
         else if a = 3 then L3 else if a = 4 then L4 else {a}} |
       a IN if i = 0 then {0} else if i = 1 then {1}
       else if i IN L then {2 * i; 2 * i + 1} else if i = 3 then {2; 3}
       else {4}} =
       {BIGINTER
         {rv_to_event p (X:num->'a->extreal) t i |
         i IN if a = 0 then {0} else if a = 1 then L1 else if a = 2 then L2
         else if a = 3 then L3 else if a = 4 then L4 else {a}} |
       a IN  {2 * i; 2 * i + 1} })``)
       THEN1( RW_TAC std_ss[] THEN ASM_SET_TAC[])
THEN RW_TAC std_ss[]       
THEN KNOW_TAC(``BIGINTER
     {BIGUNION
       {BIGINTER
         {rv_to_event p X t i |
         i IN if a = 0 then {0} else if a = 1 then L1 else if a = 2 then L2
         else if a = 3 then L3 else if a = 4 then L4 else {a}} |
       a IN if i = 0 then {0} else if i = 1 then {1}
       else if i IN L then {2 * i; 2 * i + 1} else if i = 3 then {2; 3}
       else {4}} |
     i |
     i IN L} =
     BIGINTER
     {BIGUNION
       {BIGINTER
         {rv_to_event p (X:num->'a->extreal) t i |
         i IN if a = 0 then {0} else if a = 1 then L1 else if a = 2 then L2
         else if a = 3 then L3 else if a = 4 then L4 else {a}} |
       a IN {2 * i; 2 * i + 1}} |
     i |
     i IN L}``)

     THEN1 (RW_TAC std_ss[GSYM IMAGE_DEF]
            THEN FULL_SIMP_TAC std_ss[GSYM IMAGE_DEF]
            THEN KNOW_TAC(``!i. i IN L ==> (
 BIGUNION
            (IMAGE
               (\a.
                    BIGINTER
                      (IMAGE (\i. rv_to_event p X t i)
                         (if a = 0 then {0}
                          else if a = 1 then L1
                          else if a = 2 then L2
                          else if a = 3 then L3
                          else if a = 4 then L4
                          else {a})))
               (if i = 0 then {0}
                else if i = 1 then {1}
                else if i IN L then {2 * i; 2 * i + 1}
                else if i = 3 then {2; 3}
                else {4})) =
		BIGUNION
            (IMAGE
               (\a.
                    BIGINTER
                      (IMAGE (\i. rv_to_event p (X:num->'a->extreal) t i)
                         (if a = 0 then {0}
                          else if a = 1 then L1
                          else if a = 2 then L2
                          else if a = 3 then L3
                          else if a = 4 then L4
                          else {a}))) {2 * i; 2 * i + 1}))``)

        THEN1(RW_TAC std_ss[]
	      THEN ASM_SET_TAC[])
	 THEN RW_TAC std_ss[]     
	 THEN AP_TERM_TAC
        THEN RW_TAC std_ss[IMAGE_EQ])
THEN RW_TAC std_ss[]
THEN RW_TAC std_ss[rv_to_event_def]
THEN RW_TAC std_ss[R_OR_UNION]
THEN RW_TAC std_ss[GSYM BIGUNION_PAIR]
THEN RW_TAC std_ss[GSYM IMAGE_DEF]
THEN AP_TERM_TAC
THEN KNOW_TAC(``!i:num. i IN L==>
((IMAGE
               (\a.
                    BIGINTER
                      (IMAGE (\i. DRBD_event p (X i) t)
                         (if a = 0 then {0}
                          else if a = 1 then L1
                          else if a = 2 then L2
                          else if a = 3 then L3
                          else if a = 4 then L4
                          else {a}))) {2 * i; 2 * i + 1}) =
			  {DRBD_event p (X (2 * i)) t; DRBD_event p ((X:num->'a->extreal) (2 * i + 1)) t})``)
      THEN1(RW_TAC std_ss[]
            THEN `{2*i; 2*i+1:num} = {2*i} UNION {2*i+1}` by ASM_SET_TAC[]
 	    THEN ONCE_ASM_REWRITE_TAC[]
	    THEN RW_TAC std_ss[IMAGE_UNION]
	    THEN RW_TAC std_ss[IMAGE_DEF]
	    THEN KNOW_TAC(`` {BIGINTER
     {DRBD_event p (X i) t |
     i IN if a = 0 then {0} else if a = 1 then L1 else if a = 2 then L2
     else if a = 3 then L3 else if a = 4 then L4 else {a}} |
   a IN {2 * i}} =
   {DRBD_event p ((X:num->'a->extreal) (2 * i)) t}``)
                THEN1(PSET_TAC[]
		      THEN `2*i:num <> 0` by ASM_SET_TAC[DISJOINT_DEF]
		      THEN `2*i:num <> 1` by ASM_SET_TAC[DISJOINT_DEF]
		      THEN `2*i:num <> 2` by ASM_SET_TAC[DISJOINT_DEF]
		      THEN `2*i:num <> 3` by ASM_SET_TAC[DISJOINT_DEF]
		      THEN `2*i:num <> 4` by ASM_SET_TAC[DISJOINT_DEF]
		      THEN RW_TAC std_ss[GSYM IMAGE_DEF]
		      THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
		      THEN EQ_TAC THEN1(RW_TAC std_ss[] THEN ASM_SET_TAC[])
		      THEN RW_TAC std_ss[] THEN ASM_SET_TAC[])
	  THEN RW_TAC std_ss[]
	  THEN KNOW_TAC(`` {BIGINTER
     {DRBD_event p (X i) t |
     i IN if a = 0 then {0} else if a = 1 then L1 else if a = 2 then L2
     else if a = 3 then L3 else if a = 4 then L4 else {a}} |
   a IN {2 * i+1}} =
   {DRBD_event p ((X:num->'a->extreal) (2 * i+1)) t}``)
             THEN1(PSET_TAC[]
		      THEN `2*i:num <> 0` by ASM_SET_TAC[DISJOINT_DEF]
		      THEN `2*i:num <> 1` by ASM_SET_TAC[DISJOINT_DEF]
		      THEN `2*i:num <> 2` by ASM_SET_TAC[DISJOINT_DEF]
		      THEN `2*i:num <> 3` by ASM_SET_TAC[DISJOINT_DEF]
		      THEN `2*i:num <> 4` by ASM_SET_TAC[DISJOINT_DEF]
		      THEN RW_TAC std_ss[GSYM IMAGE_DEF]
		      THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
		      THEN EQ_TAC THEN1(RW_TAC std_ss[] THEN ASM_SET_TAC[])
		      THEN RW_TAC std_ss[] THEN ASM_SET_TAC[])
	 THEN RW_TAC std_ss[]
	 THEN ASM_SET_TAC[])
THEN RW_TAC std_ss[IMAGE_EQ]);

val FINITE_PAIR = store_thm("FINITE_PAIR",
  ``!s t. FINITE {s;t}  ``,
RW_TAC std_ss[] THEN `{s;t} = {s} UNION {t}` by ASM_SET_TAC[] THEN RW_TAC std_ss[FINITE_SING, FINITE_UNION]);

val FINITE_4 = store_thm("FINITE_4",
  ``!a b c d. FINITE {a;b;c;d} ``,
RW_TAC std_ss[] THEN `{a;b;c;d} = {a;b} UNION {c;d}` by ASM_SET_TAC[]
THEN RW_TAC std_ss[FINITE_UNION, FINITE_PAIR]);


  val FINITE_3 = store_thm("FINITE_3",
  `` !a b c. FINITE {a;b;c} ``,
RW_TAC std_ss[] THEN `{a;b;c} = {a;b} UNION {c}` by ASM_SET_TAC[] THEN RW_TAC std_ss[FINITE_UNION, FINITE_SING, FINITE_PAIR]);

val DISJOINT_NUM = store_thm("DISJOINT_NUM",
  `` !a b c d.  a <>c /\ a <> d /\ b<> c /\ b <> d ==> DISJOINT {a;b} {c;d}``,
ASM_SET_TAC[]);



val PROB_SEN_network_lem1 = store_thm("PROB_SEN_network_lem1",
  ``!p L1 L2 L3 L4 L X t LL A J .
          FINITE L1 /\ L1 <> {} /\ FINITE L2 /\ L2 <> {} /\ FINITE L3 /\
          L3 <> {} /\ FINITE L4 /\ L4 <> {} /\ FINITE L /\
          DISJOINT {0; 1; 3; 4:num} L /\
	  (!i j. i IN L /\ j IN L /\ i <> j ==> DISJOINT {2*i; 2*i+1} {2*j; 2*j+1})/\
          (!i:num. i IN L ==> DISJOINT {2 * i; 2 * i + 1} {0; 1; 2; 3; 4}) /\
	  
	  indep_sets p (\i.  {X i}) (BIGUNION_o_BIGUNION LL A J)  /\
	  
	 disjoint_family_on
	    (ind_set[{0:num}; L1; L2; L3; L4; ({2*i|i IN L} UNION {2*i+1| i IN L})])
	       {0;1;2;3;4;5} /\
	       (J = ({0;1;3;4} UNION L)) /\
	       (A = (\j. if j IN L then {2*j; 2*j+1} else ( ind_set[{0}; {1}; {} ;{2;3}; {4}] j) )) /\
	       (LL = (\i. if i IN ({2*i|i IN L} UNION {2*i+1| i IN L}) then {i} else  (ind_set[{0}; L1; L2; L3; L4] i))) ==>
 (prob p
               (DRBD_series
                  (\j.
                       DRBD_parallel
                         (\a.
                              DRBD_series
                                X (LL a))
                         (A j)) J) =

 prob p (X 0) * Normal (product L1 (\l. real (prob p (X l)))) *
   (1 -
    (1 - Normal (product L2 (\l. real (prob p (X l))))) *
    (1 - Normal (product L3 (\l. real (prob p (X l)))))) *
   Normal (product L4 (\l. real (prob p (X l)))) *
   Normal
     (product L
        (\j.
             1 -
             real ((1 - prob p (X (2 * j))) * (1 - prob p (X (2 * j + 1)))))))``,

RW_TAC std_ss[disjoint_family_on]
THEN KNOW_TAC(``DISJOINT {0:num} L1 ``)
     THEN1(POP_ASSUM (MP_TAC o Q.SPEC `0`)
          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `1`)
	  THEN RW_TAC list_ss[ind_set_def, DISJOINT_DEF])
	  
THEN KNOW_TAC(``DISJOINT {0:num} L2 ``)
     THEN1(POP_ASSUM (MP_TAC o Q.SPEC `0`)
          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `2`)
	  THEN RW_TAC list_ss[ind_set_def, DISJOINT_DEF])


THEN KNOW_TAC(``DISJOINT {0:num} L3 ``)
     THEN1(POP_ASSUM (MP_TAC o Q.SPEC `0`)
          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `3`)
	  THEN RW_TAC list_ss[ind_set_def, DISJOINT_DEF])


THEN KNOW_TAC(``DISJOINT {0:num} L4 ``)
     THEN1(POP_ASSUM (MP_TAC o Q.SPEC `0`)
          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `4`)
	  THEN RW_TAC list_ss[ind_set_def, DISJOINT_DEF])

THEN KNOW_TAC(``DISJOINT {0:num} ({2 * i | i IN L} UNION {2 * i + 1 | i IN L}) ``)
     THEN1(POP_ASSUM (MP_TAC o Q.SPEC `0`)
          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `5`)
	  THEN RW_TAC list_ss[ind_set_def, DISJOINT_DEF])

THEN KNOW_TAC(``DISJOINT  (L1:num->bool) L2 ``)
     THEN1(POP_ASSUM (MP_TAC o Q.SPEC `1`)
          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `2`)
	  THEN RW_TAC list_ss[ind_set_def, DISJOINT_DEF])
	  
THEN KNOW_TAC(``DISJOINT  (L1:num->bool) L3 ``)
     THEN1(POP_ASSUM (MP_TAC o Q.SPEC `1`)
          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `3`)
	  THEN RW_TAC list_ss[ind_set_def, DISJOINT_DEF])
	  
THEN KNOW_TAC(``DISJOINT  (L1:num->bool) L4 ``)
     THEN1(POP_ASSUM (MP_TAC o Q.SPEC `1`)
          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `4`)
	  THEN RW_TAC list_ss[ind_set_def, DISJOINT_DEF])
	  

THEN KNOW_TAC(``DISJOINT  (L1:num->bool) ({2 * i | i IN L} UNION {2 * i + 1 | i IN L} )``)
     THEN1(POP_ASSUM (MP_TAC o Q.SPEC `1`)
          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `5`)
	  THEN RW_TAC list_ss[ind_set_def, DISJOINT_DEF])
	  
THEN KNOW_TAC(``DISJOINT  (L2:num->bool) L3 ``)
     THEN1(POP_ASSUM (MP_TAC o Q.SPEC `2`)
          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `3`)
	  THEN RW_TAC list_ss[ind_set_def, DISJOINT_DEF])

THEN KNOW_TAC(``DISJOINT  (L2:num->bool) L4 ``)
     THEN1(POP_ASSUM (MP_TAC o Q.SPEC `2`)
          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `4`)
	  THEN RW_TAC list_ss[ind_set_def, DISJOINT_DEF])

THEN KNOW_TAC(``DISJOINT  (L2:num->bool)  ({2 * i | i IN L} UNION {2 * i + 1 | i IN L} ) ``)
     THEN1(POP_ASSUM (MP_TAC o Q.SPEC `2`)
          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `5`)
	  THEN RW_TAC list_ss[ind_set_def, DISJOINT_DEF])

THEN KNOW_TAC(``DISJOINT  (L3:num->bool) L4 ``)
     THEN1(POP_ASSUM (MP_TAC o Q.SPEC `3`)
          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `4`)
	  THEN RW_TAC list_ss[ind_set_def, DISJOINT_DEF])

THEN KNOW_TAC(``DISJOINT  (L3:num->bool) ({2 * i | i IN L} UNION {2 * i + 1 | i IN L} ) ``)
     THEN1(POP_ASSUM (MP_TAC o Q.SPEC `3`)
          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `5`)
	  THEN RW_TAC list_ss[ind_set_def, DISJOINT_DEF])

THEN KNOW_TAC(``DISJOINT  (L4:num->bool) ({2 * i | i IN L} UNION {2 * i + 1 | i IN L} ) ``)
     THEN1(POP_ASSUM (MP_TAC o Q.SPEC `4`)
          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `5`)
	  THEN RW_TAC list_ss[ind_set_def, DISJOINT_DEF])


THEN RW_TAC std_ss[]


THEN DEP_REWRITE_TAC[PROB_DRBD_series_parallel_series_lem]
THEN RW_TAC std_ss[]
      THEN1 (RW_TAC std_ss[sets_finite_not_empty2_def]
            THEN1(PSET_TAC[]
		  THEN RW_TAC list_ss[ind_set_def] THEN ASM_SET_TAC[])
            THEN1(PSET_TAC[]
	          THEN RW_TAC list_ss[FINITE_SING, FINITE_PAIR, ind_set_def])
	    THEN1(PSET_TAC[]
	          THEN FULL_SIMP_TAC list_ss[ind_set_def, FINITE_SING, FINITE_PAIR] THEN ASM_SET_TAC[])
	   THEN1(PSET_TAC[]
	          THEN FULL_SIMP_TAC list_ss[ind_set_def, FINITE_SING, FINITE_PAIR] THEN ASM_SET_TAC[])
	   THEN1 RW_TAC std_ss[FINITE_4, FINITE_UNION]
	   THEN1(RW_TAC std_ss[disjoint_family_on]
	         THEN RW_TAC list_ss[ind_set_def]
		 THEN1(ASM_SET_TAC[])
		 THEN1(PSET_TAC[]
		       THEN1( RW_TAC list_ss[]
 		             THEN ASM_SET_TAC[])
		       THEN1(RW_TAC list_ss[]
		             THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
			     THEN `2* j <>1:num` by RW_TAC std_ss[]
			     THEN `2*j+1:num <> 1` by RW_TAC std_ss[]
			     THEN METIS_TAC[])
		       THEN1(RW_TAC list_ss[]
			     THEN `2*j <> 2:num` by RW_TAC std_ss[]
			     THEN `2*j+1 <> 2:num` by RW_TAC std_ss[]
			     THEN `2*j <> 3:num` by RW_TAC std_ss[]
			     THEN `2*j+1 <> 3:num` by RW_TAC std_ss[]
			     THEN RW_TAC std_ss[GSYM DISJOINT_DEF]
			     THEN RW_TAC std_ss[DISJOINT_NUM])
		    THEN RW_TAC list_ss[]
		    THEN ASM_SET_TAC[])
		THEN1(PSET_TAC[]
		      THEN1(RW_TAC list_ss[] THEN ASM_SET_TAC[])
		      THEN1(RW_TAC list_ss[]
		            THEN `2* j' <>1:num` by RW_TAC std_ss[]
			    THEN `2*j'+1:num <> 1` by RW_TAC std_ss[]
			    THEN SRW_TAC[][GSPECIFICATION, EXTENSION])
		      THEN1(RW_TAC list_ss[]	    
			    THEN `2*j' <> 2:num` by RW_TAC std_ss[]
			     THEN `2*j'+1 <> 2:num` by RW_TAC std_ss[]
			     THEN `2*j' <> 3:num` by RW_TAC std_ss[]
			     THEN `2*j'+1 <> 3:num` by RW_TAC std_ss[]
			     THEN RW_TAC std_ss[GSYM DISJOINT_DEF]
			     THEN RW_TAC std_ss[DISJOINT_NUM])
		     THEN RW_TAC list_ss[]
		     THEN ASM_SET_TAC[])
	      THEN PSET_TAC[]
	           THEN RW_TAC list_ss[] THEN ASM_SET_TAC[])
	   THEN1 ASM_SET_TAC[]	   

	   THEN RW_TAC std_ss[disjoint_family_on]
	         THEN RW_TAC list_ss[ ind_set_def]
		 THEN1 ASM_SET_TAC[]
 		 THEN1 ASM_SET_TAC[]
                 THEN1 ASM_SET_TAC[]
 		 THEN1 ASM_SET_TAC[]
                 THEN1( FULL_SIMP_TAC list_ss[ind_set_def] THEN PSET_TAC[] THEN FULL_SIMP_TAC list_ss[ind_set_def] THEN ASM_SET_TAC[])
		 THEN1( FULL_SIMP_TAC list_ss[ind_set_def] THEN PSET_TAC[] THEN FULL_SIMP_TAC list_ss[ind_set_def] THEN ASM_SET_TAC[])
		 THEN1( FULL_SIMP_TAC list_ss[ind_set_def] THEN PSET_TAC[] THEN FULL_SIMP_TAC list_ss[ind_set_def] THEN ASM_SET_TAC[])
		 THEN1( FULL_SIMP_TAC list_ss[ind_set_def] THEN PSET_TAC[] THEN FULL_SIMP_TAC list_ss[ind_set_def] THEN ASM_SET_TAC[])
		
		THEN PSET_TAC[]THEN RW_TAC list_ss[ind_set_def]THEN FULL_SIMP_TAC list_ss[ind_set_def] THEN ASM_SET_TAC[])
THEN `FINITE {0;1;3;4:num}` by RW_TAC std_ss[FINITE_4]
THEN `DISJOINT {0;1;3;4:num} L` by ASM_SET_TAC[]
THEN RW_TAC std_ss[PRODUCT_UNION]
THEN `({0;1;3;4:num} = {0;1;3} UNION {4} )/\ DISJOINT {0;1;3} {4:num}` by ASM_SET_TAC[]
THEN RW_TAC std_ss[PRODUCT_UNION, FINITE_3, FINITE_SING]
THEN `({0;1;3:num} = {0;1} UNION {3}) /\ DISJOINT {0;1} {3:num}` by ASM_SET_TAC[]
THEN RW_TAC std_ss[PRODUCT_UNION, FINITE_PAIR, FINITE_SING]
THEN `({0;1:num} = {0} UNION {1}) /\ DISJOINT {0:num} {1}` by ASM_SET_TAC[]
THEN RW_TAC std_ss[PRODUCT_UNION,  FINITE_SING]
THEN REWRITE_TAC[PRODUCT_SING]
THEN KNOW_TAC(``(\j:num.
           real
             (1 -
              Normal
                (product
                   (if j IN L then {2 * j; 2 * j + 1:num}
                    else ind_set [{0:num}; {1}; {}; {2; 3}; {4}] j)
                   (\a:num.
                        real
                          (1 -
                           Normal
                             (product
                                (if
                                   a IN
                                   {2 * i | i IN L} UNION
                                   {2 * i + 1 | i IN L}
                                 then
                                   {a}
                                 else ind_set [{0:num}; L1; L2; L3; L4] a)
                                (\l.
                                     real
                                       (1 - Normal (real (1 - prob p (X l)))))))))))
        0 = real (prob p (X 0))``)
	THEN1(RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
              THEN RW_TAC list_ss[ind_set_def]
	      THEN RW_TAC std_ss[PRODUCT_SING]
	      THEN1 ASM_SET_TAC[]
	      THEN1 ASM_SET_TAC[]
	      THEN RW_TAC list_ss[]
	      THEN RW_TAC list_ss[PRODUCT_SING]
	      THEN `1 <> PosInf /\ 1 <> NegInf` by RW_TAC std_ss[extreal_of_num_def, extreal_not_infty]
	      THEN KNOW_TAC(``prob p ((X:num->'a->bool) 0) <> PosInf /\ prob p (X 0) <> NegInf ``)
	           THEN1(FULL_SIMP_TAC list_ss[indep_sets]
		          THEN KNOW_TAC(``(X:num->'a->bool) 0 IN events p ``)
			       THEN1(UNDISCH_TAC(`` !i:num.
             i IN
             BIGUNION_o_BIGUNION
               (\i.
                    if
                      i IN {2 * i | i IN L} \/ i IN {2 * i + 1 | i IN L}
                    then
                      {i}
                    else ind_set [{0}; L1; L2; L3; L4] i)
               (\j.
                    if j IN L then {2 * j; 2 * j + 1}
                    else ind_set [{0}; {1}; {}; {2; 3}; {4}] j)
               ({0} UNION {1} UNION {3} UNION {4} UNION L) ==>
             {X i} SUBSET events p``)
	                          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `0`)
				  THEN DISCH_TAC
				  THEN KNOW_TAC(`` 0:num IN
    BIGUNION_o_BIGUNION
      (\i.
           if i IN {2 * i | i IN L} \/ i IN {2 * i + 1 | i IN L} then {i}
           else ind_set [{0}; L1; L2; L3; L4] i)
      (\j.
           if j IN L then {2 * j; 2 * j + 1}
           else ind_set [{0}; {1}; {}; {2; 3}; {4}] j)
      ({0} UNION {1} UNION {3} UNION {4} UNION L)``)
				  THEN1(RW_TAC std_ss[BIGUNION_o_BIGUNION_def]
				        THEN RW_TAC list_ss[ind_set_def]
					THEN PSET_TAC[BIGUNION_o_BIGUNION_def]
					THEN Q.EXISTS_TAC`{0}`
					THEN RW_TAC std_ss[]
					THEN1 ASM_SET_TAC[] 
					THEN Q.EXISTS_TAC`0`
					THEN RW_TAC list_ss[]
					THEN Q.EXISTS_TAC`{0}`
					THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
					THEN Q.EXISTS_TAC`0`
					THEN RW_TAC list_ss[])

                                 THEN RW_TAC std_ss[]
				 THEN FULL_SIMP_TAC list_ss[] THEN ASM_SET_TAC[])
		THEN `prob_space p` by FULL_SIMP_TAC std_ss[indep_sets]
		THEN RW_TAC std_ss[PROB_FINITE])
	 THEN RW_TAC std_ss[normal_real, sub_not_infty]
	 THEN RW_TAC std_ss[extreal_sub_sub2])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
THEN KNOW_TAC(`` (\j:num.
           real
             (1 -
              Normal
                (product
                   (if j IN L then {2 * j; 2 * j + 1:num}
                    else ind_set [{0:num}; {1}; {}; {2; 3}; {4}] j)
                   (\a.
                        real
                          (1 -
                           Normal
                             (product
                                (if
                                   a IN
                                   {2 * i | i IN L} UNION
                                   {2 * i + 1 | i IN L}
                                 then
                                   {a}
                                 else ind_set [{0:num}; L1; L2; L3; L4] a)
                                (\l.
                                     real
                                       (1 - Normal (real (1 - prob p (X l)))))))))))
        1 = product L1 (\l. real (prob p (X l)))``)

    THEN1(RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
          THEN RW_TAC list_ss[ind_set_def]
          THEN RW_TAC std_ss[PRODUCT_SING] THEN1 ASM_SET_TAC[]
	       THEN1 ASM_SET_TAC[]
	  THEN RW_TAC list_ss[]
	  THEN KNOW_TAC(`` !l:num. l IN L1 ==> ( real (1 - Normal (real (1 - prob p ((X:num->'a->bool) l)))) =
	   real (prob p (X l)))``)
	      THEN1(RW_TAC std_ss[]
	            THEN KNOW_TAC(``(X:num->'a->bool)l IN events p ``)
		         THEN1(FULL_SIMP_TAC std_ss[indep_sets]
			       THEN UNDISCH_TAC(`` !i:num.
             i IN
             BIGUNION_o_BIGUNION
               (\i.
                    if i IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then
                      {i}
                    else ind_set [{0}; L1; L2; L3; L4] i)
               (\j.
                    if j IN L then {2 * j; 2 * j + 1}
                    else ind_set [{0}; {1}; {}; {2; 3}; {4}] j)
               ({0} UNION {1} UNION {3} UNION {4} UNION L) ==>
             {X i} SUBSET events p``)
	                          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `l`)
				  THEN DISCH_TAC
				  THEN KNOW_TAC(`` l:num IN
    BIGUNION_o_BIGUNION
           (\i.
                if i IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {i}
                else ind_set [{0}; L1; L2; L3; L4] i)
           (\j.
                if j IN L then {2 * j; 2 * j + 1}
                else ind_set [{0}; {1}; {}; {2; 3}; {4}] j)
           ({0} UNION {1} UNION {3} UNION {4} UNION L)``)
				  THEN1(RW_TAC std_ss[BIGUNION_o_BIGUNION_def]
				        THEN RW_TAC list_ss[ind_set_def]
					THEN PSET_TAC[BIGUNION_o_BIGUNION_def]
					THEN Q.EXISTS_TAC`L1`
					THEN RW_TAC std_ss[]
					THEN Q.EXISTS_TAC`1`
					THEN RW_TAC std_ss[]
					THEN1 ASM_SET_TAC[]
					THEN1 (RW_TAC list_ss[] THEN ASM_SET_TAC[])
					THEN Q.EXISTS_TAC`{1}`
					THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
					THEN Q.EXISTS_TAC`1`
					THEN RW_TAC list_ss[])
		THEN DISCH_TAC THEN ASM_SET_TAC[])
		THEN DISCH_TAC THEN `prob p (X l) <> PosInf /\ prob p ((X:num->'a->bool) l) <> NegInf` by FULL_SIMP_TAC std_ss[indep_sets, PROB_FINITE]
     		THEN RW_TAC std_ss[extreal_sub_sub2,normal_real, sub_not_infty, extreal_of_num_def, extreal_not_infty])
      THEN RW_TAC std_ss[]
      THEN KNOW_TAC(``(product L1 (\l. real (1 - Normal (real (1 - prob p (X l))))) =
                       product L1 (\l. real (prob p ((X:num->'a->bool) l))))``)

          THEN1(RW_TAC std_ss[th])
      THEN RW_TAC std_ss[]
      THEN RW_TAC std_ss[extreal_of_num_def]
      THEN RW_TAC std_ss[extreal_sub_def]
      THEN RW_TAC std_ss[real_normal]
      THEN RW_TAC std_ss[REAL_SUB_SUB2])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]

THEN KNOW_TAC(``(\j:num.
           real
             (1 -
              Normal
                (product
                   (if j IN L then {2 * j; 2 * j + 1:num}
                    else ind_set [{0:num}; {1}; {}; {2; 3}; {4}] j)
                   (\a.
                        real
                          (1 -
                           Normal
                             (product
                                (if
                                   a IN
                                   {2 * i | i IN L} UNION
                                   {2 * i + 1 | i IN L}
                                 then
                                   {a}
                                 else ind_set [{0:num}; L1; L2; L3; L4] a)
                                (\l.
                                     real
                                       (1 - Normal (real (1 - prob p (X l)))))))))))
        3 =1 -
   (1 - product L2 (\l. real (prob p (X l)))) *
   (1 - product L3 (\l. real (prob p (X l)))) ``)

    THEN1(RW_TAC std_ss[ind_set_def] THEN1 ASM_SET_TAC[]
          THEN RW_TAC list_ss[]
	  THEN `{2;3:num} = {2} UNION {3} `by ASM_SET_TAC[]
	  THEN `DISJOINT {2}{3:num}` by ASM_SET_TAC[]
	  THEN RW_TAC std_ss[FINITE_SING, PRODUCT_UNION]
	  THEN RW_TAC std_ss[PRODUCT_SING]
	      THEN1 ASM_SET_TAC[]
	      THEN1 ASM_SET_TAC[]
	      THEN1 ASM_SET_TAC[]
	      THEN1 ASM_SET_TAC[]
	      THEN1 ASM_SET_TAC[]
	      THEN1 ASM_SET_TAC[]
	      THEN1 ASM_SET_TAC[]
	      THEN1 ASM_SET_TAC[]
          THEN RW_TAC list_ss[]
	  THEN KNOW_TAC(``!l:num. l IN L2 ==>
	                 (real (1 - Normal (real (1 - prob p (X l)))) = real (prob p((X:num->'a->bool) l)))``)
              THEN1(RW_TAC std_ss[]
	            THEN KNOW_TAC(`` (X:num->'a->bool)l IN events p``)
		         THEN1(FULL_SIMP_TAC std_ss[indep_sets]
			       THEN UNDISCH_TAC (``!i:num.
             i IN
             BIGUNION_o_BIGUNION
               (\i.
                    if i IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then
                      {i}
                    else ind_set [{0}; L1; L2; L3; L4] i)
               (\j.
                    if j IN L then {2 * j; 2 * j + 1}
                    else ind_set [{0}; {1}; {}; {2} UNION {3}; {4}] j)
               ({0} UNION {1} UNION {3} UNION {4} UNION L) ==>
             {X i} SUBSET events p ``)
	                     THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `l`)
			     THEN DISCH_TAC
			     THEN KNOW_TAC(`` l:num IN
         BIGUNION_o_BIGUNION
           (\i.
                if i IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {i}
                else ind_set [{0}; L1; L2; L3; L4] i)
           (\j.
                if j IN L then {2 * j; 2 * j + 1}
                else ind_set [{0}; {1}; {}; {2} UNION {3}; {4}] j)
           ({0} UNION {1} UNION {3} UNION {4} UNION L) ``)
	                         THEN1(RW_TAC std_ss[BIGUNION_o_BIGUNION_def]
				       THEN PSET_TAC[]
				       THEN Q.EXISTS_TAC`L2`
				       THEN RW_TAC std_ss[]
				       THEN Q.EXISTS_TAC`2`
				       THEN RW_TAC list_ss[ind_set_def]
				       THEN1 ASM_SET_TAC[]
				       THEN Q.EXISTS_TAC`{2} UNION {3}`
				       THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
				       THEN Q.EXISTS_TAC`3`
				       THEN RW_TAC std_ss[] THEN RW_TAC list_ss[])
			 THEN ASM_SET_TAC[])
		  THEN DISCH_TAC THEN `prob p ((X:num->'a->bool) l) <> PosInf /\ prob p (X l) <> NegInf` by FULL_SIMP_TAC std_ss[indep_sets, PROB_FINITE]
		  THEN RW_TAC std_ss[normal_real, extreal_of_num_def, extreal_not_infty, sub_not_infty]
		  THEN RW_TAC std_ss[extreal_sub_sub2])
	THEN DISCH_TAC
	THEN KNOW_TAC(``(product L2 (\l. real (1 - Normal (real (1 - prob p ((X:num->'a->bool) l)))))
	                 =
			 product L2 (\l. real (prob p (X l)))) ``)
	    THEN1 RW_TAC std_ss[th]
	THEN RW_TAC std_ss[]
        THEN KNOW_TAC(``!l:num. l IN L3 ==>
	                 (real (1 - Normal (real (1 - prob p (X l)))) = real (prob p((X:num->'a->bool) l)))``)
              THEN1(RW_TAC std_ss[]
	            THEN KNOW_TAC(`` (X:num->'a->bool)l IN events p``)
		         THEN1(FULL_SIMP_TAC std_ss[indep_sets]
			       THEN UNDISCH_TAC (``!i:num.
             i IN
             BIGUNION_o_BIGUNION
               (\i.
                    if i IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then
                      {i}
                    else ind_set [{0}; L1; L2; L3; L4] i)
               (\j.
                    if j IN L then {2 * j; 2 * j + 1}
                    else ind_set [{0}; {1}; {}; {2} UNION {3}; {4}] j)
               ({0} UNION {1} UNION {3} UNION {4} UNION L) ==>
             {X i} SUBSET events p ``)
	                     THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `l`)
			     THEN DISCH_TAC
			     THEN KNOW_TAC(`` l:num IN
         BIGUNION_o_BIGUNION
           (\i.
                if i IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {i}
                else ind_set [{0}; L1; L2; L3; L4] i)
           (\j.
                if j IN L then {2 * j; 2 * j + 1}
                else ind_set [{0}; {1}; {}; {2} UNION {3}; {4}] j)
           ({0} UNION {1} UNION {3} UNION {4} UNION L) ``)
	                         THEN1(RW_TAC std_ss[BIGUNION_o_BIGUNION_def]
				       THEN PSET_TAC[]
				       THEN Q.EXISTS_TAC`L3`
				       THEN RW_TAC std_ss[]
				       THEN Q.EXISTS_TAC`3`
				       THEN RW_TAC list_ss[ind_set_def]
				       THEN1 ASM_SET_TAC[]
				       THEN Q.EXISTS_TAC`{2} UNION {3}`
				       THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
				       THEN Q.EXISTS_TAC`3`
				       THEN RW_TAC std_ss[] THEN RW_TAC list_ss[])
			 THEN ASM_SET_TAC[])
		  THEN DISCH_TAC THEN `prob p ((X:num->'a->bool) l) <> PosInf /\ prob p (X l) <> NegInf` by FULL_SIMP_TAC std_ss[indep_sets, PROB_FINITE]
		  THEN RW_TAC std_ss[normal_real, extreal_of_num_def, extreal_not_infty, sub_not_infty]
		  THEN RW_TAC std_ss[extreal_sub_sub2])
	THEN DISCH_TAC
	THEN KNOW_TAC(``(product L3 (\l. real (1 - Normal (real (1 - prob p ((X:num->'a->bool) l)))))
	                 =
			 product L3 (\l. real (prob p (X l)))) ``)
	    THEN1 RW_TAC std_ss[th]
	THEN RW_TAC std_ss[]
	THEN RW_TAC std_ss[extreal_of_num_def]
	THEN RW_TAC std_ss[extreal_sub_def]
	THEN RW_TAC std_ss[real_normal])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
THEN KNOW_TAC(``(\j:num.
           real
             (1 -
              Normal
                (product
                   (if j IN L then {2 * j; 2 * j + 1:num}
                    else ind_set [{0}; {1}; {}; {2; 3}; {4:num}] j)
                   (\a.
                        real
                          (1 -
                           Normal
                             (product
                                (if
                                   a IN
                                   {2 * i | i IN L} UNION
                                   {2 * i + 1 | i IN L}
                                 then
                                   {a}
                                 else ind_set [{0:num}; L1; L2; L3; L4] a)
                                (\l.
                                     real
                                       (1 - Normal (real (1 - prob p (X l)))))))))))
        4 = product L4 (\l. real (prob p (X l)))``)
	THEN1(RW_TAC list_ss[ind_set_def] THEN1 ASM_SET_TAC[]
	      THEN RW_TAC list_ss[PRODUCT_SING]
	      THEN1 (PSET_TAC[] THEN ASM_SET_TAC[])
	      THEN1(PSET_TAC[] THEN ASM_SET_TAC[])
	      THEN KNOW_TAC(``!l:num. l IN L4 ==>
	                 (real (1 - Normal (real (1 - prob p (X l)))) = real (prob p((X:num->'a->bool) l)))``)
              THEN1(RW_TAC std_ss[]
	            THEN KNOW_TAC(`` (X:num->'a->bool)l IN events p``)
		         THEN1(FULL_SIMP_TAC std_ss[indep_sets]
			       THEN UNDISCH_TAC (``!i:num.
             i IN
             BIGUNION_o_BIGUNION
               (\i.
                    if i IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then
                      {i}
                    else ind_set [{0}; L1; L2; L3; L4] i)
               (\j.
                    if j IN L then {2 * j; 2 * j + 1}
                    else ind_set [{0}; {1}; {}; {2; 3}; {4}] j)
               ({0} UNION {1} UNION {3} UNION {4} UNION L) ==>
             {X i} SUBSET events p``)
	                     THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `l`)
			     THEN DISCH_TAC
			     THEN KNOW_TAC(`` l:num IN
        BIGUNION_o_BIGUNION
           (\i.
                if i IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {i}
                else ind_set [{0}; L1; L2; L3; L4] i)
           (\j.
                if j IN L then {2 * j; 2 * j + 1}
                else ind_set [{0}; {1}; {}; {2; 3}; {4}] j)
           ({0} UNION {1} UNION {3} UNION {4} UNION L) ``)
	                         THEN1(RW_TAC std_ss[BIGUNION_o_BIGUNION_def]
				       THEN PSET_TAC[]
				       THEN Q.EXISTS_TAC`L4`
				       THEN RW_TAC std_ss[]
				       THEN Q.EXISTS_TAC`4`
				       THEN RW_TAC list_ss[ind_set_def]
				       THEN1 ASM_SET_TAC[]
				       THEN Q.EXISTS_TAC`{4}`
				       THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
				       THEN Q.EXISTS_TAC`4`
				       THEN RW_TAC std_ss[] THEN RW_TAC list_ss[])
			    THEN ASM_SET_TAC[])
		  THEN DISCH_TAC THEN `prob p ((X:num->'a->bool) l) <> PosInf /\ prob p (X l) <> NegInf` by FULL_SIMP_TAC std_ss[indep_sets, PROB_FINITE]
		  THEN RW_TAC std_ss[normal_real, extreal_of_num_def, extreal_not_infty, sub_not_infty]
		  THEN RW_TAC std_ss[extreal_sub_sub2])
	THEN DISCH_TAC
	THEN KNOW_TAC(``(product L4 (\l. real (1 - Normal (real (1 - prob p ((X:num->'a->bool) l)))))
	                 =
			 product L4 (\l. real (prob p (X l)))) ``)
	    THEN1 RW_TAC std_ss[th]
	THEN RW_TAC std_ss[]
	THEN RW_TAC std_ss[extreal_of_num_def, extreal_sub_def, real_normal]
	THEN RW_TAC std_ss[REAL_SUB_SUB2])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
THEN KNOW_TAC(``!j. j IN L ==>
(real
               (1 -
                Normal
                  (product
                     (if j IN L then {2 * j; 2 * j + 1}
                      else ind_set [{0}; {1}; {}; {2; 3}; {4}] j)
                     (\a.
                          real
                            (1 -
                             Normal
                               (product
                                  (if
                                     a IN
                                     {2 * i | i IN L} UNION
                                     {2 * i + 1 | i IN L}
                                   then
                                     {a}
                                   else ind_set [{0}; L1; L2; L3; L4] a)
                                  (\l.
                                       real
                                         (1 -
                                          Normal (real (1 - prob p (X l)))))))))) =
					  1 - real ((1 - prob p (X (2 * j))) * (1 - prob p (X (2 * j + 1)))))``)
     THEN1(RW_TAC std_ss[]
          THEN `{2 * j; 2 * j + 1} = {2*j} UNION {2*j+1:num}` by ASM_SET_TAC[]
	  THEN KNOW_TAC(``DISJOINT  {2*j}  {2*j+1:num}``)
	       THEN1(PSET_TAC[]
	             THEN `2*j+1:num = SUC (2*j)` by RW_TAC std_ss[GSYM ADD1]
	  	     THEN `2*j < SUC (2*j)` by RW_TAC std_ss[]
	  	     THEN ONCE_ASM_REWRITE_TAC[]
	  	     THEN RW_TAC std_ss[LESS_NOT_EQ])
	THEN RW_TAC std_ss[PRODUCT_UNION, FINITE_SING]
	THEN RW_TAC std_ss[PRODUCT_SING]		  
	     THEN1(KNOW_TAC(``(X:num->'a->bool) (2*j) IN events p ``)
	           THEN1(FULL_SIMP_TAC std_ss[indep_sets]
		         THEN UNDISCH_TAC(`` !i:num.
             i IN
             BIGUNION_o_BIGUNION
               (\i.
                    if i IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then
                      {i}
                    else ind_set [{0}; L1; L2; L3; L4] i)
               (\j.
                    if j IN L then {2 * j; 2 * j + 1}
                    else ind_set [{0}; {1}; {}; {2; 3}; {4}] j)
               ({0} UNION {1} UNION {3} UNION {4} UNION L) ==>
             {X i} SUBSET events p``)
	                 THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `2*j`)
			 THEN DISCH_TAC
			 THEN KNOW_TAC(``   (2 * j IN
    BIGUNION_o_BIGUNION
      (\i.
           if i IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {i}
           else ind_set [{0}; L1; L2; L3; L4] i)
      (\j.
           if j IN L then {2 * j; 2 * j + 1}
           else ind_set [{0}; {1}; {}; {2; 3}; {4}] j)
      ({0} UNION {1} UNION {3} UNION {4} UNION L))``)
                              THEN1(RW_TAC std_ss[BIGUNION_o_BIGUNION_def]
			            THEN PSET_TAC[] 
				         THEN1 ASM_SET_TAC[]
					 THEN1 (Q.EXISTS_TAC`{2 * i'}`
					        THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
						THEN Q.EXISTS_TAC`2*i'`
						THEN RW_TAC std_ss[]
						     THEN1 (PSET_TAC[] THEN ASM_SET_TAC[])
						THEN Q.EXISTS_TAC`{2 * i'; 2*i'+1}`
						THEN RW_TAC std_ss[]
						      THEN1 ASM_SET_TAC[]
						THEN Q.EXISTS_TAC`i'`
						THEN RW_TAC list_ss[])
					 THEN1(	Q.EXISTS_TAC`{2 * i'+1}`
					        THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
						THEN Q.EXISTS_TAC`2*i'+1`
						THEN RW_TAC std_ss[]
						     THEN1 (PSET_TAC[] THEN ASM_SET_TAC[])
						THEN Q.EXISTS_TAC`{2 * i'; 2*i'+1}`
						THEN RW_TAC std_ss[]
						      THEN1 ASM_SET_TAC[]
						THEN Q.EXISTS_TAC`i'`
						THEN RW_TAC list_ss[])
				    THEN PSET_TAC[] THEN ASM_SET_TAC[])
			    THEN RW_TAC std_ss[]
			    THEN ASM_SET_TAC[])
		 THEN RW_TAC std_ss[]	    
		  THEN `prob p (X (2*j)) <> PosInf /\ prob p ((X:num->'a->bool)(2*j)) <> NegInf` by FULL_SIMP_TAC std_ss[indep_sets, PROB_FINITE]	    
		  THEN RW_TAC std_ss[extreal_of_num_def, sub_not_infty, normal_real, extreal_not_infty]

		  THEN RW_TAC std_ss[extreal_sub_sub2]
		  THEN RW_TAC std_ss[extreal_not_infty, real_mul_real, extreal_of_num_def, sub_not_infty]
		  THEN RW_TAC std_ss[extreal_sub_def]
		  THEN RW_TAC std_ss[real_normal]
		  THEN KNOW_TAC(``(X:num->'a->bool) (2*j+1) IN events p ``)
	           THEN1(FULL_SIMP_TAC std_ss[indep_sets]
		         THEN UNDISCH_TAC(`` !i:num.
             i IN
             BIGUNION_o_BIGUNION
               (\i.
                    if i IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then
                      {i}
                    else ind_set [{0}; L1; L2; L3; L4] i)
               (\j.
                    if j IN L then {2 * j; 2 * j + 1}
                    else ind_set [{0}; {1}; {}; {2; 3}; {4}] j)
               ({0} UNION {1} UNION {3} UNION {4} UNION L) ==>
             {X i} SUBSET events p``)
	                 THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `2*j+1`)
			 THEN DISCH_TAC
			 THEN KNOW_TAC(``   (2 * j+1 IN
    BIGUNION_o_BIGUNION
      (\i.
           if i IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {i}
           else ind_set [{0}; L1; L2; L3; L4] i)
      (\j.
           if j IN L then {2 * j; 2 * j + 1}
           else ind_set [{0}; {1}; {}; {2; 3}; {4}] j)
      ({0} UNION {1} UNION {3} UNION {4} UNION L))``)
                              THEN1(RW_TAC std_ss[BIGUNION_o_BIGUNION_def]
			            THEN PSET_TAC[] 
				         THEN1 ASM_SET_TAC[]
					 THEN1 (Q.EXISTS_TAC`{2 * i'+1}`
					        THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
						THEN Q.EXISTS_TAC`2*i'+1`
						THEN RW_TAC std_ss[]
						     THEN1 (PSET_TAC[] THEN ASM_SET_TAC[])
						THEN Q.EXISTS_TAC`{2 * i'; 2*i'+1}`
						THEN RW_TAC std_ss[]
						      THEN1 ASM_SET_TAC[]
						THEN Q.EXISTS_TAC`i'`
						THEN RW_TAC list_ss[])
					 THEN1(	Q.EXISTS_TAC`{2 * i'}`
					        THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
						THEN Q.EXISTS_TAC`2*i'`
						THEN RW_TAC std_ss[]
						     THEN1 (PSET_TAC[] THEN ASM_SET_TAC[])
						THEN Q.EXISTS_TAC`{2 * i'; 2*i'+1}`
						THEN RW_TAC std_ss[]
						      THEN1 ASM_SET_TAC[]
						THEN Q.EXISTS_TAC`i'`
						THEN RW_TAC list_ss[])
				    THEN PSET_TAC[] THEN ASM_SET_TAC[])
			    THEN RW_TAC std_ss[]
			    THEN ASM_SET_TAC[])
		 THEN RW_TAC std_ss[]	    
		  THEN `prob p (X (2*j+1)) <> PosInf /\ prob p ((X:num->'a->bool)(2*j+1)) <> NegInf` by FULL_SIMP_TAC std_ss[indep_sets, PROB_FINITE]	    
		  THEN RW_TAC std_ss[extreal_of_num_def, sub_not_infty, normal_real, extreal_not_infty]
		  THEN RW_TAC std_ss[GSYM extreal_of_num_def])
		  THEN ASM_SET_TAC[])
THEN RW_TAC std_ss[]
THEN KNOW_TAC(`` product L
        (\j.
             real
               (1 -
                Normal
                  (product
                     (if j IN L then {2 * j; 2 * j + 1}
                      else ind_set [{0}; {1}; {}; {2; 3}; {4}] j)
                     (\a.
                          real
                            (1 -
                             Normal
                               (product
                                  (if
                                     a IN
                                     {2 * i | i IN L} UNION
                                     {2 * i + 1 | i IN L}
                                   then
                                     {a}
                                   else ind_set [{0}; L1; L2; L3; L4] a)
                                  (\l.
                                       real
                                         (1 -
                                          Normal (real (1 - prob p (X l))))))))))) =

product L (\j. 1 -
              real ((1 - prob p (X (2 * j))) * (1 - prob p (X (2 * j + 1)))))``)
      THEN1 RW_TAC std_ss[th]
THEN RW_TAC std_ss[]
THEN RW_TAC std_ss[GSYM extreal_mul_def]
THEN KNOW_TAC(``prob p ((X:num->'a->bool) 0) <> PosInf /\ prob p (X 0) <> NegInf ``)
	           THEN1(FULL_SIMP_TAC list_ss[indep_sets]
		          THEN KNOW_TAC(``(X:num->'a->bool) 0 IN events p ``)
			       THEN1(UNDISCH_TAC(`` !i:num.
             i IN
             BIGUNION_o_BIGUNION
               (\i.
                    if
                      i IN {2 * i | i IN L} \/ i IN {2 * i + 1 | i IN L}
                    then
                      {i}
                    else ind_set [{0}; L1; L2; L3; L4] i)
               (\j.
                    if j IN L then {2 * j; 2 * j + 1}
                    else ind_set [{0}; {1}; {}; {2; 3}; {4}] j)
               ({0} UNION {1} UNION {3} UNION {4} UNION L) ==>
             {X i} SUBSET events p``)
	                          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `0`)
				  THEN DISCH_TAC
				  THEN KNOW_TAC(`` 0:num IN
    BIGUNION_o_BIGUNION
      (\i.
           if i IN {2 * i | i IN L} \/ i IN {2 * i + 1 | i IN L} then {i}
           else ind_set [{0}; L1; L2; L3; L4] i)
      (\j.
           if j IN L then {2 * j; 2 * j + 1}
           else ind_set [{0}; {1}; {}; {2; 3}; {4}] j)
      ({0} UNION {1} UNION {3} UNION {4} UNION L)``)
				  THEN1(RW_TAC std_ss[BIGUNION_o_BIGUNION_def]
				        THEN RW_TAC list_ss[ind_set_def]
					THEN PSET_TAC[BIGUNION_o_BIGUNION_def]
					THEN Q.EXISTS_TAC`{0}`
					THEN RW_TAC std_ss[]
					THEN1 ASM_SET_TAC[] 
					THEN Q.EXISTS_TAC`0`
					THEN RW_TAC list_ss[]
					THEN Q.EXISTS_TAC`{0}`
					THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
					THEN Q.EXISTS_TAC`0`
					THEN RW_TAC list_ss[])

                                 THEN RW_TAC std_ss[]
				 THEN FULL_SIMP_TAC list_ss[] THEN ASM_SET_TAC[])
		THEN `prob_space p` by FULL_SIMP_TAC std_ss[indep_sets]
		THEN RW_TAC std_ss[PROB_FINITE])
THEN RW_TAC std_ss[normal_real, sub_not_infty]
THEN RW_TAC std_ss[GSYM extreal_mul_def]
THEN RW_TAC std_ss[GSYM extreal_sub_def]
THEN RW_TAC std_ss[GSYM extreal_mul_def]
THEN RW_TAC std_ss[GSYM extreal_sub_def]
THEN RW_TAC std_ss[GSYM extreal_of_num_def]);


val SEN_network_set_req_def = Define `SEN_network_set_req p L1 L2 L3 L4 L  LL A J X =
     FINITE L1 /\ L1 <> {} /\ FINITE L2 /\ L2 <> {} /\ FINITE L3 /\
          L3 <> {} /\ FINITE L4 /\ L4 <> {} /\ FINITE L /\
          DISJOINT {0:num; 1; 3; 4} L /\
          (!i j.
               i IN L /\ j IN L /\ i <> j ==>
               DISJOINT {2 * i; 2 * i + 1} {2 * j; 2 * j + 1:num}) /\
          (!i. i IN L ==> DISJOINT {2 * i; 2 * i + 1} {0; 1; 2; 3; 4}) /\
          indep_sets p (\i. {X i}) (BIGUNION_o_BIGUNION LL A J) /\
          disjoint_family_on
            (ind_set
               [{0}; L1; L2; L3; L4;
                {2 * i | i IN L} UNION {2 * i + 1:num | i IN L}]) {0:num; 1; 2; 3; 4; 5}`;




val PROB_SEN_network_lem2 = store_thm("PROB_SEN_network_lem2",
  ``! p L1 L2 L3 L4 L X Y t. SEN_network_set_req p L1 L2 L3 L4 L 
                (\i:num.
                if i IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {i}
                else ind_set [{0}; L1; L2; L3; L4] i)
		(\j.
                if j IN L then {2 * j; 2 * j + 1:num}
                else ind_set [{0}; {1}; {}; {2:num; 3}; {4}] j) ({0; 1; 3; 4} UNION L) 
               (event_set
               [(DRBD_event p Y t,0)] (rv_to_event p X t))==>

(prob p
             (DRBD_series
                (\j. DRBD_parallel
		   (\a. DRBD_series
		           (\i.
                              event_set
                                [(DRBD_event p Y t,0)]
                                (rv_to_event p X t) i) 

               ((\i:num.
                if i IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {i}
                else ind_set [{0}; L1; L2; L3; L4] i) a))
		((\a.
                if a IN L then {2 * a; 2 * a + 1:num}
                else ind_set [{0}; {1}; {}; {2:num; 3}; {4}] a) j)) ({0; 1; 3; 4} UNION L)) =
           prob p (DRBD_event p Y t) * Normal (product L1 (\l. real (prob p (rv_to_event p X t l)))) *
           (1 -
            (1 - Normal (product L2 (\l. real (prob p (rv_to_event p X t l))))) *
            (1 - Normal (product L3 (\l. real (prob p (rv_to_event p X t l)))))) *
           Normal (product L4 (\l. real (prob p (rv_to_event p X t l)))) *
           Normal
             (product L
                (\j.
                     1 -
                     real
                       ((1 - prob p (rv_to_event p X t (2 * j))) *
                        (1 - prob p (rv_to_event p X t (2 * j + 1)))))))``,

RW_TAC std_ss[SEN_network_set_req_def]
THEN DEP_REWRITE_TAC[PROB_SEN_network_lem1]
THEN RW_TAC std_ss[]
THEN RW_TAC std_ss[event_set_def, event_set1_def]
THEN FULL_SIMP_TAC std_ss[disjoint_family_on]
THEN KNOW_TAC(``DISJOINT {0:num} L1 ``)
     THEN1(POP_ASSUM (MP_TAC o Q.SPEC `0`)
          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `1`)
	  THEN RW_TAC list_ss[ind_set_def, DISJOINT_DEF])
	  
THEN KNOW_TAC(``DISJOINT {0:num} L2 ``)
     THEN1(POP_ASSUM (MP_TAC o Q.SPEC `0`)
          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `2`)
	  THEN RW_TAC list_ss[ind_set_def, DISJOINT_DEF])


THEN KNOW_TAC(``DISJOINT {0:num} L3 ``)
     THEN1(POP_ASSUM (MP_TAC o Q.SPEC `0`)
          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `3`)
	  THEN RW_TAC list_ss[ind_set_def, DISJOINT_DEF])


THEN KNOW_TAC(``DISJOINT {0:num} L4 ``)
     THEN1(POP_ASSUM (MP_TAC o Q.SPEC `0`)
          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `4`)
	  THEN RW_TAC list_ss[ind_set_def, DISJOINT_DEF])

THEN KNOW_TAC(``DISJOINT {0:num} ({2 * i | i IN L} UNION {2 * i + 1 | i IN L}) ``)
     THEN1(POP_ASSUM (MP_TAC o Q.SPEC `0`)
          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `5`)
	  THEN RW_TAC list_ss[ind_set_def, DISJOINT_DEF])

THEN RW_TAC std_ss[]
THEN KNOW_TAC(``!i:num. i IN L1 ==> (real
               (prob p
                  (if i = 0 then DRBD_event p Y t else rv_to_event p X t i)) =
		  real
               (prob p
                  ( rv_to_event p X t i)))``)
   THEN1 ASM_SET_TAC[]
   
THEN RW_TAC std_ss[]
THEN `(product L1
        (\i.
             real
               (prob p
                  (if i = 0 then DRBD_event p Y t else rv_to_event p X t i)))) =
		  (product L1
        (\i.
             real
               (prob p
                  ( rv_to_event p X t i))))` by RW_TAC std_ss[th]


THEN ONCE_ASM_REWRITE_TAC[]

THEN KNOW_TAC(``!i:num. i IN L2 ==> (real
               (prob p
                  (if i = 0 then DRBD_event p Y t else rv_to_event p X t i)) =
		  real
               (prob p
                  ( rv_to_event p X t i)))``)
   THEN1 ASM_SET_TAC[]
   
THEN RW_TAC std_ss[]
THEN `(product L2
        (\i.
             real
               (prob p
                  (if i = 0 then DRBD_event p Y t else rv_to_event p X t i)))) =
		  (product L2
        (\i.
             real
               (prob p
                  ( rv_to_event p X t i))))` by RW_TAC std_ss[th]


THEN ONCE_ASM_REWRITE_TAC[]
THEN KNOW_TAC(``!i:num. i IN L3 ==> (real
                 (prob p
                    (if i = 0 then DRBD_event p Y t else rv_to_event p X t i)) =
		    real
                 (prob p
                    (rv_to_event p X t i)))``)
      THEN1 ASM_SET_TAC[]
THEN RW_TAC std_ss[]
THEN `product L3
           (\i.
                real
                  (prob p
                     (if i = 0 then DRBD_event p Y t
                      else rv_to_event p X t i)))=
		      product L3
           (\i.
                real
                  (prob p
                     ( rv_to_event p X t i)))` by RW_TAC std_ss[th]
THEN ONCE_ASM_REWRITE_TAC[]
THEN KNOW_TAC(``!i. i:num IN L4==> (real
               (prob p
                  (if i = 0 then DRBD_event p Y t else rv_to_event p X t i)) = real
               (prob p
                  ( rv_to_event p X t i)))``)
     THEN1 ASM_SET_TAC[]
THEN RW_TAC std_ss[]
THEN `(product L4
        (\i.
             real
               (prob p
                  (if i = 0 then DRBD_event p Y t else rv_to_event p X t i)))) =
		  (product L4
        (\i.
             real
               (prob p
                  (rv_to_event p X t i))))` by RW_TAC std_ss[th]

THEN ONCE_ASM_REWRITE_TAC[]
THEN KNOW_TAC(``!j:num. j IN L ==>
((
             1 -
             real
               ((1 -
                 prob p
                   (if j = 0 then DRBD_event p Y t
                    else rv_to_event p X t (2 * j))) *
                (1 - prob p (rv_to_event p (X:num->'a->extreal) t (2 * j + 1))))) =
		(
             1 -
             real
               ((1 -
                 prob p
                   (rv_to_event p X t (2 * j))) *
                (1 - prob p (rv_to_event p X t (2 * j + 1))))))``)
	THEN1 ASM_SET_TAC[]
THEN RW_TAC std_ss[]	     
THEN `(product L
        (\j.
             1 -
             real
               ((1 -
                 prob p
                   (if j = 0 then DRBD_event p Y t
                    else rv_to_event p X t (2 * j))) *
                (1 - prob p (rv_to_event p X t (2 * j + 1)))))) =
	(product L
        (\j.
             1 -
             real
               ((1 - prob p (rv_to_event p X t (2 * j))) *
                (1 - prob p (rv_to_event p X t (2 * j + 1))))))` by RW_TAC std_ss[th]	
THEN RW_TAC std_ss[]);


val DISJOINT_def_2 = store_thm("DISJOINT_def_2",
  ``!s t. DISJOINT s t = (!a. a IN s ==> ~(a IN t)) ``,
ASM_SET_TAC[]);


val Q_SEN_network_nR_AND_DRBD_series_lem = store_thm(
  "Q_SEN_network_nR_AND_DRBD_series_lem",
  `` !p L1 L2 L3 L4 L X Y t.
            FINITE L1 /\ L1 <> {} /\ FINITE L2 /\ L2 <> {} /\ FINITE L3 /\
            L3 <> {} /\ FINITE L4 /\ L4 <> {} /\ FINITE L /\
            DISJOINT {0; 1; 3; 4} L /\
            (!i. i IN L ==> DISJOINT {2 * i; 2 * i + 1} {0; 1; 2; 3; 4}) /\
	    disjoint_family_on
            (ind_set
               [{0}; L1; L2; L3; L4;
                {2 * i | i IN L} UNION {2 * i + 1 | i IN L}])
            {0; 1; 2; 3; 4; 5}  ==>
            (DRBD_event p
               (nR_AND
                  (\i.
                       if i = 0 then Y
                       else if i = 1 then nR_AND X L1
                       else if i = 3 then R_OR (nR_AND X L2) (nR_AND X L3)
                       else if i = 4 then nR_AND X L4
                       else R_OR (X (2 * i)) (X (2 * i + 1)))
                  ({0; 1; 3; 4} UNION L)) t =
             DRBD_series
               (\j.
                    DRBD_parallel
                      (\a.
                           DRBD_series (\i.
                                     event_set
                                       [(DRBD_event p Y t,0)] (rv_to_event p X t) i)
                             ((\i.
              if i IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {i}
              else ind_set [{0}; L1; L2; L3; L4] i) a))
                      ((\j.
              if j IN L then {2 * j; 2 * j + 1}
              else ind_set [{0}; {1}; {}; {2; 3}; {4}] j) j)) ({0; 1; 3; 4:num} UNION L))``,

RW_TAC std_ss[]
THEN KNOW_TAC(``FINITE ({0;1;3;4:num} UNION L) ``)
     THEN1(`{0;1;3;4:num} = {0} UNION ({1} UNION ({3} UNION ({4})))` by ASM_SET_TAC[]
           THEN RW_TAC std_ss[FINITE_UNION, FINITE_SING])
THEN `{0;1;3;4:num} UNION L <> {}` by ASM_SET_TAC[]
THEN RW_TAC std_ss[nR_AND_DRBD_series]	   
THEN KNOW_TAC(`` DRBD_series
     (rv_to_event p
        (\i.
             if i:num = 0 then  Y 
             else if i = 1 then nR_AND X L1
             else if i = 3 then R_OR (nR_AND X L2) (nR_AND X L3)
             else if i = 4 then nR_AND X L4
             else R_OR (X (2 * i)) (X (2 * i + 1))) t) ({0; 1; 3; 4} UNION L) =
	     DRBD_series
     (
          rv_to_event p
            (\i:num.
                 if i = 0 then Y
                 else if i = 1 then nR_AND X L1
                 else if i = 3 then R_OR (nR_AND X L2) (nR_AND X L3)
                 else if i = 4 then nR_AND X L4
                 else R_OR (X (2 * i)) (X (2 * i + 1))) t ) {0; 1; 3; 4} INTER
   DRBD_series
     (
          rv_to_event p
            (\i:num.
                 if i = 0 then Y
                 else if i = 1 then nR_AND X L1
                 else if i = 3 then R_OR (nR_AND X L2) (nR_AND X L3)
                 else if i = 4 then nR_AND X L4
                 else R_OR (X (2 * i)) (X (2 * i + 1))) t ) L ``)
        THEN1(RW_TAC std_ss[DRBD_series_def]
              THEN RW_TAC std_ss[GSYM IMAGE_DEF]
 	      THEN RW_TAC std_ss[IMAGE_UNION]
	      THEN RW_TAC std_ss[BIGINTER_UNION])
THEN RW_TAC std_ss[]	      

THEN KNOW_TAC(``
   DRBD_series
     (rv_to_event p
        (\i:num.
             if i = 0 then Y
             else if i = 1 then nR_AND X L1
             else if i = 3 then R_OR (nR_AND X L2) (nR_AND X L3)
             else if i = 4 then nR_AND X L4
             else R_OR (X (2 * i)) (X (2 * i + 1))) t) ({0; 1; 3; 4})=
    DRBD_event p ( Y) t INTER
    DRBD_event p (nR_AND X L1) t INTER
    DRBD_event p (R_OR (nR_AND X L2) (nR_AND X L3)) t INTER
    DRBD_event p (nR_AND X L4) t  ``)

    
     THEN1(RW_TAC std_ss[DRBD_series_def, rv_to_event_def]
           THEN KNOW_TAC(``
     {DRBD_event p
       (if i = 0 then Y
        else if i = 1 then nR_AND X L1
        else if i = 3 then R_OR (nR_AND X L2) (nR_AND X L3)
        else if i = 4 then nR_AND X L4
        else R_OR (X (2 * i)) (X (2 * i + 1))) t |
     i IN {0; 1:num; 3; 4} } =
     {DRBD_event p
       Y t;
      DRBD_event p (nR_AND X (L1:num->bool)) t;
      DRBD_event p ( R_OR (nR_AND X (L2:num->bool)) (nR_AND X (L3:num->bool))) t;
      DRBD_event p (nR_AND X (L4:num->bool)) t }``)  

             THEN1(PSET_TAC[]
                    THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
 		    THEN EQ_TAC
		         THEN1(RW_TAC std_ss[] THEN RW_TAC std_ss[])
	            THEN RW_TAC std_ss[]
		         THEN1(Q.EXISTS_TAC`0`
			        THEN RW_TAC std_ss[])
			 THEN1(Q.EXISTS_TAC`1`
			       THEN RW_TAC std_ss[])
			  THEN1(Q.EXISTS_TAC`3`
			       THEN RW_TAC std_ss[])

		    THEN Q.EXISTS_TAC`4`
		    THEN RW_TAC std_ss[])
       THEN RW_TAC std_ss[]
       THEN RW_TAC std_ss[BIGINTER_4_sets])
THEN RW_TAC std_ss[]       
THEN KNOW_TAC(``DRBD_series
     (rv_to_event p
        (\i:num.
             if i = 0 then Y
             else if i = 1 then nR_AND X L1
             else if i = 3 then R_OR (nR_AND X L2) (nR_AND X L3)
             else if i = 4 then nR_AND X L4
             else R_OR (X (2 * i)) (X (2 * i + 1))) t) L =
	     DRBD_series
     (rv_to_event p
        (\i. R_OR (X (2 * i)) (X (2 * i + 1))) t) L``)
    THEN1(RW_TAC std_ss[DRBD_series_def]
          THEN AP_TERM_TAC
	  THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
	  THEN EQ_TAC
	       THEN1( RW_TAC std_ss[]
	             THEN Q.EXISTS_TAC`i`
	             THEN RW_TAC std_ss[]
		     THEN EQ_TAC
	                  THEN1(RW_TAC std_ss[]
	                        THEN FULL_SIMP_TAC std_ss[DISJOINT_DEF]
		     		THEN `i:num <> 1` by ASM_SET_TAC[]
     		     		THEN `i:num <> 0` by ASM_SET_TAC[]
		     		THEN `i:num <> 3` by ASM_SET_TAC[]
		     		THEN `i:num <> 4` by ASM_SET_TAC[]
		     		THEN FULL_SIMP_TAC std_ss[]
		     		THEN FULL_SIMP_TAC std_ss[rv_to_event_def])
	             THEN RW_TAC std_ss[]
	 	     THEN `i:num <> 1` by ASM_SET_TAC[]
     	 	     THEN `i:num <> 0` by ASM_SET_TAC[]
	 	     THEN `i:num <> 3` by ASM_SET_TAC[]
	 	     THEN `i:num <> 4` by ASM_SET_TAC[]
	 	     THEN RW_TAC std_ss[rv_to_event_def]
	 	     THEN FULL_SIMP_TAC std_ss[rv_to_event_def])
          THEN RW_TAC std_ss[]
	  THEN Q.EXISTS_TAC`i`
	  THEN RW_TAC std_ss[]
	  THEN EQ_TAC
	        THEN1(RW_TAC std_ss[]
		      THEN `i:num <> 1` by ASM_SET_TAC[]
     		      THEN `i:num <> 0` by ASM_SET_TAC[]
		      THEN `i:num <> 3` by ASM_SET_TAC[]
		      THEN `i:num <> 4` by ASM_SET_TAC[]
		      THEN FULL_SIMP_TAC std_ss[]
		      THEN FULL_SIMP_TAC std_ss[rv_to_event_def])
          THEN `i:num <> 1` by ASM_SET_TAC[]
     	  THEN `i:num <> 0` by ASM_SET_TAC[]
	  THEN `i:num <> 3` by ASM_SET_TAC[]
	  THEN `i:num <> 4` by ASM_SET_TAC[]
	  THEN RW_TAC std_ss[rv_to_event_def])

THEN RW_TAC std_ss[]
THEN ONCE_REWRITE_TAC[DRBD_series_def]
THEN RW_TAC std_ss[GSYM IMAGE_DEF]
THEN RW_TAC std_ss[IMAGE_UNION]
THEN RW_TAC std_ss[BIGINTER_UNION]
THEN RW_TAC std_ss[IMAGE_DEF, GSYM DRBD_series_def]
THEN KNOW_TAC(``DRBD_series
     (\i.
          DRBD_parallel
            (\a.
                 DRBD_series (\i.
                        event_set [(DRBD_event p Y t,0)] (rv_to_event p X t)
                          i)
                   (if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then
                      {a}
                    else ind_set [{0}; L1; L2; L3; L4] a))
            (if i IN L then {2 * i; 2 * i + 1}
             else ind_set [{0}; {1}; {}; {2; 3}; {4}] i)) {0; 1; 3; 4} =
	    DRBD_event p (Y) t INTER DRBD_event p (nR_AND X L1) t INTER
   DRBD_event p (R_OR (nR_AND X L2) (nR_AND X L3)) t INTER
   DRBD_event p (nR_AND X L4) t ``)
   THEN1(RW_TAC std_ss[DRBD_series_def]
	 THEN RW_TAC std_ss[GSYM IMAGE_DEF]
	 THEN `{0;1;3;4:num} = {0} UNION ({1} UNION ({3} UNION {4}))` by ASM_SET_TAC[]
	 THEN ONCE_ASM_REWRITE_TAC[]
	 THEN RW_TAC std_ss[IMAGE_UNION]
	 THEN RW_TAC std_ss[BIGINTER_UNION]
	 THEN RW_TAC std_ss[IMAGE_DEF]


	 THEN KNOW_TAC(``!i k:num. i IN {k} ==> (i = k) ``)
	      THEN1(ASM_SET_TAC[])
	 THEN RW_TAC std_ss[]     
	 THEN KNOW_TAC(`` 
	    BIGINTER
     {DRBD_parallel
       (\a.
            BIGINTER
              {event_set [(DRBD_event p Y t,0)] (rv_to_event p X t) i |
              i IN
              if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
              else ind_set [{0}; L1; L2; L3; L4] a})
       (if i IN L then {2 * i; 2 * i + 1}
        else ind_set [{0}; {1}; {}; {2; 3}; {4}] i) |
     i IN {0:num}} =
       BIGINTER
     {DRBD_parallel
       (\a.
            BIGINTER
             {event_set [(DRBD_event p Y t,0)] (rv_to_event p X t) i |
              i IN
              if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
              else ind_set [{0}; L1; L2; L3; L4] a}) {0}} ``)
	      THEN1 (`!i:num. i NOTIN L ==> ((if i IN L then {2 * i; 2 * i + 1}
        else ind_set [{0}; {1}; {}; {2; 3}; {4}] i) = (ind_set [{0}; {1}; {}; {2; 3}; {4}] i))` by RW_TAC std_ss[]
	     	     THEN PSET_TAC[]
	     	     THEN RW_TAC std_ss[]
	             THEN PSET_TAC[]
		     THEN KNOW_TAC(`` BIGINTER
     {DRBD_parallel
       (\a.
            BIGINTER
             {event_set [(DRBD_event p Y t,0)] (rv_to_event p X t) i |
              i IN
              if
                (?i. (a = 2 * i) /\ i IN L) \/ ?i. (a = 2 * i + 1) /\ i IN L
              then
                {a} else ind_set [{0}; L1; L2; L3; L4] a})
       (if i IN L then {2 * i; 2 * i + 1}
        else ind_set [{0}; {1}; {}; {2; 3}; {4}] i) |
     i = 0}   =
      BIGINTER
     {DRBD_parallel
       (\a.
            BIGINTER
             {event_set [(DRBD_event p Y t,0)] (rv_to_event p X t) i  |
              i IN
              if
                (?i. (a = 2 * i) /\ i IN L) \/ ?i. (a = 2 * i + 1) /\ i IN L
              then
                {a} else ind_set [{0}; L1; L2; L3; L4] a})
       (if 0 IN L then {2 * i; 2 * i + 1}
        else ind_set [{0}; {1}; {}; {2; 3}; {4}] 0) }``)
	   THEN1 (RW_TAC std_ss[] THEN ASM_SET_TAC[])
	   THEN RW_TAC std_ss[ind_set_def]
	   THEN RW_TAC list_ss[])
     THEN RW_TAC std_ss[]	    
     THEN KNOW_TAC(`` BIGINTER
         {DRBD_parallel
        (\a.
             BIGINTER
               {event_set [(DRBD_event p Y t,0)] (rv_to_event p X t) i  |
               i IN
               if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
               else ind_set [{0}; L1; L2; L3; L4] a})
        (if i IN L then {2 * i; 2 * i + 1}
         else ind_set [{0}; {1}; {}; {2; 3}; {4}] i) |
      i IN {1}} =
      BIGINTER
      {DRBD_parallel
        (\a.
             BIGINTER
              {event_set [(DRBD_event p Y t,0)] (rv_to_event p X t) i |
               i IN
               if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
               else ind_set [{0}; L1; L2; L3; L4] a}) {1}}``)
	    THEN1(PSET_TAC[]
	          THEN KNOW_TAC(`` BIGINTER
     {DRBD_parallel
       (\a.
            BIGINTER
             {event_set [(DRBD_event p Y t,0)] (rv_to_event p X t) i  |
              i IN
              if
                (?i. (a = 2 * i) /\ i IN L) \/ ?i. (a = 2 * i + 1) /\ i IN L
              then
                {a} else ind_set [{0}; L1; L2; L3; L4] a})
       (if i IN L then {2 * i; 2 * i + 1}
        else ind_set [{0}; {1}; {}; {2; 3}; {4}] i) |
     i = 1} =
      BIGINTER
     {DRBD_parallel
       (\a.
            BIGINTER
              {event_set [(DRBD_event p Y t,0)] (rv_to_event p X t) i  |
              i IN
              if
                (?i. (a = 2 * i) /\ i IN L) \/ ?i. (a = 2 * i + 1) /\ i IN L
              then
                {a} else ind_set [{0}; L1; L2; L3; L4] a})
       (if 1:num IN L then {2 * i; 2 * i + 1}
        else ind_set [{0}; {1}; {}; {2; 3}; {4}] 1) }``)
   	    THEN1 (RW_TAC std_ss[] THEN ASM_SET_TAC[])
	    THEN RW_TAC list_ss[ind_set_def])
    THEN RW_TAC std_ss[]	 
    THEN KNOW_TAC(``BIGINTER
       {DRBD_parallel
         (\a.
              BIGINTER
               {event_set [(DRBD_event p Y t,0)] (rv_to_event p X t) i |
                i IN
                if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
                else ind_set [{0}; L1; L2; L3; L4] a})
         (if i IN L then {2 * i; 2 * i + 1}
          else ind_set [{0}; {1}; {}; {2; 3}; {4}] i) |
       i IN {3}} =
       BIGINTER
       {DRBD_parallel
         (\a.
              BIGINTER
               {event_set [(DRBD_event p Y t,0)] (rv_to_event p X t) i  |
                i IN
                if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
                else ind_set [{0}; L1; L2; L3; L4] a}) {2;3}}``)
          THEN1(PSET_TAC[]
	        THEN KNOW_TAC(`` BIGINTER
     {DRBD_parallel
       (\a.
            BIGINTER
             {event_set [(DRBD_event p Y t,0)] (rv_to_event p X t) i |
              i IN
              if
                (?i. (a = 2 * i) /\ i IN L) \/ ?i. (a = 2 * i + 1) /\ i IN L
              then
                {a} else ind_set [{0}; L1; L2; L3; L4] a})
       (if i IN L then {2 * i; 2 * i + 1}
        else ind_set [{0}; {1}; {}; {2; 3}; {4}] i) |
     i = 3} =
     BIGINTER
     {DRBD_parallel
       (\a.
            BIGINTER
             {event_set [(DRBD_event p Y t,0)] (rv_to_event p X t) i  |
              i IN
              if
                (?i. (a = 2 * i) /\ i IN L) \/ ?i. (a = 2 * i + 1) /\ i IN L
              then
                {a} else ind_set [{0}; L1; L2; L3; L4] a})
       (if 3:num IN L then {2 * i; 2 * i + 1}
        else ind_set [{0}; {1}; {}; {2; 3}; {4}] 3)}``)
           THEN1 (RW_TAC std_ss[] THEN ASM_SET_TAC[])
           THEN RW_TAC list_ss[ind_set_def])
     THEN RW_TAC std_ss[]
     THEN KNOW_TAC(``BIGINTER
       {DRBD_parallel
         (\a.
              BIGINTER
               {event_set [(DRBD_event p Y t,0)] (rv_to_event p X t) i  |
                i IN
                if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
                else ind_set [{0}; L1; L2; L3; L4] a})
         (if i IN L then {2 * i; 2 * i + 1}
          else ind_set [{0}; {1}; {}; {2; 3}; {4}] i) |
       i IN {4}} =
       BIGINTER
       {DRBD_parallel
         (\a.
              BIGINTER
               {event_set [(DRBD_event p Y t,0)] (rv_to_event p X t) i  |
                i IN
                if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
                else ind_set [{0}; L1; L2; L3; L4] a}) {4}}``)
		THEN1(PSET_TAC[]
		      THEN KNOW_TAC(``  BIGINTER
     {DRBD_parallel
       (\a.
            BIGINTER
              {event_set [(DRBD_event p Y t,0)] (rv_to_event p X t) i  |
              i IN
              if
                (?i. (a = 2 * i) /\ i IN L) \/ ?i. (a = 2 * i + 1) /\ i IN L
              then
                {a} else ind_set [{0}; L1; L2; L3; L4] a})
       (if i IN L then {2 * i; 2 * i + 1}
        else ind_set [{0}; {1}; {}; {2; 3}; {4}] i) |
     i = 4} =
      BIGINTER
     {DRBD_parallel
       (\a.
            BIGINTER
             {event_set [(DRBD_event p Y t,0)] (rv_to_event p X t) i  |
              i IN
              if
                (?i. (a = 2 * i) /\ i IN L) \/ ?i. (a = 2 * i + 1) /\ i IN L
              then
                {a} else ind_set [{0}; L1; L2; L3; L4] a})
       (if 4:num IN L then {2 * i; 2 * i + 1}
        else ind_set [{0}; {1}; {}; {2; 3}; {4}] 4) }``)
               THEN1(RW_TAC std_ss[] THEN ASM_SET_TAC[])
	       THEN RW_TAC list_ss[ind_set_def])
      THEN RW_TAC std_ss[]	       
      THEN RW_TAC std_ss[BIGINTER_SING]
      THEN RW_TAC std_ss[rv_to_event_def]
      THEN RW_TAC std_ss[DRBD_parallel_def]
      THEN KNOW_TAC(``BIGUNION
     {BIGINTER
        {event_set [(DRBD_event p Y t,0)] (\i. DRBD_event p (X i) t) i |
       i IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
       else ind_set [{0}; L1; L2; L3; L4] a} |
     a IN {0}} =
      DRBD_event p Y t  ``)
           THEN1(PSET_TAC[ind_set_def, event_set_def, event_set1_def] THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
	         THEN EQ_TAC THEN1 (RW_TAC std_ss[] THEN  ASM_SET_TAC[ind_set_def])
		 THEN RW_TAC std_ss[] THEN Q.EXISTS_TAC`DRBD_event p (Y) t`
		 THEN ASM_SET_TAC[])
      THEN RW_TAC std_ss[]
      THEN KNOW_TAC(``BIGUNION
      {BIGINTER
         {event_set [(DRBD_event p Y t,0)] (\i. DRBD_event p (X i) t) i|
        i IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
        else ind_set [{0}; L1; L2; L3; L4] a} |
      a IN {1}} =
      DRBD_event p (nR_AND X L1) t``)
           THEN1(RW_TAC std_ss[nR_AND_DRBD_series]
	         THEN KNOW_TAC(``{BIGINTER
        {event_set [(DRBD_event p Y t,0)] (\i. DRBD_event p (X i) t) i |
       i IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
       else ind_set [{0}; L1; L2; L3; L4] a} |
     a IN {1}} =
            {BIGINTER {rv_to_event p (X:num->'a->extreal) t i | i IN L1}}``)
	         THEN1 (RW_TAC list_ss[ind_set_def, event_set_def, event_set1_def]
		        THEN KNOW_TAC(``{BIGINTER
      {event_set [(DRBD_event p Y t,0)] (\i. DRBD_event p (X i) t) i |
     i IN if a IN {2 * i | i IN L} \/ a IN {2 * i + 1 | i IN L} then {a}
     else EL a [{0}; L1; L2; L3; L4]} |
   a = 1} =
   {BIGINTER
      {event_set [(DRBD_event p Y t,0)] (\i. DRBD_event p (X i) t) i |
     i IN if (1:num) IN {2 * i | i IN L} \/ 1:num IN {2 * i + 1 | i IN L} then {1:num}
     else EL (1:num) [{0}; L1; L2; L3; L4]}}``) THEN1 (RW_TAC std_ss[event_set_def, event_set1_def] THEN SRW_TAC [][GSPECIFICATION, EXTENSION] THEN EQ_TAC THEN RW_TAC std_ss[] THEN ASM_SET_TAC[] )
                THEN RW_TAC std_ss[]
		THEN1 ASM_SET_TAC[]
		THEN1 ASM_SET_TAC[]
		THEN RW_TAC list_ss[rv_to_event_def, event_set_def, event_set1_def, ind_set_def]
		THEN FULL_SIMP_TAC list_ss[event_set_def, event_set1_def]
		THEN RW_TAC std_ss[GSYM IMAGE_DEF]
		THEN KNOW_TAC(``!i:num. i IN L1 ==> ((if i = 0 then DRBD_event p Y t else DRBD_event p (X i) t) = DRBD_event p (X i) t)  ``)
		    THEN1 (RW_TAC std_ss[]
		           THEN KNOW_TAC(``DISJOINT {0:num} L1 ``)	  
			        THEN1(UNDISCH_TAC(``disjoint_family_on
            (ind_set
               [{0:num}; L1; L2; L3; L4;
                {2 * i | i IN L} UNION {2 * i + 1 | i IN L}])
            {0; 1; 2; 3; 4; 5} ``)
	                                THEN RW_TAC std_ss[disjoint_family_on]
					THEN POP_ASSUM (MP_TAC o Q.SPEC `0`) THEN DISCH_TAC
					THEN POP_ASSUM (MP_TAC o Q.SPEC `1`)
					THEN RW_TAC list_ss[ind_set_def]
					THEN RW_TAC std_ss[DISJOINT_DEF])
			   THEN ASM_SET_TAC[])
		THEN RW_TAC std_ss[]
		THEN `(IMAGE (\i. if i = 0 then DRBD_event p Y t else DRBD_event p (X i) t)
         L1) = (IMAGE (\i. DRBD_event p (X i) t) L1)` by  RW_TAC std_ss[IMAGE_EQ]
	        THEN RW_TAC std_ss[])
	  THEN RW_TAC std_ss[]
	  THEN RW_TAC std_ss[BIGUNION_SING]
	  THEN RW_TAC std_ss[DRBD_series_def])
    THEN RW_TAC std_ss[]	  
    THEN KNOW_TAC(``BIGUNION
       {BIGINTER
         {event_set [(DRBD_event p Y t,0)] (\i. DRBD_event p (X i) t) i  |
         i IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
         else ind_set [{0}; L1; L2; L3; L4] a} |
       a IN {2; 3}} =
        DRBD_event p (R_OR (nR_AND X L2) (nR_AND (X:num->'a->extreal) L3)) t ``)
	    THEN1(RW_TAC std_ss[R_OR_UNION]
	         THEN RW_TAC std_ss[nR_AND_DRBD_series]
		 THEN KNOW_TAC(`` {BIGINTER
       {event_set [(DRBD_event p Y t,0)] (\i. DRBD_event p (X i) t) i  |
       i IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
       else ind_set [{0}; L1; L2; L3; L4] a} |
     a IN {2; 3}} =

   {BIGINTER
      {event_set [(DRBD_event p Y t,0)] (\i. DRBD_event p (X i) t) i  |
       i IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
       else ind_set [{0}; L1; L2; L3; L4] a} |
     (a=2)} UNION
   {BIGINTER
       {event_set [(DRBD_event p Y t,0)] (\i. DRBD_event p (X i) t) i  |
       i IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
       else ind_set [{0}; L1; L2; L3; L4] a} |
     (a = 3)}``)
                     THEN1(PSET_TAC [] THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
		           THEN RW_TAC std_ss[] THEN EQ_TAC
			   THEN1( RW_TAC std_ss[] THEN ASM_SET_TAC[])
   			   THEN1( RW_TAC std_ss[] THEN ASM_SET_TAC[])
			   THEN1( RW_TAC std_ss[] THEN ASM_SET_TAC[])
			   THEN1( RW_TAC std_ss[] THEN ASM_SET_TAC[])
			   THEN1( RW_TAC std_ss[] THEN ASM_SET_TAC[])
			   THEN1( RW_TAC std_ss[] THEN ASM_SET_TAC[])
			   THEN1(RW_TAC std_ss[] THEN1(PSET_TAC[] THEN ASM_SET_TAC[])
			         THEN PSET_TAC[] THEN ASM_SET_TAC[])
			   THEN RW_TAC std_ss[] THEN1(Q.EXISTS_TAC `2:num` THEN PSET_TAC[] THEN RW_TAC std_ss[] THEN ASM_SET_TAC[])
			   
			   THEN Q.EXISTS_TAC`3`
			   THEN RW_TAC std_ss[])
		THEN RW_TAC std_ss[]
		THEN KNOW_TAC(``{BIGINTER
       {event_set [(DRBD_event p Y t,0)] (\i. DRBD_event p (X i) t) i  |
        i IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
        else ind_set [{0}; L1; L2; L3; L4] a} |
      a = 2} =
   {BIGINTER { DRBD_event p (X i) t | i IN L2}}``)
                      THEN1( RW_TAC list_ss[ind_set_def]
		        THEN KNOW_TAC(``{BIGINTER
    {event_set [(DRBD_event p Y t,0)] (\i. DRBD_event p (X i) t) i  |
     i IN if a IN {2 * i | i IN L} \/ a IN {2 * i + 1 | i IN L} then {a}
     else EL a [{0}; L1; L2; L3; L4]} |
   a = 2} =
   {BIGINTER
     {event_set [(DRBD_event p Y t,0)] (\i. DRBD_event p (X i) t) i  |
     i IN if (2:num) IN {2 * i | i IN L} \/ 2:num IN {2 * i + 1 | i IN L} then {2:num}
     else EL (2:num) [{0}; L1; L2; L3; L4]}}``) THEN1 (RW_TAC std_ss[] THEN SRW_TAC [][GSPECIFICATION, EXTENSION] THEN EQ_TAC THEN RW_TAC std_ss[] THEN ASM_SET_TAC[] )
                        THEN RW_TAC std_ss[]
		        THEN1 ASM_SET_TAC[]
		       THEN1 ASM_SET_TAC[]
		       THEN RW_TAC list_ss[rv_to_event_def, event_set_def, event_set1_def, ind_set_def]
	            	THEN FULL_SIMP_TAC list_ss[event_set_def, event_set1_def]
		 	THEN RW_TAC std_ss[GSYM IMAGE_DEF]
			THEN KNOW_TAC(``!i:num. i IN L2 ==> ((if i = 0 then DRBD_event p Y t else DRBD_event p (X i) t) = DRBD_event p (X i) t)  ``)
		    THEN1 (RW_TAC std_ss[]
		           THEN KNOW_TAC(``DISJOINT {0:num} L2 ``)	  
			        THEN1(UNDISCH_TAC(``disjoint_family_on
            (ind_set
               [{0:num}; L1; L2; L3; L4;
                {2 * i | i IN L} UNION {2 * i + 1 | i IN L}])
            {0; 1; 2; 3; 4; 5} ``)
	                                THEN RW_TAC std_ss[disjoint_family_on]
					THEN POP_ASSUM (MP_TAC o Q.SPEC `0`) THEN DISCH_TAC
					THEN POP_ASSUM (MP_TAC o Q.SPEC `2`)
					THEN RW_TAC list_ss[ind_set_def]
					THEN RW_TAC std_ss[DISJOINT_DEF])
			   THEN ASM_SET_TAC[])
		   THEN RW_TAC std_ss[]
		   THEN `(IMAGE (\i. if i = 0 then DRBD_event p Y t else DRBD_event p (X i) t)
         L2) = (IMAGE (\i. DRBD_event p (X i) t) L2)` by  RW_TAC std_ss[IMAGE_EQ]
	            THEN RW_TAC std_ss[])
	      
	       THEN RW_TAC std_ss[]      
               THEN KNOW_TAC(``{BIGINTER
        {event_set [(DRBD_event p Y t,0)] (\i. DRBD_event p (X i) t) i |
        i IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
        else ind_set [{0}; L1; L2; L3; L4] a} |
      a = 3} =
   {BIGINTER {DRBD_event p (X i) t | i IN L3}}``)
                     THEN1(RW_TAC list_ss[ind_set_def]
		        THEN KNOW_TAC(``{BIGINTER
    {event_set [(DRBD_event p Y t,0)] (\i. DRBD_event p (X i) t) i |
     i IN if a IN {2 * i | i IN L} \/ a IN {2 * i + 1 | i IN L} then {a}
     else EL a [{0}; L1; L2; L3; L4]} |
   a = 3} =
   {BIGINTER
    {event_set [(DRBD_event p Y t,0)] (\i. DRBD_event p (X i) t) i |
     i IN if (3:num) IN {2 * i | i IN L} \/ 3:num IN {2 * i + 1 | i IN L} then {3:num}
     else EL (3:num) [{0}; L1; L2; L3; L4]}}``) THEN1 (RW_TAC std_ss[] THEN SRW_TAC [][GSPECIFICATION, EXTENSION] THEN EQ_TAC THEN RW_TAC std_ss[] THEN ASM_SET_TAC[] )
                       THEN RW_TAC std_ss[]
		       THEN1 ASM_SET_TAC[]
		       	THEN1 ASM_SET_TAC[]
			THEN RW_TAC list_ss[rv_to_event_def, event_set_def, event_set1_def, ind_set_def]
	            	THEN FULL_SIMP_TAC list_ss[event_set_def, event_set1_def]
		 	THEN RW_TAC std_ss[GSYM IMAGE_DEF]
			THEN KNOW_TAC(``!i:num. i IN L3 ==> ((if i = 0 then DRBD_event p Y t else DRBD_event p (X i) t) = DRBD_event p (X i) t)  ``)
		    THEN1 (RW_TAC std_ss[]
		           THEN KNOW_TAC(``DISJOINT {0:num} L3 ``)	  
			        THEN1(UNDISCH_TAC(``disjoint_family_on
            (ind_set
               [{0:num}; L1; L2; L3; L4;
                {2 * i | i IN L} UNION {2 * i + 1 | i IN L}])
            {0; 1; 2; 3; 4; 5} ``)
	                                THEN RW_TAC std_ss[disjoint_family_on]
					THEN POP_ASSUM (MP_TAC o Q.SPEC `0`) THEN DISCH_TAC
					THEN POP_ASSUM (MP_TAC o Q.SPEC `3`)
					THEN RW_TAC list_ss[ind_set_def]
					THEN RW_TAC std_ss[DISJOINT_DEF])
			   THEN ASM_SET_TAC[])
		     THEN RW_TAC std_ss[]
		     THEN `(IMAGE (\i. if i = 0 then DRBD_event p Y t else DRBD_event p (X i) t)
         L3) = (IMAGE (\i. DRBD_event p (X i) t) L3)` by  RW_TAC std_ss[IMAGE_EQ]
	              THEN RW_TAC std_ss[])

			
		 THEN RW_TAC std_ss[]
		 THEN KNOW_TAC(``{BIGINTER {DRBD_event p (X i) t | i IN L2}} UNION
      {BIGINTER {DRBD_event p (X i) t | i IN L3}} =
       {BIGINTER {DRBD_event p (X i) t | i IN L2}; 
      BIGINTER {DRBD_event p ((X:num->'a->extreal) i) t | i IN L3}} ``)

                     THEN1(ASM_SET_TAC[])
		  THEN RW_TAC std_ss[]
		  THEN RW_TAC std_ss[BIGUNION_PAIR]
		  THEN RW_TAC std_ss[DRBD_series_def, BIGUNION_PAIR, rv_to_event_def])
   THEN RW_TAC std_ss[]      
   THEN KNOW_TAC(`` BIGUNION
       {BIGINTER
       {event_set [(DRBD_event p Y t,0)] (\i. DRBD_event p (X i) t) i |
         i IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
         else ind_set [{0}; L1; L2; L3; L4] a} |
       a IN {4}} = DRBD_event p (nR_AND (X:num->'a->extreal) L4) t ``)
     THEN1(RW_TAC std_ss[nR_AND_DRBD_series]
           THEN RW_TAC std_ss[DRBD_series_def, rv_to_event_def]
	   THEN KNOW_TAC(``{BIGINTER
      {event_set [(DRBD_event p Y t,0)] (\i. DRBD_event p (X i) t) i|
       i IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
       else ind_set [{0}; L1; L2; L3; L4] a} |
     a IN {4}} =
     {BIGINTER {DRBD_event p ((X:num->'a->extreal) i) t | i IN L4}}``)
               THEN1(RW_TAC list_ss[ind_set_def]
		        THEN KNOW_TAC(``{BIGINTER
    {event_set [(DRBD_event p Y t,0)] (\i. DRBD_event p (X i) t) i |
     i IN if a IN {2 * i | i IN L} \/ a IN {2 * i + 1 | i IN L} then {a}
     else EL a [{0}; L1; L2; L3; L4]} |
   a = 4} =
   {BIGINTER
    {event_set [(DRBD_event p Y t,0)] (\i. DRBD_event p (X i) t) i |
     i IN if (4:num) IN {2 * i | i IN L} \/ 4:num IN {2 * i + 1 | i IN L} then {4:num}
     else EL (4:num) [{0}; L1; L2; L3; L4]}}``) THEN1 (RW_TAC std_ss[] THEN SRW_TAC [][GSPECIFICATION, EXTENSION] THEN EQ_TAC THEN RW_TAC std_ss[] THEN PSET_TAC[] THEN ASM_SET_TAC[] )
                       THEN RW_TAC std_ss[]
		       THEN1(KNOW_TAC(`` !i:num. i IN L ==> 2*i <> 4``)
	                     THEN1(RW_TAC std_ss[]
	             	     THEN MP_TAC (Q.ISPECL [`{2*i:num; 2*i+1:num}`, `{0;1;2;3;4:num}`]DISJOINT_def_2)
	     		     THEN RW_TAC std_ss[]
		     	     THEN POP_ASSUM (MP_TAC o Q.SPEC `4`)
		     	     THEN ASM_SET_TAC[DISJOINT_def_2])
	                THEN ASM_SET_TAC[])
			THEN1 ASM_SET_TAC[]
			THEN RW_TAC list_ss[rv_to_event_def, event_set_def, event_set1_def, ind_set_def]
	            	THEN FULL_SIMP_TAC list_ss[event_set_def, event_set1_def]
		 	THEN RW_TAC std_ss[GSYM IMAGE_DEF]
			THEN KNOW_TAC(``!i:num. i IN L4 ==> ((if i = 0 then DRBD_event p Y t else DRBD_event p (X i) t) = DRBD_event p (X i) t)  ``)
		    THEN1 (RW_TAC std_ss[]
		           THEN KNOW_TAC(``DISJOINT {0:num} L4 ``)	  
			        THEN1(UNDISCH_TAC(``disjoint_family_on
            (ind_set
               [{0:num}; L1; L2; L3; L4;
                {2 * i | i IN L} UNION {2 * i + 1 | i IN L}])
            {0; 1; 2; 3; 4; 5} ``)
	                                THEN RW_TAC std_ss[disjoint_family_on]
					THEN POP_ASSUM (MP_TAC o Q.SPEC `0`) THEN DISCH_TAC
					THEN POP_ASSUM (MP_TAC o Q.SPEC `4`)
					THEN RW_TAC list_ss[ind_set_def]
					THEN RW_TAC std_ss[DISJOINT_DEF])
			   THEN ASM_SET_TAC[])
		     THEN RW_TAC std_ss[]
		     THEN `(IMAGE (\i. if i = 0 then DRBD_event p Y t else DRBD_event p (X i) t)
         L4) = (IMAGE (\i. DRBD_event p (X i) t) L4)` by  RW_TAC std_ss[IMAGE_EQ]
	              THEN RW_TAC std_ss[])
			
		THEN RW_TAC std_ss[]	
	        THEN RW_TAC std_ss[BIGUNION_SING])
   THEN RW_TAC std_ss[]
   THEN RW_TAC std_ss[INTER_ASSOC])
THEN RW_TAC std_ss[]   
THEN AP_TERM_TAC
THEN RW_TAC std_ss[DRBD_series_def, DRBD_parallel_def]
THEN KNOW_TAC(`` !i:num. i IN L ==>(
             {BIGINTER
     {event_set [(DRBD_event p Y t,0)] (rv_to_event p X t) i |
       i IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
       else ind_set [{0}; L1; L2; L3; L4] a} |
     a |
     a IN if i IN L then {2 * i; 2 * i + 1}
     else ind_set [{0}; {1}; {}; {2; 3}; {4}] i} =
       {BIGINTER
       {event_set [(DRBD_event p Y t,0)] (rv_to_event p X t) i |
       i IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
       else ind_set [{0}; L1; L2; L3; L4] a} |
     a |
     a IN  {2 * i; 2 * i + 1}})``)
       THEN1( RW_TAC std_ss[] THEN ASM_SET_TAC[])
THEN RW_TAC std_ss[]       
THEN KNOW_TAC(``BIGINTER
     {BIGUNION
       {BIGINTER
         {event_set [(DRBD_event p Y t,0)] (rv_to_event p X t) i |
         i IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
         else ind_set [{0}; L1; L2; L3; L4] a} |
       a |
       a IN if i IN L then {2 * i; 2 * i + 1}
       else ind_set [{0}; {1}; {}; {2; 3}; {4}] i} |
     i |
     i IN L} =
     BIGINTER
     {BIGUNION
       {BIGINTER
         {event_set [(DRBD_event p Y t,0)] (rv_to_event p X t) i |
         i IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
         else ind_set [{0}; L1; L2; L3; L4] a} |
       a |
       a IN  {2 * i; 2 * i + 1}
       } |
     i |
     i IN L}``)

     THEN1 (RW_TAC std_ss[GSYM IMAGE_DEF]
            THEN FULL_SIMP_TAC std_ss[GSYM IMAGE_DEF]
            THEN KNOW_TAC(``!i. i IN L ==> (
BIGUNION
               (IMAGE
                  (\a.
                       BIGINTER
                         (IMAGE (\i.
                                 event_set [(DRBD_event p Y t,0)]
                                   (rv_to_event p X t) i)
                            (if
                               a IN
                               IMAGE (\i. 2 * i) L UNION
                               IMAGE (\i. 2 * i + 1) L
                             then
                               {a}
                             else ind_set [{0}; L1; L2; L3; L4] a)))
                  (if i IN L then {2 * i; 2 * i + 1}
                   else ind_set [{0}; {1}; {}; {2; 3}; {4}] i)) =
		BIGUNION
               (IMAGE
                  (\a.
                       BIGINTER
                         (IMAGE (\i.
                                 event_set [(DRBD_event p Y t,0)]
                                   (rv_to_event p X t) i)
                            (if
                               a IN
                               IMAGE (\i. 2 * i) L UNION
                               IMAGE (\i. 2 * i + 1) L
                             then
                               {a}
                             else ind_set [{0}; L1; L2; L3; L4] a)))
                  {2 * i; 2 * i + 1}))``)

        THEN1(RW_TAC std_ss[]
	      THEN ASM_SET_TAC[])
	 THEN RW_TAC std_ss[]     
	 THEN AP_TERM_TAC
        THEN RW_TAC std_ss[IMAGE_EQ])
THEN RW_TAC std_ss[]
THEN RW_TAC std_ss[rv_to_event_def]
THEN RW_TAC std_ss[R_OR_UNION]
THEN RW_TAC std_ss[GSYM BIGUNION_PAIR]
THEN RW_TAC std_ss[GSYM IMAGE_DEF]
THEN AP_TERM_TAC
THEN KNOW_TAC(``!i:num. i IN L==>
((IMAGE
               (\a.
                    BIGINTER
                      (IMAGE (\i.
                              event_set [(DRBD_event p Y t,0)]
                                (\i. DRBD_event p (X i) t) i)
                         (if
                            a IN
                            BIGUNION
                              {IMAGE (\i. 2 * i) L; IMAGE (\i. 2 * i + 1) L}
                          then
                            {a}
                          else ind_set [{0}; L1; L2; L3; L4] a)))
               {2 * i; 2 * i + 1}) =
			  {DRBD_event p (X (2 * i)) t; DRBD_event p ((X:num->'a->extreal) (2 * i + 1)) t})``)
      THEN1(RW_TAC std_ss[]
            THEN KNOW_TAC(``(2 * i:num) IN BIGUNION {{2 * i | i IN L}; {2 * i + 1 | i IN L}} ``)
 	    	 THEN1( PSET_TAC[]THEN Q.EXISTS_TAC`{2*i|i IN L}`
		        THEN ASM_SET_TAC[])
	     THEN `{2*i; 2*i+1:num} = {2*i} UNION {2*i+1}` by ASM_SET_TAC[]
	    THEN DISCH_TAC
 	    THEN ONCE_ASM_REWRITE_TAC[]
	    THEN RW_TAC std_ss[IMAGE_UNION]
	    THEN RW_TAC std_ss[IMAGE_DEF]
	    THEN KNOW_TAC(`` {BIGINTER
    {event_set [(DRBD_event p Y t,0)] (\i. DRBD_event p (X i) t) i' |
     i' IN if a IN BIGUNION {{2 * i | i IN L}; {2 * i + 1 | i IN L}} then {a}
      else ind_set [{0}; L1; L2; L3; L4] a} |
   a IN {2 * i}} =
  { BIGINTER {DRBD_event p ((X:num->'a->extreal) (2 * i)) t}}``)
                THEN1(KNOW_TAC(`` {BIGINTER{event_set [(DRBD_event p Y t,0)] (\i. DRBD_event p (X i) t) i' |
     i' IN if a IN BIGUNION {{2 * i | i IN L}; {2 * i + 1 | i IN L}} then {a}
     else ind_set [{0}; L1; L2; L3; L4] a} |
   a IN {2 * i}} =
   {BIGINTER{event_set [(DRBD_event p Y t,0)] (\i. DRBD_event p (X i) t) i' |
     i' IN if a IN BIGUNION {{2 * i | i IN L}; {2 * i + 1 | i IN L}} then {a}
     else ind_set [{0}; L1; L2; L3; L4] a} |
   (a =2 * i)}``)
		      THEN1 ASM_SET_TAC[]
               	      THEN RW_TAC std_ss[]
   	       	      THEN KNOW_TAC(``
		       !a. {event_set [(DRBD_event p Y t,0)] (\i. DRBD_event p (X i) t) i' |
     i' IN if a IN BIGUNION {{2 * i | i IN L}; {2 * i + 1 | i IN L}} then {a}
     else ind_set [{0}; L1; L2; L3; L4] a} =
            (\a. {event_set [(DRBD_event p Y t,0)] (\i. DRBD_event p (X i) t) i'|
     i' IN if a IN BIGUNION {{2 * i | i IN L}; {2 * i + 1 | i IN L}} then {a}
     else ind_set [{0}; L1; L2; L3; L4] a}) a``)
       	   	  	  THEN1 RW_TAC std_ss[]
              	       THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
     	      	       THEN KNOW_TAC(``{BIGINTER
     ((\a.
          {event_set [(DRBD_event p Y t,0)] (\i. DRBD_event p (X i) t) i' |
           i' IN
           if a IN BIGUNION {{2 * i | i IN L}; {2 * i + 1 | i IN L}} then {a}
           else ind_set [{0}; L1; L2; L3; L4] a}) a) |
   a = 2 * i} =
   {BIGINTER
     ((\a.
           {event_set [(DRBD_event p Y t,0)] (\i. DRBD_event p (X i) t) i' |
           i' IN
           if a IN BIGUNION {{2 * i | i IN L}; {2 * i + 1 | i IN L}} then {a}
           else ind_set [{0}; L1; L2; L3; L4] a}) (2 * i))}``)
           	           THEN1 ASM_SET_TAC[]

	            THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
	  	    THEN RW_TAC std_ss[]
     	            THEN KNOW_TAC(``{event_set [(DRBD_event p Y t,0)] (\i. DRBD_event p (X i) t) i' | i' = 2 * i} =
     {DRBD_event p (X ( 2 * i:num)) t}``) THEN1 ASM_SET_TAC[event_set_def, event_set1_def]
                     THEN RW_TAC std_ss[]
		     THEN ONCE_ASM_REWRITE_TAC[]
		     THEN FULL_SIMP_TAC std_ss[event_set_def, event_set1_def]
                     THEN PSET_TAC[])


	    THEN RW_TAC std_ss[]
	    THEN KNOW_TAC(``(2 * i+1:num) IN BIGUNION {{2 * i | i IN L}; {2 * i + 1 | i IN L}} ``)
 	    	 THEN1( PSET_TAC[]THEN Q.EXISTS_TAC`{2*i+1|i IN L}`
		        THEN ASM_SET_TAC[])
	     THEN DISCH_TAC		
	     THEN KNOW_TAC(`` {BIGINTER
     {event_set [(DRBD_event p Y t,0)] (\i. DRBD_event p (X i) t) i' |
     i' IN if a IN BIGUNION {{2 * i | i IN L}; {2 * i + 1 | i IN L}} then {a}
      else ind_set [{0}; L1; L2; L3; L4] a} |
   a IN {2 * i+1}} =
  { BIGINTER {DRBD_event p ((X:num->'a->extreal) (2 * i+1)) t}}``)
                THEN1(KNOW_TAC(`` {BIGINTER {event_set [(DRBD_event p Y t,0)] (\i. DRBD_event p (X i) t) i' |
     i' IN if a IN BIGUNION {{2 * i | i IN L}; {2 * i + 1 | i IN L}} then {a}
     else ind_set [{0}; L1; L2; L3; L4] a} |
   a IN {2 * i+1}} =
   {BIGINTER {event_set [(DRBD_event p Y t,0)] (\i. DRBD_event p (X i) t) i' |
     i' IN if a IN BIGUNION {{2 * i | i IN L}; {2 * i + 1 | i IN L}} then {a}
     else ind_set [{0}; L1; L2; L3; L4] a} |
   (a =2 * i+1)}``)
		      THEN1 ASM_SET_TAC[]
               	      THEN RW_TAC std_ss[]
   	       	      THEN KNOW_TAC(`` !a.  {event_set [(DRBD_event p Y t,0)] (\i. DRBD_event p (X i) t) i'|
     i' IN if a IN BIGUNION {{2 * i | i IN L}; {2 * i + 1 | i IN L}} then {a}
     else ind_set [{0}; L1; L2; L3; L4] a} =
            (\a.  {event_set [(DRBD_event p Y t,0)] (\i. DRBD_event p (X i) t) i' |
     i' IN if a IN BIGUNION {{2 * i | i IN L}; {2 * i + 1 | i IN L}} then {a}
     else ind_set [{0}; L1; L2; L3; L4] a}) a``)
       	   	  	  THEN1 RW_TAC std_ss[]
              	       THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
      	      	       THEN KNOW_TAC(``{BIGINTER
     ((\a.
            {event_set [(DRBD_event p Y t,0)] (\i. DRBD_event p (X i) t) i' |
           i' IN
           if a IN BIGUNION {{2 * i | i IN L}; {2 * i + 1 | i IN L}} then {a}
           else ind_set [{0}; L1; L2; L3; L4] a}) a) |
   a = 2 * i+1} =
   {BIGINTER
     ((\a.
           {event_set [(DRBD_event p Y t,0)] (\i. DRBD_event p (X i) t) i' |
           i' IN
           if a IN BIGUNION {{2 * i | i IN L}; {2 * i + 1 | i IN L}} then {a}
           else ind_set [{0}; L1; L2; L3; L4] a}) (2 * i+1))}``)
           	           THEN1 ASM_SET_TAC[]

	            THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
	  	    THEN RW_TAC std_ss[]
     	            THEN KNOW_TAC(`` {event_set [(DRBD_event p Y t,0)] (\i. DRBD_event p (X i) t) i' | i' = 2 * i+1} =
     {DRBD_event p (X ( 2 * i+1:num)) t}``) THEN1 ASM_SET_TAC[event_set_def, event_set1_def]
                     THEN RW_TAC std_ss[]
                     THEN PSET_TAC[])
    THEN  RW_TAC std_ss[BIGINTER_SING]
   THEN ASM_SET_TAC[])
THEN RW_TAC std_ss[IMAGE_EQ]);





val Q_SEN_network_nR_AND_DRBD_series_one_spare = store_thm(
  "Q_SEN_network_nR_AND_DRBD_series_one_spare",
  `` !p L1 L2 L3 L4 L X Y Ysa Ysd t.
            FINITE L1 /\ L1 <> {} /\ FINITE L2 /\ L2 <> {} /\ FINITE L3 /\
            L3 <> {} /\ FINITE L4 /\ L4 <> {} /\ FINITE L /\
            DISJOINT {0; 1; 3; 4} L /\
            (!i. i IN L ==> DISJOINT {2 * i; 2 * i + 1} {0; 1; 2; 3; 4}) /\
	    disjoint_family_on
            (ind_set
               [{0}; L1; L2; L3; L4;
                {2 * i | i IN L} UNION {2 * i + 1 | i IN L}])
            {0; 1; 2; 3; 4; 5}  ==>
            (DRBD_event p
               (nR_AND
                  (\i.
                       if i = 0 then R_WSP Y Ysa Ysd
                       else if i = 1 then nR_AND X L1
                       else if i = 3 then R_OR (nR_AND X L2) (nR_AND X L3)
                       else if i = 4 then nR_AND X L4
                       else R_OR (X (2 * i)) (X (2 * i + 1)))
                  ({0; 1; 3; 4} UNION L)) t =
             DRBD_series
               (\j.
                    DRBD_parallel
                      (\a.
                           DRBD_series (\i.
                                     event_set
                                       [(DRBD_event p (R_WSP Y Ysa  Ysd) t,0)] (rv_to_event p X t) i)
                             ((\i.
              if i IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {i}
              else ind_set [{0}; L1; L2; L3; L4] i) a))
                      ((\j.
              if j IN L then {2 * j; 2 * j + 1}
              else ind_set [{0}; {1}; {}; {2; 3}; {4}] j) j)) ({0; 1; 3; 4:num} UNION L))``,
RW_TAC std_ss [Q_SEN_network_nR_AND_DRBD_series_lem]);


val PROB_DRBD_SEN_network = store_thm("PROB_DRBD_SEN_network",
  `` ! p L1 L2 L3 L4 L X Y t. SEN_network_set_req p L1 L2 L3 L4 L 
                (\i:num.
                if i IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {i}
                else ind_set [{0}; L1; L2; L3; L4] i)
		(\j.
                if j IN L then {2 * j; 2 * j + 1:num}
                else ind_set [{0}; {1}; {}; {2:num; 3}; {4}] j) ({0; 1; 3; 4} UNION L) 
               (event_set
               [(DRBD_event p Y t,0)] (rv_to_event p X t))==>

(prob p
             (DRBD_event p (nR_AND
                (\i.
                     if i = 0 then Y
                     else if i = 1 then nR_AND X L1
                     else if i = 3 then R_OR (nR_AND X L2) (nR_AND X L3)
                     else if i = 4 then nR_AND X L4
                     else R_OR (X (2 * i)) (X (2 * i + 1)))
                ({0; 1; 3; 4} UNION L)) t) =
           Rel p Y t * Normal (product L1 (\l. real (Rel p (X l) t ))) *
           (1 -
            (1 - Normal (product L2 (\l. real (Rel p (X l) t)))) *
            (1 - Normal (product L3 (\l. real (Rel p (X l) t))))) *
           Normal (product L4 (\l. real (Rel p (X l) t ))) *
           Normal
             (product L
                (\j.
                     1 -
                     real
                       ((1 - Rel p (X (2*j)) t) *
                        (1 - Rel p (X (2*j+1)) t))))) ``,

REPEAT (GEN_TAC)
THEN DISCH_TAC
THEN DEP_REWRITE_TAC[Q_SEN_network_nR_AND_DRBD_series_lem]
THEN FULL_SIMP_TAC std_ss[SEN_network_set_req_def, Rel_def]
THEN KNOW_TAC(``!i:num. DRBD_event p (X i) t = rv_to_event p X t i ``)
    THEN1 RW_TAC std_ss[rv_to_event_def]
THEN RW_TAC std_ss[]    
THEN DEP_REWRITE_TAC[GSYM PROB_SEN_network_lem2]
THEN RW_TAC std_ss[SEN_network_set_req_def]);





val PROB_DRBD_SEN_network_one_spare = store_thm("PROB_DRBD_SEN_network_one_spare",
  `` ! p L1 L2 L3 L4 L X Y Ysa Ysd t. SEN_network_set_req p L1 L2 L3 L4 L 
                (\i:num.
                if i IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {i}
                else ind_set [{0}; L1; L2; L3; L4] i)
		(\j.
                if j IN L then {2 * j; 2 * j + 1:num}
                else ind_set [{0}; {1}; {}; {2:num; 3}; {4}] j) ({0; 1; 3; 4} UNION L) 
               (event_set
               [(DRBD_event p (R_WSP Y Ysa Ysd) t,0)] (rv_to_event p X t))==>

(prob p
             (DRBD_event p (nR_AND
                (\i.
                     if i = 0 then R_WSP Y Ysa Ysd
                     else if i = 1 then nR_AND X L1
                     else if i = 3 then R_OR (nR_AND X L2) (nR_AND X L3)
                     else if i = 4 then nR_AND X L4
                     else R_OR (X (2 * i)) (X (2 * i + 1)))
                ({0; 1; 3; 4} UNION L)) t) =
           Rel p (R_WSP Y Ysa Ysd) t * Normal (product L1 (\l. real (Rel p (X l) t ))) *
           (1 -
            (1 - Normal (product L2 (\l. real (Rel p (X l) t)))) *
            (1 - Normal (product L3 (\l. real (Rel p (X l) t))))) *
           Normal (product L4 (\l. real (Rel p (X l) t ))) *
           Normal
             (product L
                (\j.
                     1 -
                     real
                       ((1 - Rel p (X (2*j)) t) *
                        (1 - Rel p (X (2*j+1)) t))))) ``,



REPEAT (GEN_TAC)
THEN DISCH_TAC
THEN DEP_REWRITE_TAC[PROB_DRBD_SEN_network]
THEN RW_TAC std_ss[]);



val PROB_DRBD_SEN_network_spares = store_thm("PROB_DRBD_SEN_network_spares",
  `` ! p L1 L2 L3 L4 L X Y Ysa Ysd t. SEN_network_set_req p L1 L2 L3 L4 L 
                (\i:num.
                if i IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {i}
                else ind_set [{0}; L1; L2; L3; L4] i)
		(\j.
                if j IN L then {2 * j; 2 * j + 1:num}
                else ind_set [{0}; {1}; {}; {2:num; 3}; {4}] j) ({0; 1; 3; 4} UNION L) 
               (event_set
               [(DRBD_event p (R_WSP (Y 0) (Ysa 0) (Ysd 0)) t,0)] (rv_to_event p X t)) /\
	        (!i:num. i IN L1 ==>  (X i = R_WSP (Y i) (Ysa i) (Ysd i))) ==>

(prob p
             (DRBD_event p (nR_AND
                (\i.
                     if i = 0 then R_WSP (Y 0) (Ysa 0) (Ysd 0)
                     else if i = 1 then nR_AND X L1
                     else if i = 3 then R_OR (nR_AND X L2) (nR_AND X L3)
                     else if i = 4 then nR_AND X L4
                     else R_OR (X (2 * i)) (X (2 * i + 1)))
                ({0; 1; 3; 4} UNION L)) t) =
           Normal (product ({0} UNION L1) (\l. real (Rel p (R_WSP (Y l) (Ysa l) (Ysd l) ) t ))) *
           (1 -
            (1 - Normal (product L2 (\l. real (Rel p (X l) t)))) *
            (1 - Normal (product L3 (\l. real (Rel p (X l) t))))) *
           Normal (product L4 (\l. real (Rel p (X l) t ))) *
           Normal
             (product L
                (\j.
                     1 -
                     real
                       ((1 - Rel p (X (2*j)) t) *
                        (1 - Rel p (X (2*j+1)) t))))) ``,



REPEAT (GEN_TAC)
THEN DISCH_TAC
THEN DEP_REWRITE_TAC[PROB_DRBD_SEN_network_one_spare]
THEN RW_TAC std_ss[]
THEN KNOW_TAC(``  Rel p (R_WSP (Y 0) (Ysa 0) (Ysd 0)) t *
   Normal (product L1 (\l:num. real (Rel p (X l) t)))  =
     Normal
     (product ({0} UNION L1)
        (\l. real (Rel p (R_WSP (Y l) (Ysa l) (Ysd l)) t)))  ``)
    THEN1(FULL_SIMP_TAC std_ss[SEN_network_set_req_def]
          THEN UNDISCH_TAC(`` disjoint_family_on
           (ind_set
              [{0:num}; L1; L2; L3; L4;
               {2 * i | i IN L} UNION {2 * i + 1 | i IN L}])
           {0; 1; 2; 3; 4; 5}``)
	  THEN RW_TAC std_ss[disjoint_family_on]
	  THEN POP_ASSUM(MP_TAC o Q.SPEC `0`)
	  THEN DISCH_TAC
	  THEN POP_ASSUM (MP_TAC o Q.SPEC `1`)
	  THEN RW_TAC std_ss[] 
	  THEN FULL_SIMP_TAC list_ss[ind_set_def]
	  THEN `DISJOINT {0:num} L1` by ASM_SET_TAC[]
	  THEN `FINITE {0:num}` by RW_TAC std_ss[FINITE_SING]	 
	  THEN RW_TAC std_ss[PRODUCT_UNION]
	  THEN RW_TAC std_ss[GSYM extreal_mul_def]
	  THEN RW_TAC std_ss[PRODUCT_SING]
	  THEN FULL_SIMP_TAC std_ss[indep_sets]
	  THEN FULL_SIMP_TAC std_ss[event_set_def, event_set1_def]
	  THEN UNDISCH_TAC(``  !(i :num).
             i IN
             BIGUNION_o_BIGUNION
               (\ (i :num).
                    if
                      i IN {(2 :num) * i | i IN (L :num -> bool)} \/
                      i IN {(2 :num) * i + (1 :num) | i IN L}
                    then
                      {i}
                    else
                      EL i
                        [{(0 :num)}; (L1 :num -> bool); (L2 :num -> bool);
                         (L3 :num -> bool); (L4 :num -> bool)])
               (\ (j :num).
                    if j IN L then {(2 :num) * j; (2 :num) * j + (1 :num)}
                    else
                      EL j
                        [{(0 :num)}; {(1 :num)}; ({} :num -> bool);
                         {(2 :num); (3 :num)}; {(4 :num)}])
               ({(0 :num); (1 :num); (3 :num); (4 :num)} UNION L) ==>
             {if i = (0 :num) then
                DRBD_event
                  (p :
                     ('a -> bool) #
                     (('a -> bool) -> bool) # (('a -> bool) -> extreal))
                  (R_WSP ((Y :num -> 'a -> extreal) (0 :num))
                     ((Ysa :num -> 'a -> extreal) (0 :num))
                     ((Ysd :num -> 'a -> extreal) (0 :num))) (t :real)
              else rv_to_event p (X :num -> 'a -> extreal) t i} SUBSET
             events p ``)
	  THEN DISCH_TAC   
	  THEN POP_ASSUM (MP_TAC o Q.SPEC `0:num`)
	  THEN RW_TAC std_ss[]
	  THEN KNOW_TAC(``0:num IN  BIGUNION_o_BIGUNION
               (\ (i :num).
                    if
                      i IN {(2 :num) * i | i IN (L :num -> bool)} \/
                      i IN {(2 :num) * i + (1 :num) | i IN L}
                    then
                      {i}
                    else
                      EL i
                        [{(0 :num)}; (L1 :num -> bool); (L2 :num -> bool);
                         (L3 :num -> bool); (L4 :num -> bool)])
               (\ (j :num).
                    if j IN L then {(2 :num) * j; (2 :num) * j + (1 :num)}
                    else
                      EL j
                        [{(0 :num)}; {(1 :num)}; ({} :num -> bool);
                         {(2 :num); (3 :num)}; {(4 :num)}])
               ({(0 :num); (1 :num); (3 :num); (4 :num)} UNION L) ``)
	      THEN1 (RW_TAC std_ss[BIGUNION_o_BIGUNION_def]
	             THEN RW_TAC list_ss[ind_set_def]
		     THEN PSET_TAC[BIGUNION_o_BIGUNION_def]
		     THEN Q.EXISTS_TAC`{0}`
		     THEN RW_TAC std_ss[]
		          THEN1 ASM_SET_TAC[] 
		     THEN Q.EXISTS_TAC`0`
		     THEN RW_TAC list_ss[]
		     THEN Q.EXISTS_TAC`{0}`
		     THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
		     THEN Q.EXISTS_TAC`0`
		     THEN RW_TAC list_ss[])
        THEN RW_TAC std_ss[Rel_def]
	THEN FULL_SIMP_TAC std_ss[]
	THEN KNOW_TAC(``DRBD_event p (R_WSP (Y (0:num)) (Ysa (0:num)) (Ysd (0:num))) t IN events p ``)
	     THEN1 ASM_SET_TAC[]
	THEN DISCH_TAC
	THEN `prob p (DRBD_event p (R_WSP (Y (0:num)) (Ysa (0:num)) (Ysd (0:num))) t) <> PosInf /\
	     prob p (DRBD_event p (R_WSP (Y 0) (Ysa 0) (Ysd 0)) t) <> NegInf` by RW_TAC std_ss[PROB_FINITE]
	THEN RW_TAC std_ss[normal_real]
	THEN KNOW_TAC(``!l:num. l IN L1 ==> (real (prob p (DRBD_event p (X l) t)) = real (prob p (DRBD_event p (R_WSP (Y l) (Ysa l) (Ysd l)) t))) ``)
            THEN1(RW_TAC std_ss[])
	THEN RW_TAC std_ss[]    
	THEN AP_TERM_TAC
	THEN RW_TAC std_ss[th] )
THEN RW_TAC std_ss[] );



(* ========================================================================== *)
(*                                                                            *)
(*                              DFT                                           *)
(*                                                                            *)
(* ========================================================================== *)


val PROB_SEN_network_DFT_lem1 = store_thm("PROB_SEN_network_DFT_lem1",
  ``!p L1 L2 L3 L4 L X t LL A J .
          FINITE L1 /\ L1 <> {} /\ FINITE L2 /\ L2 <> {} /\ FINITE L3 /\
          L3 <> {} /\ FINITE L4 /\ L4 <> {} /\ FINITE L /\
          DISJOINT {0; 1; 3; 4:num} L /\
	  (!i j. i IN L /\ j IN L /\ i <> j ==> DISJOINT {2*i; 2*i+1} {2*j; 2*j+1})/\
          (!i:num. i IN L ==> DISJOINT {2 * i; 2 * i + 1} {0; 1; 2; 3; 4}) /\
	  
	  indep_sets p (\i.  {X i}) (BIGUNION_o_BIGUNION LL A J)  /\
	  
	 disjoint_family_on
	    (ind_set[{0:num}; L1; L2; L3; L4; ({2*i|i IN L} UNION {2*i+1| i IN L})])
	       {0;1;2;3;4;5} /\
	       (J = ({0;1;3;4} UNION L)) /\
	       (A = (\j. if j IN L then {2*j; 2*j+1} else ( ind_set[{0}; {1}; {} ;{2;3}; {4}] j) )) /\
	       (LL = (\i. if i IN ({2*i|i IN L} UNION {2*i+1| i IN L}) then {i} else  (ind_set[{0}; L1; L2; L3; L4] i))) ==>
 (prob p
               (bigunion
                  (\j.
                       biginter
                         (\a.
                              bigunion
                                X (LL a))
                         (A j)) J) = 1 -
   (1 - prob p (X 0)) * Normal (product L1 (\l. real (1 - prob p (X l)))) *
   (1 -
    (1 - Normal (product L2 (\l. real (1 - prob p (X l))))) *
    (1 - Normal (product L3 (\l. real (1 - prob p (X l)))))) *
   Normal (product L4 (\l. real (1 - prob p (X l)))) *
   Normal
     (product L (\j. 1 - real (prob p (X (2 * j)) * prob p (X (2 * j + 1))))))``,

RW_TAC std_ss[disjoint_family_on]
THEN KNOW_TAC(``DISJOINT {0:num} L1 ``)
     THEN1(POP_ASSUM (MP_TAC o Q.SPEC `0`)
          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `1`)
	  THEN RW_TAC list_ss[ind_set_def, DISJOINT_DEF])
	  
THEN KNOW_TAC(``DISJOINT {0:num} L2 ``)
     THEN1(POP_ASSUM (MP_TAC o Q.SPEC `0`)
          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `2`)
	  THEN RW_TAC list_ss[ind_set_def, DISJOINT_DEF])


THEN KNOW_TAC(``DISJOINT {0:num} L3 ``)
     THEN1(POP_ASSUM (MP_TAC o Q.SPEC `0`)
          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `3`)
	  THEN RW_TAC list_ss[ind_set_def, DISJOINT_DEF])


THEN KNOW_TAC(``DISJOINT {0:num} L4 ``)
     THEN1(POP_ASSUM (MP_TAC o Q.SPEC `0`)
          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `4`)
	  THEN RW_TAC list_ss[ind_set_def, DISJOINT_DEF])

THEN KNOW_TAC(``DISJOINT {0:num} ({2 * i | i IN L} UNION {2 * i + 1 | i IN L}) ``)
     THEN1(POP_ASSUM (MP_TAC o Q.SPEC `0`)
          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `5`)
	  THEN RW_TAC list_ss[ind_set_def, DISJOINT_DEF])

THEN KNOW_TAC(``DISJOINT  (L1:num->bool) L2 ``)
     THEN1(POP_ASSUM (MP_TAC o Q.SPEC `1`)
          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `2`)
	  THEN RW_TAC list_ss[ind_set_def, DISJOINT_DEF])
	  
THEN KNOW_TAC(``DISJOINT  (L1:num->bool) L3 ``)
     THEN1(POP_ASSUM (MP_TAC o Q.SPEC `1`)
          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `3`)
	  THEN RW_TAC list_ss[ind_set_def, DISJOINT_DEF])
	  
THEN KNOW_TAC(``DISJOINT  (L1:num->bool) L4 ``)
     THEN1(POP_ASSUM (MP_TAC o Q.SPEC `1`)
          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `4`)
	  THEN RW_TAC list_ss[ind_set_def, DISJOINT_DEF])
	  

THEN KNOW_TAC(``DISJOINT  (L1:num->bool) ({2 * i | i IN L} UNION {2 * i + 1 | i IN L} )``)
     THEN1(POP_ASSUM (MP_TAC o Q.SPEC `1`)
          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `5`)
	  THEN RW_TAC list_ss[ind_set_def, DISJOINT_DEF])
	  
THEN KNOW_TAC(``DISJOINT  (L2:num->bool) L3 ``)
     THEN1(POP_ASSUM (MP_TAC o Q.SPEC `2`)
          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `3`)
	  THEN RW_TAC list_ss[ind_set_def, DISJOINT_DEF])

THEN KNOW_TAC(``DISJOINT  (L2:num->bool) L4 ``)
     THEN1(POP_ASSUM (MP_TAC o Q.SPEC `2`)
          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `4`)
	  THEN RW_TAC list_ss[ind_set_def, DISJOINT_DEF])

THEN KNOW_TAC(``DISJOINT  (L2:num->bool)  ({2 * i | i IN L} UNION {2 * i + 1 | i IN L} ) ``)
     THEN1(POP_ASSUM (MP_TAC o Q.SPEC `2`)
          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `5`)
	  THEN RW_TAC list_ss[ind_set_def, DISJOINT_DEF])

THEN KNOW_TAC(``DISJOINT  (L3:num->bool) L4 ``)
     THEN1(POP_ASSUM (MP_TAC o Q.SPEC `3`)
          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `4`)
	  THEN RW_TAC list_ss[ind_set_def, DISJOINT_DEF])

THEN KNOW_TAC(``DISJOINT  (L3:num->bool) ({2 * i | i IN L} UNION {2 * i + 1 | i IN L} ) ``)
     THEN1(POP_ASSUM (MP_TAC o Q.SPEC `3`)
          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `5`)
	  THEN RW_TAC list_ss[ind_set_def, DISJOINT_DEF])

THEN KNOW_TAC(``DISJOINT  (L4:num->bool) ({2 * i | i IN L} UNION {2 * i + 1 | i IN L} ) ``)
     THEN1(POP_ASSUM (MP_TAC o Q.SPEC `4`)
          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `5`)
	  THEN RW_TAC list_ss[ind_set_def, DISJOINT_DEF])


THEN RW_TAC std_ss[]


THEN  MP_TAC(Q.ISPECL [`p:('a->bool)#(('a->bool)->bool)#(('a->bool)->extreal)`, `X:num->'a->bool`, `(\a:num. if
                         a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L}
                       then
                         {a}
                       else ind_set [{0:num}; L1; L2; L3; L4] a)`, `(\j:num. (if j IN L then {2 * j; 2 * j + 1}
                else ind_set [{0:num}; {1}; {}; {2; 3}; {4}] j))`, `(\i:num. {0:num; 1; 3; 4} UNION L)`, `j:num`] PROB_bigunion_biginter_bigunion_lem2)

THEN RW_TAC std_ss[]
THEN KNOW_TAC(``sets_finite_not_empty
           (\a:num.
                if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
                else ind_set [{0:num}; L1; L2; L3; L4] a)
           (\j:num.
                if j IN L then {2 * j; 2 * j + 1}
                else ind_set [{0:num}; {1}; {}; {2; 3}; {4}] j)
           (\i:num. {0:num; 1; 3; 4} UNION L) {j} ``)
      THEN1 (RW_TAC std_ss[sets_finite_not_empty_def]
       	    THEN1 ASM_SET_TAC[]
	    THEN1 RW_TAC std_ss[FINITE_UNION, FINITE_4]
	    THEN1( PSET_TAC[]
	           THEN1 ASM_SET_TAC[]
		   THEN1 ASM_SET_TAC[]  
		   THEN1 ASM_SET_TAC[]  
		   THEN1 ASM_SET_TAC[]  
		   THEN1 ASM_SET_TAC[]  
		   THEN1 ASM_SET_TAC[]  
		   THEN1 ASM_SET_TAC[]  
		   THEN1 ASM_SET_TAC[]  
		   THEN1 ASM_SET_TAC[]  
		   THEN1 ASM_SET_TAC[]  
		   THEN1 ASM_SET_TAC[]  
		   THEN1 ASM_SET_TAC[]  
		   THEN1(FULL_SIMP_TAC list_ss[ind_set_def]
		         THEN ASM_SET_TAC[])
		   THEN1(FULL_SIMP_TAC list_ss[ind_set_def] THEN ASM_SET_TAC[])	 
		   THEN1(FULL_SIMP_TAC list_ss[ind_set_def] THEN ASM_SET_TAC[])	 
		   THEN1(FULL_SIMP_TAC list_ss[ind_set_def] THEN ASM_SET_TAC[])	 
		   THEN1(FULL_SIMP_TAC list_ss[ind_set_def] THEN ASM_SET_TAC[])
		   THEN FULL_SIMP_TAC list_ss[ind_set_def] THEN ASM_SET_TAC[])
	   THEN1(PSET_TAC[] THEN FULL_SIMP_TAC list_ss[ind_set_def]
	         THEN1 RW_TAC std_ss[FINITE_SING]
		 THEN1 RW_TAC std_ss[FINITE_SING]
		 THEN1 RW_TAC std_ss[FINITE_SING]
		 THEN1 RW_TAC std_ss[FINITE_SING]
		 THEN1 RW_TAC std_ss[FINITE_SING]
		 THEN1 RW_TAC std_ss[FINITE_SING]
		 THEN1 RW_TAC std_ss[FINITE_SING]
		 THEN1 RW_TAC std_ss[FINITE_SING]
		 THEN1 RW_TAC std_ss[FINITE_SING]
		 THEN1 RW_TAC std_ss[FINITE_SING]
		 THEN1 RW_TAC std_ss[FINITE_SING]
		 THEN1 RW_TAC std_ss[FINITE_SING]
		 THEN1 ASM_SET_TAC[]
		 THEN ASM_SET_TAC[])
	  THEN1(RW_TAC list_ss[ind_set_def]
	        THEN1 ASM_SET_TAC[]
		THEN PSET_TAC[]
		THEN RW_TAC list_ss[] THEN ASM_SET_TAC[])
	  THEN1(PSET_TAC[] THEN RW_TAC list_ss[ind_set_def] THEN RW_TAC std_ss[FINITE_UNION, FINITE_PAIR, FINITE_4, FINITE_SING])
	  THEN1 (RW_TAC std_ss[FINITE_SING])
	  THEN1(RW_TAC std_ss[disjoint_family_on]
                 THEN1(ASM_SET_TAC[])
		 THEN ASM_SET_TAC[])
	 THEN1(RW_TAC std_ss[disjoint_family_on]
	       THEN RW_TAC list_ss[ind_set_def]
	       THEN PSET_TAC[] THEN FULL_SIMP_TAC list_ss[ind_set_def] THEN ASM_SET_TAC[])
	       
	 THEN1(RW_TAC std_ss[disjoint_family_on]
	       THEN RW_TAC list_ss[ind_set_def]
	       THEN1 ASM_SET_TAC[]
	       THEN1 ASM_SET_TAC[]
	       THEN1 ASM_SET_TAC[]
	       THEN1 ASM_SET_TAC[]
	       THEN1(PSET_TAC[]
	             THEN RW_TAC list_ss[] THEN FULL_SIMP_TAC list_ss[ind_set_def] THEN PSET_TAC[] THEN ASM_SET_TAC[])
	       THEN1 (FULL_SIMP_TAC list_ss[ind_set_def] THEN PSET_TAC[] THEN FULL_SIMP_TAC list_ss[] THEN ASM_SET_TAC[])
	       THEN1 (FULL_SIMP_TAC list_ss[ind_set_def] THEN PSET_TAC[] THEN FULL_SIMP_TAC list_ss[] THEN ASM_SET_TAC[])
	       THEN1 (FULL_SIMP_TAC list_ss[ind_set_def] THEN PSET_TAC[] THEN FULL_SIMP_TAC list_ss[] THEN ASM_SET_TAC[])
	       THEN  FULL_SIMP_TAC list_ss[ind_set_def] THEN PSET_TAC[] THEN FULL_SIMP_TAC list_ss[] THEN ASM_SET_TAC[])
	 THEN RW_TAC std_ss[disjoint_family_on, ind_set_def]
	 THEN PSET_TAC[]
	      THEN1 (SRW_TAC[][GSPECIFICATION, EXTENSION] THEN RW_TAC arith_ss[])
      
	       THEN1(RW_TAC list_ss[ind_set_def]
	             THEN UNDISCH_TAC(`` !i:num.
             i IN L ==>
             (i <> 0 /\ 2 * i + 1 <> 2 /\ 2 * i + 1 <> 3 /\ 2 * i + 1 <> 4) /\
             i <> 0 /\ i <> 1 /\ i <> 2 ``)
	                THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `j'`)
	     		THEN RW_TAC std_ss[]
			THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
			THEN RW_TAC arith_ss[])
		   THEN1(RW_TAC list_ss[ind_set_def] THEN UNDISCH_TAC(`` !i:num.
             i IN L ==>
             (i <> 0 /\ 2 * i + 1 <> 2 /\ 2 * i + 1 <> 3 /\ 2 * i + 1 <> 4) /\
             i <> 0 /\ i <> 1 /\ i <> 2 ``)
	                THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `j'`)
	     		THEN RW_TAC std_ss[]
			THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
			THEN RW_TAC arith_ss[])	
                  THEN1( UNDISCH_TAC(`` !i:num.
             i IN L ==>
             (i <> 0 /\ 2 * i + 1 <> 2 /\ 2 * i + 1 <> 3 /\ 2 * i + 1 <> 4) /\
             i <> 0 /\ i <> 1 /\ i <> 2 ``)
	                THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `j'`)
	     		THEN RW_TAC std_ss[]
			THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
			THEN RW_TAC arith_ss[])
	      THEN1(PSET_TAC[] THEN RW_TAC list_ss[]
	            THEN UNDISCH_TAC(`` !i:num.
             i IN L ==>
             (i <> 0 /\ 2 * i + 1 <> 2 /\ 2 * i + 1 <> 3 /\ 2 * i + 1 <> 4) /\
             i <> 0 /\ i <> 1 /\ i <> 2 ``)
	                THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `j'`)
	     		THEN RW_TAC std_ss[]
			THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
			THEN RW_TAC arith_ss[])
	     THEN1( PSET_TAC[] THEN RW_TAC list_ss[] THEN ASM_SET_TAC[])
	      THEN1(PSET_TAC[] THEN RW_TAC list_ss[]
	            THEN UNDISCH_TAC(`` !i:num.
             i IN L ==>
             (i <> 0 /\ 2 * i + 1 <> 2 /\ 2 * i + 1 <> 3 /\ 2 * i + 1 <> 4) /\
             i <> 0 /\ i <> 1 /\ i <> 2 ``)
	                THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `j''`)
	     		THEN RW_TAC std_ss[]
			THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
			THEN RW_TAC arith_ss[])
	    THEN1(PSET_TAC[] THEN RW_TAC list_ss[]
	            THEN UNDISCH_TAC(`` !i:num.
             i IN L ==>
             (i <> 0 /\ 2 * i + 1 <> 2 /\ 2 * i + 1 <> 3 /\ 2 * i + 1 <> 4) /\
             i <> 0 /\ i <> 1 /\ i <> 2 ``)
	                THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `j''`)
	     		THEN RW_TAC std_ss[]
			THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
			THEN RW_TAC arith_ss[])
	      THEN1(PSET_TAC[] THEN RW_TAC list_ss[]
	            THEN UNDISCH_TAC(`` !i:num.
             i IN L ==>
             (i <> 0 /\ 2 * i + 1 <> 2 /\ 2 * i + 1 <> 3 /\ 2 * i + 1 <> 4) /\
             i <> 0 /\ i <> 1 /\ i <> 2 ``)
	                THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `j''`)
	     		THEN RW_TAC std_ss[]
			THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
			THEN RW_TAC arith_ss[])
	     THEN RW_TAC list_ss[] THEN PSET_TAC[] THEN ASM_SET_TAC[])

THEN DISCH_TAC THEN FULL_SIMP_TAC std_ss[]	     
THEN `FINITE {0;1;3;4:num}` by RW_TAC std_ss[FINITE_4]
THEN `DISJOINT {0;1;3;4:num} L` by ASM_SET_TAC[]
THEN RW_TAC std_ss[PRODUCT_UNION]
THEN `({0;1;3;4:num} = {0;1;3} UNION {4} )/\ DISJOINT {0;1;3} {4:num}` by ASM_SET_TAC[]
THEN RW_TAC std_ss[PRODUCT_UNION, FINITE_3, FINITE_SING]
THEN `({0;1;3:num} = {0;1} UNION {3}) /\ DISJOINT {0;1} {3:num}` by ASM_SET_TAC[]
THEN RW_TAC std_ss[PRODUCT_UNION, FINITE_PAIR, FINITE_SING]
THEN `({0;1:num} = {0} UNION {1}) /\ DISJOINT {0:num} {1}` by ASM_SET_TAC[]
THEN RW_TAC std_ss[PRODUCT_UNION,  FINITE_SING]
THEN REWRITE_TAC[PRODUCT_SING]
THEN KNOW_TAC(``(\j.
           real
             (1 -
              Normal
                (product
                   (if j IN L then {2 * j; 2 * j + 1}
                    else ind_set [{0}; {1}; {}; {2; 3}; {4}] j)
                   (\a.
                        real
                          (1 -
                           Normal
                             (product
                                (if
                                   a IN
                                   {2 * i | i IN L} UNION
                                   {2 * i + 1 | i IN L}
                                 then
                                   {a}
                                 else ind_set [{0}; L1; L2; L3; L4] a)
                                (\i. real (1 - prob p (X i))))))))) 0 = real (1- prob p (X 0))``)
	THEN1(RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
              THEN RW_TAC list_ss[ind_set_def]
	      THEN RW_TAC std_ss[PRODUCT_SING]
	      THEN1 ASM_SET_TAC[]
	      THEN1 ASM_SET_TAC[]
	      THEN RW_TAC list_ss[]
	      THEN RW_TAC list_ss[PRODUCT_SING]
	      THEN `1 <> PosInf /\ 1 <> NegInf` by RW_TAC std_ss[extreal_of_num_def, extreal_not_infty]
	      THEN KNOW_TAC(``prob p ((X:num->'a->bool) 0) <> PosInf /\ prob p (X 0) <> NegInf ``)
	           THEN1(FULL_SIMP_TAC list_ss[indep_sets]
		          THEN KNOW_TAC(``(X:num->'a->bool) 0 IN events p ``)
			       THEN1(UNDISCH_TAC(`` !i:num.
             i IN
             BIGUNION_o_BIGUNION
               (\i.
                    if
                      i IN {2 * i | i IN L} \/ i IN {2 * i + 1 | i IN L}
                    then
                      {i}
                    else ind_set [{0}; L1; L2; L3; L4] i)
               (\j.
                    if j IN L then {2 * j; 2 * j + 1}
                    else ind_set [{0}; {1}; {}; {2; 3}; {4}] j)
               ({0} UNION {1} UNION {3} UNION {4} UNION L) ==>
             {X i} SUBSET events p``)
	                          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `0`)
				  THEN DISCH_TAC
				  THEN KNOW_TAC(`` 0:num IN
    BIGUNION_o_BIGUNION
      (\i.
           if i IN {2 * i | i IN L} \/ i IN {2 * i + 1 | i IN L} then {i}
           else ind_set [{0}; L1; L2; L3; L4] i)
      (\j.
           if j IN L then {2 * j; 2 * j + 1}
           else ind_set [{0}; {1}; {}; {2; 3}; {4}] j)
      ({0} UNION {1} UNION {3} UNION {4} UNION L)``)
				  THEN1(RW_TAC std_ss[BIGUNION_o_BIGUNION_def]
				        THEN RW_TAC list_ss[ind_set_def]
					THEN PSET_TAC[BIGUNION_o_BIGUNION_def]
					THEN Q.EXISTS_TAC`{0}`
					THEN RW_TAC std_ss[]
					THEN1 ASM_SET_TAC[] 
					THEN Q.EXISTS_TAC`0`
					THEN RW_TAC list_ss[]
					THEN Q.EXISTS_TAC`{0}`
					THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
					THEN Q.EXISTS_TAC`0`
					THEN RW_TAC list_ss[])

                                 THEN RW_TAC std_ss[]
				 THEN FULL_SIMP_TAC list_ss[] THEN ASM_SET_TAC[])
		THEN `prob_space p` by FULL_SIMP_TAC std_ss[indep_sets]
		THEN RW_TAC std_ss[PROB_FINITE])
	 THEN RW_TAC std_ss[normal_real, sub_not_infty]
	 THEN RW_TAC std_ss[extreal_sub_sub2])
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
THEN KNOW_TAC(`` (\j.
           real
             (1 -
              Normal
                (product
                   (if j IN L then {2 * j; 2 * j + 1}
                    else ind_set [{0}; {1}; {}; {2; 3}; {4}] j)
                   (\a.
                        real
                          (1 -
                           Normal
                             (product
                                (if
                                   a IN
                                   {2 * i | i IN L} UNION
                                   {2 * i + 1 | i IN L}
                                 then
                                   {a}
                                 else ind_set [{0}; L1; L2; L3; L4] a)
                                (\i. real (1 - prob p (X i))))))))) 1 =
				product L1 (\l. real (1- prob p (X l)))``)

    THEN1(RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
          THEN RW_TAC list_ss[ind_set_def]
          THEN RW_TAC std_ss[PRODUCT_SING] THEN1 ASM_SET_TAC[]
	       THEN1 ASM_SET_TAC[]
	  THEN RW_TAC list_ss[]
	  THEN RW_TAC std_ss[extreal_sub_sub2,normal_real, sub_not_infty, extreal_of_num_def, extreal_not_infty, real_normal])
      
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]

THEN KNOW_TAC(`` (\j.
           real
             (1 -
              Normal
                (product
                   (if j IN L then {2 * j; 2 * j + 1}
                    else ind_set [{0}; {1}; {}; {2; 3}; {4}] j)
                   (\a.
                        real
                          (1 -
                           Normal
                             (product
                                (if
                                   a IN
                                   {2 * i | i IN L} UNION
                                   {2 * i + 1 | i IN L}
                                 then
                                   {a}
                                 else ind_set [{0}; L1; L2; L3; L4] a)
                                (\i. real (1 - prob p (X i))))))))) 3 =1 -
   (1 - product L2 (\l. real (1- prob p (X l)))) *  (1- product L3 (\l. real (1- prob p (X l))))``)

    THEN1(RW_TAC std_ss[ind_set_def] THEN1 ASM_SET_TAC[]
          THEN RW_TAC list_ss[]
	  THEN `{2;3:num} = {2} UNION {3} `by ASM_SET_TAC[]
	  THEN `DISJOINT {2}{3:num}` by ASM_SET_TAC[]
	  THEN RW_TAC std_ss[FINITE_SING, PRODUCT_UNION]
	  THEN RW_TAC std_ss[PRODUCT_SING]
	      THEN1 ASM_SET_TAC[]
	      THEN1 ASM_SET_TAC[]
	      THEN1 ASM_SET_TAC[]
	      THEN1 ASM_SET_TAC[]
	      THEN1 ASM_SET_TAC[]
	      THEN1 ASM_SET_TAC[]
	      THEN1 ASM_SET_TAC[]
	      THEN1 ASM_SET_TAC[]
          THEN RW_TAC list_ss[]
	  THEN RW_TAC std_ss[normal_real, real_normal,extreal_of_num_def, extreal_not_infty, sub_not_infty]
	  THEN RW_TAC std_ss[extreal_sub_def,extreal_sub_sub2, real_normal])
	  
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
THEN KNOW_TAC(``(\j.
           real
             (1 -
              Normal
                (product
                   (if j IN L then {2 * j; 2 * j + 1}
                    else ind_set [{0}; {1}; {}; {2; 3}; {4}] j)
                   (\a.
                        real
                          (1 -
                           Normal
                             (product
                                (if
                                   a IN
                                   {2 * i | i IN L} UNION
                                   {2 * i + 1 | i IN L}
                                 then
                                   {a}
                                 else ind_set [{0}; L1; L2; L3; L4] a)
                                (\i. real (1 - prob p (X i))))))))) 4  = product L4 (\l. real (1- prob p (X l)))``)
	THEN1(RW_TAC list_ss[ind_set_def] THEN1 ASM_SET_TAC[]
	      THEN RW_TAC list_ss[PRODUCT_SING]
	      THEN1 (PSET_TAC[] THEN ASM_SET_TAC[])
	      THEN1(PSET_TAC[] THEN ASM_SET_TAC[])
	      THEN RW_TAC std_ss[normal_real, extreal_of_num_def, extreal_not_infty, sub_not_infty]
              THEN RW_TAC std_ss[extreal_sub_sub2, real_normal])
	
THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
THEN KNOW_TAC(``!j. j IN L ==>
(real
               (1 -
                Normal
                  (product
                     (if j IN L then {2 * j; 2 * j + 1}
                      else ind_set [{0}; {1}; {}; {2; 3}; {4}] j)
                     (\a.
                          real
                            (1 -
                             Normal
                               (product
                                  (if
                                     a IN
                                     {2 * i | i IN L} UNION
                                     {2 * i + 1 | i IN L}
                                   then
                                     {a}
                                   else ind_set [{0}; L1; L2; L3; L4] a)
                                  (\i. real (1 - prob p (X i)))))))) =
					  1 - real (prob p (X (2 * j)) * prob p (X (2 * j + 1))))``)
     THEN1(RW_TAC std_ss[]
          THEN `{2 * j'; 2 * j' + 1} = {2*j'} UNION {2*j'+1:num}` by ASM_SET_TAC[]
	  THEN KNOW_TAC(``DISJOINT  {2*j'}  {2*j'+1:num}``)
	       THEN1(PSET_TAC[]
	             THEN `2*j'+1:num = SUC (2*j')` by RW_TAC std_ss[GSYM ADD1]
	  	     THEN `2*j' < SUC (2*j')` by RW_TAC std_ss[]
	  	     THEN ONCE_ASM_REWRITE_TAC[]
	  	     THEN RW_TAC std_ss[LESS_NOT_EQ])
	THEN RW_TAC std_ss[PRODUCT_UNION, FINITE_SING]
	THEN RW_TAC std_ss[PRODUCT_SING]		  
	     THEN1(KNOW_TAC(``(X:num->'a->bool) (2*j') IN events p ``)
	           THEN1(FULL_SIMP_TAC std_ss[indep_sets]
		         THEN UNDISCH_TAC(`` !i:num.
             i IN
             BIGUNION_o_BIGUNION
               (\i.
                    if i IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then
                      {i}
                    else ind_set [{0}; L1; L2; L3; L4] i)
               (\j.
                    if j IN L then {2 * j; 2 * j + 1}
                    else ind_set [{0}; {1}; {}; {2; 3}; {4}] j)
               ({0} UNION {1} UNION {3} UNION {4} UNION L) ==>
             {X i} SUBSET events p``)
	                 THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `2*j'`)
			 THEN DISCH_TAC
			 THEN KNOW_TAC(``   (2 * j' IN
    BIGUNION_o_BIGUNION
      (\i.
           if i IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {i}
           else ind_set [{0}; L1; L2; L3; L4] i)
      (\j.
           if j IN L then {2 * j; 2 * j + 1}
           else ind_set [{0}; {1}; {}; {2; 3}; {4}] j)
      ({0} UNION {1} UNION {3} UNION {4} UNION L))``)
                              THEN1(RW_TAC std_ss[BIGUNION_o_BIGUNION_def]
			            THEN PSET_TAC[] 
				         THEN1 ASM_SET_TAC[]
					 THEN1 (Q.EXISTS_TAC`{2 * i'}`
					        THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
						THEN Q.EXISTS_TAC`2*i'`
						THEN RW_TAC std_ss[]
						     THEN1 (PSET_TAC[] THEN ASM_SET_TAC[])
						THEN Q.EXISTS_TAC`{2 * i'; 2*i'+1}`
						THEN RW_TAC std_ss[]
						      THEN1 ASM_SET_TAC[]
						THEN Q.EXISTS_TAC`i'`
						THEN RW_TAC list_ss[])
					 THEN1(	Q.EXISTS_TAC`{2 * i'+1}`
					        THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
						THEN Q.EXISTS_TAC`2*i'+1`
						THEN RW_TAC std_ss[]
						     THEN1 (PSET_TAC[] THEN ASM_SET_TAC[])
						THEN Q.EXISTS_TAC`{2 * i'; 2*i'+1}`
						THEN RW_TAC std_ss[]
						      THEN1 ASM_SET_TAC[]
						THEN Q.EXISTS_TAC`i'`
						THEN RW_TAC list_ss[])
				    THEN PSET_TAC[] THEN ASM_SET_TAC[])
			    THEN RW_TAC std_ss[]
			    THEN ASM_SET_TAC[])
		 THEN RW_TAC std_ss[]	    
		  THEN `prob p (X (2*j')) <> PosInf /\ prob p ((X:num->'a->bool)(2*j')) <> NegInf` by FULL_SIMP_TAC std_ss[indep_sets, PROB_FINITE]	    
		  THEN KNOW_TAC(``(X:num->'a->bool) (2*j'+1) IN events p ``)
	           THEN1(FULL_SIMP_TAC std_ss[indep_sets]
		         THEN UNDISCH_TAC(`` !i:num.
             i IN
             BIGUNION_o_BIGUNION
               (\i.
                    if i IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then
                      {i}
                    else ind_set [{0}; L1; L2; L3; L4] i)
               (\j.
                    if j IN L then {2 * j; 2 * j + 1}
                    else ind_set [{0}; {1}; {}; {2; 3}; {4}] j)
               ({0} UNION {1} UNION {3} UNION {4} UNION L) ==>
             {X i} SUBSET events p``)
	                 THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `2*j'+1`)
			 THEN DISCH_TAC
			 THEN KNOW_TAC(``   (2 * j'+1 IN
    BIGUNION_o_BIGUNION
      (\i.
           if i IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {i}
           else ind_set [{0}; L1; L2; L3; L4] i)
      (\j.
           if j IN L then {2 * j; 2 * j + 1}
           else ind_set [{0}; {1}; {}; {2; 3}; {4}] j)
      ({0} UNION {1} UNION {3} UNION {4} UNION L))``)
                              THEN1(RW_TAC std_ss[BIGUNION_o_BIGUNION_def]
			            THEN PSET_TAC[] 
				         THEN1 ASM_SET_TAC[]
					 THEN1 (Q.EXISTS_TAC`{2 * i'+1}`
					        THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
						THEN Q.EXISTS_TAC`2*i'+1`
						THEN RW_TAC std_ss[]
						     THEN1 (PSET_TAC[] THEN ASM_SET_TAC[])
						THEN Q.EXISTS_TAC`{2 * i'; 2*i'+1}`
						THEN RW_TAC std_ss[]
						      THEN1 ASM_SET_TAC[]
						THEN Q.EXISTS_TAC`i'`
						THEN RW_TAC list_ss[])
					 THEN1(	Q.EXISTS_TAC`{2 * i'}`
					        THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
						THEN Q.EXISTS_TAC`2*i'`
						THEN RW_TAC std_ss[]
						     THEN1 (PSET_TAC[] THEN ASM_SET_TAC[])
						THEN Q.EXISTS_TAC`{2 * i'; 2*i'+1}`
						THEN RW_TAC std_ss[]
						      THEN1 ASM_SET_TAC[]
						THEN Q.EXISTS_TAC`i'`
						THEN RW_TAC list_ss[])
				    THEN PSET_TAC[] THEN ASM_SET_TAC[])
			    THEN RW_TAC std_ss[]
			    THEN ASM_SET_TAC[])
		 THEN RW_TAC std_ss[]	    
		  THEN `prob p (X (2*j'+1)) <> PosInf /\ prob p ((X:num->'a->bool)(2*j'+1)) <> NegInf` by FULL_SIMP_TAC std_ss[indep_sets, PROB_FINITE]	    
		  THEN RW_TAC std_ss[extreal_of_num_def, sub_not_infty, normal_real, extreal_not_infty]
		  THEN RW_TAC std_ss[extreal_sub_sub2]
		  THEN RW_TAC std_ss[extreal_not_infty, real_mul_real, extreal_of_num_def, sub_not_infty]
		  THEN RW_TAC std_ss[extreal_sub_def]
		  THEN RW_TAC std_ss[real_normal])
	  THEN ASM_SET_TAC[])
THEN RW_TAC std_ss[]
THEN KNOW_TAC(``  product L
        (\j.
             real
               (1 -
                Normal
                  (product
                     (if j IN L then {2 * j; 2 * j + 1}
                      else ind_set [{0}; {1}; {}; {2; 3}; {4}] j)
                     (\a.
                          real
                            (1 -
                             Normal
                               (product
                                  (if
                                     a IN
                                     {2 * i | i IN L} UNION
                                     {2 * i + 1 | i IN L}
                                   then
                                     {a}
                                   else ind_set [{0}; L1; L2; L3; L4] a)
                                  (\i. real (1 - prob p (X i))))))))) =

product L (\j. 1 -
              real ((prob p (X (2 * j))) * (prob p (X (2 * j + 1)))))``)
      THEN1 RW_TAC std_ss[th]
THEN RW_TAC std_ss[]
THEN RW_TAC std_ss[GSYM extreal_mul_def]
THEN KNOW_TAC(``prob p ((X:num->'a->bool) 0) <> PosInf /\ prob p (X 0) <> NegInf ``)
	           THEN1(FULL_SIMP_TAC list_ss[indep_sets]
		          THEN KNOW_TAC(``(X:num->'a->bool) 0 IN events p ``)
			       THEN1(UNDISCH_TAC(`` !i:num.
             i IN
             BIGUNION_o_BIGUNION
               (\i.
                    if
                      i IN {2 * i | i IN L} \/ i IN {2 * i + 1 | i IN L}
                    then
                      {i}
                    else ind_set [{0}; L1; L2; L3; L4] i)
               (\j.
                    if j IN L then {2 * j; 2 * j + 1}
                    else ind_set [{0}; {1}; {}; {2; 3}; {4}] j)
               ({0} UNION {1} UNION {3} UNION {4} UNION L) ==>
             {X i} SUBSET events p``)
	                          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `0`)
				  THEN DISCH_TAC
				  THEN KNOW_TAC(`` 0:num IN
    BIGUNION_o_BIGUNION
      (\i.
           if i IN {2 * i | i IN L} \/ i IN {2 * i + 1 | i IN L} then {i}
           else ind_set [{0}; L1; L2; L3; L4] i)
      (\j.
           if j IN L then {2 * j; 2 * j + 1}
           else ind_set [{0}; {1}; {}; {2; 3}; {4}] j)
      ({0} UNION {1} UNION {3} UNION {4} UNION L)``)
				  THEN1(RW_TAC std_ss[BIGUNION_o_BIGUNION_def]
				        THEN RW_TAC list_ss[ind_set_def]
					THEN PSET_TAC[BIGUNION_o_BIGUNION_def]
					THEN Q.EXISTS_TAC`{0}`
					THEN RW_TAC std_ss[]
					THEN1 ASM_SET_TAC[] 
					THEN Q.EXISTS_TAC`0`
					THEN RW_TAC list_ss[]
					THEN Q.EXISTS_TAC`{0}`
					THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
					THEN Q.EXISTS_TAC`0`
					THEN RW_TAC list_ss[])

                                 THEN RW_TAC std_ss[]
				 THEN FULL_SIMP_TAC list_ss[] THEN ASM_SET_TAC[])
		THEN `prob_space p` by FULL_SIMP_TAC std_ss[indep_sets]
		THEN RW_TAC std_ss[PROB_FINITE])
THEN RW_TAC std_ss[normal_real, sub_not_infty, extreal_of_num_def, extreal_not_infty]
THEN RW_TAC std_ss[GSYM extreal_mul_def]
THEN RW_TAC std_ss[GSYM extreal_sub_def]
THEN RW_TAC std_ss[GSYM extreal_mul_def]
THEN RW_TAC std_ss[GSYM extreal_sub_def]
THEN RW_TAC std_ss[GSYM extreal_of_num_def]);





val PROB_SEN_network_DFT_lem2 = store_thm("PROB_SEN_network_DFT_lem2",
  ``!p L1 L2 L3 L4 L X Y t LL A J .
          FINITE L1 /\ L1 <> {} /\ FINITE L2 /\ L2 <> {} /\ FINITE L3 /\
          L3 <> {} /\ FINITE L4 /\ L4 <> {} /\ FINITE L /\
          DISJOINT {0; 1; 3; 4:num} L /\
	  (!i j. i IN L /\ j IN L /\ i <> j ==> DISJOINT {2*i; 2*i+1} {2*j; 2*j+1})/\
          (!i:num. i IN L ==> DISJOINT {2 * i; 2 * i + 1} {0; 1; 2; 3; 4}) /\
	  
	  indep_sets p (\i.  {event_set [(DFT_event p Y t,0)]
                                  (rv_to_devent p X t) i}) (BIGUNION_o_BIGUNION LL A J)  /\
	  
	 disjoint_family_on
	    (ind_set[{0:num}; L1; L2; L3; L4; ({2*i|i IN L} UNION {2*i+1| i IN L})])
	       {0;1;2;3;4;5} /\
	       (J = ({0;1;3;4} UNION L)) /\
	       (A = (\j. if j IN L then {2*j; 2*j+1} else ( ind_set[{0}; {1}; {} ;{2;3}; {4}] j) )) /\
	       (LL = (\i. if i IN ({2*i|i IN L} UNION {2*i+1| i IN L}) then {i} else  (ind_set[{0}; L1; L2; L3; L4] i))) ==>
 (prob p
               (bigunion
                  (\j.
                       biginter
                         (\a.
                              bigunion
                               (\i.
                                event_set [(DFT_event p Y t,0)]
                                  (rv_to_devent p X t) i)  ((\i.
                                 if
                                   i IN
                                   {2 * i | i IN L} UNION
                                   {2 * i + 1 | i IN L}
                                 then
                                   {i}
                                 else ind_set [{0}; L1; L2; L3; L4] i) a))
                    ((\j.
                          if j IN L then {2 * j; 2 * j + 1}
                          else ind_set [{0}; {1}; {}; {2; 3}; {4}] j) j))
             ({0; 1; 3; 4} UNION L)) = 1 -
   (1 - prob p (DFT_event p Y t)) * Normal (product L1 (\l. real (1 - prob p (rv_to_devent p X t l)))) *
   (1 -
    (1 - Normal (product L2 (\l. real (1 - prob p (rv_to_devent p X t  l))))) *
    (1 - Normal (product L3 (\l. real (1 - prob p  (rv_to_devent p X t  l)))))) *
   Normal (product L4 (\l. real (1 - prob p (rv_to_devent p X t  l)))) *
   Normal
     (product L (\j. 1 - real (prob p (rv_to_devent p X t  (2 * j)) * prob p (rv_to_devent p X t  (2 * j + 1))))))``,


RW_TAC std_ss[]
THEN DEP_REWRITE_TAC[PROB_SEN_network_DFT_lem1]
THEN RW_TAC std_ss[event_set_def, event_set1_def]
THEN FULL_SIMP_TAC std_ss[disjoint_family_on]
THEN KNOW_TAC(``DISJOINT {0:num} L1 ``)
     THEN1(POP_ASSUM (MP_TAC o Q.SPEC `0`)
          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `1`)
	  THEN RW_TAC list_ss[ind_set_def, DISJOINT_DEF])
	  
THEN KNOW_TAC(``DISJOINT {0:num} L2 ``)
     THEN1(POP_ASSUM (MP_TAC o Q.SPEC `0`)
          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `2`)
	  THEN RW_TAC list_ss[ind_set_def, DISJOINT_DEF])


THEN KNOW_TAC(``DISJOINT {0:num} L3 ``)
     THEN1(POP_ASSUM (MP_TAC o Q.SPEC `0`)
          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `3`)
	  THEN RW_TAC list_ss[ind_set_def, DISJOINT_DEF])


THEN KNOW_TAC(``DISJOINT {0:num} L4 ``)
     THEN1(POP_ASSUM (MP_TAC o Q.SPEC `0`)
          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `4`)
	  THEN RW_TAC list_ss[ind_set_def, DISJOINT_DEF])

THEN KNOW_TAC(``DISJOINT {0:num} ({2 * i | i IN L} UNION {2 * i + 1 | i IN L}) ``)
     THEN1(POP_ASSUM (MP_TAC o Q.SPEC `0`)
          THEN DISCH_TAC THEN POP_ASSUM (MP_TAC o Q.SPEC `5`)
	  THEN RW_TAC list_ss[ind_set_def, DISJOINT_DEF])
THEN RW_TAC std_ss[]
THEN KNOW_TAC(`` (product L1
        (\i.
             real
               (1 -
                prob p
                  (if i = 0 then DFT_event p Y t else rv_to_devent p X t i)))) =
		  (product L1
        (\i:num.
             real
               (1 -
                prob p
                  (rv_to_devent p X t i))))``)
     THEN1(KNOW_TAC(`` !i:num. i IN L1 ==>  (real
            (1 -
             prob p (if i = 0 then DFT_event p Y t else rv_to_devent p X t i)) =
	      real
            (1 -
             prob p (rv_to_devent p X t i)))``)

             THEN1(RW_TAC std_ss[] THEN ASM_SET_TAC[])
            THEN RW_TAC std_ss[th])
THEN RW_TAC std_ss[]
THEN KNOW_TAC(`` (product L2
        (\i.
             real
               (1 -
                prob p
                  (if i = 0 then DFT_event p Y t else rv_to_devent p X t i)))) =
		  (product L2
        (\i:num.
             real
               (1 -
                prob p
                  (rv_to_devent p X t i))))``)
     THEN1(KNOW_TAC(`` !i:num. i IN L2 ==>  (real
            (1 -
             prob p (if i = 0 then DFT_event p Y t else rv_to_devent p X t i)) =
	      real
            (1 -
             prob p (rv_to_devent p X t i)))``)

             THEN1(RW_TAC std_ss[] THEN ASM_SET_TAC[])
            THEN RW_TAC std_ss[th])
	          
THEN RW_TAC std_ss[]
THEN KNOW_TAC(`` (product L3
        (\i.
             real
               (1 -
                prob p
                  (if i = 0 then DFT_event p Y t else rv_to_devent p X t i)))) =
		  (product L3
        (\i:num.
             real
               (1 -
                prob p
                  (rv_to_devent p X t i))))``)
     THEN1(KNOW_TAC(`` !i:num. i IN L3 ==>  (real
            (1 -
             prob p (if i = 0 then DFT_event p Y t else rv_to_devent p X t i)) =
	      real
            (1 -
             prob p (rv_to_devent p X t i)))``)

             THEN1(RW_TAC std_ss[] THEN ASM_SET_TAC[])
            THEN RW_TAC std_ss[th])
	          
THEN RW_TAC std_ss[]

THEN KNOW_TAC(`` (product L4
        (\i.
             real
               (1 -
                prob p
                  (if i = 0 then DFT_event p Y t else rv_to_devent p X t i)))) =
		  (product L4
        (\i:num.
             real
               (1 -
                prob p
                  (rv_to_devent p X t i))))``)
     THEN1(KNOW_TAC(`` !i:num. i IN L4 ==>  (real
            (1 -
             prob p (if i = 0 then DFT_event p Y t else rv_to_devent p X t i)) =
	      real
            (1 -
             prob p (rv_to_devent p X t i)))``)

             THEN1(RW_TAC std_ss[] THEN ASM_SET_TAC[])
            THEN RW_TAC std_ss[th])
	          
THEN RW_TAC std_ss[]
THEN KNOW_TAC(`` (product L
        (\j:num.
             1 -
             real
               (prob p
                  (if j = 0 then DFT_event p Y t
                   else rv_to_devent p X t (2 * j)) *
                prob p (rv_to_devent p X t (2 * j + 1))))) =
		(product L
        (\j.
             1 -
             real
               (prob p
                  ( rv_to_devent p X t (2 * j)) *
                prob p (rv_to_devent p X t (2 * j + 1)))))``)
     THEN1(KNOW_TAC(``!j:num. j IN L ==>
     ( 1 -
          real
            (prob p
               (if j = 0 then DFT_event p Y t
                else rv_to_devent p X t (2 * j)) *
             prob p (rv_to_devent p X t (2 * j + 1))) =
	    1 -
          real
            (prob p
               ( rv_to_devent p X t (2 * j)) *
             prob p (rv_to_devent p X t (2 * j + 1))) )``)
             THEN1(RW_TAC std_ss[] THEN ASM_SET_TAC[])
             THEN RW_TAC std_ss[th])
THEN RW_TAC std_ss[]	     );



val PROB_SEN_network_DFT_lem3 = store_thm("PROB_SEN_network_DFT_lem3",
  ``!p L1 L2 L3 L4 L X Y Ysa Ysd t.
  SEN_network_set_req p L1 L2 L3 L4 L
     (\i.
         if i IN ({2*i|i IN L} UNION {2*i+1| i IN L}) then {i}
	 else  (ind_set[{0}; L1; L2; L3; L4] i))
    (\j. if j IN L then {2*j; 2*j+1}
         else ( ind_set[{0}; {1}; {} ;{2;3}; {4}] j) )
    ({0;1;3;4} UNION L)
    (\i.
        event_set [(DFT_event p (WSP Y Ysa Ysd) t,0)]
            (rv_to_devent p X t) i) /\

   (!i:num. i IN
            (L1 UNION L2 UNION L3 UNION L4 UNION {2*i | i IN L } UNION
            {2*i+1:num| i IN L}) ==>
	    rv_gt0_ninfinity[X i])  ==>
 (prob p
             (bigunion
                (\j.
                    biginter
                       (\a.
                            bigunion
                              (\i.
                                   event_set
                                     [(DFT_event p (WSP Y Ysa Ysd) t,0)]
                                     (rv_to_devent p X t) i)
                              ((\i.
                                    if
                                      i IN
                                      {2 * i | i IN L} UNION
                                      {2 * i + 1 | i IN L}
                                    then
                                      {i}
                                    else ind_set [{0}; L1; L2; L3; L4] i) a))
                       ((\j.
                             if j IN L then {2 * j; 2 * j + 1}
                             else ind_set [{0}; {1}; {}; {2; 3}; {4}] j) j))
                ({0; 1; 3; 4} UNION L)) =
           1 -
           (1 - prob p (DFT_event p (WSP Y Ysa Ysd) t)) *
           Normal (product L1 (\l. real (1 - CDF p (real o X l) t))) *
           (1 -
            (1 - Normal (product L2 (\l. real (1 - CDF p (real o X l) t)))) *
            (1 - Normal (product L3 (\l. real (1 - CDF p (real o X l) t))))) *
           Normal (product L4 (\l. real (1 - CDF p (real o X l) t))) *
           Normal
             (product L
                (\j.
                     1 -
                     real
                       (CDF p (real o X (2 * j)) t *
                        CDF p (real o X (2 * j + 1)) t))))``,
RW_TAC std_ss[SEN_network_set_req_def]
THEN MP_TAC (Q.ISPECL [`p:('a->bool)#(('a->bool)->bool)#(('a->bool)->extreal)`, `L1:num->bool` , `L2:num->bool` , `L3:num->bool` , `L4:num->bool` , `L:num->bool`,  `X:num->'a->extreal`, `WSP (Y:'a->extreal) Ysa Ysd`, `t:real`, `(\i.
                if i:num IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {i}
                else ind_set [{0:num}; L1; L2; L3; L4] i)`, `(\j:num.
                if j IN L then {2 * j; 2 * j + 1}
                else ind_set [{0:num}; {1}; {}; {2; 3}; {4}] j)`  ,`({0; 1; 3; 4:num} UNION L)` ]PROB_SEN_network_DFT_lem2)
THEN RW_TAC std_ss[]

THEN RW_TAC std_ss[rv_to_devent_def]
THEN KNOW_TAC(``product L1 (\l:num. real (1 - prob p (DFT_event p (X l) t))) =
       (product L1 (\l. real (1 - CDF p (real o X l) t)))``)
       THEN1(KNOW_TAC(``!l:num. l IN L1 ==>
               (real (1 - prob p (DFT_event p (X l) t)) =
	        real (1 - CDF p (real o X l) t))``)
	     THEN1(RW_TAC std_ss[]
	          THEN RW_TAC std_ss[o_DEF]
		  THEN AP_TERM_TAC THEN DEP_REWRITE_TAC[CDF_prob_DFT_event]
		  THEN FULL_SIMP_TAC list_ss[rv_gt0_ninfinity_def, ETA_THM]
		  THEN METIS_TAC[])
	    THEN RW_TAC std_ss[th])
THEN RW_TAC std_ss[]
THEN KNOW_TAC(``product L2 (\l:num. real (1 - prob p (DFT_event p (X l) t))) =
       (product L2 (\l. real (1 - CDF p (real o X l) t)))``)
       THEN1(KNOW_TAC(``!l:num. l IN L2 ==>
               (real (1 - prob p (DFT_event p (X l) t)) =
	        real (1 - CDF p (real o X l) t))``)
	     THEN1(RW_TAC std_ss[]
	          THEN RW_TAC std_ss[o_DEF]
		  THEN AP_TERM_TAC THEN DEP_REWRITE_TAC[CDF_prob_DFT_event]
		  THEN FULL_SIMP_TAC list_ss[rv_gt0_ninfinity_def, ETA_THM]
		  THEN METIS_TAC[])
	    THEN RW_TAC std_ss[th])
THEN RW_TAC std_ss[]	    
THEN KNOW_TAC(``product L3 (\l:num. real (1 - prob p (DFT_event p (X l) t))) =
       (product L3 (\l. real (1 - CDF p (real o X l) t)))``)
       THEN1(KNOW_TAC(``!l:num. l IN L3 ==>
               (real (1 - prob p (DFT_event p (X l) t)) =
	        real (1 - CDF p (real o X l) t))``)
	     THEN1(RW_TAC std_ss[]
	          THEN RW_TAC std_ss[o_DEF]
		  THEN AP_TERM_TAC THEN DEP_REWRITE_TAC[CDF_prob_DFT_event]
		  THEN FULL_SIMP_TAC list_ss[rv_gt0_ninfinity_def, ETA_THM]
		  THEN METIS_TAC[])
	    THEN RW_TAC std_ss[th])
THEN RW_TAC std_ss[]	    

THEN KNOW_TAC(``product L4 (\l:num. real (1 - prob p (DFT_event p (X l) t))) =
       (product L4 (\l. real (1 - CDF p (real o X l) t)))``)
       THEN1(KNOW_TAC(``!l:num. l IN L4 ==>
               (real (1 - prob p (DFT_event p (X l) t)) =
	        real (1 - CDF p (real o X l) t))``)
	     THEN1(RW_TAC std_ss[]
	          THEN RW_TAC std_ss[o_DEF]
		  THEN AP_TERM_TAC THEN DEP_REWRITE_TAC[CDF_prob_DFT_event]
		  THEN FULL_SIMP_TAC list_ss[rv_gt0_ninfinity_def, ETA_THM]
		  THEN METIS_TAC[])
	    THEN RW_TAC std_ss[th])
THEN RW_TAC std_ss[]	    

THEN KNOW_TAC(``(product L
        (\j:num.
             1 -
             real
               (prob p (DFT_event p (X (2 * j)) t) *
                prob p (DFT_event p (X (2 * j + 1)) t)))) =
	(product L
        (\j.
             1 -
             real
               (CDF p (real o X (2 * j)) t * CDF p (real o X (2 * j + 1)) t)))	``)
     THEN1(KNOW_TAC(``!j:num. j IN L ==>
                         ( 1 -
          real
            (prob p (DFT_event p (X (2 * j)) t) *
             prob p (DFT_event p (X (2 * j + 1)) t)) =
	      1 -
          real (CDF p (real o X (2 * j)) t * CDF p (real o X (2 * j + 1)) t))``)
	  THEN1(RW_TAC std_ss[]
		 THEN RW_TAC std_ss[o_DEF]
		  THEN AP_TERM_TAC THEN DEP_REWRITE_TAC[CDF_prob_DFT_event]
		  THEN FULL_SIMP_TAC list_ss[rv_gt0_ninfinity_def, ETA_THM]
		  THEN RW_TAC std_ss[]
		  THEN1 (UNDISCH_TAC(``  !i:num.
             ((((i IN L1 \/ i IN L2) \/ i IN L3) \/ i IN L4) \/
              i IN {2 * i | i IN L}) \/ i IN {2 * i + 1 | i IN L} ==>
             !s. 0 <= X i s /\ X i s <> PosInf``)
	                 THEN DISCH_TAC
			 THEN POP_ASSUM (MP_TAC o Q.SPEC `2*j`)
			 THEN ASM_SET_TAC[])
		   THEN1 (UNDISCH_TAC(``  !i:num.
             ((((i IN L1 \/ i IN L2) \/ i IN L3) \/ i IN L4) \/
              i IN {2 * i | i IN L}) \/ i IN {2 * i + 1 | i IN L} ==>
             !s. 0 <= X i s /\ X i s <> PosInf``)
	                 THEN DISCH_TAC
			 THEN POP_ASSUM (MP_TAC o Q.SPEC `2*j`)
			 THEN ASM_SET_TAC[])	 

		   THEN1 (UNDISCH_TAC(``  !i:num.
             ((((i IN L1 \/ i IN L2) \/ i IN L3) \/ i IN L4) \/
              i IN {2 * i | i IN L}) \/ i IN {2 * i + 1 | i IN L} ==>
             !s. 0 <= X i s /\ X i s <> PosInf``)
	                 THEN DISCH_TAC
			 THEN POP_ASSUM (MP_TAC o Q.SPEC `2*j+1`)
			 THEN ASM_SET_TAC[])
		   THEN1 (UNDISCH_TAC(``  !i:num.
             ((((i IN L1 \/ i IN L2) \/ i IN L3) \/ i IN L4) \/
              i IN {2 * i | i IN L}) \/ i IN {2 * i + 1 | i IN L} ==>
             !s. 0 <= X i s /\ X i s <> PosInf``)
	                 THEN DISCH_TAC
			 THEN POP_ASSUM (MP_TAC o Q.SPEC `2*j+1`)
			 THEN ASM_SET_TAC[])
		   THEN METIS_TAC[])
	    THEN RW_TAC std_ss[th])  
THEN RW_TAC std_ss[]);



val Q_dSEN_network_plus_lem1 = store_thm("Q_dSEN_network_plus_lem1",
  `` !L1 L2 L3 L4 L X Y.  FINITE (L1:num->bool) /\ FINITE (L2:num->bool) /\ FINITE (L3:num->bool) /\
                      FINITE (L4:num->bool) /\ FINITE (L:num->bool) ==>

 (n_OR
                (MAP (\i:num.
                     if i = 0 then Y
                     else if i = 1 then n_OR (MAP X (SET_TO_LIST L1))
                     else if i = 3 then D_AND (n_OR (MAP X (SET_TO_LIST L2))) (n_OR (MAP X (SET_TO_LIST L3)))
                     else if i = 4 then n_OR (MAP X (SET_TO_LIST L4))
                     else D_AND (X (2 * i)) (X (2 * i + 1)))
                (SET_TO_LIST ({0; 1; 3; 4} UNION L))) =
		(nR_AND
                  (\i.
                       if i = 0 then Y
                       else if i = 1 then nR_AND X L1
                       else if i = 3 then R_OR (nR_AND X L2) (nR_AND X L3)
                       else if i = 4 then nR_AND X L4
                       else R_OR (X (2 * i)) (X (2 * i + 1)))
                  ({0; 1; 3; 4} UNION L)))``,
RW_TAC std_ss[]
THEN DEP_REWRITE_TAC[n_OR_nR_AND,n_AND_nR_OR]
THEN RW_TAC std_ss[]
THEN1  RW_TAC std_ss[FINITE_UNION, FINITE_4]
THEN RW_TAC std_ss[D_AND_def, R_OR_def]);

 

val BIGUNION_4_sets = store_thm("BIGUNION_4_sets",
  `` !a b c d. BIGUNION {a;b;c;d} = a UNION b UNION c UNION d ``,
ASM_SET_TAC[]);


val Q_dSEN_network_plus_lem2 = store_thm("Q_dSEN_network_plus_lem2",
  ``  !p L1 L2 L3 L4 L X Y t.
      FINITE (L1:num->bool) /\ L1 <> {} /\ FINITE (L2:num->bool) /\ L2 <> {} /\ FINITE (L3:num->bool) /\
            L3 <> {} /\ FINITE (L4:num->bool) /\ L4 <> {} /\ FINITE (L:num->bool) /\
            DISJOINT {0; 1; 3; 4} L /\
            (!i. i IN L ==> DISJOINT {2 * i; 2 * i + 1} {0; 1; 2; 3; 4}) /\
	    disjoint_family_on
            (ind_set
               [{0}; L1; L2; L3; L4;
                {2 * i | i IN L} UNION {2 * i + 1 | i IN L}])
            {0; 1; 2; 3; 4; 5} ==>

(DFT_event p (n_OR
                (MAP (\i:num.
                     if i = 0 then Y
                     else if i = 1 then n_OR (MAP X (SET_TO_LIST L1))
                     else if i = 3 then D_AND (n_OR (MAP X (SET_TO_LIST L2))) (n_OR (MAP X (SET_TO_LIST L3)))
                     else if i = 4 then n_OR (MAP X (SET_TO_LIST L4))
                     else D_AND (X (2 * i)) (X (2 * i + 1)))
                (SET_TO_LIST ({0; 1; 3; 4} UNION L)))) t =
	 BIGUNION
     {BIGINTER
       {BIGUNION
         {event_set [(DFT_event p Y t,0)] (rv_to_devent p X t) i |
         i IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
         else ind_set [{0}; L1; L2; L3; L4] a} |
       a|
       a IN if j IN L then {2 * j; 2 * j + 1}
       else ind_set [{0}; {1}; {}; {2; 3}; {4}] j} |
    j|
     j IN {0; 1; 3; 4} UNION L})``,

RW_TAC std_ss[GSYM biginter_def,GSYM  bigunion_def]
THEN DEP_REWRITE_TAC [n_OR_BIGUNION]
THEN `FINITE ({0;1;3;4:num} UNION L)` by RW_TAC std_ss[FINITE_UNION, FINITE_4]
THEN RW_TAC std_ss[]
THEN RW_TAC std_ss[GSYM bigunion_def]
THEN RW_TAC std_ss[ETA_THM]
THEN KNOW_TAC(`` bigunion
     (\i:num.
          rv_to_devent p
            (\i.
                 if i = 0 then Y
                 else if i = 1 then n_OR (MAP X (SET_TO_LIST L1))
                 else if i = 3 then
                   D_AND (n_OR (MAP X (SET_TO_LIST L2)))
                     (n_OR (MAP X (SET_TO_LIST L3)))
                 else if i = 4 then n_OR (MAP X (SET_TO_LIST L4))
                 else D_AND (X (2 * i)) (X (2 * i + 1))) t i)
     ({0; 1; 3; 4} UNION L) =
	     bigunion
     (\i.
          rv_to_devent p
            (\i.
                 if i = 0 then Y
                 else if i = 1 then n_OR (MAP X (SET_TO_LIST L1))
                 else if i = 3 then
                   D_AND (n_OR (MAP X (SET_TO_LIST L2)))
                     (n_OR (MAP X (SET_TO_LIST L3)))
                 else if i = 4 then n_OR (MAP X (SET_TO_LIST L4))
                 else D_AND (X (2 * i)) (X (2 * i + 1))) t i)
     ({0; 1; 3; 4} ) UNION
   bigunion
     (\i.
          rv_to_devent p
            (\i.
                 if i = 0 then Y
                 else if i = 1 then n_OR (MAP X (SET_TO_LIST L1))
                 else if i = 3 then
                   D_AND (n_OR (MAP X (SET_TO_LIST L2)))
                     (n_OR (MAP X (SET_TO_LIST L3)))
                 else if i = 4 then n_OR (MAP X (SET_TO_LIST L4))
                 else D_AND (X (2 * i)) (X (2 * i + 1))) t i)
     ( L) ``) 
        THEN1(RW_TAC std_ss[bigunion_def]
              THEN RW_TAC std_ss[GSYM IMAGE_DEF]
 	      THEN RW_TAC std_ss[IMAGE_UNION]
	      THEN RW_TAC std_ss[BIGUNION_UNION])
THEN RW_TAC std_ss[]	      

THEN KNOW_TAC(``
   bigunion
     (\i.
          rv_to_devent p
            (\i.
                 if i = 0 then Y
                 else if i = 1 then n_OR (MAP X (SET_TO_LIST L1))
                 else if i = 3 then
                   D_AND (n_OR (MAP X (SET_TO_LIST L2)))
                     (n_OR (MAP X (SET_TO_LIST L3)))
                 else if i = 4 then n_OR (MAP X (SET_TO_LIST L4))
                 else D_AND (X (2 * i)) (X (2 * i + 1))) t i) {0; 1; 3; 4}=
    DFT_event p ( Y) t UNION
    DFT_event p (n_OR (MAP X (SET_TO_LIST L1))) t UNION
    DFT_event p (D_AND (n_OR (MAP X (SET_TO_LIST L2)))
                     (n_OR (MAP X (SET_TO_LIST L3)))) t UNION
    DFT_event p (n_OR (MAP X (SET_TO_LIST L4))) t  ``)

    
     THEN1(RW_TAC std_ss[bigunion_def, rv_to_event_def]
           THEN KNOW_TAC(``
     {DFT_event p
       (if i = 0 then Y
        else if i = 1 then n_OR (MAP X (SET_TO_LIST L1))
        else if i = 3 then  D_AND (n_OR (MAP X (SET_TO_LIST L2)))
                     (n_OR (MAP X (SET_TO_LIST L3)))
        else if i = 4 then  n_OR (MAP X (SET_TO_LIST L4))
        else D_AND (X (2 * i)) (X (2 * i + 1))) t |
     i IN {0; 1:num; 3; 4} } =
     {DFT_event p
       Y t;
      DFT_event p (n_OR (MAP X (SET_TO_LIST (L1:num->bool)))) t;
      DFT_event p (D_AND (n_OR (MAP X (SET_TO_LIST (L2:num->bool))))
                     (n_OR (MAP X (SET_TO_LIST (L3:num->bool))))) t;
      DFT_event p (n_OR (MAP X (SET_TO_LIST (L4:num->bool)))) t }``)  

             THEN1(PSET_TAC[]
                    THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
 		    THEN EQ_TAC
		         THEN1(RW_TAC std_ss[] THEN RW_TAC std_ss[])
	            THEN RW_TAC std_ss[]
		         THEN1(Q.EXISTS_TAC`0`
			        THEN RW_TAC std_ss[])
			 THEN1(Q.EXISTS_TAC`1`
			       THEN RW_TAC std_ss[])
			  THEN1(Q.EXISTS_TAC`3`
			       THEN RW_TAC std_ss[])

		    THEN Q.EXISTS_TAC`4`
		    THEN RW_TAC std_ss[])
       THEN RW_TAC std_ss[rv_to_devent_def]
       THEN RW_TAC std_ss[BIGUNION_4_sets])
THEN RW_TAC std_ss[]       
THEN KNOW_TAC(`` bigunion
     (\i:num.
          rv_to_devent p
            (\i.
                 if i = 0 then Y
                 else if i = 1 then n_OR (MAP X (SET_TO_LIST L1))
                 else if i = 3 then
                   D_AND (n_OR (MAP X (SET_TO_LIST L2)))
                     (n_OR (MAP X (SET_TO_LIST L3)))
                 else if i = 4 then n_OR (MAP X (SET_TO_LIST L4))
                 else D_AND (X (2 * i)) (X (2 * i + 1))) t i) L  =
	    bigunion
     (\i:num.
          rv_to_devent p
            (\i.
                D_AND (X (2 * i)) (X (2 * i + 1))) t i) L ``)
    THEN1(RW_TAC std_ss[bigunion_def]
          THEN AP_TERM_TAC
	  THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
	  THEN EQ_TAC
	       THEN1(RW_TAC std_ss[]
	             THEN Q.EXISTS_TAC`i`
	             THEN RW_TAC std_ss[]
		     THEN EQ_TAC
	                  THEN1(RW_TAC std_ss[]
	                        THEN FULL_SIMP_TAC std_ss[DISJOINT_DEF]
		     		THEN `i:num <> 1` by ASM_SET_TAC[]
     		     		THEN `i:num <> 0` by ASM_SET_TAC[]
		     		THEN `i:num <> 3` by ASM_SET_TAC[]
		     		THEN `i:num <> 4` by ASM_SET_TAC[]
		     		THEN FULL_SIMP_TAC std_ss[]
		     		THEN FULL_SIMP_TAC std_ss[rv_to_devent_def])
	             THEN RW_TAC std_ss[]
	 	     THEN `i:num <> 1` by ASM_SET_TAC[]
     	 	     THEN `i:num <> 0` by ASM_SET_TAC[]
	 	     THEN `i:num <> 3` by ASM_SET_TAC[]
	 	     THEN `i:num <> 4` by ASM_SET_TAC[]
	 	     THEN RW_TAC std_ss[rv_to_devent_def]
	 	     THEN FULL_SIMP_TAC std_ss[rv_to_devent_def])
          THEN RW_TAC std_ss[]
	  THEN Q.EXISTS_TAC`i`
	  THEN RW_TAC std_ss[]
	  THEN EQ_TAC
	        THEN1(RW_TAC std_ss[]
		      THEN `i:num <> 1` by ASM_SET_TAC[]
     		      THEN `i:num <> 0` by ASM_SET_TAC[]
		      THEN `i:num <> 3` by ASM_SET_TAC[]
		      THEN `i:num <> 4` by ASM_SET_TAC[]
		      THEN FULL_SIMP_TAC std_ss[]
		      THEN FULL_SIMP_TAC std_ss[rv_to_devent_def])
          THEN `i:num <> 1` by ASM_SET_TAC[]
     	  THEN `i:num <> 0` by ASM_SET_TAC[]
	  THEN `i:num <> 3` by ASM_SET_TAC[]
	  THEN `i:num <> 4` by ASM_SET_TAC[]
	  THEN RW_TAC std_ss[rv_to_devent_def])

THEN RW_TAC std_ss[]
THEN ONCE_REWRITE_TAC[bigunion_def]
THEN RW_TAC std_ss[GSYM IMAGE_DEF]
THEN RW_TAC std_ss[IMAGE_UNION]
THEN RW_TAC std_ss[BIGUNION_UNION]
THEN RW_TAC std_ss[IMAGE_DEF, GSYM bigunion_def]
THEN KNOW_TAC(``
bigunion
     (\i.
          biginter
            (\a.
                 bigunion
                   (\i.
                        event_set [(DFT_event p Y t,0)] (rv_to_devent p X t)
                          i)
                   (if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then
                      {a}
                    else ind_set [{0}; L1; L2; L3; L4] a))
            (if i IN L then {2 * i; 2 * i + 1}
             else ind_set [{0}; {1}; {}; {2; 3}; {4}] i)) {0; 1; 3; 4:num} =
  DFT_event p Y t UNION DFT_event p (n_OR (MAP X (SET_TO_LIST L1))) t UNION
   DFT_event p
     (D_AND (n_OR (MAP X (SET_TO_LIST L2))) (n_OR (MAP X (SET_TO_LIST L3))))
     t UNION DFT_event p (n_OR (MAP X (SET_TO_LIST L4))) t ``)
   THEN1(RW_TAC std_ss[bigunion_def]
	 THEN RW_TAC std_ss[GSYM IMAGE_DEF]
	 THEN `{0;1;3;4:num} = {0} UNION ({1} UNION ({3} UNION {4}))` by ASM_SET_TAC[]
	 THEN ONCE_ASM_REWRITE_TAC[]
	 THEN RW_TAC std_ss[IMAGE_UNION]
	 THEN RW_TAC std_ss[BIGUNION_UNION]
	 THEN RW_TAC std_ss[IMAGE_DEF]


	 THEN KNOW_TAC(``!i k:num. i IN {k} ==> (i = k) ``)
	      THEN1(ASM_SET_TAC[])
	 THEN RW_TAC std_ss[]     
	 THEN KNOW_TAC(`` 
	    BIGUNION
     {biginter
       (\a.
            BIGUNION
              {event_set [(DFT_event p Y t,0)] (rv_to_devent p X t) i |
              i IN
              if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
              else ind_set [{0}; L1; L2; L3; L4] a})
       (if i IN L then {2 * i; 2 * i + 1}
        else ind_set [{0}; {1}; {}; {2; 3}; {4}] i) |
     i IN {0}} =
       BIGUNION
     {biginter
       (\a.
            BIGUNION
              {event_set [(DFT_event p Y t,0)] (rv_to_devent p X t) i |
              i IN
              if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
              else ind_set [{0}; L1; L2; L3; L4] a}) {0:num}} ``)
	      THEN1 (`!i:num. i NOTIN L ==> ((if i IN L then {2 * i; 2 * i + 1}
        else ind_set [{0}; {1}; {}; {2; 3}; {4}] i) = (ind_set [{0}; {1}; {}; {2; 3}; {4}] i))` by RW_TAC std_ss[]
	     	     THEN PSET_TAC[]
	     	     THEN RW_TAC std_ss[]
	             THEN PSET_TAC[]
		     THEN KNOW_TAC(``  BIGUNION
     {biginter
       (\a.
            BIGUNION
              {event_set [(DFT_event p Y t,0)] (rv_to_devent p X t) i |
              i IN
              if
                (?i. (a = 2 * i) /\ i IN L) \/ ?i. (a = 2 * i + 1) /\ i IN L
              then
                {a} else ind_set [{0}; L1; L2; L3; L4] a})
       (if i IN L then {2 * i; 2 * i + 1}
        else ind_set [{0}; {1}; {}; {2; 3}; {4}] i) |
     i = 0}   =
      BIGUNION
     {biginter
       (\a.
            BIGUNION
              {event_set [(DFT_event p Y t,0)] (rv_to_devent p X t) i |
              i IN
              if
                (?i. (a = 2 * i) /\ i IN L) \/ ?i. (a = 2 * i + 1) /\ i IN L
              then
                {a} else ind_set [{0}; L1; L2; L3; L4] a})
       (if 0 IN L then {2 * i; 2 * i + 1}
        else ind_set [{0}; {1}; {}; {2; 3}; {4}]  0)}``)
	   THEN1 (RW_TAC std_ss[] THEN ASM_SET_TAC[])
	   THEN RW_TAC std_ss[ind_set_def]
	   THEN RW_TAC list_ss[])
     THEN RW_TAC std_ss[]	    
     THEN KNOW_TAC(`` BIGUNION
      {biginter
        (\a.
             BIGUNION
               {event_set [(DFT_event p Y t,0)] (rv_to_devent p X t) i |
               i IN
               if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
               else ind_set [{0}; L1; L2; L3; L4] a})
        (if i IN L then {2 * i; 2 * i + 1}
         else ind_set [{0}; {1}; {}; {2; 3}; {4}] i) |
      i IN {1:num}} =

BIGUNION
      {biginter
        (\a.
             BIGUNION
               {event_set [(DFT_event p Y t,0)] (rv_to_devent p X t) i |
               i IN
               if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
               else ind_set [{0}; L1; L2; L3; L4] a}) {1}}``)
	    THEN1(PSET_TAC[]
	          THEN KNOW_TAC(``  BIGUNION
     {biginter
       (\a.
            BIGUNION
              {event_set [(DFT_event p Y t,0)] (rv_to_devent p X t) i |
              i IN
              if
                (?i. (a = 2 * i) /\ i IN L) \/ ?i. (a = 2 * i + 1) /\ i IN L
              then
                {a} else ind_set [{0}; L1; L2; L3; L4] a})
       (if i IN L then {2 * i; 2 * i + 1}
        else ind_set [{0}; {1}; {}; {2; 3}; {4}] i) |
     i = 1:num}=

 BIGUNION
     {biginter
       (\a.
            BIGUNION
              {event_set [(DFT_event p Y t,0)] (rv_to_devent p X t) i |
              i IN
              if
                (?i. (a = 2 * i) /\ i IN L) \/ ?i. (a = 2 * i + 1) /\ i IN L
              then
                {a} else ind_set [{0}; L1; L2; L3; L4] a})
       (if 1 IN L then {2 * i; 2 * i + 1}
        else ind_set [{0}; {1}; {}; {2; 3}; {4}] 1)}``)
   	    THEN1 (RW_TAC std_ss[] THEN ASM_SET_TAC[])
	    THEN RW_TAC list_ss[ind_set_def])
    THEN RW_TAC std_ss[]	 
    THEN KNOW_TAC(``BIGUNION
       {biginter
         (\a.
              BIGUNION
                {event_set [(DFT_event p Y t,0)] (rv_to_devent p X t) i |
                i IN
                if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
                else ind_set [{0}; L1; L2; L3; L4] a})
         (if i IN L then {2 * i; 2 * i + 1}
          else ind_set [{0}; {1}; {}; {2; 3}; {4}] i) |
       i IN {3}} =
BIGUNION
       {biginter
         (\a.
              BIGUNION
                {event_set [(DFT_event p Y t,0)] (rv_to_devent p X t) i |
                i IN
                if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
                else ind_set [{0}; L1; L2; L3; L4] a}) {2;3}}``)

          THEN1(PSET_TAC[]
	        THEN KNOW_TAC(`` BIGUNION
     {biginter
       (\a.
            BIGUNION
              {event_set [(DFT_event p Y t,0)] (rv_to_devent p X t) i |
              i IN
              if
                (?i. (a = 2 * i) /\ i IN L) \/ ?i. (a = 2 * i + 1) /\ i IN L
              then
                {a} else ind_set [{0}; L1; L2; L3; L4] a})
       (if i IN L then {2 * i; 2 * i + 1}
        else ind_set [{0}; {1}; {}; {2; 3}; {4}] i) |
     i = 3} =
     BIGUNION
     {biginter
       (\a.
            BIGUNION
              {event_set [(DFT_event p Y t,0)] (rv_to_devent p X t) i |
              i IN
              if
                (?i. (a = 2 * i) /\ i IN L) \/ ?i. (a = 2 * i + 1) /\ i IN L
              then
                {a} else ind_set [{0}; L1; L2; L3; L4] a})
       (if 3 IN L then {2 * i; 2 * i + 1}
        else ind_set [{0}; {1}; {}; {2; 3}; {4}]  3)} ``)
           THEN1 (RW_TAC std_ss[] THEN ASM_SET_TAC[])
           THEN RW_TAC list_ss[ind_set_def])
     THEN RW_TAC std_ss[]
     THEN KNOW_TAC(`` BIGUNION
       {biginter
         (\a.
              BIGUNION
                {event_set [(DFT_event p Y t,0)] (rv_to_devent p X t) i |
                i IN
                if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
                else ind_set [{0}; L1; L2; L3; L4] a})
         (if i IN L then {2 * i; 2 * i + 1}
          else ind_set [{0}; {1}; {}; {2; 3}; {4}] i) |
       i IN {4}} =
      BIGUNION
       {biginter
         (\a.
              BIGUNION
                {event_set [(DFT_event p Y t,0)] (rv_to_devent p X t) i |
                i IN
                if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
                else ind_set [{0}; L1; L2; L3; L4] a}) {4}}``)
		THEN1(PSET_TAC[]
		      THEN KNOW_TAC(``   BIGUNION
     {biginter
       (\a.
            BIGUNION
              {event_set [(DFT_event p Y t,0)] (rv_to_devent p X t) i |
              i IN
              if
                (?i. (a = 2 * i) /\ i IN L) \/ ?i. (a = 2 * i + 1) /\ i IN L
              then
                {a} else ind_set [{0}; L1; L2; L3; L4] a})
       (if i IN L then {2 * i; 2 * i + 1}
        else ind_set [{0}; {1}; {}; {2; 3}; {4}] i) |
     i = 4}  =
      BIGUNION
     {biginter
       (\a.
            BIGUNION
              {event_set [(DFT_event p Y t,0)] (rv_to_devent p X t) i |
              i IN
              if
                (?i. (a = 2 * i) /\ i IN L) \/ ?i. (a = 2 * i + 1) /\ i IN L
              then
                {a} else ind_set [{0}; L1; L2; L3; L4] a})
       (if 4 IN L then {2 * i; 2 * i + 1}
        else ind_set [{0}; {1}; {}; {2; 3}; {4}] 4)} ``)
               THEN1(RW_TAC std_ss[] THEN ASM_SET_TAC[])
	       THEN RW_TAC list_ss[ind_set_def])
      THEN RW_TAC std_ss[]	       
      THEN RW_TAC std_ss[BIGUNION_SING]
      THEN RW_TAC std_ss[rv_to_devent_def]
      THEN RW_TAC std_ss[biginter_def]
      THEN KNOW_TAC(``
       BIGINTER
     {BIGUNION
       {event_set [(DFT_event p Y t,0)] (\i. DFT_event p (X i) t) i |
       i IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
       else ind_set [{0}; L1; L2; L3; L4] a} |
     a IN {0}}=
      DFT_event p Y t  ``)
           THEN1(PSET_TAC[ind_set_def, event_set_def, event_set1_def] THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
	         THEN EQ_TAC THEN1 (RW_TAC std_ss[] THEN  ASM_SET_TAC[ind_set_def])
		 THEN RW_TAC std_ss[] THEN Q.EXISTS_TAC`DFT_event p (Y) t`
		 THEN ASM_SET_TAC[])
      THEN RW_TAC std_ss[]
      THEN KNOW_TAC(``
      BIGINTER
      {BIGUNION
        {event_set [(DFT_event p Y t,0)] (\i. DFT_event p (X i) t) i |
        i IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
        else ind_set [{0}; L1; L2; L3; L4] a} |
      a IN {1}} =
      DFT_event p (n_OR (MAP X (SET_TO_LIST L1))) t``)
           THEN1(RW_TAC std_ss[n_OR_BIGUNION]
	         THEN KNOW_TAC(``{BIGUNION
       {event_set [(DFT_event p Y t,0)] (\i. DFT_event p (X i) t) i |
       i IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
       else ind_set [{0}; L1; L2; L3; L4] a} |
     a IN {1}} =
            {BIGUNION {rv_to_devent p (X:num->'a->extreal) t i | i IN L1}}``)
	         THEN1 (RW_TAC list_ss[ind_set_def]
		        THEN KNOW_TAC(``{BIGUNION
     {event_set [(DFT_event p Y t,0)] (\i. DFT_event p (X i) t) i |
     i IN if a IN {2 * i | i IN L} \/ a IN {2 * i + 1 | i IN L} then {a}
     else EL a [{0}; L1; L2; L3; L4]} |
   a = 1} =
   {BIGUNION
      {event_set [(DFT_event p Y t,0)] (\i. DFT_event p (X i) t) i |
     i IN if (1:num) IN {2 * i | i IN L} \/ 1:num IN {2 * i + 1 | i IN L} then {1:num}
     else EL (1:num) [{0}; L1; L2; L3; L4]}}``) THEN1 (RW_TAC std_ss[event_set_def, event_set1_def] THEN SRW_TAC [][GSPECIFICATION, EXTENSION] THEN EQ_TAC THEN RW_TAC std_ss[] THEN ASM_SET_TAC[] )
                THEN RW_TAC std_ss[]
		THEN1 ASM_SET_TAC[]
		THEN1 ASM_SET_TAC[]
		THEN RW_TAC list_ss[rv_to_devent_def, event_set_def, event_set1_def, ind_set_def]
		THEN FULL_SIMP_TAC list_ss[event_set_def, event_set1_def]
		THEN RW_TAC std_ss[GSYM IMAGE_DEF]
		THEN KNOW_TAC(``!i:num. i IN L1 ==> ((if i = 0 then DFT_event p Y t else DFT_event p (X i) t) = DFT_event p (X i) t)  ``)
		    THEN1 (RW_TAC std_ss[]
		           THEN KNOW_TAC(``DISJOINT {0:num} L1 ``)	  
			        THEN1(UNDISCH_TAC(``disjoint_family_on
            (ind_set
               [{0:num}; L1; L2; L3; L4;
                {2 * i | i IN L} UNION {2 * i + 1 | i IN L}])
            {0; 1; 2; 3; 4; 5} ``)
	                                THEN RW_TAC std_ss[disjoint_family_on]
					THEN POP_ASSUM (MP_TAC o Q.SPEC `0`) THEN DISCH_TAC
					THEN POP_ASSUM (MP_TAC o Q.SPEC `1`)
					THEN RW_TAC list_ss[ind_set_def]
					THEN RW_TAC std_ss[DISJOINT_DEF])
			   THEN ASM_SET_TAC[])
		THEN RW_TAC std_ss[]
		THEN `(IMAGE (\i. if i = 0 then DFT_event p Y t else DFT_event p (X i) t)
         L1) = (IMAGE (\i. DFT_event p (X i) t) L1)` by  RW_TAC std_ss[IMAGE_EQ]
	        THEN RW_TAC std_ss[])
	  THEN RW_TAC std_ss[]
	  THEN RW_TAC std_ss[BIGINTER_SING]
	  THEN RW_TAC std_ss[bigunion_def])
    THEN RW_TAC std_ss[]	  
    THEN KNOW_TAC(``BIGINTER
       {BIGUNION
         {event_set [(DFT_event p Y t,0)] (\i. DFT_event p (X i) t) i |
         i IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
         else ind_set [{0}; L1; L2; L3; L4] a} |
       a IN {2; 3}} =
        DFT_event p (D_AND (n_OR (MAP X (SET_TO_LIST L2))) (n_OR (MAP (X:num->'a->extreal) (SET_TO_LIST L3)))) t ``)
	    THEN1(RW_TAC std_ss[AND_INTER]
	         THEN RW_TAC std_ss[n_OR_BIGUNION]
		 THEN KNOW_TAC(`` {BIGUNION
       {event_set [(DFT_event p Y t,0)] (\i. DFT_event p (X i) t) i |
       i IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
       else ind_set [{0}; L1; L2; L3; L4] a} |
     a IN {2; 3}} =

{BIGUNION
       {event_set [(DFT_event p Y t,0)] (\i. DFT_event p (X i) t) i |
       i IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
       else ind_set [{0}; L1; L2; L3; L4] a} |
     (a=2)} UNION
   {BIGUNION
       {event_set [(DFT_event p Y t,0)] (\i. DFT_event p (X i) t) i |
       i IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
       else ind_set [{0}; L1; L2; L3; L4] a} | (a = 3)}``)
                     THEN1(PSET_TAC [] THEN SRW_TAC[][GSPECIFICATION, EXTENSION]
		           THEN RW_TAC std_ss[] THEN EQ_TAC
			   THEN1( RW_TAC std_ss[] THEN ASM_SET_TAC[])
   			   THEN1( RW_TAC std_ss[] THEN ASM_SET_TAC[])
			   THEN1( RW_TAC std_ss[] THEN ASM_SET_TAC[])
			   THEN1( RW_TAC std_ss[] THEN ASM_SET_TAC[])
			   THEN1( RW_TAC std_ss[] THEN ASM_SET_TAC[])
			   THEN1( RW_TAC std_ss[] THEN ASM_SET_TAC[])
			   THEN1(RW_TAC std_ss[] THEN1(PSET_TAC[] THEN ASM_SET_TAC[])
			         THEN PSET_TAC[] THEN ASM_SET_TAC[])
			   THEN RW_TAC std_ss[] THEN1(Q.EXISTS_TAC `2:num` THEN PSET_TAC[] THEN RW_TAC std_ss[] THEN ASM_SET_TAC[])
			   
			   THEN Q.EXISTS_TAC`3`
			   THEN RW_TAC std_ss[])
		THEN RW_TAC std_ss[]
		THEN KNOW_TAC(``{BIGUNION
        {event_set [(DFT_event p Y t,0)] (\i. DFT_event p (X i) t) i |
        i IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
        else ind_set [{0}; L1; L2; L3; L4] a} |
      a = 2} =
   {BIGUNION { DFT_event p (X i) t | i IN L2}}``)
                      THEN1( RW_TAC list_ss[ind_set_def]
		        THEN KNOW_TAC(``{BIGUNION
     {event_set [(DFT_event p Y t,0)] (\i. DFT_event p (X i) t) i |
     i IN if a IN {2 * i | i IN L} \/ a IN {2 * i + 1 | i IN L} then {a}
     else EL a [{0}; L1; L2; L3; L4]} |
   a = 2} =
   {BIGUNION
     {event_set [(DFT_event p Y t,0)] (\i. DFT_event p (X i) t) i |
     i IN if (2:num) IN {2 * i | i IN L} \/ 2:num IN {2 * i + 1 | i IN L} then {2:num}
     else EL (2:num) [{0}; L1; L2; L3; L4]}}``) THEN1 (RW_TAC std_ss[] THEN SRW_TAC [][GSPECIFICATION, EXTENSION] THEN EQ_TAC THEN RW_TAC std_ss[] THEN ASM_SET_TAC[] )
                        THEN RW_TAC std_ss[]
		        THEN1 ASM_SET_TAC[]
		       THEN1 ASM_SET_TAC[]
		       THEN RW_TAC list_ss[rv_to_devent_def, event_set_def, event_set1_def, ind_set_def]
	            	THEN FULL_SIMP_TAC list_ss[event_set_def, event_set1_def]
		 	THEN RW_TAC std_ss[GSYM IMAGE_DEF]
			THEN KNOW_TAC(``!i:num. i IN L2 ==> ((if i = 0 then DFT_event p Y t else DFT_event p (X i) t) = DFT_event p (X i) t)  ``)
		    THEN1 (RW_TAC std_ss[]
		           THEN KNOW_TAC(``DISJOINT {0:num} L2 ``)	  
			        THEN1(UNDISCH_TAC(``disjoint_family_on
            (ind_set
               [{0:num}; L1; L2; L3; L4;
                {2 * i | i IN L} UNION {2 * i + 1 | i IN L}])
            {0; 1; 2; 3; 4; 5} ``)
	                                THEN RW_TAC std_ss[disjoint_family_on]
					THEN POP_ASSUM (MP_TAC o Q.SPEC `0`) THEN DISCH_TAC
					THEN POP_ASSUM (MP_TAC o Q.SPEC `2`)
					THEN RW_TAC list_ss[ind_set_def]
					THEN RW_TAC std_ss[DISJOINT_DEF])
			   THEN ASM_SET_TAC[])
		   THEN RW_TAC std_ss[]
		   THEN `(IMAGE (\i. if i = 0 then DFT_event p Y t else DFT_event p (X i) t)
         L2) = (IMAGE (\i. DFT_event p (X i) t) L2)` by  RW_TAC std_ss[IMAGE_EQ]
	            THEN RW_TAC std_ss[])
	      
	       THEN RW_TAC std_ss[]      
               THEN KNOW_TAC(``{BIGUNION
        {event_set [(DFT_event p Y t,0)] (\i. DFT_event p (X i) t) i |
        i IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
        else ind_set [{0}; L1; L2; L3; L4] a} |
      a = 3} =
   {BIGUNION {DFT_event p (X i) t | i IN L3}}``)
                     THEN1(RW_TAC list_ss[ind_set_def]
		        THEN KNOW_TAC(``{BIGUNION
    {event_set [(DFT_event p Y t,0)] (\i. DFT_event p (X i) t) i |
     i IN if a IN {2 * i | i IN L} \/ a IN {2 * i + 1 | i IN L} then {a}
     else EL a [{0}; L1; L2; L3; L4]} |
   a = 3} =
   {BIGUNION
    {event_set [(DFT_event p Y t,0)] (\i. DFT_event p (X i) t) i |
     i IN if (3:num) IN {2 * i | i IN L} \/ 3:num IN {2 * i + 1 | i IN L} then {3:num}
     else EL (3:num) [{0}; L1; L2; L3; L4]}}``) THEN1 (RW_TAC std_ss[] THEN SRW_TAC [][GSPECIFICATION, EXTENSION] THEN EQ_TAC THEN RW_TAC std_ss[] THEN ASM_SET_TAC[] )
                       THEN RW_TAC std_ss[]
		       THEN1 ASM_SET_TAC[]
		       	THEN1 ASM_SET_TAC[]
			THEN RW_TAC list_ss[rv_to_devent_def, event_set_def, event_set1_def, ind_set_def]
	            	THEN FULL_SIMP_TAC list_ss[event_set_def, event_set1_def]
		 	THEN RW_TAC std_ss[GSYM IMAGE_DEF]
			THEN KNOW_TAC(``!i:num. i IN L3 ==> ((if i = 0 then DFT_event p Y t else DFT_event p (X i) t) = DFT_event p (X i) t)  ``)
		    THEN1 (RW_TAC std_ss[]
		           THEN KNOW_TAC(``DISJOINT {0:num} L3 ``)	  
			        THEN1(UNDISCH_TAC(``disjoint_family_on
            (ind_set
               [{0:num}; L1; L2; L3; L4;
                {2 * i | i IN L} UNION {2 * i + 1 | i IN L}])
            {0; 1; 2; 3; 4; 5} ``)
	                                THEN RW_TAC std_ss[disjoint_family_on]
					THEN POP_ASSUM (MP_TAC o Q.SPEC `0`) THEN DISCH_TAC
					THEN POP_ASSUM (MP_TAC o Q.SPEC `3`)
					THEN RW_TAC list_ss[ind_set_def]
					THEN RW_TAC std_ss[DISJOINT_DEF])
			   THEN ASM_SET_TAC[])
		     THEN RW_TAC std_ss[]
		     THEN `(IMAGE (\i. if i = 0 then DFT_event p Y t else DFT_event p (X i) t)
         L3) = (IMAGE (\i. DFT_event p (X i) t) L3)` by  RW_TAC std_ss[IMAGE_EQ]
	              THEN RW_TAC std_ss[])

			
		 THEN RW_TAC std_ss[]
		 THEN KNOW_TAC(``{BIGUNION {DFT_event p (X i) t | i IN L2}} UNION
      {BIGUNION {DFT_event p (X i) t | i IN L3}} =
       {BIGUNION {DFT_event p (X i) t | i IN L2}; 
      BIGUNION {DFT_event p ((X:num->'a->extreal) i) t | i IN L3}} ``)

                     THEN1(ASM_SET_TAC[])
		  THEN RW_TAC std_ss[]
		  THEN RW_TAC std_ss[BIGINTER_INTER]
		  THEN RW_TAC std_ss[rv_to_devent_def])
   THEN RW_TAC std_ss[]      
   THEN KNOW_TAC(``
   BIGINTER
       {BIGUNION
         {event_set [(DFT_event p Y t,0)] (\i. DFT_event p (X i) t) i |
         i IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
         else ind_set [{0}; L1; L2; L3; L4] a} |
       a IN {4}} = DFT_event p (n_OR (MAP (X:num->'a->extreal) (SET_TO_LIST L4))) t ``)
     THEN1(RW_TAC std_ss[n_OR_BIGUNION]
           THEN RW_TAC std_ss[DRBD_parallel_def, rv_to_devent_def]
	   THEN KNOW_TAC(``{BIGUNION
      {event_set [(DFT_event p Y t,0)] (\i. DFT_event p (X i) t) i|
       i IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
       else ind_set [{0}; L1; L2; L3; L4] a} |
     a IN {4}} =
     {BIGUNION {DFT_event p ((X:num->'a->extreal) i) t | i IN L4}}``)
               THEN1(RW_TAC list_ss[ind_set_def]
		        THEN KNOW_TAC(``{BIGUNION
    {event_set [(DFT_event p Y t,0)] (\i. DFT_event p (X i) t) i |
     i IN if a IN {2 * i | i IN L} \/ a IN {2 * i + 1 | i IN L} then {a}
     else EL a [{0}; L1; L2; L3; L4]} |
   a = 4} =
   {BIGUNION
    {event_set [(DFT_event p Y t,0)] (\i. DFT_event p (X i) t) i |
     i IN if (4:num) IN {2 * i | i IN L} \/ 4:num IN {2 * i + 1 | i IN L} then {4:num}
     else EL (4:num) [{0}; L1; L2; L3; L4]}}``) THEN1 (RW_TAC std_ss[] THEN SRW_TAC [][GSPECIFICATION, EXTENSION] THEN EQ_TAC THEN RW_TAC std_ss[] THEN PSET_TAC[] THEN ASM_SET_TAC[] )
                       THEN RW_TAC std_ss[]
		       THEN1(KNOW_TAC(`` !i:num. i IN L ==> 2*i <> 4``)
	                     THEN1(RW_TAC std_ss[]
	             	     THEN MP_TAC (Q.ISPECL [`{2*i:num; 2*i+1:num}`, `{0;1;2;3;4:num}`]DISJOINT_def_2)
		     	     THEN RW_TAC std_ss[]
		     	     THEN POP_ASSUM (MP_TAC o Q.SPEC `4`)
		     	     THEN ASM_SET_TAC[DISJOINT_def_2])
	                THEN ASM_SET_TAC[])
			THEN1 ASM_SET_TAC[]
			THEN RW_TAC list_ss[rv_to_devent_def, event_set_def, event_set1_def, ind_set_def]
	            	THEN FULL_SIMP_TAC list_ss[event_set_def, event_set1_def]
		 	THEN RW_TAC std_ss[GSYM IMAGE_DEF]
			THEN KNOW_TAC(``!i:num. i IN L4 ==> ((if i = 0 then DFT_event p Y t else DFT_event p (X i) t) = DFT_event p (X i) t)  ``)
		    THEN1 (RW_TAC std_ss[]
		           THEN KNOW_TAC(``DISJOINT {0:num} L4 ``)	  
			        THEN1(UNDISCH_TAC(``disjoint_family_on
            (ind_set
               [{0:num}; L1; L2; L3; L4;
                {2 * i | i IN L} UNION {2 * i + 1 | i IN L}])
            {0; 1; 2; 3; 4; 5} ``)
	                                THEN RW_TAC std_ss[disjoint_family_on]
					THEN POP_ASSUM (MP_TAC o Q.SPEC `0`) THEN DISCH_TAC
					THEN POP_ASSUM (MP_TAC o Q.SPEC `4`)
					THEN RW_TAC list_ss[ind_set_def]
					THEN RW_TAC std_ss[DISJOINT_DEF])
			   THEN ASM_SET_TAC[])
		     THEN RW_TAC std_ss[]
		     THEN `(IMAGE (\i. if i = 0 then DFT_event p Y t else DFT_event p (X i) t)
         L4) = (IMAGE (\i. DFT_event p (X i) t) L4)` by  RW_TAC std_ss[IMAGE_EQ]
	              THEN RW_TAC std_ss[])
			
		THEN RW_TAC std_ss[]	
	        THEN RW_TAC std_ss[BIGINTER_SING])
   THEN RW_TAC std_ss[]
   THEN RW_TAC std_ss[UNION_ASSOC])
THEN RW_TAC std_ss[]   
THEN AP_TERM_TAC
THEN RW_TAC std_ss[biginter_def, bigunion_def]
THEN KNOW_TAC(`` !i:num. i IN L ==>(
             {BIGUNION
     {event_set [(DFT_event p Y t,0)] (rv_to_devent p X t) i |
       i IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
       else ind_set [{0}; L1; L2; L3; L4] a} |
     a |
     a IN if i IN L then {2 * i; 2 * i + 1}
     else ind_set [{0}; {1}; {}; {2; 3}; {4}] i} =
       {BIGUNION
       {event_set [(DFT_event p Y t,0)] (rv_to_devent p X t) i |
       i IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
       else ind_set [{0}; L1; L2; L3; L4] a} |
     a |
     a IN  {2 * i; 2 * i + 1}})``)
       THEN1( RW_TAC std_ss[] THEN ASM_SET_TAC[])
THEN RW_TAC std_ss[]       
THEN KNOW_TAC(``
 BIGUNION
     {BIGINTER
       {BIGUNION
         {event_set [(DFT_event p Y t,0)] (rv_to_devent p X t) i |
         i IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
         else ind_set [{0}; L1; L2; L3; L4] a} |
       a |
       a IN if i IN L then {2 * i; 2 * i + 1}
       else ind_set [{0}; {1}; {}; {2; 3}; {4}] i} |
     i:num |
     i IN L} =

 BIGUNION
     {BIGINTER
       {BIGUNION
         {event_set [(DFT_event p Y t,0)] (rv_to_devent p X t) i |
         i:num IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
         else ind_set [{0:num}; L1; L2; L3; L4] a} |
       a |
       a:num IN {2 * i:num; 2 * i + 1:num}
       } |
     i |
     i IN L}``)

     THEN1 (RW_TAC std_ss[GSYM IMAGE_DEF]
            THEN FULL_SIMP_TAC std_ss[GSYM IMAGE_DEF]
            THEN KNOW_TAC(``!i. i IN L ==> (
BIGINTER
               (IMAGE
                  (\a.
                       BIGUNION
                         (IMAGE
                            (\i.
                                 event_set [(DFT_event p Y t,0)]
                                   (rv_to_devent p X t) i)
                            (if
                               a IN
                               IMAGE (\i. 2 * i) L UNION
                               IMAGE (\i. 2 * i + 1) L
                             then
                               {a}
                             else ind_set [{0}; L1; L2; L3; L4] a)))
                  (if i IN L then {2 * i; 2 * i + 1}
                   else ind_set [{0}; {1}; {}; {2; 3}; {4}] i))=
	 BIGINTER
               (IMAGE
                  (\a.
                       BIGUNION
                         (IMAGE
                            (\i.
                                 event_set [(DFT_event p Y t,0)]
                                   (rv_to_devent p X t) i)
                            (if
                               a IN
                               IMAGE (\i. 2 * i) L UNION
                               IMAGE (\i. 2 * i + 1) L
                             then
                               {a}
                             else ind_set [{0}; L1; L2; L3; L4] a)))
                  {2 * i; 2 * i + 1}))``)

        THEN1(RW_TAC std_ss[]
	      THEN ASM_SET_TAC[])
	 THEN RW_TAC std_ss[]     
	 THEN AP_TERM_TAC
        THEN RW_TAC std_ss[IMAGE_EQ])
THEN RW_TAC std_ss[]
THEN RW_TAC std_ss[rv_to_devent_def]
THEN RW_TAC std_ss[AND_INTER]
THEN RW_TAC std_ss[GSYM BIGINTER_INTER]
THEN RW_TAC std_ss[GSYM IMAGE_DEF]
THEN AP_TERM_TAC
THEN KNOW_TAC(``!i:num. i IN L==>
 (BIGINTER
            (IMAGE
               (\a.
                    BIGUNION
                      (IMAGE
                         (\i.
                              event_set [(DFT_event p Y t,0)]
                                (\i. DFT_event p (X i) t) i)
                         (if
                            a IN
                            IMAGE (\i. 2 * i) L UNION IMAGE (\i. 2 * i + 1) L
                          then
                            {a}
                          else ind_set [{0}; L1; L2; L3; L4] a)))
               {2 * i; 2 * i + 1}) =
			 BIGINTER {DFT_event p (X (2 * i)) t; DFT_event p (X (2 * i + 1)) t})``)
      THEN1(RW_TAC std_ss[]
            THEN KNOW_TAC(``(2 * i:num) IN BIGUNION {{2 * i | i IN L}; {2 * i + 1 | i IN L}} ``)
 	    	 THEN1( PSET_TAC[]THEN Q.EXISTS_TAC`{2*i|i IN L}`
		        THEN ASM_SET_TAC[])
	     THEN `{2*i; 2*i+1:num} = {2*i} UNION {2*i+1}` by ASM_SET_TAC[]
	    THEN DISCH_TAC
 	    THEN ONCE_ASM_REWRITE_TAC[]
	    THEN RW_TAC std_ss[IMAGE_UNION]
	    THEN RW_TAC std_ss[IMAGE_DEF]
	    THEN KNOW_TAC(`` {BIGUNION
        {event_set [(DFT_event p Y t,0)] (\i. DFT_event p (X i) t) i' |
        i' IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
        else ind_set [{0}; L1; L2; L3; L4] a} |
      a IN {2 * i}} =
  { BIGUNION {DFT_event p ((X:num->'a->extreal) (2 * i)) t}}``)
                THEN1(KNOW_TAC(`` {BIGUNION{event_set [(DFT_event p Y t,0)] (\i. DFT_event p (X i) t) i' |
     i' IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
     else ind_set [{0}; L1; L2; L3; L4] a} |
   a IN {2 * i}} =
   {BIGUNION{event_set [(DFT_event p Y t,0)] (\i. DFT_event p (X i) t) i' |
     i' IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
     else ind_set [{0}; L1; L2; L3; L4] a} |
   (a =2 * i)}``)
		      THEN1 ASM_SET_TAC[]
               	      THEN RW_TAC std_ss[]
   	       	      THEN KNOW_TAC(``
		       !a. {event_set [(DFT_event p Y t,0)] (\i. DFT_event p (X i) t) i' |
     i' IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
     else ind_set [{0}; L1; L2; L3; L4] a} =
            (\a. {event_set [(DFT_event p Y t,0)] (\i. DFT_event p (X i) t) i' |
     i' IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
     else ind_set [{0}; L1; L2; L3; L4] a}) a``)
       	   	  	  THEN1 RW_TAC std_ss[]
              	       THEN  DISC_RW_KILL
     	      	       THEN KNOW_TAC(``{BIGUNION
     ((\a.
          {event_set [(DFT_event p Y t,0)] (\i. DFT_event p (X i) t) i' |
           i' IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
           else ind_set [{0}; L1; L2; L3; L4] a}) a) |
   (a  =2 * i)} =
   {BIGUNION
     ((\a.
           {event_set [(DFT_event p Y t,0)] (\i. DFT_event p (X i) t) i' |
           i' IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
           else ind_set [{0}; L1; L2; L3; L4] a}) (2 * i))}``)
           	           THEN1 ASM_SET_TAC[]

	            THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
	  	    THEN RW_TAC std_ss[]
     	            THEN1( KNOW_TAC(``{event_set [(DFT_event p Y t,0)] (\i. DFT_event p (X i) t) i' | i' = 2 * i} =
     {DFT_event p (X ( 2 * i:num)) t}``) THEN1 ASM_SET_TAC[event_set_def, event_set1_def]
                          THEN RW_TAC std_ss[]
		     	  THEN ONCE_ASM_REWRITE_TAC[]
		     	  THEN FULL_SIMP_TAC std_ss[event_set_def, event_set1_def]
                     	  THEN PSET_TAC[])
                    THEN ASM_SET_TAC[])		   

	    THEN RW_TAC std_ss[]
	    THEN KNOW_TAC(``(2 * i+1:num) IN BIGUNION {{2 * i | i IN L}; {2 * i + 1 | i IN L}} ``)
 	    	 THEN1( PSET_TAC[]THEN Q.EXISTS_TAC`{2*i+1|i IN L}`
		        THEN ASM_SET_TAC[])
	     THEN DISCH_TAC		
	     THEN KNOW_TAC(`` {BIGUNION
     {event_set [(DFT_event p Y t,0)] (\i. DFT_event p (X i) t) i' |
        i' IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
        else ind_set [{0}; L1; L2; L3; L4] a} |
   a IN {2 * i+1}} =
  { BIGUNION {DFT_event p ((X:num->'a->extreal) (2 * i+1)) t}}``)
                THEN1(KNOW_TAC(`` {BIGUNION
     {event_set [(DFT_event p Y t,0)] (\i. DFT_event p (X i) t) i' |
     i' IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
     else ind_set [{0}; L1; L2; L3; L4] a} |
   a IN {2 * i + 1}} =
   {BIGUNION
     {event_set [(DFT_event p Y t,0)] (\i. DFT_event p (X i) t) i' |
     i' IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
     else ind_set [{0}; L1; L2; L3; L4] a} |
      (a =2 * i+1)}``)
		      THEN1 ASM_SET_TAC[]
               	      THEN RW_TAC std_ss[]
   	       	      THEN KNOW_TAC(`` !a. {event_set [(DFT_event p Y t,0)] (\i. DFT_event p (X i) t) i' |
     i' IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
     else ind_set [{0}; L1; L2; L3; L4] a}=
            (\a.  {event_set [(DFT_event p Y t,0)] (\i. DFT_event p (X i) t) i' |
     i' IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
     else ind_set [{0}; L1; L2; L3; L4] a}) a``)
       	   	  	  THEN1 RW_TAC std_ss[]
              	       THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
      	      	       THEN KNOW_TAC(``{BIGUNION
     ((\a.
           {event_set [(DFT_event p Y t,0)] (\i. DFT_event p (X i) t) i' |
           i' IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
           else ind_set [{0}; L1; L2; L3; L4] a}) a) |
   a = 2 * i + 1} =
   {BIGUNION
     ((\a.
           {event_set [(DFT_event p Y t,0)] (\i. DFT_event p (X i) t) i' |
           i' IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
           else ind_set [{0}; L1; L2; L3; L4] a})(2 * i + 1))}``)
           	           THEN1 ASM_SET_TAC[]

	            THEN DISCH_TAC THEN ONCE_ASM_REWRITE_TAC[]
	  	    THEN RW_TAC std_ss[]
     	            THEN1( KNOW_TAC(`` {event_set [(DFT_event p Y t,0)] (\i. DFT_event p (X i) t) i' | i' = 2 * i+1} =
     {DFT_event p (X ( 2 * i+1:num)) t}``) THEN1 ASM_SET_TAC[event_set_def, event_set1_def]
                          THEN RW_TAC std_ss[]
                          THEN PSET_TAC[])
		     THEN ASM_SET_TAC[]	  )
    THEN  RW_TAC std_ss[BIGUNION_SING]
   THEN ASM_SET_TAC[])
THEN RW_TAC std_ss[IMAGE_EQ]);



val Q_dSEN_network_plus = store_thm("Q_dSEN_network_plus",
  ``  !p L1 L2 L3 L4 L X Y Ysa Ysd t.
      FINITE (L1:num->bool) /\ L1 <> {} /\ FINITE (L2:num->bool) /\ L2 <> {} /\ FINITE (L3:num->bool) /\
            L3 <> {} /\ FINITE (L4:num->bool) /\ L4 <> {} /\ FINITE (L:num->bool) /\
            DISJOINT {0; 1; 3; 4} L /\
            (!i. i IN L ==> DISJOINT {2 * i; 2 * i + 1} {0; 1; 2; 3; 4}) /\
	    disjoint_family_on
            (ind_set
               [{0}; L1; L2; L3; L4;
                {2 * i | i IN L} UNION {2 * i + 1 | i IN L}])
            {0; 1; 2; 3; 4; 5} ==>

(DFT_event p (n_OR
                (MAP (\i:num.
                     if i = 0 then WSP Y Ysa Ysd
                     else if i = 1 then n_OR (MAP X (SET_TO_LIST L1))
                     else if i = 3 then D_AND (n_OR (MAP X (SET_TO_LIST L2))) (n_OR (MAP X (SET_TO_LIST L3)))
                     else if i = 4 then n_OR (MAP X (SET_TO_LIST L4))
                     else D_AND (X (2 * i)) (X (2 * i + 1)))
                (SET_TO_LIST ({0; 1; 3; 4} UNION L)))) t =
	 BIGUNION
     {BIGINTER
       {BIGUNION
         {event_set [(DFT_event p (WSP Y Ysa Ysd) t,0)] (rv_to_devent p X t) i |
         i IN if a IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {a}
         else ind_set [{0}; L1; L2; L3; L4] a} |
       a |
       a IN if j IN L then {2 * j; 2 * j + 1}
       else ind_set [{0}; {1}; {}; {2; 3}; {4}] j} |
     j |
     j IN {0; 1; 3; 4} UNION L})``,

RW_TAC std_ss[Q_dSEN_network_plus_lem2]);



val PROB_SEN_plus_network_DFT = store_thm("PROB_SEN_plus_network_DFT",
  ``!p L1 L2 L3 L4 L X Y Ysa Ysd t.
  SEN_network_set_req p L1 L2 L3 L4 L
     (\i.
         if i IN ({2*i|i IN L} UNION {2*i+1| i IN L}) then {i}
	 else  (ind_set[{0}; L1; L2; L3; L4] i))
    (\j. if j IN L then {2*j; 2*j+1}
         else ( ind_set[{0}; {1}; {} ;{2;3}; {4}] j) )
    ({0;1;3;4} UNION L)
    (\i.
        event_set [(DFT_event p (WSP Y Ysa Ysd) t,0)]
            (rv_to_devent p X t) i) /\

   (!i:num. i IN
            (L1 UNION L2 UNION L3 UNION L4 UNION {2*i | i IN L } UNION
            {2*i+1:num| i IN L}) ==>
	    rv_gt0_ninfinity[X i])  ==>
 (prob p
           (DFT_event p 
             (n_OR
                (MAP
                   (\i.
                        if i = 0 then WSP Y Ysa Ysd
                        else if i = 1 then n_OR (MAP X (SET_TO_LIST L1))
                        else if i = 3 then
                          D_AND (n_OR (MAP X (SET_TO_LIST L2)))
                            (n_OR (MAP X (SET_TO_LIST L3)))
                        else if i = 4 then n_OR (MAP X (SET_TO_LIST L4))
                        else D_AND (X (2 * i)) (X (2 * i + 1)))
                   (SET_TO_LIST ({0; 1; 3; 4} UNION L)))) t) =
           1 -
           (1 - prob p (DFT_event p (WSP Y Ysa Ysd) t)) *
           Normal (product L1 (\l. real (1 - CDF p (real o X l) t))) *
           (1 -
            (1 - Normal (product L2 (\l. real (1 - CDF p (real o X l) t)))) *
            (1 - Normal (product L3 (\l. real (1 - CDF p (real o X l) t))))) *
           Normal (product L4 (\l. real (1 - CDF p (real o X l) t))) *
           Normal
             (product L
                (\j.
                     1 -
                     real
                       (CDF p (real o X (2 * j)) t *
                        CDF p (real o X (2 * j + 1)) t))))``,
REPEAT (GEN_TAC)
THEN DISCH_TAC
THEN DEP_REWRITE_TAC[Q_dSEN_network_plus]
THEN FULL_SIMP_TAC std_ss[SEN_network_set_req_def]
THEN RW_TAC std_ss[]
THEN DEP_REWRITE_TAC [GSYM PROB_SEN_network_DFT_lem3]
THEN RW_TAC std_ss[SEN_network_set_req_def]
THEN RW_TAC std_ss[bigunion_def, biginter_def]);








val PROB_SEN_plus_network_DFT_spares = store_thm("PROB_SEN_plus_network_DFT_spares",
  ``!p L1 L2 L3 L4 L X Y Ysa Ysd t.
  SEN_network_set_req p L1 L2 L3 L4 L
     (\i.
         if i IN ({2*i|i IN L} UNION {2*i+1| i IN L}) then {i}
	 else  (ind_set[{0}; L1; L2; L3; L4] i))
    (\j. if j IN L then {2*j; 2*j+1}
         else ( ind_set[{0}; {1}; {} ;{2;3}; {4}] j) )
    ({0;1;3;4} UNION L)
    (\i.
        event_set [(DFT_event p (WSP (Y 0) (Ysa 0) (Ysd 0)) t,0)]
            (rv_to_devent p X t) i) /\

   (!i:num. i IN
            (L1 UNION L2 UNION L3 UNION L4 UNION {2*i | i IN L } UNION
            {2*i+1:num| i IN L}) ==>
	    rv_gt0_ninfinity[X i]) /\
   (!i:num. i IN L1 ==>  (X i = WSP (Y i) (Ysa i) (Ysd i)))  	    ==>
 (prob p
           (DFT_event p 
             (n_OR
                (MAP
                   (\i.
                        if i = 0 then WSP (Y 0) (Ysa 0) (Ysd 0)
                        else if i = 1 then n_OR (MAP X (SET_TO_LIST L1))
                        else if i = 3 then
                          D_AND (n_OR (MAP X (SET_TO_LIST L2)))
                            (n_OR (MAP X (SET_TO_LIST L3)))
                        else if i = 4 then n_OR (MAP X (SET_TO_LIST L4))
                        else D_AND (X (2 * i)) (X (2 * i + 1)))
                   (SET_TO_LIST ({0; 1; 3; 4} UNION L)))) t) =
           1 -
           Normal (product ({0} UNION L1) (\l. real (1 - prob p (DFT_event p (WSP (Y l) (Ysa l) (Ysd l)) t)))) *
           (1 -
            (1 - Normal (product L2 (\l. real (1 - CDF p (real o X l) t)))) *
            (1 - Normal (product L3 (\l. real (1 - CDF p (real o X l) t))))) *
           Normal (product L4 (\l. real (1 - CDF p (real o X l) t))) *
           Normal
             (product L
                (\j.
                     1 -
                     real
                       (CDF p (real o X (2 * j)) t *
                        CDF p (real o X (2 * j + 1)) t))))``,


REPEAT (GEN_TAC)
THEN DISCH_TAC
THEN DEP_REWRITE_TAC[ PROB_SEN_plus_network_DFT]
THEN RW_TAC std_ss[]
THEN KNOW_TAC(`` (1 - prob p (DFT_event p (WSP (Y (0:num)) (Ysa (0:num)) (Ysd (0:num))) t)) *
   Normal (product L1 (\l:num. real (1 - CDF p (real o X l) t))) =
      Normal
     (product ({0} UNION L1)
        (\l:num. real (1 - prob p (DFT_event p (WSP (Y l) (Ysa l) (Ysd l)) t))))  ``)
    THEN1(FULL_SIMP_TAC std_ss[SEN_network_set_req_def]
          THEN UNDISCH_TAC(`` disjoint_family_on
           (ind_set
              [{0:num}; L1; L2; L3; L4;
               {2 * i | i IN L} UNION {2 * i + 1 | i IN L}])
           {0; 1; 2; 3; 4; 5}``)
	  THEN RW_TAC std_ss[disjoint_family_on]
	  THEN POP_ASSUM(MP_TAC o Q.SPEC `0`)
	  THEN DISCH_TAC
	  THEN POP_ASSUM (MP_TAC o Q.SPEC `1`)
	  THEN RW_TAC std_ss[] 
	  THEN FULL_SIMP_TAC list_ss[ind_set_def]
	  THEN `DISJOINT {0:num} L1` by ASM_SET_TAC[]
	  THEN `FINITE {0:num}` by RW_TAC std_ss[FINITE_SING]	 
	  THEN RW_TAC std_ss[PRODUCT_UNION]
	  THEN RW_TAC std_ss[GSYM extreal_mul_def]
	  THEN RW_TAC std_ss[PRODUCT_SING]
	  THEN FULL_SIMP_TAC std_ss[indep_sets]
	  THEN FULL_SIMP_TAC std_ss[event_set_def, event_set1_def]
	  THEN UNDISCH_TAC(``  !(i :num).
             i IN
             BIGUNION_o_BIGUNION
               (\ (i :num).
                    if
                      i IN {(2 :num) * i | i IN (L :num -> bool)} \/
                      i IN {(2 :num) * i + (1 :num) | i IN L}
                    then
                      {i}
                    else
                      EL i
                        [{(0 :num)}; (L1 :num -> bool); (L2 :num -> bool);
                         (L3 :num -> bool); (L4 :num -> bool)])
               (\ (j :num).
                    if j IN L then {(2 :num) * j; (2 :num) * j + (1 :num)}
                    else
                      EL j
                        [{(0 :num)}; {(1 :num)}; ({} :num -> bool);
                         {(2 :num); (3 :num)}; {(4 :num)}])
               ({(0 :num); (1 :num); (3 :num); (4 :num)} UNION L) ==>
             {if i = (0 :num) then
                DFT_event
                  (p :
                     ('a -> bool) #
                     (('a -> bool) -> bool) # (('a -> bool) -> extreal))
                  (WSP ((Y :num -> 'a -> extreal) (0 :num))
                     ((Ysa :num -> 'a -> extreal) (0 :num))
                     ((Ysd :num -> 'a -> extreal) (0 :num))) (t :real)
              else rv_to_devent p (X :num -> 'a -> extreal) t i} SUBSET
             events p ``)
	  THEN DISCH_TAC   
	  THEN POP_ASSUM (MP_TAC o Q.SPEC `0:num`)
	  THEN RW_TAC std_ss[]
	  THEN KNOW_TAC(``0:num IN  BIGUNION_o_BIGUNION
               (\ (i :num).
                    if
                      i IN {(2 :num) * i | i IN (L :num -> bool)} \/
                      i IN {(2 :num) * i + (1 :num) | i IN L}
                    then
                      {i}
                    else
                      EL i
                        [{(0 :num)}; (L1 :num -> bool); (L2 :num -> bool);
                         (L3 :num -> bool); (L4 :num -> bool)])
               (\ (j :num).
                    if j IN L then {(2 :num) * j; (2 :num) * j + (1 :num)}
                    else
                      EL j
                        [{(0 :num)}; {(1 :num)}; ({} :num -> bool);
                         {(2 :num); (3 :num)}; {(4 :num)}])
               ({(0 :num); (1 :num); (3 :num); (4 :num)} UNION L) ``)
	      THEN1 (RW_TAC std_ss[BIGUNION_o_BIGUNION_def]
	             THEN RW_TAC list_ss[ind_set_def]
		     THEN PSET_TAC[BIGUNION_o_BIGUNION_def]
		     THEN Q.EXISTS_TAC`{0}`
		     THEN RW_TAC std_ss[]
		          THEN1 ASM_SET_TAC[] 
		     THEN Q.EXISTS_TAC`0`
		     THEN RW_TAC list_ss[]
		     THEN Q.EXISTS_TAC`{0}`
		     THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
		     THEN Q.EXISTS_TAC`0`
		     THEN RW_TAC list_ss[])
        THEN RW_TAC std_ss[]
	THEN FULL_SIMP_TAC std_ss[]
	THEN KNOW_TAC(``DFT_event p (WSP (Y (0:num)) (Ysa (0:num)) (Ysd (0:num))) t IN events p ``)
	     THEN1 ASM_SET_TAC[]
	THEN DISCH_TAC
	THEN `prob p (DFT_event p (WSP (Y (0:num)) (Ysa (0:num)) (Ysd (0:num))) t) <> PosInf /\
	     prob p (DFT_event p (WSP (Y 0) (Ysa 0) (Ysd 0)) t) <> NegInf` by RW_TAC std_ss[PROB_FINITE]
	THEN RW_TAC std_ss[normal_real, extreal_of_num_def, sub_not_infty]
	THEN AP_TERM_TAC
	THEN KNOW_TAC(``!l:num. l IN L1 ==> (real (Normal 1 - CDF p (real o X l) t) =
	                                     real (Normal 1 - prob p (DFT_event p (WSP (Y l) (Ysa l) (Ysd l)) t)))``)
            THEN1(RW_TAC std_ss[]
	          THEN FULL_SIMP_TAC list_ss[rv_gt0_ninfinity_def]
		  THEN `WSP (Y l) (Ysa l) (Ysd l) = X l` by RW_TAC std_ss[]
		  THEN ONCE_ASM_REWRITE_TAC[]
		  THEN METIS_TAC[CDF_prob_DFT_event])
	THEN RW_TAC std_ss[]	  
	THEN RW_TAC std_ss[th])
THEN RW_TAC std_ss[]);	
	


val PROB_DRBD_SEN_network_spares = store_thm("PROB_DRBD_SEN_network_spares",
  `` ! p L1 L2 L3 L4 L X Y Ysa Ysd t. SEN_network_set_req p L1 L2 L3 L4 L 
                (\i:num.
                if i IN {2 * i | i IN L} UNION {2 * i + 1 | i IN L} then {i}
                else ind_set [{0}; L1; L2; L3; L4] i)
		(\j.
                if j IN L then {2 * j; 2 * j + 1:num}
                else ind_set [{0}; {1}; {}; {2:num; 3}; {4}] j) ({0; 1; 3; 4} UNION L) 
               (event_set
               [(DRBD_event p (R_WSP (Y 0) (Ysa 0) (Ysd 0)) t,0)] (rv_to_event p X t)) /\
	        (!i:num. i IN L1 ==>  (X i = R_WSP (Y i) (Ysa i) (Ysd i))) ==>

(prob p
             (DRBD_event p (nR_AND
                (\i.
                     if i = 0 then R_WSP (Y 0) (Ysa 0) (Ysd 0)
                     else if i = 1 then nR_AND X L1
                     else if i = 3 then R_OR (nR_AND X L2) (nR_AND X L3)
                     else if i = 4 then nR_AND X L4
                     else R_OR (X (2 * i)) (X (2 * i + 1)))
                ({0; 1; 3; 4} UNION L)) t) =
           Normal (product ({0} UNION L1) (\l. real (Rel p (R_WSP (Y l) (Ysa l) (Ysd l) ) t ))) *
           (1 -
            (1 - Normal (product L2 (\l. real (Rel p (X l) t)))) *
            (1 - Normal (product L3 (\l. real (Rel p (X l) t))))) *
           Normal (product L4 (\l. real (Rel p (X l) t ))) *
           Normal
             (product L
                (\j.
                     1 -
                     real
                       ((1 - Rel p (X (2*j)) t) *
                        (1 - Rel p (X (2*j+1)) t))))) ``,



REPEAT (GEN_TAC)
THEN DISCH_TAC
THEN DEP_REWRITE_TAC[PROB_DRBD_SEN_network_one_spare]
THEN RW_TAC std_ss[]
THEN KNOW_TAC(``  Rel p (R_WSP (Y 0) (Ysa 0) (Ysd 0)) t *
   Normal (product L1 (\l:num. real (Rel p (X l) t)))  =
     Normal
     (product ({0} UNION L1)
        (\l. real (Rel p (R_WSP (Y l) (Ysa l) (Ysd l)) t)))  ``)
    THEN1(FULL_SIMP_TAC std_ss[SEN_network_set_req_def]
          THEN UNDISCH_TAC(`` disjoint_family_on
           (ind_set
              [{0:num}; L1; L2; L3; L4;
               {2 * i | i IN L} UNION {2 * i + 1 | i IN L}])
           {0; 1; 2; 3; 4; 5}``)
	  THEN RW_TAC std_ss[disjoint_family_on]
	  THEN POP_ASSUM(MP_TAC o Q.SPEC `0`)
	  THEN DISCH_TAC
	  THEN POP_ASSUM (MP_TAC o Q.SPEC `1`)
	  THEN RW_TAC std_ss[] 
	  THEN FULL_SIMP_TAC list_ss[ind_set_def]
	  THEN `DISJOINT {0:num} L1` by ASM_SET_TAC[]
	  THEN `FINITE {0:num}` by RW_TAC std_ss[FINITE_SING]	 
	  THEN RW_TAC std_ss[PRODUCT_UNION]
	  THEN RW_TAC std_ss[GSYM extreal_mul_def]
	  THEN RW_TAC std_ss[PRODUCT_SING]
	  THEN FULL_SIMP_TAC std_ss[indep_sets]
	  THEN FULL_SIMP_TAC std_ss[event_set_def, event_set1_def]
	  THEN UNDISCH_TAC(``  !(i :num).
             i IN
             BIGUNION_o_BIGUNION
               (\ (i :num).
                    if
                      i IN {(2 :num) * i | i IN (L :num -> bool)} \/
                      i IN {(2 :num) * i + (1 :num) | i IN L}
                    then
                      {i}
                    else
                      EL i
                        [{(0 :num)}; (L1 :num -> bool); (L2 :num -> bool);
                         (L3 :num -> bool); (L4 :num -> bool)])
               (\ (j :num).
                    if j IN L then {(2 :num) * j; (2 :num) * j + (1 :num)}
                    else
                      EL j
                        [{(0 :num)}; {(1 :num)}; ({} :num -> bool);
                         {(2 :num); (3 :num)}; {(4 :num)}])
               ({(0 :num); (1 :num); (3 :num); (4 :num)} UNION L) ==>
             {if i = (0 :num) then
                DRBD_event
                  (p :
                     ('a -> bool) #
                     (('a -> bool) -> bool) # (('a -> bool) -> extreal))
                  (R_WSP ((Y :num -> 'a -> extreal) (0 :num))
                     ((Ysa :num -> 'a -> extreal) (0 :num))
                     ((Ysd :num -> 'a -> extreal) (0 :num))) (t :real)
              else rv_to_event p (X :num -> 'a -> extreal) t i} SUBSET
             events p ``)
	  THEN DISCH_TAC   
	  THEN POP_ASSUM (MP_TAC o Q.SPEC `0:num`)
	  THEN RW_TAC std_ss[]
	  THEN KNOW_TAC(``0:num IN  BIGUNION_o_BIGUNION
               (\ (i :num).
                    if
                      i IN {(2 :num) * i | i IN (L :num -> bool)} \/
                      i IN {(2 :num) * i + (1 :num) | i IN L}
                    then
                      {i}
                    else
                      EL i
                        [{(0 :num)}; (L1 :num -> bool); (L2 :num -> bool);
                         (L3 :num -> bool); (L4 :num -> bool)])
               (\ (j :num).
                    if j IN L then {(2 :num) * j; (2 :num) * j + (1 :num)}
                    else
                      EL j
                        [{(0 :num)}; {(1 :num)}; ({} :num -> bool);
                         {(2 :num); (3 :num)}; {(4 :num)}])
               ({(0 :num); (1 :num); (3 :num); (4 :num)} UNION L) ``)
	      THEN1 (RW_TAC std_ss[BIGUNION_o_BIGUNION_def]
	             THEN RW_TAC list_ss[ind_set_def]
		     THEN PSET_TAC[BIGUNION_o_BIGUNION_def]
		     THEN Q.EXISTS_TAC`{0}`
		     THEN RW_TAC std_ss[]
		          THEN1 ASM_SET_TAC[] 
		     THEN Q.EXISTS_TAC`0`
		     THEN RW_TAC list_ss[]
		     THEN Q.EXISTS_TAC`{0}`
		     THEN RW_TAC std_ss[] THEN1 ASM_SET_TAC[]
		     THEN Q.EXISTS_TAC`0`
		     THEN RW_TAC list_ss[])
        THEN RW_TAC std_ss[Rel_def]
	THEN FULL_SIMP_TAC std_ss[]
	THEN KNOW_TAC(``DRBD_event p (R_WSP (Y (0:num)) (Ysa (0:num)) (Ysd (0:num))) t IN events p ``)
	     THEN1 ASM_SET_TAC[]
	THEN DISCH_TAC
	THEN `prob p (DRBD_event p (R_WSP (Y (0:num)) (Ysa (0:num)) (Ysd (0:num))) t) <> PosInf /\
	     prob p (DRBD_event p (R_WSP (Y 0) (Ysa 0) (Ysd 0)) t) <> NegInf` by RW_TAC std_ss[PROB_FINITE]
	THEN RW_TAC std_ss[normal_real]
	THEN KNOW_TAC(``!l:num. l IN L1 ==> (real (prob p (DRBD_event p (X l) t)) = real (prob p (DRBD_event p (R_WSP (Y l) (Ysa l) (Ysd l)) t))) ``)
            THEN1(RW_TAC std_ss[])
	THEN RW_TAC std_ss[]    
	THEN AP_TERM_TAC
	THEN RW_TAC std_ss[th] )
THEN RW_TAC std_ss[] );




(* -------------------------------------------------------------------------- *)
(*                                          Equivalnece                       *)
(*                                                                            *)
(*                                                                            *)
(* -------------------------------------------------------------------------- *)


val sSEN_DRBD_DFT_eq = store_thm("sSEN_DRBD_DFT_eq",
  ``!L Y Ysa Ysd X. FINITE L /\ (!s. ALL_DISTINCT [Y s; Ysa s; Ysd s]) ==>
  (nR_AND (\i. if i = 0 then R_WSP Y Ysa Ysd else ((X:num->'a->extreal) i)) ({0} UNION L) =
  n_OR (MAP (\i. if i = 0 then WSP Y Ysa Ysd else (X:num->'a->extreal) i) (SET_TO_LIST ({0:num} UNION L))))``,
RW_TAC std_ss[]
THEN `FINITE ({0:num} UNION L)` by ASM_SET_TAC[FINITE_SING, FINITE_UNION]
THEN RW_TAC std_ss[n_OR_nR_AND]
THEN RW_TAC std_ss[D_WSP_R_WSP]);



val sSEN_DRBD_DFT_event_eq = store_thm("sSEN_DRBD_DFT_event_eq",
  ``  !p L Y Ysa Ysd X t. FINITE L /\ (!s. ALL_DISTINCT [Y s; Ysa s; Ysd s]) ==>
 ( DRBD_event p (nR_AND (\i. if i = 0 then R_WSP Y Ysa Ysd else ((X:num->'a->extreal) i)) ({0} UNION L)) t =
  p_space p DIFF DFT_event p (n_OR (MAP (\i. if i = 0 then WSP Y Ysa Ysd else (X:num->'a->extreal) i) (SET_TO_LIST ({0:num} UNION L)))) t)``,

RW_TAC std_ss[sSEN_DRBD_DFT_eq, COMPL_DRBD_DFT_event]);


val SEN_DRBD_DFT_terminal_eq = store_thm("SEN_DRBD_DFT_terminal_eq",
  ``!L1 L2 X Y Ysa Ysd Z Zsa Zsd.
FINITE L1 /\ FINITE L2 /\ (!s. ALL_DISTINCT [Y s; Ysa s; Ysd s; Z s; Zsa s; Zsd s ])   ==> (

(nR_AND
                (\i:num.
                     if i = 0 then R_WSP Y Ysa Ysd
                     else if i = 1 then R_OR (nR_AND X L1) (nR_AND X L2)
                     else R_WSP Z Zsa Zsd) {0; 1; 2}) = 

(n_OR
                   (MAP (\i.
                     if i = 0 then WSP Y Ysa Ysd
                     else if i = 1 then D_AND (n_OR (MAP X (SET_TO_LIST L1))) (n_OR(MAP  X (SET_TO_LIST L2)))
                    else WSP Z Zsa Zsd) (SET_TO_LIST {0:num; 1; 2}))) )``,


RW_TAC std_ss[]
THEN `FINITE {0;1;2:num}` by RW_TAC std_ss[FINITE_3]
THEN RW_TAC std_ss[n_OR_nR_AND]
THEN RW_TAC std_ss[]
THEN `(!s. ALL_DISTINCT [Y s; Ysa s; Ysd s;])` by FULL_SIMP_TAC list_ss[ALL_DISTINCT, MEM]
THEN `(!s. ALL_DISTINCT [Z s; Zsa s; Zsd s;])` by FULL_SIMP_TAC list_ss[ALL_DISTINCT, MEM]
THEN RW_TAC std_ss[D_WSP_R_WSP]
THEN RW_TAC std_ss[D_AND_R_OR]);

val SEN_DRBD_DFT_terminal_event_eq = store_thm("SEN_DRBD_DFT_terminal_event_eq",
  `` !p L1 L2 X Y Ysa Ysd Z Zsa Zsd t.
FINITE L1 /\ FINITE L2 /\ (!s. ALL_DISTINCT [Y s; Ysa s; Ysd s; Z s; Zsa s; Zsd s ])   ==>

(DRBD_event p (nR_AND
                (\i:num.
                     if i = 0 then R_WSP Y Ysa Ysd
                     else if i = 1 then R_OR (nR_AND X L1) (nR_AND X L2)
                     else R_WSP Z Zsa Zsd) {0; 1; 2}) t =
p_space p DIFF (DFT_event p (n_OR
                   (MAP (\i.
                     if i = 0 then WSP Y Ysa Ysd
                     else if i = 1 then D_AND (n_OR (MAP X (SET_TO_LIST L1))) (n_OR(MAP  X (SET_TO_LIST L2)))
                    else WSP Z Zsa Zsd) (SET_TO_LIST {0:num; 1; 2}))) t))``,
RW_TAC std_ss[SEN_DRBD_DFT_terminal_eq, COMPL_DRBD_DFT_event]);



val SEN_DRBD_DFT_broadcast_eq = store_thm("SEN_DRBD_DFT_broadcast_eq",
  ``!L1 L2 L3 Y Ysa Ysd X.
    FINITE L1 /\ FINITE L2 /\ FINITE L3 /\ (!s. ALL_DISTINCT [Y s; Ysa s; Ysd s]) ==>
  (nR_AND
              (\i:num.
                   if i = 0 then R_WSP Y Ysa Ysd
                   else if i = 1 then R_OR (nR_AND X L1) (nR_AND X L2)
                   else (nR_AND X L3)) {0; 1; 2:num} =
		    n_OR
                (MAP
                   (\i:num.
                        if i = 0 then WSP Y Ysa Ysd
                        else if i = 1 then
                          D_AND (n_OR (MAP X (SET_TO_LIST L1)))
                            (n_OR (MAP X (SET_TO_LIST L2)))
                        else n_OR (MAP X (SET_TO_LIST L3)))
                   (SET_TO_LIST {0:num; 1; 2}))) ``,

RW_TAC std_ss[]
THEN `FINITE {0;1;2:num}` by RW_TAC std_ss[FINITE_3]
THEN RW_TAC std_ss[n_OR_nR_AND, D_AND_R_OR, D_WSP_R_WSP]);



val SEN_DRBD_DFT_broadcast_event_eq = store_thm("SEN_DRBD_DFT_broadcast_event_eq",
  `` !p L1 L2 L3 X Y Ysa Ysd t.
  FINITE L1 /\ FINITE L2 /\ FINITE L3 /\ (!s. ALL_DISTINCT [Y s; Ysa s; Ysd s]) ==>
 (DRBD_event p (nR_AND
              (\i:num.
                   if i = 0 then R_WSP Y Ysa Ysd
                   else if i = 1 then R_OR (nR_AND X L1) (nR_AND X L2)
                   else (nR_AND X L3)) {0; 1; 2:num}) t =
		   p_space p DIFF DFT_event p (n_OR
                (MAP
                   (\i:num.
                        if i = 0 then WSP Y Ysa Ysd
                        else if i = 1 then
                          D_AND (n_OR (MAP X (SET_TO_LIST L1)))
                            (n_OR (MAP X (SET_TO_LIST L2)))
                        else n_OR (MAP X (SET_TO_LIST L3)))
                   (SET_TO_LIST {0:num; 1; 2}))) t) ``,

RW_TAC std_ss[SEN_DRBD_DFT_broadcast_eq, COMPL_DRBD_DFT_event]);


val _ = export_theory();
